/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/errors","vs/base/common/resources","vs/base/common/buffer","vs/platform/files/common/files","vs/platform/configuration/common/configuration","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/platform/product/common/productService","vs/platform/environment/electron-main/environmentMainService","vs/base/node/pfs","vs/base/common/strings","os","vs/platform/workspaces/common/workspaces","vs/base/common/arrays","vs/base/common/extpath","fs","vs/platform/telemetry/common/telemetry","vs/base/common/uuid","vs/base/common/labels","vs/platform/windows/electron-main/windows","vs/base/common/process","vs/base/common/map","vs/base/parts/ipc/common/ipc","vs/platform/state/electron-main/state","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/functional","vs/base/common/json","child_process","vs/base/common/decorators","vs/base/common/objects","vs/platform/environment/common/environment","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/stream","vs/platform/backup/electron-main/backup","vs/platform/environment/node/argvHelper","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/base/parts/ipc/node/ipc.net","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/keybindings","crypto","net","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/hash","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/storage/electron-main/storageMainService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/keyCodes","vs/base/common/processes","vs/base/common/stopwatch","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/node/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/common/io","vs/platform/credentials/node/credentialsMainService","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/remote/common/tunnel","vs/platform/url/common/url","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/codicons","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/keybindingParser","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/cache","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/common/worker/simpleWorker","vs/base/node/crypto","vs/base/node/decoder","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/credentials/common/credentials","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/resolvedKeybindingItem","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagement","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/extensions/electron-main/workerMainProcessExtensionHostStarter","zlib","vs/platform/driver/node/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/driver/electron-main/driver","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","path","assert","graceful-fs","worker_threads","vs/code/electron-main/main"],te=function(j){for(var e=[],p=0,n=j.length;p<n;p++)e[p]=ee[j[p]];return e};define(ee[105],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function p(n,D){if(!n)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=p}),define(ee[106],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function p(k){return k?k.replace(/\$\((.*?)\)/g,(E,w)=>` ${w} `).trim():""}e.getCodiconAriaLabel=p;class n{constructor(E,w,S){this.id=E,this.definition=w,this.description=S,n._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n._allCodicons}}e.Codicon=n,n._allCodicons=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function D(k,E){const w=["codicon","codicon-"+k];return E&&w.push("codicon-modifier-"+E),w}e.getClassNamesArray=D;var C;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const E=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function w(M){if(M instanceof n)return["codicon","codicon-"+M.id];const y=E.exec(M.id);if(!y)return w(n.error);let[,f,t]=y;const d=["codicon","codicon-"+f];return t&&d.push("codicon-modifier-"+t.substr(1)),d}k.asClassNameArray=w;function S(M){return w(M).join(" ")}k.asClassName=S;function b(M){return"."+w(M).join(".")}k.asCSSSelector=b})(C=e.CSSIcon||(e.CSSIcon={}))}),define(ee[46],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function p(k){return(E,w,S)=>{let b=null,M=null;if(typeof S.value=="function"?(b="value",M=S.value):typeof S.get=="function"&&(b="get",M=S.get),!M)throw new Error("not supported");S[b]=k(M,w)}}e.createDecorator=p;function n(k,E,w){let S=null,b=null;if(typeof w.value=="function"?(S="value",b=w.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(S="get",b=w.get),!b)throw new Error("not supported");const M=`$memoize$${E}`;w[S]=function(...y){return this.hasOwnProperty(M)||Object.defineProperty(this,M,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,y)}),this[M]}}e.memoize=n;function D(k,E,w){return p((S,b)=>{const M=`$debounce$${b}`,y=`$debounce$result$${b}`;return function(...f){this[y]||(this[y]=w?w():void 0),clearTimeout(this[M]),E&&(this[y]=E(this[y],...f),f=[this[y]]),this[M]=setTimeout(()=>{S.apply(this,f),this[y]=w?w():void 0},k)}})}e.debounce=D;function C(k,E,w){return p((S,b)=>{const M=`$throttle$timer$${b}`,y=`$throttle$result$${b}`,f=`$throttle$lastRun$${b}`,t=`$throttle$pending$${b}`;return function(...d){if(this[y]||(this[y]=w?w():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),E&&(this[y]=E(this[y],...d)),this[t])return;const m=this[f]+k;m<=Date.now()?(this[f]=Date.now(),S.apply(this,[this[y]]),this[y]=w?w():void 0):(this[t]=!0,this[M]=setTimeout(()=>{this[t]=!1,this[f]=Date.now(),S.apply(this,[this[y]]),this[y]=w?w():void 0},m-Date.now()))}})}e.throttle=C}),define(ee[15],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class p{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(o){setTimeout(()=>{throw o.stack?new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.listeners.push(o),()=>{this._removeListener(o)}}emit(o){this.listeners.forEach(l=>{l(o)})}_removeListener(o){this.listeners.splice(this.listeners.indexOf(o),1)}setUnexpectedErrorHandler(o){this.unexpectedErrorHandler=o}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(o){this.unexpectedErrorHandler(o),this.emit(o)}onUnexpectedExternalError(o){this.unexpectedErrorHandler(o)}}e.ErrorHandler=p,e.errorHandler=new p;function n(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=n;function D(c){w(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=D;function C(c){w(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=C;function k(c){if(c instanceof Error){let{name:o,message:l}=c;const s=c.stacktrace||c.stack;return{$isError:!0,name:o,message:l,stack:s}}return c}e.transformErrorForSerialization=k;const E="Canceled";function w(c){return c instanceof S?!0:c instanceof Error&&c.name===E&&c.message===E}e.isCancellationError=w;class S extends Error{constructor(){super(E);this.name=this.message}}e.CancellationError=S;function b(){const c=new Error(E);return c.name=c.message,c}e.canceled=b;function M(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=M;function y(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=y;function f(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function t(c){const o=new Error(`${c} has been disposed`);return o.name="DISPOSED",o}e.disposed=t;function d(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=d;class m extends Error{constructor(o){super("NotImplemented");o&&(this.message=o)}}e.NotImplementedError=m;class v extends Error{constructor(o){super("NotSupported");o&&(this.message=o)}}e.NotSupportedError=v;class P extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=P;function u(c){const o=c;return o instanceof Error&&Array.isArray(o.actions)}e.isErrorWithActions=u;function g(c,o=Object.create(null)){const l=new Error(c);return o.actions&&(l.actions=o.actions),l}e.createErrorWithActions=g}),define(ee[28],te([0,1,15]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function n(F,A=0){return F[F.length-(1+A)]}e.tail=n;function D(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.tail2=D;function C(F,A,U=(O,_)=>O===_){if(F===A)return!0;if(!F||!A||F.length!==A.length)return!1;for(let O=0,_=F.length;O<_;O++)if(!U(F[O],A[O]))return!1;return!0}e.equals=C;function k(F,A,U){let O=0,_=F.length-1;for(;O<=_;){const Y=(O+_)/2|0,ie=U(F[Y],A);if(ie<0)O=Y+1;else if(ie>0)_=Y-1;else return Y}return-(O+1)}e.binarySearch=k;function E(F,A){let U=0,O=F.length;if(O===0)return 0;for(;U<O;){const _=Math.floor((U+O)/2);A(F[_])?O=_:U=_+1}return U}e.findFirstInSorted=E;function w(F,A,U){if(F=F|0,F>=A.length)throw new TypeError("invalid index");let O=A[Math.floor(A.length*Math.random())],_=[],Y=[],ie=[];for(let oe of A){const J=U(oe,O);J<0?_.push(oe):J>0?Y.push(oe):ie.push(oe)}return F<_.length?w(F,_,U):F<_.length+ie.length?ie[0]:w(F-(_.length+ie.length),Y,U)}e.quickSelect=w;function S(F,A){const U=[];let O;for(const _ of F.slice(0).sort(A))!O||A(O[0],_)!==0?(O=[_],U.push(O)):O.push(_);return U}e.groupBy=S;function b(F,A,U){const O=[];function _(oe,J,ce){if(J===0&&ce.length===0)return;const le=O[O.length-1];le&&le.start+le.deleteCount===oe?(le.deleteCount+=J,le.toInsert.push(...ce)):O.push({start:oe,deleteCount:J,toInsert:ce})}let Y=0,ie=0;for(;;){if(Y===F.length){_(Y,0,A.slice(ie));break}if(ie===A.length){_(Y,F.length-Y,[]);break}const oe=F[Y],J=A[ie],ce=U(oe,J);ce===0?(Y+=1,ie+=1):ce<0?(_(Y,1,[]),Y+=1):ce>0&&(_(Y,0,[J]),ie+=1)}return O}e.sortedDiff=b;function M(F,A,U){const O=b(F,A,U),_=[],Y=[];for(const ie of O)_.push(...F.slice(ie.start,ie.start+ie.deleteCount)),Y.push(...ie.toInsert);return{removed:_,added:Y}}e.delta=M;function y(F,A,U){if(U===0)return[];const O=F.slice(0,U).sort(A);return t(F,A,O,U,F.length),O}e.top=y;function f(F,A,U,O,_){return U===0?Promise.resolve([]):new Promise((Y,ie)=>{(async()=>{const oe=F.length,J=F.slice(0,U).sort(A);for(let ce=U,le=Math.min(U+O,oe);ce<oe;ce=le,le=Math.min(le+O,oe)){if(ce>U&&await new Promise(he=>setTimeout(he)),_&&_.isCancellationRequested)throw(0,p.canceled)();t(F,A,J,ce,le)}return J})().then(Y,ie)})}e.topAsync=f;function t(F,A,U,O,_){for(const Y=U.length;O<_;O++){const ie=F[O];if(A(ie,U[Y-1])<0){U.pop();const oe=E(U,J=>A(ie,J)<0);U.splice(oe,0,ie)}}}function d(F){return F.filter(A=>!!A)}e.coalesce=d;function m(F){let A=0;for(let U=0;U<F.length;U++)F[U]&&(F[A]=F[U],A+=1);F.length=A}e.coalesceInPlace=m;function v(F,A,U){F.splice(U,0,F.splice(A,1)[0])}e.move=v;function P(F){return!Array.isArray(F)||F.length===0}e.isFalsyOrEmpty=P;function u(F){return Array.isArray(F)&&F.length>0}e.isNonEmptyArray=u;function g(F,A=U=>U){const U=new Set;return F.filter(O=>{const _=A(O);return U.has(_)?!1:(U.add(_),!0)})}e.distinct=g;function c(F){const A=new Set;return U=>{const O=F(U);return A.has(O)?!1:(A.add(O),!0)}}e.uniqueFilter=c;function o(F,A){const U=l(F,A);if(U!==-1)return F[U]}e.findLast=o;function l(F,A){for(let U=F.length-1;U>=0;U--){const O=F[U];if(A(O))return U}return-1}e.lastIndex=l;function s(F,A){return F.length>0?F[0]:A}e.firstOrDefault=s;function i(F,A,U=(O,_)=>O===_){let O=0;for(let _=0,Y=Math.min(F.length,A.length);_<Y&&U(F[_],A[_]);_++)O++;return O}e.commonPrefixLength=i;function r(F){return[].concat(...F)}e.flatten=r;function a(F,A){let U=typeof A=="number"?F:0;typeof A=="number"?U=F:(U=0,A=F);const O=[];if(U<=A)for(let _=U;_<A;_++)O.push(_);else for(let _=U;_>A;_--)O.push(_);return O}e.range=a;function h(F,A,U){return F.reduce((O,_)=>(O[A(_)]=U?U(_):_,O),Object.create(null))}e.index=h;function I(F,A){return F.push(A),()=>R(F,A)}e.insert=I;function R(F,A){const U=F.indexOf(A);if(U>-1)return F.splice(U,1),A}e.remove=R;function L(F,A,U){const O=F.slice(0,A),_=F.slice(A);return O.concat(U,_)}e.arrayInsert=L;function T(F,A){let U;if(typeof A=="number"){let O=A;U=()=>{const _=Math.sin(O++)*179426549;return _-Math.floor(_)}}else U=Math.random;for(let O=F.length-1;O>0;O-=1){const _=Math.floor(U()*(O+1)),Y=F[O];F[O]=F[_],F[_]=Y}}e.shuffle=T;function $(F,A){const U=F.indexOf(A);U>-1&&(F.splice(U,1),F.unshift(A))}e.pushToStart=$;function Q(F,A){const U=F.indexOf(A);U>-1&&(F.splice(U,1),F.push(A))}e.pushToEnd=Q;function se(F,A){return Array.isArray(F)?F.map(A):A(F)}e.mapArrayOrNot=se;function re(F){return Array.isArray(F)?F:[F]}e.asArray=re;function V(F){return F[Math.floor(Math.random()*F.length)]}e.getRandomElement=V;function Z(F,A){for(const U of F){const O=A(U);if(O!==void 0)return O}}e.mapFind=Z;function H(F,A,U){const O=x(F,A),_=F.length,Y=U.length;F.length=_+Y;for(let ie=_-1;ie>=O;ie--)F[ie+Y]=F[ie];for(let ie=0;ie<Y;ie++)F[ie+O]=U[ie]}e.insertInto=H;function K(F,A,U,O){const _=x(F,A),Y=F.splice(_,U);return H(F,_,O),Y}e.splice=K;function x(F,A){return A<0?Math.max(A+F.length,0):Math.min(A,F.length)}function B(F,A){return(U,O)=>A(F(U),F(O))}e.compareBy=B;const z=(F,A)=>F-A;e.numberComparator=z;function G(F,A){if(F.length===0)return;let U=F[0];for(let O=1;O<F.length;O++){const _=F[O];A(_,U)>0&&(U=_)}return U}e.findMaxBy=G;function q(F,A){if(F.length===0)return;let U=F[0];for(let O=1;O<F.length;O++){const _=F[O];A(_,U)>=0&&(U=_)}return U}e.findLastMaxBy=q;function W(F,A){return G(F,(U,O)=>-A(U,O))}e.findMinBy=W;class N{constructor(A){this.items=A,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(A){let U=this.firstIdx;for(;U<this.items.length&&A(this.items[U]);)U++;const O=U===this.firstIdx?null:this.items.slice(this.firstIdx,U);return this.firstIdx=U,O}takeFromEndWhile(A){let U=this.lastIdx;for(;U>=0&&A(this.items[U]);)U--;const O=U===this.lastIdx?null:this.items.slice(U+1,this.lastIdx+1);return this.lastIdx=U,O}peek(){return this.items[this.firstIdx]}dequeue(){const A=this.items[this.firstIdx];return this.firstIdx++,A}takeCount(A){const U=this.items.slice(this.firstIdx,this.firstIdx+A);return this.firstIdx+=A,U}}e.ArrayQueue=N}),define(ee[43],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function p(n){const D=this;let C=!1,k;return function(){return C||(C=!0,k=n.apply(D,arguments)),k}}e.once=p}),define(ee[70],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var p;(function(n){function D(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}n.is=D;const C=Object.freeze([]);function k(){return C}n.empty=k;function*E(c){yield c}n.single=E;function w(c){return c||C}n.from=w;function S(c){return!c||c[Symbol.iterator]().next().done===!0}n.isEmpty=S;function b(c){return c[Symbol.iterator]().next().value}n.first=b;function M(c,o){for(const l of c)if(o(l))return!0;return!1}n.some=M;function y(c,o){for(const l of c)if(o(l))return l}n.find=y;function*f(c,o){for(const l of c)o(l)&&(yield l)}n.filter=f;function*t(c,o){let l=0;for(const s of c)yield o(s,l++)}n.map=t;function*d(...c){for(const o of c)for(const l of o)yield l}n.concat=d;function*m(c){for(const o of c)for(const l of o)yield l}n.concatNested=m;function v(c,o,l){let s=l;for(const i of c)s=o(s,i);return s}n.reduce=v;function*P(c,o,l=c.length){for(o<0&&(o+=c.length),l<0?l+=c.length:l>c.length&&(l=c.length);o<l;o++)yield c[o]}n.slice=P;function u(c,o=Number.POSITIVE_INFINITY){const l=[];if(o===0)return[l,c];const s=c[Symbol.iterator]();for(let i=0;i<o;i++){const r=s.next();if(r.done)return[l,n.empty()];l.push(r.value)}return[l,{[Symbol.iterator](){return s}}]}n.consume=u;function g(c,o,l=(s,i)=>s===i){const s=c[Symbol.iterator](),i=o[Symbol.iterator]();for(;;){const r=s.next(),a=i.next();if(r.done!==a.done)return!1;if(r.done)return!0;if(!l(r.value,a.value))return!1}}n.equals=g})(p=e.Iterable||(e.Iterable={}))}),define(ee[44],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var p;(function(o){o[o.None=0]="None",o[o.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=2]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",o[o.InvalidUnicode=4]="InvalidUnicode",o[o.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",o[o.InvalidCharacter=6]="InvalidCharacter"})(p=e.ScanError||(e.ScanError={}));var n;(function(o){o[o.OpenBraceToken=1]="OpenBraceToken",o[o.CloseBraceToken=2]="CloseBraceToken",o[o.OpenBracketToken=3]="OpenBracketToken",o[o.CloseBracketToken=4]="CloseBracketToken",o[o.CommaToken=5]="CommaToken",o[o.ColonToken=6]="ColonToken",o[o.NullKeyword=7]="NullKeyword",o[o.TrueKeyword=8]="TrueKeyword",o[o.FalseKeyword=9]="FalseKeyword",o[o.StringLiteral=10]="StringLiteral",o[o.NumericLiteral=11]="NumericLiteral",o[o.LineCommentTrivia=12]="LineCommentTrivia",o[o.BlockCommentTrivia=13]="BlockCommentTrivia",o[o.LineBreakTrivia=14]="LineBreakTrivia",o[o.Trivia=15]="Trivia",o[o.Unknown=16]="Unknown",o[o.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(o){o[o.InvalidSymbol=1]="InvalidSymbol",o[o.InvalidNumberFormat=2]="InvalidNumberFormat",o[o.PropertyNameExpected=3]="PropertyNameExpected",o[o.ValueExpected=4]="ValueExpected",o[o.ColonExpected=5]="ColonExpected",o[o.CommaExpected=6]="CommaExpected",o[o.CloseBraceExpected=7]="CloseBraceExpected",o[o.CloseBracketExpected=8]="CloseBracketExpected",o[o.EndOfFileExpected=9]="EndOfFileExpected",o[o.InvalidCommentToken=10]="InvalidCommentToken",o[o.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=12]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",o[o.InvalidUnicode=14]="InvalidUnicode",o[o.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",o[o.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(o){o.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function k(o,l=!1){let s=0,i=o.length,r="",a=0,h=16,I=0;function R(V){let Z=0,H=0;for(;Z<V;){const K=o.charCodeAt(s);if(K>=48&&K<=57)H=H*16+K-48;else if(K>=65&&K<=70)H=H*16+K-65+10;else if(K>=97&&K<=102)H=H*16+K-97+10;else break;s++,Z++}return Z<V&&(H=-1),H}function L(V){s=V,r="",a=0,h=16,I=0}function T(){const V=s;if(o.charCodeAt(s)===48)s++;else for(s++;s<o.length&&S(o.charCodeAt(s));)s++;if(s<o.length&&o.charCodeAt(s)===46)if(s++,s<o.length&&S(o.charCodeAt(s)))for(s++;s<o.length&&S(o.charCodeAt(s));)s++;else return I=3,o.substring(V,s);let Z=s;if(s<o.length&&(o.charCodeAt(s)===69||o.charCodeAt(s)===101))if(s++,(s<o.length&&o.charCodeAt(s)===43||o.charCodeAt(s)===45)&&s++,s<o.length&&S(o.charCodeAt(s))){for(s++;s<o.length&&S(o.charCodeAt(s));)s++;Z=s}else I=3;return o.substring(V,Z)}function $(){let V="",Z=s;for(;;){if(s>=i){V+=o.substring(Z,s),I=2;break}const H=o.charCodeAt(s);if(H===34){V+=o.substring(Z,s),s++;break}if(H===92){if(V+=o.substring(Z,s),s++,s>=i){I=2;break}switch(o.charCodeAt(s++)){case 34:V+='"';break;case 92:V+="\\";break;case 47:V+="/";break;case 98:V+="\b";break;case 102:V+="\f";break;case 110:V+=`
`;break;case 114:V+="\r";break;case 116:V+="	";break;case 117:{const x=R(4);x>=0?V+=String.fromCharCode(x):I=4;break}default:I=5}Z=s;continue}if(H>=0&&H<=31)if(w(H)){V+=o.substring(Z,s),I=2;break}else I=6;s++}return V}function Q(){if(r="",I=0,a=s,s>=i)return a=i,h=17;let V=o.charCodeAt(s);if(E(V)){do s++,r+=String.fromCharCode(V),V=o.charCodeAt(s);while(E(V));return h=15}if(w(V))return s++,r+=String.fromCharCode(V),V===13&&o.charCodeAt(s)===10&&(s++,r+=`
`),h=14;switch(V){case 123:return s++,h=1;case 125:return s++,h=2;case 91:return s++,h=3;case 93:return s++,h=4;case 58:return s++,h=6;case 44:return s++,h=5;case 34:return s++,r=$(),h=10;case 47:{const Z=s-1;if(o.charCodeAt(s+1)===47){for(s+=2;s<i&&!w(o.charCodeAt(s));)s++;return r=o.substring(Z,s),h=12}if(o.charCodeAt(s+1)===42){s+=2;const H=i-1;let K=!1;for(;s<H;){if(o.charCodeAt(s)===42&&o.charCodeAt(s+1)===47){s+=2,K=!0;break}s++}return K||(s++,I=1),r=o.substring(Z,s),h=13}return r+=String.fromCharCode(V),s++,h=16}case 45:if(r+=String.fromCharCode(V),s++,s===i||!S(o.charCodeAt(s)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=T(),h=11;default:for(;s<i&&se(V);)s++,V=o.charCodeAt(s);if(a!==s){switch(r=o.substring(a,s),r){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return r+=String.fromCharCode(V),s++,h=16}}function se(V){if(E(V)||w(V))return!1;switch(V){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let V;do V=Q();while(V>=12&&V<=15);return V}return{setPosition:L,getPosition:()=>s,scan:l?re:Q,getToken:()=>h,getTokenValue:()=>r,getTokenOffset:()=>a,getTokenLength:()=>s-a,getTokenError:()=>I}}e.createScanner=k;function E(o){return o===32||o===9||o===11||o===12||o===160||o===5760||o>=8192&&o<=8203||o===8239||o===8287||o===12288||o===65279}function w(o){return o===10||o===13||o===8232||o===8233}function S(o){return o>=48&&o<=57}var b;(function(o){o[o.nullCharacter=0]="nullCharacter",o[o.maxAsciiCharacter=127]="maxAsciiCharacter",o[o.lineFeed=10]="lineFeed",o[o.carriageReturn=13]="carriageReturn",o[o.lineSeparator=8232]="lineSeparator",o[o.paragraphSeparator=8233]="paragraphSeparator",o[o.nextLine=133]="nextLine",o[o.space=32]="space",o[o.nonBreakingSpace=160]="nonBreakingSpace",o[o.enQuad=8192]="enQuad",o[o.emQuad=8193]="emQuad",o[o.enSpace=8194]="enSpace",o[o.emSpace=8195]="emSpace",o[o.threePerEmSpace=8196]="threePerEmSpace",o[o.fourPerEmSpace=8197]="fourPerEmSpace",o[o.sixPerEmSpace=8198]="sixPerEmSpace",o[o.figureSpace=8199]="figureSpace",o[o.punctuationSpace=8200]="punctuationSpace",o[o.thinSpace=8201]="thinSpace",o[o.hairSpace=8202]="hairSpace",o[o.zeroWidthSpace=8203]="zeroWidthSpace",o[o.narrowNoBreakSpace=8239]="narrowNoBreakSpace",o[o.ideographicSpace=12288]="ideographicSpace",o[o.mathematicalSpace=8287]="mathematicalSpace",o[o.ogham=5760]="ogham",o[o._=95]="_",o[o.$=36]="$",o[o._0=48]="_0",o[o._1=49]="_1",o[o._2=50]="_2",o[o._3=51]="_3",o[o._4=52]="_4",o[o._5=53]="_5",o[o._6=54]="_6",o[o._7=55]="_7",o[o._8=56]="_8",o[o._9=57]="_9",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.ampersand=38]="ampersand",o[o.asterisk=42]="asterisk",o[o.at=64]="at",o[o.backslash=92]="backslash",o[o.bar=124]="bar",o[o.caret=94]="caret",o[o.closeBrace=125]="closeBrace",o[o.closeBracket=93]="closeBracket",o[o.closeParen=41]="closeParen",o[o.colon=58]="colon",o[o.comma=44]="comma",o[o.dot=46]="dot",o[o.doubleQuote=34]="doubleQuote",o[o.equals=61]="equals",o[o.exclamation=33]="exclamation",o[o.greaterThan=62]="greaterThan",o[o.lessThan=60]="lessThan",o[o.minus=45]="minus",o[o.openBrace=123]="openBrace",o[o.openBracket=91]="openBracket",o[o.openParen=40]="openParen",o[o.percent=37]="percent",o[o.plus=43]="plus",o[o.question=63]="question",o[o.semicolon=59]="semicolon",o[o.singleQuote=39]="singleQuote",o[o.slash=47]="slash",o[o.tilde=126]="tilde",o[o.backspace=8]="backspace",o[o.formFeed=12]="formFeed",o[o.byteOrderMark=65279]="byteOrderMark",o[o.tab=9]="tab",o[o.verticalTab=11]="verticalTab"})(b||(b={}));function M(o,l){const s=[],i=new Object;let r;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function I(R,L,T,$){a.value=R,a.offset=L,a.length=T,a.type=$,a.colonOffset=void 0,r=a}try{u(o,{onObjectBegin:(R,L)=>{if(l<=R)throw i;r=void 0,h=l>R,s.push("")},onObjectProperty:(R,L,T)=>{if(l<L||(I(R,L,T,"property"),s[s.length-1]=R,l<=L+T))throw i},onObjectEnd:(R,L)=>{if(l<=R)throw i;r=void 0,s.pop()},onArrayBegin:(R,L)=>{if(l<=R)throw i;r=void 0,s.push(0)},onArrayEnd:(R,L)=>{if(l<=R)throw i;r=void 0,s.pop()},onLiteralValue:(R,L,T)=>{if(l<L||(I(R,L,T,c(R)),l<=L+T))throw i},onSeparator:(R,L,T)=>{if(l<=L)throw i;if(R===":"&&r&&r.type==="property")r.colonOffset=L,h=!1,r=void 0;else if(R===","){const $=s[s.length-1];typeof $=="number"?s[s.length-1]=$+1:(h=!0,s[s.length-1]=""),r=void 0}}})}catch(R){if(R!==i)throw R}return{path:s,previousNode:r,isAtPropertyKey:h,matches:R=>{let L=0;for(let T=0;L<R.length&&T<s.length;T++)if(R[L]===s[T]||R[L]==="*")L++;else if(R[L]!=="**")return!1;return L===R.length}}}e.getLocation=M;function y(o,l=[],s=C.DEFAULT){let i=null,r=[];const a=[];function h(R){Array.isArray(r)?r.push(R):i!==null&&(r[i]=R)}return u(o,{onObjectBegin:()=>{const R={};h(R),a.push(r),r=R,i=null},onObjectProperty:R=>{i=R},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const R=[];h(R),a.push(r),r=R,i=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:h,onError:(R,L,T)=>{l.push({error:R,offset:L,length:T})}},s),r[0]}e.parse=y;function f(o,l=[],s=C.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(R){i.type==="property"&&(i.length=R-i.offset,i=i.parent)}function a(R){return i.children.push(R),R}u(o,{onObjectBegin:R=>{i=a({type:"object",offset:R,length:-1,parent:i,children:[]})},onObjectProperty:(R,L,T)=>{i=a({type:"property",offset:L,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:R,offset:L,length:T,parent:i})},onObjectEnd:(R,L)=>{i.length=R+L-i.offset,i=i.parent,r(R+L)},onArrayBegin:(R,L)=>{i=a({type:"array",offset:R,length:-1,parent:i,children:[]})},onArrayEnd:(R,L)=>{i.length=R+L-i.offset,i=i.parent,r(R+L)},onLiteralValue:(R,L,T)=>{a({type:c(R),offset:L,length:T,parent:i,value:R}),r(L+T)},onSeparator:(R,L,T)=>{i.type==="property"&&(R===":"?i.colonOffset=L:R===","&&r(L))},onError:(R,L,T)=>{l.push({error:R,offset:L,length:T})}},s);const I=i.children[0];return I&&delete I.parent,I}e.parseTree=f;function t(o,l){if(!o)return;let s=o;for(let i of l)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let r=!1;for(const a of s.children)if(Array.isArray(a.children)&&a.children[0].value===i){s=a.children[1],r=!0;break}if(!r)return}else{const r=i;if(s.type!=="array"||r<0||!Array.isArray(s.children)||r>=s.children.length)return;s=s.children[r]}return s}e.findNodeAtLocation=t;function d(o){if(!o.parent||!o.parent.children)return[];const l=d(o.parent);if(o.parent.type==="property"){const s=o.parent.children[0].value;l.push(s)}else if(o.parent.type==="array"){const s=o.parent.children.indexOf(o);s!==-1&&l.push(s)}return l}e.getNodePath=d;function m(o){switch(o.type){case"array":return o.children.map(m);case"object":{const l=Object.create(null);for(let s of o.children){const i=s.children[1];i&&(l[s.children[0].value]=m(i))}return l}case"null":case"string":case"number":case"boolean":return o.value;default:return}}e.getNodeValue=m;function v(o,l,s=!1){return l>=o.offset&&l<o.offset+o.length||s&&l===o.offset+o.length}e.contains=v;function P(o,l,s=!1){if(v(o,l,s)){const i=o.children;if(Array.isArray(i))for(let r=0;r<i.length&&i[r].offset<=l;r++){const a=P(i[r],l,s);if(a)return a}return o}}e.findNodeAtOffset=P;function u(o,l,s=C.DEFAULT){const i=k(o,!1);function r(N){return N?()=>N(i.getTokenOffset(),i.getTokenLength()):()=>!0}function a(N){return N?F=>N(F,i.getTokenOffset(),i.getTokenLength()):()=>!0}const h=r(l.onObjectBegin),I=a(l.onObjectProperty),R=r(l.onObjectEnd),L=r(l.onArrayBegin),T=r(l.onArrayEnd),$=a(l.onLiteralValue),Q=a(l.onSeparator),se=r(l.onComment),re=a(l.onError),V=s&&s.disallowComments,Z=s&&s.allowTrailingComma;function H(){for(;;){const N=i.scan();switch(i.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:V||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(N){case 12:case 13:V?K(10):se();break;case 16:K(1);break;case 15:case 14:break;default:return N}}}function K(N,F=[],A=[]){if(re(N),F.length+A.length>0){let U=i.getToken();for(;U!==17;){if(F.indexOf(U)!==-1){H();break}else if(A.indexOf(U)!==-1)break;U=H()}}}function x(N){const F=i.getTokenValue();return N?$(F):I(F),H(),!0}function B(){switch(i.getToken()){case 11:{let N=0;try{N=JSON.parse(i.getTokenValue()),typeof N!="number"&&(K(2),N=0)}catch{K(2)}$(N);break}case 7:$(null);break;case 8:$(!0);break;case 9:$(!1);break;default:return!1}return H(),!0}function z(){return i.getToken()!==10?(K(3,[],[2,5]),!1):(x(!1),i.getToken()===6?(Q(":"),H(),W()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function G(){h(),H();let N=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(N||K(4,[],[]),Q(","),H(),i.getToken()===2&&Z)break}else N&&K(6,[],[]);z()||K(4,[],[2,5]),N=!0}return R(),i.getToken()!==2?K(7,[2],[]):H(),!0}function q(){L(),H();let N=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(N||K(4,[],[]),Q(","),H(),i.getToken()===4&&Z)break}else N&&K(6,[],[]);W()||K(4,[],[4,5]),N=!0}return T(),i.getToken()!==4?K(8,[4],[]):H(),!0}function W(){switch(i.getToken()){case 3:return q();case 1:return G();case 10:return x(!0);default:return B()}}return H(),i.getToken()===17?s.allowEmptyContent?!0:(K(4,[],[]),!1):W()?(i.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}e.visit=u;function g(o,l){let s=k(o),i=[],r,a=0,h;do switch(h=s.getPosition(),r=s.scan(),r){case 12:case 13:case 17:a!==h&&i.push(o.substring(a,h)),l!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,l)),a=s.getPosition();break}while(r!==17);return i.join("")}e.stripComments=g;function c(o){switch(typeof o){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(o){if(Array.isArray(o))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(ee[107],te([0,1,44]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function n(S,b,M){let y,f,t,d,m;if(b){for(d=b.offset,m=d+b.length,t=d;t>0&&!w(S,t-1);)t--;let h=m;for(;h<S.length&&!w(S,h);)h++;f=S.substring(t,h),y=k(f,M)}else f=S,y=0,t=0,d=0,m=S.length;const v=E(M,S);let P=!1,u=0,g;M.insertSpaces?g=C(" ",M.tabSize||4):g="	";const c=(0,p.createScanner)(f,!1);let o=!1;function l(){return v+C(g,y+u)}function s(){let h=c.scan();for(P=!1;h===15||h===14;)P=P||h===14,h=c.scan();return o=h===16||c.getTokenError()!==0,h}const i=[];function r(h,I,R){!o&&I<m&&R>d&&S.substring(I,R)!==h&&i.push({offset:I,length:R-I,content:h})}let a=s();if(a!==17){const h=c.getTokenOffset()+t,I=C(g,y);r(I,t,h)}for(;a!==17;){let h=c.getTokenOffset()+c.getTokenLength()+t,I=s(),R="";for(;!P&&(I===12||I===13);){const T=c.getTokenOffset()+t;r(" ",h,T),h=c.getTokenOffset()+c.getTokenLength()+t,R=I===12?l():"",I=s()}if(I===2)a!==1&&(u--,R=l());else if(I===4)a!==3&&(u--,R=l());else{switch(a){case 3:case 1:u++,R=l();break;case 5:case 12:R=l();break;case 13:P?R=l():R=" ";break;case 6:R=" ";break;case 10:if(I===6){R="";break}case 7:case 8:case 9:case 11:case 2:case 4:I===12||I===13?R=" ":I!==5&&I!==17&&(o=!0);break;case 16:o=!0;break}P&&(I===12||I===13)&&(R=l())}const L=c.getTokenOffset()+t;r(R,h,L),a=I}return i}e.format=n;function D(S,b){const M=JSON.stringify(S,void 0,b.insertSpaces?b.tabSize||4:"	");return b.eol!==void 0?M.replace(/\r\n|\r|\n/g,b.eol):M}e.toFormattedString=D;function C(S,b){let M="";for(let y=0;y<b;y++)M+=S;return M}function k(S,b){let M=0,y=0;const f=b.tabSize||4;for(;M<S.length;){const t=S.charAt(M);if(t===" ")y++;else if(t==="	")y+=f;else break;M++}return Math.floor(y/f)}function E(S,b){for(let M=0;M<b.length;M++){const y=b.charAt(M);if(y==="\r")return M+1<b.length&&b.charAt(M+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=E;function w(S,b){return`\r
`.indexOf(S.charAt(b))!==-1}e.isEOL=w}),define(ee[108],te([0,1,44,107]),function(j,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(S,b,M){return C(S,b,void 0,M)}e.removeProperty=D;function C(S,b,M,y,f){const t=b.slice(),d=[],m=(0,p.parseTree)(S,d);let v,P;for(;t.length>0&&(P=t.pop(),v=(0,p.findNodeAtLocation)(m,t),v===void 0&&M!==void 0);)typeof P=="string"?M={[P]:M}:M=[M];if(v)if(v.type==="object"&&typeof P=="string"&&Array.isArray(v.children)){const u=(0,p.findNodeAtLocation)(v,[P]);if(u!==void 0)if(M===void 0){if(!u.parent)throw new Error("Malformed AST");const g=v.children.indexOf(u.parent);let c,o=u.parent.offset+u.parent.length;if(g>0){const l=v.children[g-1];c=l.offset+l.length}else c=v.offset+1,v.children.length>1&&(o=v.children[1].offset);return k(S,{offset:c,length:o-c,content:""},y)}else return k(S,{offset:u.offset,length:u.length,content:JSON.stringify(M)},y);else{if(M===void 0)return[];const g=`${JSON.stringify(P)}: ${JSON.stringify(M)}`,c=f?f(v.children.map(l=>l.children[0].value)):v.children.length;let o;if(c>0){const l=v.children[c-1];o={offset:l.offset+l.length,length:0,content:","+g}}else v.children.length===0?o={offset:v.offset+1,length:0,content:g}:o={offset:v.offset+1,length:0,content:g+","};return k(S,o,y)}}else if(v.type==="array"&&typeof P=="number"&&Array.isArray(v.children))if(M!==void 0){const u=`${JSON.stringify(M)}`;let g;if(v.children.length===0||P===0)g={offset:v.offset+1,length:0,content:v.children.length===0?u:u+","};else{const c=P===-1||P>v.children.length?v.children.length:P,o=v.children[c-1];g={offset:o.offset+o.length,length:0,content:","+u}}return k(S,g,y)}else{const u=P,g=v.children[u];let c;if(v.children.length===1)c={offset:v.offset+1,length:v.length-2,content:""};else if(v.children.length-1===u){const o=v.children[u-1],l=o.offset+o.length,s=v.offset+v.length;c={offset:l,length:s-2-l,content:""}}else c={offset:g.offset,length:v.children[u+1].offset-g.offset,content:""};return k(S,c,y)}else throw new Error(`Can not add ${typeof P!="number"?"index":"property"} to parent of type ${v.type}`);else{if(M===void 0)throw new Error("Can not delete in empty document");return k(S,{offset:m?m.offset:0,length:m?m.length:0,content:JSON.stringify(M)},y)}}e.setProperty=C;function k(S,b,M){let y=E(S,b),f=b.offset,t=b.offset+b.content.length;if(b.length===0||b.content.length===0){for(;f>0&&!(0,n.isEOL)(y,f-1);)f--;for(;t<y.length&&!(0,n.isEOL)(y,t);)t++}const d=(0,n.format)(y,{offset:f,length:t-f},M);for(let v=d.length-1;v>=0;v--){const P=d[v];y=E(y,P),f=Math.min(f,P.offset),t=Math.max(t,P.offset+P.length),t+=P.content.length-P.length}const m=S.length-(y.length-t)-f;return[{offset:f,length:m,content:y.substring(f,t)}]}e.withFormatting=k;function E(S,b){return S.substring(0,b.offset)+b.content+S.substring(b.offset+b.length)}e.applyEdit=E;function w(S,b){let M=b.slice(0).sort((f,t)=>{const d=f.offset-t.offset;return d===0?f.length-t.length:d}),y=S.length;for(let f=M.length-1;f>=0;f--){let t=M[f];if(t.offset+t.length<=y)S=E(S,t);else throw new Error("Overlapping edit");y=t.offset}return S}e.applyEdits=w}),define(ee[82],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=e.EVENT_KEY_CODE_MAP=e.ScanCode=e.KeyCode=void 0;var p;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.NumLock=78]="NumLock",t[t.ScrollLock=79]="ScrollLock",t[t.Semicolon=80]="Semicolon",t[t.Equal=81]="Equal",t[t.Comma=82]="Comma",t[t.Minus=83]="Minus",t[t.Period=84]="Period",t[t.Slash=85]="Slash",t[t.Backquote=86]="Backquote",t[t.BracketLeft=87]="BracketLeft",t[t.Backslash=88]="Backslash",t[t.BracketRight=89]="BracketRight",t[t.Quote=90]="Quote",t[t.OEM_8=91]="OEM_8",t[t.IntlBackslash=92]="IntlBackslash",t[t.Numpad0=93]="Numpad0",t[t.Numpad1=94]="Numpad1",t[t.Numpad2=95]="Numpad2",t[t.Numpad3=96]="Numpad3",t[t.Numpad4=97]="Numpad4",t[t.Numpad5=98]="Numpad5",t[t.Numpad6=99]="Numpad6",t[t.Numpad7=100]="Numpad7",t[t.Numpad8=101]="Numpad8",t[t.Numpad9=102]="Numpad9",t[t.NumpadMultiply=103]="NumpadMultiply",t[t.NumpadAdd=104]="NumpadAdd",t[t.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=106]="NumpadSubtract",t[t.NumpadDecimal=107]="NumpadDecimal",t[t.NumpadDivide=108]="NumpadDivide",t[t.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",t[t.ABNT_C1=110]="ABNT_C1",t[t.ABNT_C2=111]="ABNT_C2",t[t.AudioVolumeMute=112]="AudioVolumeMute",t[t.AudioVolumeUp=113]="AudioVolumeUp",t[t.AudioVolumeDown=114]="AudioVolumeDown",t[t.BrowserSearch=115]="BrowserSearch",t[t.BrowserHome=116]="BrowserHome",t[t.BrowserBack=117]="BrowserBack",t[t.BrowserForward=118]="BrowserForward",t[t.MediaTrackNext=119]="MediaTrackNext",t[t.MediaTrackPrevious=120]="MediaTrackPrevious",t[t.MediaStop=121]="MediaStop",t[t.MediaPlayPause=122]="MediaPlayPause",t[t.LaunchMediaPlayer=123]="LaunchMediaPlayer",t[t.LaunchMail=124]="LaunchMail",t[t.LaunchApp2=125]="LaunchApp2",t[t.MAX_VALUE=126]="MAX_VALUE"})(p=e.KeyCode||(e.KeyCode={}));var n;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.None=0]="None",t[t.Hyper=1]="Hyper",t[t.Super=2]="Super",t[t.Fn=3]="Fn",t[t.FnLock=4]="FnLock",t[t.Suspend=5]="Suspend",t[t.Resume=6]="Resume",t[t.Turbo=7]="Turbo",t[t.Sleep=8]="Sleep",t[t.WakeUp=9]="WakeUp",t[t.KeyA=10]="KeyA",t[t.KeyB=11]="KeyB",t[t.KeyC=12]="KeyC",t[t.KeyD=13]="KeyD",t[t.KeyE=14]="KeyE",t[t.KeyF=15]="KeyF",t[t.KeyG=16]="KeyG",t[t.KeyH=17]="KeyH",t[t.KeyI=18]="KeyI",t[t.KeyJ=19]="KeyJ",t[t.KeyK=20]="KeyK",t[t.KeyL=21]="KeyL",t[t.KeyM=22]="KeyM",t[t.KeyN=23]="KeyN",t[t.KeyO=24]="KeyO",t[t.KeyP=25]="KeyP",t[t.KeyQ=26]="KeyQ",t[t.KeyR=27]="KeyR",t[t.KeyS=28]="KeyS",t[t.KeyT=29]="KeyT",t[t.KeyU=30]="KeyU",t[t.KeyV=31]="KeyV",t[t.KeyW=32]="KeyW",t[t.KeyX=33]="KeyX",t[t.KeyY=34]="KeyY",t[t.KeyZ=35]="KeyZ",t[t.Digit1=36]="Digit1",t[t.Digit2=37]="Digit2",t[t.Digit3=38]="Digit3",t[t.Digit4=39]="Digit4",t[t.Digit5=40]="Digit5",t[t.Digit6=41]="Digit6",t[t.Digit7=42]="Digit7",t[t.Digit8=43]="Digit8",t[t.Digit9=44]="Digit9",t[t.Digit0=45]="Digit0",t[t.Enter=46]="Enter",t[t.Escape=47]="Escape",t[t.Backspace=48]="Backspace",t[t.Tab=49]="Tab",t[t.Space=50]="Space",t[t.Minus=51]="Minus",t[t.Equal=52]="Equal",t[t.BracketLeft=53]="BracketLeft",t[t.BracketRight=54]="BracketRight",t[t.Backslash=55]="Backslash",t[t.IntlHash=56]="IntlHash",t[t.Semicolon=57]="Semicolon",t[t.Quote=58]="Quote",t[t.Backquote=59]="Backquote",t[t.Comma=60]="Comma",t[t.Period=61]="Period",t[t.Slash=62]="Slash",t[t.CapsLock=63]="CapsLock",t[t.F1=64]="F1",t[t.F2=65]="F2",t[t.F3=66]="F3",t[t.F4=67]="F4",t[t.F5=68]="F5",t[t.F6=69]="F6",t[t.F7=70]="F7",t[t.F8=71]="F8",t[t.F9=72]="F9",t[t.F10=73]="F10",t[t.F11=74]="F11",t[t.F12=75]="F12",t[t.PrintScreen=76]="PrintScreen",t[t.ScrollLock=77]="ScrollLock",t[t.Pause=78]="Pause",t[t.Insert=79]="Insert",t[t.Home=80]="Home",t[t.PageUp=81]="PageUp",t[t.Delete=82]="Delete",t[t.End=83]="End",t[t.PageDown=84]="PageDown",t[t.ArrowRight=85]="ArrowRight",t[t.ArrowLeft=86]="ArrowLeft",t[t.ArrowDown=87]="ArrowDown",t[t.ArrowUp=88]="ArrowUp",t[t.NumLock=89]="NumLock",t[t.NumpadDivide=90]="NumpadDivide",t[t.NumpadMultiply=91]="NumpadMultiply",t[t.NumpadSubtract=92]="NumpadSubtract",t[t.NumpadAdd=93]="NumpadAdd",t[t.NumpadEnter=94]="NumpadEnter",t[t.Numpad1=95]="Numpad1",t[t.Numpad2=96]="Numpad2",t[t.Numpad3=97]="Numpad3",t[t.Numpad4=98]="Numpad4",t[t.Numpad5=99]="Numpad5",t[t.Numpad6=100]="Numpad6",t[t.Numpad7=101]="Numpad7",t[t.Numpad8=102]="Numpad8",t[t.Numpad9=103]="Numpad9",t[t.Numpad0=104]="Numpad0",t[t.NumpadDecimal=105]="NumpadDecimal",t[t.IntlBackslash=106]="IntlBackslash",t[t.ContextMenu=107]="ContextMenu",t[t.Power=108]="Power",t[t.NumpadEqual=109]="NumpadEqual",t[t.F13=110]="F13",t[t.F14=111]="F14",t[t.F15=112]="F15",t[t.F16=113]="F16",t[t.F17=114]="F17",t[t.F18=115]="F18",t[t.F19=116]="F19",t[t.F20=117]="F20",t[t.F21=118]="F21",t[t.F22=119]="F22",t[t.F23=120]="F23",t[t.F24=121]="F24",t[t.Open=122]="Open",t[t.Help=123]="Help",t[t.Select=124]="Select",t[t.Again=125]="Again",t[t.Undo=126]="Undo",t[t.Cut=127]="Cut",t[t.Copy=128]="Copy",t[t.Paste=129]="Paste",t[t.Find=130]="Find",t[t.AudioVolumeMute=131]="AudioVolumeMute",t[t.AudioVolumeUp=132]="AudioVolumeUp",t[t.AudioVolumeDown=133]="AudioVolumeDown",t[t.NumpadComma=134]="NumpadComma",t[t.IntlRo=135]="IntlRo",t[t.KanaMode=136]="KanaMode",t[t.IntlYen=137]="IntlYen",t[t.Convert=138]="Convert",t[t.NonConvert=139]="NonConvert",t[t.Lang1=140]="Lang1",t[t.Lang2=141]="Lang2",t[t.Lang3=142]="Lang3",t[t.Lang4=143]="Lang4",t[t.Lang5=144]="Lang5",t[t.Abort=145]="Abort",t[t.Props=146]="Props",t[t.NumpadParenLeft=147]="NumpadParenLeft",t[t.NumpadParenRight=148]="NumpadParenRight",t[t.NumpadBackspace=149]="NumpadBackspace",t[t.NumpadMemoryStore=150]="NumpadMemoryStore",t[t.NumpadMemoryRecall=151]="NumpadMemoryRecall",t[t.NumpadMemoryClear=152]="NumpadMemoryClear",t[t.NumpadMemoryAdd=153]="NumpadMemoryAdd",t[t.NumpadMemorySubtract=154]="NumpadMemorySubtract",t[t.NumpadClear=155]="NumpadClear",t[t.NumpadClearEntry=156]="NumpadClearEntry",t[t.ControlLeft=157]="ControlLeft",t[t.ShiftLeft=158]="ShiftLeft",t[t.AltLeft=159]="AltLeft",t[t.MetaLeft=160]="MetaLeft",t[t.ControlRight=161]="ControlRight",t[t.ShiftRight=162]="ShiftRight",t[t.AltRight=163]="AltRight",t[t.MetaRight=164]="MetaRight",t[t.BrightnessUp=165]="BrightnessUp",t[t.BrightnessDown=166]="BrightnessDown",t[t.MediaPlay=167]="MediaPlay",t[t.MediaRecord=168]="MediaRecord",t[t.MediaFastForward=169]="MediaFastForward",t[t.MediaRewind=170]="MediaRewind",t[t.MediaTrackNext=171]="MediaTrackNext",t[t.MediaTrackPrevious=172]="MediaTrackPrevious",t[t.MediaStop=173]="MediaStop",t[t.Eject=174]="Eject",t[t.MediaPlayPause=175]="MediaPlayPause",t[t.MediaSelect=176]="MediaSelect",t[t.LaunchMail=177]="LaunchMail",t[t.LaunchApp2=178]="LaunchApp2",t[t.LaunchApp1=179]="LaunchApp1",t[t.SelectTask=180]="SelectTask",t[t.LaunchScreenSaver=181]="LaunchScreenSaver",t[t.BrowserSearch=182]="BrowserSearch",t[t.BrowserHome=183]="BrowserHome",t[t.BrowserBack=184]="BrowserBack",t[t.BrowserForward=185]="BrowserForward",t[t.BrowserStop=186]="BrowserStop",t[t.BrowserRefresh=187]="BrowserRefresh",t[t.BrowserFavorites=188]="BrowserFavorites",t[t.ZoomToggle=189]="ZoomToggle",t[t.MailReply=190]="MailReply",t[t.MailForward=191]="MailForward",t[t.MailSend=192]="MailSend",t[t.MAX_VALUE=193]="MAX_VALUE"})(n=e.ScanCode||(e.ScanCode={}));class D{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(d,m){this._keyCodeToStr[d]=m,this._strToKeyCode[m.toLowerCase()]=d}keyCodeToStr(d){return this._keyCodeToStr[d]}strToKeyCode(d){return this._strToKeyCode[d.toLowerCase()]||0}}const C=new D,k=new D,E=new D;e.EVENT_KEY_CODE_MAP=new Array(230),e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const w=[],S=Object.create(null),b=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:t=>b[t]||0,toEnum:t=>S[t]||0,toString:t=>w[t]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let t=0;t<=193;t++)e.IMMUTABLE_CODE_TO_KEY_CODE[t]=-1;for(let t=0;t<=126;t++)e.IMMUTABLE_KEY_CODE_TO_CODE[t]=-1;(function(){const t="",d=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",t,t],[0,1,1,"Hyper",0,t,0,t,t,t],[0,1,2,"Super",0,t,0,t,t,t],[0,1,3,"Fn",0,t,0,t,t,t],[0,1,4,"FnLock",0,t,0,t,t,t],[0,1,5,"Suspend",0,t,0,t,t,t],[0,1,6,"Resume",0,t,0,t,t,t],[0,1,7,"Turbo",0,t,0,t,t,t],[0,1,8,"Sleep",0,t,0,"VK_SLEEP",t,t],[0,1,9,"WakeUp",0,t,0,t,t,t],[31,0,10,"KeyA",31,"A",65,"VK_A",t,t],[32,0,11,"KeyB",32,"B",66,"VK_B",t,t],[33,0,12,"KeyC",33,"C",67,"VK_C",t,t],[34,0,13,"KeyD",34,"D",68,"VK_D",t,t],[35,0,14,"KeyE",35,"E",69,"VK_E",t,t],[36,0,15,"KeyF",36,"F",70,"VK_F",t,t],[37,0,16,"KeyG",37,"G",71,"VK_G",t,t],[38,0,17,"KeyH",38,"H",72,"VK_H",t,t],[39,0,18,"KeyI",39,"I",73,"VK_I",t,t],[40,0,19,"KeyJ",40,"J",74,"VK_J",t,t],[41,0,20,"KeyK",41,"K",75,"VK_K",t,t],[42,0,21,"KeyL",42,"L",76,"VK_L",t,t],[43,0,22,"KeyM",43,"M",77,"VK_M",t,t],[44,0,23,"KeyN",44,"N",78,"VK_N",t,t],[45,0,24,"KeyO",45,"O",79,"VK_O",t,t],[46,0,25,"KeyP",46,"P",80,"VK_P",t,t],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",t,t],[48,0,27,"KeyR",48,"R",82,"VK_R",t,t],[49,0,28,"KeyS",49,"S",83,"VK_S",t,t],[50,0,29,"KeyT",50,"T",84,"VK_T",t,t],[51,0,30,"KeyU",51,"U",85,"VK_U",t,t],[52,0,31,"KeyV",52,"V",86,"VK_V",t,t],[53,0,32,"KeyW",53,"W",87,"VK_W",t,t],[54,0,33,"KeyX",54,"X",88,"VK_X",t,t],[55,0,34,"KeyY",55,"Y",89,"VK_Y",t,t],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",t,t],[22,0,36,"Digit1",22,"1",49,"VK_1",t,t],[23,0,37,"Digit2",23,"2",50,"VK_2",t,t],[24,0,38,"Digit3",24,"3",51,"VK_3",t,t],[25,0,39,"Digit4",25,"4",52,"VK_4",t,t],[26,0,40,"Digit5",26,"5",53,"VK_5",t,t],[27,0,41,"Digit6",27,"6",54,"VK_6",t,t],[28,0,42,"Digit7",28,"7",55,"VK_7",t,t],[29,0,43,"Digit8",29,"8",56,"VK_8",t,t],[30,0,44,"Digit9",30,"9",57,"VK_9",t,t],[21,0,45,"Digit0",21,"0",48,"VK_0",t,t],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",t,t],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",t,t],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",t,t],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",t,t],[10,1,50,"Space",10,"Space",32,"VK_SPACE",t,t],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,t,0,t,t,t],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",t,t],[59,1,64,"F1",59,"F1",112,"VK_F1",t,t],[60,1,65,"F2",60,"F2",113,"VK_F2",t,t],[61,1,66,"F3",61,"F3",114,"VK_F3",t,t],[62,1,67,"F4",62,"F4",115,"VK_F4",t,t],[63,1,68,"F5",63,"F5",116,"VK_F5",t,t],[64,1,69,"F6",64,"F6",117,"VK_F6",t,t],[65,1,70,"F7",65,"F7",118,"VK_F7",t,t],[66,1,71,"F8",66,"F8",119,"VK_F8",t,t],[67,1,72,"F9",67,"F9",120,"VK_F9",t,t],[68,1,73,"F10",68,"F10",121,"VK_F10",t,t],[69,1,74,"F11",69,"F11",122,"VK_F11",t,t],[70,1,75,"F12",70,"F12",123,"VK_F12",t,t],[0,1,76,"PrintScreen",0,t,0,t,t,t],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",t,t],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",t,t],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",t,t],[14,1,80,"Home",14,"Home",36,"VK_HOME",t,t],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",t,t],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",t,t],[13,1,83,"End",13,"End",35,"VK_END",t,t],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",t,t],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",t],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",t],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",t],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",t],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",t,t],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",t,t],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",t,t],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",t,t],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",t,t],[3,1,94,"NumpadEnter",3,t,0,t,t,t],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",t,t],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",t,t],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",t,t],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",t,t],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",t,t],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",t,t],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",t,t],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",t,t],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",t,t],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",t,t],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",t,t],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",t,t],[58,1,107,"ContextMenu",58,"ContextMenu",93,t,t,t],[0,1,108,"Power",0,t,0,t,t,t],[0,1,109,"NumpadEqual",0,t,0,t,t,t],[71,1,110,"F13",71,"F13",124,"VK_F13",t,t],[72,1,111,"F14",72,"F14",125,"VK_F14",t,t],[73,1,112,"F15",73,"F15",126,"VK_F15",t,t],[74,1,113,"F16",74,"F16",127,"VK_F16",t,t],[75,1,114,"F17",75,"F17",128,"VK_F17",t,t],[76,1,115,"F18",76,"F18",129,"VK_F18",t,t],[77,1,116,"F19",77,"F19",130,"VK_F19",t,t],[0,1,117,"F20",0,t,0,"VK_F20",t,t],[0,1,118,"F21",0,t,0,"VK_F21",t,t],[0,1,119,"F22",0,t,0,"VK_F22",t,t],[0,1,120,"F23",0,t,0,"VK_F23",t,t],[0,1,121,"F24",0,t,0,"VK_F24",t,t],[0,1,122,"Open",0,t,0,t,t,t],[0,1,123,"Help",0,t,0,t,t,t],[0,1,124,"Select",0,t,0,t,t,t],[0,1,125,"Again",0,t,0,t,t,t],[0,1,126,"Undo",0,t,0,t,t,t],[0,1,127,"Cut",0,t,0,t,t,t],[0,1,128,"Copy",0,t,0,t,t,t],[0,1,129,"Paste",0,t,0,t,t,t],[0,1,130,"Find",0,t,0,t,t,t],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",t,t],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",t,t],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",t,t],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",t,t],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",t,t],[0,1,136,"KanaMode",0,t,0,t,t,t],[0,0,137,"IntlYen",0,t,0,t,t,t],[0,1,138,"Convert",0,t,0,t,t,t],[0,1,139,"NonConvert",0,t,0,t,t,t],[0,1,140,"Lang1",0,t,0,t,t,t],[0,1,141,"Lang2",0,t,0,t,t,t],[0,1,142,"Lang3",0,t,0,t,t,t],[0,1,143,"Lang4",0,t,0,t,t,t],[0,1,144,"Lang5",0,t,0,t,t,t],[0,1,145,"Abort",0,t,0,t,t,t],[0,1,146,"Props",0,t,0,t,t,t],[0,1,147,"NumpadParenLeft",0,t,0,t,t,t],[0,1,148,"NumpadParenRight",0,t,0,t,t,t],[0,1,149,"NumpadBackspace",0,t,0,t,t,t],[0,1,150,"NumpadMemoryStore",0,t,0,t,t,t],[0,1,151,"NumpadMemoryRecall",0,t,0,t,t,t],[0,1,152,"NumpadMemoryClear",0,t,0,t,t,t],[0,1,153,"NumpadMemoryAdd",0,t,0,t,t,t],[0,1,154,"NumpadMemorySubtract",0,t,0,t,t,t],[0,1,155,"NumpadClear",0,t,0,t,t,t],[0,1,156,"NumpadClearEntry",0,t,0,t,t,t],[5,1,0,t,5,"Ctrl",17,"VK_CONTROL",t,t],[4,1,0,t,4,"Shift",16,"VK_SHIFT",t,t],[6,1,0,t,6,"Alt",18,"VK_MENU",t,t],[57,1,0,t,57,"Meta",0,"VK_COMMAND",t,t],[5,1,157,"ControlLeft",5,t,0,"VK_LCONTROL",t,t],[4,1,158,"ShiftLeft",4,t,0,"VK_LSHIFT",t,t],[6,1,159,"AltLeft",6,t,0,"VK_LMENU",t,t],[57,1,160,"MetaLeft",57,t,0,"VK_LWIN",t,t],[5,1,161,"ControlRight",5,t,0,"VK_RCONTROL",t,t],[4,1,162,"ShiftRight",4,t,0,"VK_RSHIFT",t,t],[6,1,163,"AltRight",6,t,0,"VK_RMENU",t,t],[57,1,164,"MetaRight",57,t,0,"VK_RWIN",t,t],[0,1,165,"BrightnessUp",0,t,0,t,t,t],[0,1,166,"BrightnessDown",0,t,0,t,t,t],[0,1,167,"MediaPlay",0,t,0,t,t,t],[0,1,168,"MediaRecord",0,t,0,t,t,t],[0,1,169,"MediaFastForward",0,t,0,t,t,t],[0,1,170,"MediaRewind",0,t,0,t,t,t],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",t,t],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",t,t],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",t,t],[0,1,174,"Eject",0,t,0,t,t,t],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",t,t],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",t,t],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",t,t],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",t,t],[0,1,179,"LaunchApp1",0,t,0,"VK_MEDIA_LAUNCH_APP1",t,t],[0,1,180,"SelectTask",0,t,0,t,t,t],[0,1,181,"LaunchScreenSaver",0,t,0,t,t,t],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",t,t],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",t,t],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",t,t],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",t,t],[0,1,186,"BrowserStop",0,t,0,"VK_BROWSER_STOP",t,t],[0,1,187,"BrowserRefresh",0,t,0,"VK_BROWSER_REFRESH",t,t],[0,1,188,"BrowserFavorites",0,t,0,"VK_BROWSER_FAVORITES",t,t],[0,1,189,"ZoomToggle",0,t,0,t,t,t],[0,1,190,"MailReply",0,t,0,t,t,t],[0,1,191,"MailForward",0,t,0,t,t,t],[0,1,192,"MailSend",0,t,0,t,t,t],[109,1,0,t,109,"KeyInComposition",229,t,t,t],[111,1,0,t,111,"ABNT_C2",194,"VK_ABNT_C2",t,t],[91,1,0,t,91,"OEM_8",223,"VK_OEM_8",t,t],[0,1,0,t,0,t,0,"VK_CLEAR",t,t],[0,1,0,t,0,t,0,"VK_KANA",t,t],[0,1,0,t,0,t,0,"VK_HANGUL",t,t],[0,1,0,t,0,t,0,"VK_JUNJA",t,t],[0,1,0,t,0,t,0,"VK_FINAL",t,t],[0,1,0,t,0,t,0,"VK_HANJA",t,t],[0,1,0,t,0,t,0,"VK_KANJI",t,t],[0,1,0,t,0,t,0,"VK_CONVERT",t,t],[0,1,0,t,0,t,0,"VK_NONCONVERT",t,t],[0,1,0,t,0,t,0,"VK_ACCEPT",t,t],[0,1,0,t,0,t,0,"VK_MODECHANGE",t,t],[0,1,0,t,0,t,0,"VK_SELECT",t,t],[0,1,0,t,0,t,0,"VK_PRINT",t,t],[0,1,0,t,0,t,0,"VK_EXECUTE",t,t],[0,1,0,t,0,t,0,"VK_SNAPSHOT",t,t],[0,1,0,t,0,t,0,"VK_HELP",t,t],[0,1,0,t,0,t,0,"VK_APPS",t,t],[0,1,0,t,0,t,0,"VK_PROCESSKEY",t,t],[0,1,0,t,0,t,0,"VK_PACKET",t,t],[0,1,0,t,0,t,0,"VK_DBE_SBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_DBE_DBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_ATTN",t,t],[0,1,0,t,0,t,0,"VK_CRSEL",t,t],[0,1,0,t,0,t,0,"VK_EXSEL",t,t],[0,1,0,t,0,t,0,"VK_EREOF",t,t],[0,1,0,t,0,t,0,"VK_PLAY",t,t],[0,1,0,t,0,t,0,"VK_ZOOM",t,t],[0,1,0,t,0,t,0,"VK_NONAME",t,t],[0,1,0,t,0,t,0,"VK_PA1",t,t],[0,1,0,t,0,t,0,"VK_OEM_CLEAR",t,t]];let m=[],v=[];for(const P of d){const[u,g,c,o,l,s,i,r,a,h]=P;if(v[c]||(v[c]=!0,w[c]=o,S[o]=c,b[o.toLowerCase()]=c,g&&(e.IMMUTABLE_CODE_TO_KEY_CODE[c]=l,l!==0&&l!==3&&l!==5&&l!==4&&l!==6&&l!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[l]=c))),!m[l]){if(m[l]=!0,!s)throw new Error(`String representation missing for key code ${l} around scan code ${o}`);C.define(l,s),k.define(l,a||s),E.define(l,h||a||s)}i&&(e.EVENT_KEY_CODE_MAP[i]=l),r&&(e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[r]=l)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var M;(function(t){function d(c){return C.keyCodeToStr(c)}t.toString=d;function m(c){return C.strToKeyCode(c)}t.fromString=m;function v(c){return k.keyCodeToStr(c)}t.toUserSettingsUS=v;function P(c){return E.keyCodeToStr(c)}t.toUserSettingsGeneral=P;function u(c){return k.strToKeyCode(c)||E.strToKeyCode(c)}t.fromUserSettings=u;function g(c){if(c>=93&&c<=108)return null;switch(c){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return C.keyCodeToStr(c)}t.toElectronAccelerator=g})(M=e.KeyCodeUtils||(e.KeyCodeUtils={}));var y;(function(t){t[t.CtrlCmd=2048]="CtrlCmd",t[t.Shift=1024]="Shift",t[t.Alt=512]="Alt",t[t.WinCtrl=256]="WinCtrl"})(y=e.KeyMod||(e.KeyMod={}));function f(t,d){const m=(d&65535)<<16>>>0;return(t|m)>>>0}e.KeyChord=f}),define(ee[59],te([0,1,15]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ScanCodeBinding=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=void 0;var n;(function(M){M[M.CtrlCmd=2048]="CtrlCmd",M[M.Shift=1024]="Shift",M[M.Alt=512]="Alt",M[M.WinCtrl=256]="WinCtrl",M[M.KeyCode=255]="KeyCode"})(n||(n={}));function D(M,y){if(M===0)return null;const f=(M&65535)>>>0,t=(M&4294901760)>>>16;return t!==0?new E([C(f,y),C(t,y)]):new E([C(f,y)])}e.createKeybinding=D;function C(M,y){const f=!!(M&2048),t=!!(M&256),d=y===2?t:f,m=!!(M&1024),v=!!(M&512),P=y===2?f:t,u=M&255;return new k(d,m,v,P,u)}e.createSimpleKeybinding=C;class k{constructor(y,f,t,d,m){this.ctrlKey=y,this.shiftKey=f,this.altKey=t,this.metaKey=d,this.keyCode=m}equals(y){return this.ctrlKey===y.ctrlKey&&this.shiftKey===y.shiftKey&&this.altKey===y.altKey&&this.metaKey===y.metaKey&&this.keyCode===y.keyCode}getHashCode(){const y=this.ctrlKey?"1":"0",f=this.shiftKey?"1":"0",t=this.altKey?"1":"0",d=this.metaKey?"1":"0";return`${y}${f}${t}${d}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new E([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=k;class E{constructor(y){if(y.length===0)throw(0,p.illegalArgument)("parts");this.parts=y}getHashCode(){let y="";for(let f=0,t=this.parts.length;f<t;f++)f!==0&&(y+=";"),y+=this.parts[f].getHashCode();return y}equals(y){if(y===null||this.parts.length!==y.parts.length)return!1;for(let f=0;f<this.parts.length;f++)if(!this.parts[f].equals(y.parts[f]))return!1;return!0}}e.ChordKeybinding=E;class w{constructor(y,f,t,d,m){this.ctrlKey=y,this.shiftKey=f,this.altKey=t,this.metaKey=d,this.scanCode=m}equals(y){return this.ctrlKey===y.ctrlKey&&this.shiftKey===y.shiftKey&&this.altKey===y.altKey&&this.metaKey===y.metaKey&&this.scanCode===y.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=w;class S{constructor(y,f,t,d,m,v){this.ctrlKey=y,this.shiftKey=f,this.altKey=t,this.metaKey=d,this.keyLabel=m,this.keyAriaLabel=v}}e.ResolvedKeybindingPart=S;class b{}e.ResolvedKeybinding=b}),define(ee[109],te([0,1,82,59]),function(j,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class D{static _readModifiers(k){k=k.toLowerCase().trim();let E=!1,w=!1,S=!1,b=!1,M;do M=!1,/^ctrl(\+|\-)/.test(k)&&(E=!0,k=k.substr("ctrl-".length),M=!0),/^shift(\+|\-)/.test(k)&&(w=!0,k=k.substr("shift-".length),M=!0),/^alt(\+|\-)/.test(k)&&(S=!0,k=k.substr("alt-".length),M=!0),/^meta(\+|\-)/.test(k)&&(b=!0,k=k.substr("meta-".length),M=!0),/^win(\+|\-)/.test(k)&&(b=!0,k=k.substr("win-".length),M=!0),/^cmd(\+|\-)/.test(k)&&(b=!0,k=k.substr("cmd-".length),M=!0);while(M);let y;const f=k.indexOf(" ");return f>0?(y=k.substring(0,f),k=k.substring(f)):(y=k,k=""),{remains:k,ctrl:E,shift:w,alt:S,meta:b,key:y}}static parseSimpleKeybinding(k){const E=this._readModifiers(k),w=p.KeyCodeUtils.fromUserSettings(E.key);return[new n.SimpleKeybinding(E.ctrl,E.shift,E.alt,E.meta,w),E.remains]}static parseKeybinding(k,E){if(!k)return null;const w=[];let S;do[S,k]=this.parseSimpleKeybinding(k),w.push(S);while(k.length>0);return new n.ChordKeybinding(w)}static parseSimpleUserBinding(k){const E=this._readModifiers(k),w=E.key.match(/^\[([^\]]+)\]$/);if(w){const b=w[1],M=p.ScanCodeUtils.lowerCaseToEnum(b);return[new n.ScanCodeBinding(E.ctrl,E.shift,E.alt,E.meta,M),E.remains]}const S=p.KeyCodeUtils.fromUserSettings(E.key);return[new n.SimpleKeybinding(E.ctrl,E.shift,E.alt,E.meta,S),E.remains]}static parseUserBinding(k){if(!k)return[];const E=[];let w;for(;k.length>0;)[w,k]=this.parseSimpleUserBinding(k),E.push(w);return E}}e.KeybindingParser=D}),define(ee[110],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class p{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new p(()=>D(this.getValue()))}}e.Lazy=p}),define(ee[2],te([0,1,43,70]),function(j,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let C=null;function k(i){C=i}if(e.setDisposableTracker=k,D){const i="__is_disposable_tracked__";k(new class{trackDisposable(r){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[i]||console.log(a)},3e3)}setParent(r,a){if(r&&r!==P.None)try{r[i]=!0}catch{}}markAsDisposed(r){if(r&&r!==P.None)try{r[i]=!0}catch{}}markAsSingleton(r){}})}function E(i){return C?.trackDisposable(i),i}function w(i){C?.markAsDisposed(i)}function S(i,r){C?.setParent(i,r)}function b(i,r){if(!!C)for(const a of i)C.setParent(a,r)}function M(i){return C?.markAsSingleton(i),i}e.markAsSingleton=M;class y extends Error{constructor(r){super(`Encountered errors while disposing of store. Errors: [${r.join(", ")}]`);this.errors=r}}e.MultiDisposeError=y;function f(i){return typeof i.dispose=="function"&&i.dispose.length===0}e.isDisposable=f;function t(i){if(n.Iterable.is(i)){let r=[];for(const a of i)if(a)try{a.dispose()}catch(h){r.push(h)}if(r.length===1)throw r[0];if(r.length>1)throw new y(r);return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}e.dispose=t;function d(...i){const r=m(()=>t(i));return b(i,r),r}e.combinedDisposable=d;function m(i){const r=E({dispose:(0,p.once)(()=>{w(r),i()})});return r}e.toDisposable=m;class v{constructor(){this._toDispose=new Set,this._isDisposed=!1,E(this)}dispose(){this._isDisposed||(w(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{t(this._toDispose.values())}finally{this._toDispose.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return S(r,this),this._isDisposed?v.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(r),r}}e.DisposableStore=v,v.DISABLE_DISPOSED_WARNING=!1;class P{constructor(){this._store=new v,E(this),S(this._store,this)}dispose(){w(this),this._store.dispose()}_register(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(r)}}e.Disposable=P,P.None=Object.freeze({dispose(){}});class u{constructor(){this._isDisposed=!1,E(this)}get value(){return this._isDisposed?void 0:this._value}set value(r){this._isDisposed||r===this._value||(this._value?.dispose(),r&&S(r,this),this._value=r)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,w(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const r=this._value;return this._value=void 0,r&&S(r,null),r}}e.MutableDisposable=u;class g{constructor(r){this._disposable=r,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=g;class c{constructor(){this.references=new Map}acquire(r,...a){let h=this.references.get(r);h||(h={counter:0,object:this.createReferencedObject(r,...a)},this.references.set(r,h));const{object:I}=h,R=(0,p.once)(()=>{--h.counter==0&&(this.destroyReferencedObject(r,h.object),this.references.delete(r))});return h.counter++,{object:I,dispose:R}}}e.ReferenceCollection=c;class o{constructor(r){this.referenceCollection=r}async acquire(r,...a){const h=this.referenceCollection.acquire(r,...a);try{return{object:await h.object,dispose:()=>h.dispose()}}catch(I){throw h.dispose(),I}}}e.AsyncReferenceCollection=o;class l{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=l;function s(i){const r=new v;try{i(r)}finally{r.dispose()}}e.disposeOnReturn=s}),define(ee[111],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class p{constructor(C){this.element=C,this.next=p.Undefined,this.prev=p.Undefined}}p.Undefined=new p(void 0);class n{constructor(){this._first=p.Undefined,this._last=p.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===p.Undefined}clear(){let C=this._first;for(;C!==p.Undefined;){const k=C.next;C.prev=p.Undefined,C.next=p.Undefined,C=k}this._first=p.Undefined,this._last=p.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,k){const E=new p(C);if(this._first===p.Undefined)this._first=E,this._last=E;else if(k){const S=this._last;this._last=E,E.prev=S,S.next=E}else{const S=this._first;this._first=E,E.next=S,S.prev=E}this._size+=1;let w=!1;return()=>{w||(w=!0,this._remove(E))}}shift(){if(this._first!==p.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==p.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==p.Undefined&&C.next!==p.Undefined){const k=C.prev;k.next=C.next,C.next.prev=k}else C.prev===p.Undefined&&C.next===p.Undefined?(this._first=p.Undefined,this._last=p.Undefined):C.next===p.Undefined?(this._last=this._last.prev,this._last.next=p.Undefined):C.prev===p.Undefined&&(this._first=this._first.next,this._first.prev=p.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==p.Undefined;)yield C.element,C=C.next}}e.LinkedList=n}),function(){function j(D){const C=[];typeof D=="number"&&C.push("code/timeOrigin",D);function k(w){C.push(w,Date.now())}function E(){const w=[];for(let S=0;S<C.length;S+=2)w.push({name:C[S],startTime:C[S+1]});return w}return{mark:k,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?j():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const k of performance.getEntriesByType("mark"))C.push({name:k.name,startTime:Math.round(D+k.startTime)});return C}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return j(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),j()}function p(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return p(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=p(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=p(n))}(),define(ee[3],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const p="en";let n=!1,D=!1,C=!1,k=!1,E=!1,w=!1,S=!1,b=!1,M,y=p,f,t;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?d=e.globals.vscode.process:typeof process!="undefined"&&(d=process);const m=typeof d?.versions?.electron=="string",v=m&&d?.type==="renderer";if(e.isElectronSandboxed=v&&d?.sandboxed,typeof navigator=="object"&&!v)t=navigator.userAgent,n=t.indexOf("Windows")>=0,D=t.indexOf("Macintosh")>=0,b=(t.indexOf("Macintosh")>=0||t.indexOf("iPad")>=0||t.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=t.indexOf("Linux")>=0,w=!0,M=navigator.language,y=M;else if(typeof d=="object"){n=d.platform==="win32",D=d.platform==="darwin",C=d.platform==="linux",k=C&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,S=m,M=p,y=p;const r=d.env.VSCODE_NLS_CONFIG;if(r)try{const a=JSON.parse(r),h=a.availableLanguages["*"];M=a.locale,y=h||p,f=a._translationsConfigFile}catch{}E=!0}else console.error("Unable to resolve platform.");var P;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(P=e.Platform||(e.Platform={}));function u(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=u;let g=0;D?g=1:n?g=3:C&&(g=2),e.isWindows=n,e.isMacintosh=D,e.isLinux=C,e.isLinuxSnap=k,e.isNative=E,e.isElectron=S,e.isWeb=w,e.isIOS=b,e.platform=g,e.userAgent=t,e.language=y;var c;(function(r){function a(){return e.language}r.value=a;function h(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=h;function I(){return e.language==="en"}r.isDefault=I})(c=e.Language||(e.Language={})),e.locale=M,e.translationsConfigFile=f,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let r=[];e.globals.addEventListener("message",h=>{if(h.data&&h.data.vscodeScheduleAsyncWork)for(let I=0,R=r.length;I<R;I++){const L=r[I];if(L.id===h.data.vscodeScheduleAsyncWork){r.splice(I,1),L.callback();return}}});let a=0;return h=>{const I=++a;r.push({id:I,callback:h}),e.globals.postMessage({vscodeScheduleAsyncWork:I},"*")}}return r=>setTimeout(r)})();var o;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||b?2:n?1:3;let l=!0,s=!1;function i(){if(!s){s=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,l=new Uint16Array(r.buffer)[0]===(2<<8)+1}return l}e.isLittleEndian=i,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ee[35],te([0,1,3]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof p.globals.vscode!="undefined"&&typeof p.globals.vscode.process!="undefined"){const D=p.globals.vscode.process;n={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process!="undefined"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return p.isWindows?"win32":p.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(ee[9],te([0,1,35]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,D=97,C=90,k=122,E=46,w=47,S=92,b=58,M=63;class y extends Error{constructor(g,c,o){let l;typeof c=="string"&&c.indexOf("not ")===0?(l="must not be",c=c.replace(/^not /,"")):l="must be";const s=g.indexOf(".")!==-1?"property":"argument";let i=`The "${g}" ${s} ${l} of type ${c}`;i+=`. Received type ${typeof o}`;super(i);this.code="ERR_INVALID_ARG_TYPE"}}function f(u,g){if(typeof u!="string")throw new y(g,"string",u)}function t(u){return u===w||u===S}function d(u){return u===w}function m(u){return u>=n&&u<=C||u>=D&&u<=k}function v(u,g,c,o){let l="",s=0,i=-1,r=0,a=0;for(let h=0;h<=u.length;++h){if(h<u.length)a=u.charCodeAt(h);else{if(o(a))break;a=w}if(o(a)){if(!(i===h-1||r===1))if(r===2){if(l.length<2||s!==2||l.charCodeAt(l.length-1)!==E||l.charCodeAt(l.length-2)!==E){if(l.length>2){const I=l.lastIndexOf(c);I===-1?(l="",s=0):(l=l.slice(0,I),s=l.length-1-l.lastIndexOf(c)),i=h,r=0;continue}else if(l.length!==0){l="",s=0,i=h,r=0;continue}}g&&(l+=l.length>0?`${c}..`:"..",s=2)}else l.length>0?l+=`${c}${u.slice(i+1,h)}`:l=u.slice(i+1,h),s=h-i-1;i=h,r=0}else a===E&&r!==-1?++r:r=-1}return l}function P(u,g){if(g===null||typeof g!="object")throw new y("pathObject","Object",g);const c=g.dir||g.root,o=g.base||`${g.name||""}${g.ext||""}`;return c?c===g.root?`${c}${o}`:`${c}${u}${o}`:o}e.win32={resolve(...u){let g="",c="",o=!1;for(let l=u.length-1;l>=-1;l--){let s;if(l>=0){if(s=u[l],f(s,"path"),s.length===0)continue}else g.length===0?s=p.cwd():(s=p.env[`=${g}`]||p.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==g.toLowerCase()&&s.charCodeAt(2)===S)&&(s=`${g}\\`));const i=s.length;let r=0,a="",h=!1;const I=s.charCodeAt(0);if(i===1)t(I)&&(r=1,h=!0);else if(t(I))if(h=!0,t(s.charCodeAt(1))){let R=2,L=R;for(;R<i&&!t(s.charCodeAt(R));)R++;if(R<i&&R!==L){const T=s.slice(L,R);for(L=R;R<i&&t(s.charCodeAt(R));)R++;if(R<i&&R!==L){for(L=R;R<i&&!t(s.charCodeAt(R));)R++;(R===i||R!==L)&&(a=`\\\\${T}\\${s.slice(L,R)}`,r=R)}}}else r=1;else m(I)&&s.charCodeAt(1)===b&&(a=s.slice(0,2),r=2,i>2&&t(s.charCodeAt(2))&&(h=!0,r=3));if(a.length>0)if(g.length>0){if(a.toLowerCase()!==g.toLowerCase())continue}else g=a;if(o){if(g.length>0)break}else if(c=`${s.slice(r)}\\${c}`,o=h,h&&g.length>0)break}return c=v(c,!o,"\\",t),o?`${g}\\${c}`:`${g}${c}`||"."},normalize(u){f(u,"path");const g=u.length;if(g===0)return".";let c=0,o,l=!1;const s=u.charCodeAt(0);if(g===1)return d(s)?"\\":u;if(t(s))if(l=!0,t(u.charCodeAt(1))){let r=2,a=r;for(;r<g&&!t(u.charCodeAt(r));)r++;if(r<g&&r!==a){const h=u.slice(a,r);for(a=r;r<g&&t(u.charCodeAt(r));)r++;if(r<g&&r!==a){for(a=r;r<g&&!t(u.charCodeAt(r));)r++;if(r===g)return`\\\\${h}\\${u.slice(a)}\\`;r!==a&&(o=`\\\\${h}\\${u.slice(a,r)}`,c=r)}}}else c=1;else m(s)&&u.charCodeAt(1)===b&&(o=u.slice(0,2),c=2,g>2&&t(u.charCodeAt(2))&&(l=!0,c=3));let i=c<g?v(u.slice(c),!l,"\\",t):"";return i.length===0&&!l&&(i="."),i.length>0&&t(u.charCodeAt(g-1))&&(i+="\\"),o===void 0?l?`\\${i}`:i:l?`${o}\\${i}`:`${o}${i}`},isAbsolute(u){f(u,"path");const g=u.length;if(g===0)return!1;const c=u.charCodeAt(0);return t(c)||g>2&&m(c)&&u.charCodeAt(1)===b&&t(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let g,c;for(let s=0;s<u.length;++s){const i=u[s];f(i,"path"),i.length>0&&(g===void 0?g=c=i:g+=`\\${i}`)}if(g===void 0)return".";let o=!0,l=0;if(typeof c=="string"&&t(c.charCodeAt(0))){++l;const s=c.length;s>1&&t(c.charCodeAt(1))&&(++l,s>2&&(t(c.charCodeAt(2))?++l:o=!1))}if(o){for(;l<g.length&&t(g.charCodeAt(l));)l++;l>=2&&(g=`\\${g.slice(l)}`)}return e.win32.normalize(g)},relative(u,g){if(f(u,"from"),f(g,"to"),u===g)return"";const c=e.win32.resolve(u),o=e.win32.resolve(g);if(c===o||(u=c.toLowerCase(),g=o.toLowerCase(),u===g))return"";let l=0;for(;l<u.length&&u.charCodeAt(l)===S;)l++;let s=u.length;for(;s-1>l&&u.charCodeAt(s-1)===S;)s--;const i=s-l;let r=0;for(;r<g.length&&g.charCodeAt(r)===S;)r++;let a=g.length;for(;a-1>r&&g.charCodeAt(a-1)===S;)a--;const h=a-r,I=i<h?i:h;let R=-1,L=0;for(;L<I;L++){const $=u.charCodeAt(l+L);if($!==g.charCodeAt(r+L))break;$===S&&(R=L)}if(L!==I){if(R===-1)return o}else{if(h>I){if(g.charCodeAt(r+L)===S)return o.slice(r+L+1);if(L===2)return o.slice(r+L)}i>I&&(u.charCodeAt(l+L)===S?R=L:L===2&&(R=3)),R===-1&&(R=0)}let T="";for(L=l+R+1;L<=s;++L)(L===s||u.charCodeAt(L)===S)&&(T+=T.length===0?"..":"\\..");return r+=R,T.length>0?`${T}${o.slice(r,a)}`:(o.charCodeAt(r)===S&&++r,o.slice(r,a))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const g=e.win32.resolve(u);if(g.length<=2)return u;if(g.charCodeAt(0)===S){if(g.charCodeAt(1)===S){const c=g.charCodeAt(2);if(c!==M&&c!==E)return`\\\\?\\UNC\\${g.slice(2)}`}}else if(m(g.charCodeAt(0))&&g.charCodeAt(1)===b&&g.charCodeAt(2)===S)return`\\\\?\\${g}`;return u},dirname(u){f(u,"path");const g=u.length;if(g===0)return".";let c=-1,o=0;const l=u.charCodeAt(0);if(g===1)return t(l)?u:".";if(t(l)){if(c=o=1,t(u.charCodeAt(1))){let r=2,a=r;for(;r<g&&!t(u.charCodeAt(r));)r++;if(r<g&&r!==a){for(a=r;r<g&&t(u.charCodeAt(r));)r++;if(r<g&&r!==a){for(a=r;r<g&&!t(u.charCodeAt(r));)r++;if(r===g)return u;r!==a&&(c=o=r+1)}}}}else m(l)&&u.charCodeAt(1)===b&&(c=g>2&&t(u.charCodeAt(2))?3:2,o=c);let s=-1,i=!0;for(let r=g-1;r>=o;--r)if(t(u.charCodeAt(r))){if(!i){s=r;break}}else i=!1;if(s===-1){if(c===-1)return".";s=c}return u.slice(0,s)},basename(u,g){g!==void 0&&f(g,"ext"),f(u,"path");let c=0,o=-1,l=!0,s;if(u.length>=2&&m(u.charCodeAt(0))&&u.charCodeAt(1)===b&&(c=2),g!==void 0&&g.length>0&&g.length<=u.length){if(g===u)return"";let i=g.length-1,r=-1;for(s=u.length-1;s>=c;--s){const a=u.charCodeAt(s);if(t(a)){if(!l){c=s+1;break}}else r===-1&&(l=!1,r=s+1),i>=0&&(a===g.charCodeAt(i)?--i==-1&&(o=s):(i=-1,o=r))}return c===o?o=r:o===-1&&(o=u.length),u.slice(c,o)}for(s=u.length-1;s>=c;--s)if(t(u.charCodeAt(s))){if(!l){c=s+1;break}}else o===-1&&(l=!1,o=s+1);return o===-1?"":u.slice(c,o)},extname(u){f(u,"path");let g=0,c=-1,o=0,l=-1,s=!0,i=0;u.length>=2&&u.charCodeAt(1)===b&&m(u.charCodeAt(0))&&(g=o=2);for(let r=u.length-1;r>=g;--r){const a=u.charCodeAt(r);if(t(a)){if(!s){o=r+1;break}continue}l===-1&&(s=!1,l=r+1),a===E?c===-1?c=r:i!==1&&(i=1):c!==-1&&(i=-1)}return c===-1||l===-1||i===0||i===1&&c===l-1&&c===o+1?"":u.slice(c,l)},format:P.bind(null,"\\"),parse(u){f(u,"path");const g={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return g;const c=u.length;let o=0,l=u.charCodeAt(0);if(c===1)return t(l)?(g.root=g.dir=u,g):(g.base=g.name=u,g);if(t(l)){if(o=1,t(u.charCodeAt(1))){let R=2,L=R;for(;R<c&&!t(u.charCodeAt(R));)R++;if(R<c&&R!==L){for(L=R;R<c&&t(u.charCodeAt(R));)R++;if(R<c&&R!==L){for(L=R;R<c&&!t(u.charCodeAt(R));)R++;R===c?o=R:R!==L&&(o=R+1)}}}}else if(m(l)&&u.charCodeAt(1)===b){if(c<=2)return g.root=g.dir=u,g;if(o=2,t(u.charCodeAt(2))){if(c===3)return g.root=g.dir=u,g;o=3}}o>0&&(g.root=u.slice(0,o));let s=-1,i=o,r=-1,a=!0,h=u.length-1,I=0;for(;h>=o;--h){if(l=u.charCodeAt(h),t(l)){if(!a){i=h+1;break}continue}r===-1&&(a=!1,r=h+1),l===E?s===-1?s=h:I!==1&&(I=1):s!==-1&&(I=-1)}return r!==-1&&(s===-1||I===0||I===1&&s===r-1&&s===i+1?g.base=g.name=u.slice(i,r):(g.name=u.slice(i,s),g.base=u.slice(i,r),g.ext=u.slice(s,r))),i>0&&i!==o?g.dir=u.slice(0,i-1):g.dir=g.root,g},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let g="",c=!1;for(let o=u.length-1;o>=-1&&!c;o--){const l=o>=0?u[o]:p.cwd();f(l,"path"),l.length!==0&&(g=`${l}/${g}`,c=l.charCodeAt(0)===w)}return g=v(g,!c,"/",d),c?`/${g}`:g.length>0?g:"."},normalize(u){if(f(u,"path"),u.length===0)return".";const g=u.charCodeAt(0)===w,c=u.charCodeAt(u.length-1)===w;return u=v(u,!g,"/",d),u.length===0?g?"/":c?"./":".":(c&&(u+="/"),g?`/${u}`:u)},isAbsolute(u){return f(u,"path"),u.length>0&&u.charCodeAt(0)===w},join(...u){if(u.length===0)return".";let g;for(let c=0;c<u.length;++c){const o=u[c];f(o,"path"),o.length>0&&(g===void 0?g=o:g+=`/${o}`)}return g===void 0?".":e.posix.normalize(g)},relative(u,g){if(f(u,"from"),f(g,"to"),u===g||(u=e.posix.resolve(u),g=e.posix.resolve(g),u===g))return"";const c=1,o=u.length,l=o-c,s=1,i=g.length-s,r=l<i?l:i;let a=-1,h=0;for(;h<r;h++){const R=u.charCodeAt(c+h);if(R!==g.charCodeAt(s+h))break;R===w&&(a=h)}if(h===r)if(i>r){if(g.charCodeAt(s+h)===w)return g.slice(s+h+1);if(h===0)return g.slice(s+h)}else l>r&&(u.charCodeAt(c+h)===w?a=h:h===0&&(a=0));let I="";for(h=c+a+1;h<=o;++h)(h===o||u.charCodeAt(h)===w)&&(I+=I.length===0?"..":"/..");return`${I}${g.slice(s+a)}`},toNamespacedPath(u){return u},dirname(u){if(f(u,"path"),u.length===0)return".";const g=u.charCodeAt(0)===w;let c=-1,o=!0;for(let l=u.length-1;l>=1;--l)if(u.charCodeAt(l)===w){if(!o){c=l;break}}else o=!1;return c===-1?g?"/":".":g&&c===1?"//":u.slice(0,c)},basename(u,g){g!==void 0&&f(g,"ext"),f(u,"path");let c=0,o=-1,l=!0,s;if(g!==void 0&&g.length>0&&g.length<=u.length){if(g===u)return"";let i=g.length-1,r=-1;for(s=u.length-1;s>=0;--s){const a=u.charCodeAt(s);if(a===w){if(!l){c=s+1;break}}else r===-1&&(l=!1,r=s+1),i>=0&&(a===g.charCodeAt(i)?--i==-1&&(o=s):(i=-1,o=r))}return c===o?o=r:o===-1&&(o=u.length),u.slice(c,o)}for(s=u.length-1;s>=0;--s)if(u.charCodeAt(s)===w){if(!l){c=s+1;break}}else o===-1&&(l=!1,o=s+1);return o===-1?"":u.slice(c,o)},extname(u){f(u,"path");let g=-1,c=0,o=-1,l=!0,s=0;for(let i=u.length-1;i>=0;--i){const r=u.charCodeAt(i);if(r===w){if(!l){c=i+1;break}continue}o===-1&&(l=!1,o=i+1),r===E?g===-1?g=i:s!==1&&(s=1):g!==-1&&(s=-1)}return g===-1||o===-1||s===0||s===1&&g===o-1&&g===c+1?"":u.slice(g,o)},format:P.bind(null,"/"),parse(u){f(u,"path");const g={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return g;const c=u.charCodeAt(0)===w;let o;c?(g.root="/",o=1):o=0;let l=-1,s=0,i=-1,r=!0,a=u.length-1,h=0;for(;a>=o;--a){const I=u.charCodeAt(a);if(I===w){if(!r){s=a+1;break}continue}i===-1&&(r=!1,i=a+1),I===E?l===-1?l=a:h!==1&&(h=1):l!==-1&&(h=-1)}if(i!==-1){const I=s===0&&c?1:s;l===-1||h===0||h===1&&l===i-1&&l===s+1?g.base=g.name=u.slice(I,i):(g.name=u.slice(I,l),g.base=u.slice(I,i),g.ext=u.slice(l,i))}return s>0?g.dir=u.slice(0,s-1):c&&(g.dir="/"),g},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=p.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p.platform==="win32"?e.win32.join:e.posix.join,e.resolve=p.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=p.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=p.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=p.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=p.platform==="win32"?e.win32.extname:e.posix.extname,e.format=p.platform==="win32"?e.win32.format:e.posix.format,e.parse=p.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=p.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=p.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ee[83],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var p;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(p=e.Source||(e.Source={}));var n;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(n=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(C,...k){const E=k.reduce((b,M)=>(b[M]=!0,b),{}),w=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(b=>!E[b]).forEach(b=>{for(let M=0;M<w.length;M++)if(b.search(w[M])!==-1){delete C[b];break}})}e.sanitizeProcessEnvironment=D}),define(ee[84],te([0,1,3]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=p.globals.performance&&typeof p.globals.performance.now=="function";class D{constructor(k){this._highResolution=n&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new D(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?p.globals.performance.now():Date.now()}}e.StopWatch=D}),define(ee[4],te([0,1,15,43,2,111,84]),function(j,e,p,n,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var E;(function(g){g.None=()=>D.Disposable.None;function c(x){return(B,z=null,G)=>{let q=!1,W;return W=x(N=>{if(!q)return W?W.dispose():q=!0,B.call(z,N)},null,G),q&&W.dispose(),W}}g.once=c;function o(x,B){return h((z,G=null,q)=>x(W=>z.call(G,B(W)),null,q))}g.map=o;function l(x,B){return h((z,G=null,q)=>x(W=>{B(W),z.call(G,W)},null,q))}g.forEach=l;function s(x,B){return h((z,G=null,q)=>x(W=>B(W)&&z.call(G,W),null,q))}g.filter=s;function i(x){return x}g.signal=i;function r(...x){return(B,z=null,G)=>(0,D.combinedDisposable)(...x.map(q=>q(W=>B.call(z,W),null,G)))}g.any=r;function a(x,B,z){let G=z;return o(x,q=>(G=B(G,q),G))}g.reduce=a;function h(x){let B;const z=new y({onFirstListenerAdd(){B=x(z.fire,z)},onLastListenerRemove(){B.dispose()}});return z.event}function I(x,B,z,G=100,q=!1){let W,N,F=0;return x(A=>{F++,W=z(W,A),q&&!N&&(B(W),W=void 0),clearTimeout(N),N=setTimeout(()=>{const U=W;W=void 0,N=void 0,(!q||F>1)&&B(U),F=0},G)})}g.debouncedListener=I;function R(x,B,z=100,G=!1,q){let W,N,F,A=0;const U=new y({leakWarningThreshold:q,onFirstListenerAdd(){W=x(O=>{A++,N=B(N,O),G&&!F&&(U.fire(N),N=void 0),clearTimeout(F),F=setTimeout(()=>{const _=N;N=void 0,F=void 0,(!G||A>1)&&U.fire(_),A=0},z)})},onLastListenerRemove(){W.dispose()}});return U.event}g.debounce=R;function L(x,B=(z,G)=>z===G){let z=!0,G;return s(x,q=>{const W=z||!B(q,G);return z=!1,G=q,W})}g.latch=L;function T(x,B){return[g.filter(x,B),g.filter(x,z=>!B(z))]}g.split=T;function $(x,B=!1,z=[]){let G=z.slice(),q=x(F=>{G?G.push(F):N.fire(F)});const W=()=>{G&&G.forEach(F=>N.fire(F)),G=null},N=new y({onFirstListenerAdd(){q||(q=x(F=>N.fire(F)))},onFirstListenerDidAdd(){G&&(B?setTimeout(W):W())},onLastListenerRemove(){q&&q.dispose(),q=null}});return N.event}g.buffer=$;class Q{constructor(B){this.event=B}map(B){return new Q(o(this.event,B))}forEach(B){return new Q(l(this.event,B))}filter(B){return new Q(s(this.event,B))}reduce(B,z){return new Q(a(this.event,B,z))}latch(){return new Q(L(this.event))}debounce(B,z=100,G=!1,q){return new Q(R(this.event,B,z,G,q))}on(B,z,G){return this.event(B,z,G)}once(B,z,G){return c(this.event)(B,z,G)}}function se(x){return new Q(x)}g.chain=se;function re(x,B,z=G=>G){const G=(...F)=>N.fire(z(...F)),q=()=>x.on(B,G),W=()=>x.removeListener(B,G),N=new y({onFirstListenerAdd:q,onLastListenerRemove:W});return N.event}g.fromNodeEventEmitter=re;function V(x,B,z=G=>G){const G=(...F)=>N.fire(z(...F)),q=()=>x.addEventListener(B,G),W=()=>x.removeEventListener(B,G),N=new y({onFirstListenerAdd:q,onLastListenerRemove:W});return N.event}g.fromDOMEventEmitter=V;function Z(x){return new Promise(B=>c(x)(B))}g.toPromise=Z;function H(x,B){return B(void 0),x(z=>B(z))}g.runAndSubscribe=H;function K(x,B){let z=null;function G(W){z?.dispose(),z=new D.DisposableStore,B(W,z)}G(void 0);const q=x(W=>G(W));return(0,D.toDisposable)(()=>{q.dispose(),z?.dispose()})}g.runAndSubscribeWithStore=K})(E=e.Event||(e.Event={}));class w{constructor(c){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${c}_${w._idPool++}`}start(c){this._stopWatch=new k.StopWatch(!0),this._listenerCount=c}stop(){if(this._stopWatch){const c=this._stopWatch.elapsed();this._elapsedOverall+=c,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${c.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}w._idPool=0;let S=-1;function b(g){const c=S;return S=g,{dispose(){S=c}}}e.setGlobalLeakWarningThreshold=b;class M{constructor(c,o=Math.random().toString(18).slice(2,5)){this.customThreshold=c,this.name=o,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(c){let o=S;if(typeof this.customThreshold=="number"&&(o=this.customThreshold),o<=0||c<o)return;this._stacks||(this._stacks=new Map);const l=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(l)||0;if(this._stacks.set(l,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=o*.5;let i,r=0;for(const[a,h]of this._stacks)(!i||r<h)&&(i=a,r=h);console.warn(`[${this.name}] potential listener LEAK detected, having ${c} listeners already. MOST frequent listener (${r}):`),console.warn(i)}return()=>{const i=this._stacks.get(l)||0;this._stacks.set(l,i-1)}}}class y{constructor(c){this._disposed=!1,this._options=c,this._leakageMon=S>0?new M(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new w(this._options._profName):void 0}get event(){return this._event||(this._event=(c,o,l)=>{this._listeners||(this._listeners=new C.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(o?[c,o]:c);s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,c,o);const r=this._leakageMon?.check(this._listeners.size),a=(0,D.toDisposable)(()=>{r&&r(),this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return l instanceof D.DisposableStore?l.add(a):Array.isArray(l)&&l.push(a),a}),this._event}fire(c){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new C.LinkedList);for(let o of this._listeners)this._deliveryQueue.push([o,c]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[o,l]=this._deliveryQueue.shift();try{typeof o=="function"?o.call(void 0,l):o[0].call(o[1],l)}catch(s){(0,p.onUnexpectedError)(s)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=y;class f extends y{async fireAsync(c,o,l){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const s of this._listeners)this._asyncDeliveryQueue.push([s,c]);for(;this._asyncDeliveryQueue.size>0&&!o.isCancellationRequested;){const[s,i]=this._asyncDeliveryQueue.shift(),r=[],a={...i,token:o,waitUntil:h=>{if(Object.isFrozen(r))throw new Error("waitUntil can NOT be called asynchronous");l&&(h=l(h,typeof s=="function"?s:s[0])),r.push(h)}};try{typeof s=="function"?s.call(void 0,a):s[0].call(s[1],a)}catch(h){(0,p.onUnexpectedError)(h);continue}Object.freeze(r),await Promise.allSettled(r).then(h=>{for(const I of h)I.status==="rejected"&&(0,p.onUnexpectedError)(I.reason)})}}}}e.AsyncEmitter=f;class t extends y{constructor(c){super(c);this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=c?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const c=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(c))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(c){this._listeners&&(this._isPaused!==0?this._eventQueue.push(c):super.fire(c))}}e.PauseableEmitter=t;class d extends t{constructor(c){super(c);this._delay=c.delay??100}fire(c){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(c)}}e.DebounceEmitter=d;class m extends y{constructor(c){super(c);this._queuedEvents=[],this._mergeFn=c?.merge}fire(c){this._queuedEvents.push(c),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(o=>super.fire(o)),this._queuedEvents=[]})}}e.MicrotaskEmitter=m;class v{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new y({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(c){const o={event:c,listener:null};this.events.push(o),this.hasListeners&&this.hook(o);const l=()=>{this.hasListeners&&this.unhook(o);const s=this.events.indexOf(o);this.events.splice(s,1)};return(0,D.toDisposable)((0,n.once)(l))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(c=>this.hook(c))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(c=>this.unhook(c))}hook(c){c.listener=c.event(o=>this.emitter.fire(o))}unhook(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=v;class P{constructor(){this.buffers=[]}wrapEvent(c){return(o,l,s)=>c(i=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>o.call(l,i)):o.call(l,i)},void 0,s)}bufferEvents(c){const o=[];this.buffers.push(o);const l=c();return this.buffers.pop(),o.forEach(s=>s()),l}}e.EventBufferer=P;class u{constructor(){this.listening=!1,this.inputEvent=E.None,this.inputEventListener=D.Disposable.None,this.emitter=new y({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(c){this.inputEvent=c,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=c(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=u}),define(ee[21],te([0,1,4]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(E,w){const S=setTimeout(E.bind(w),0);return{dispose(){clearTimeout(S)}}});var D;(function(E){function w(S){return S===E.None||S===E.Cancelled||S instanceof C?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}E.isCancellationToken=w,E.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:p.Event.None}),E.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(D=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new p.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(w){this._token=void 0,this._parentListener=void 0,this._parentListener=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=D.Cancelled}dispose(w=!1){w&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=k}),define(ee[112],te([0,1,21]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class n{constructor(k){this.task=k,this.result=null}get(){if(this.result)return this.result;const k=new p.CancellationTokenSource,E=this.task(k.token);return this.result={promise:E,dispose:()=>{this.result=null,k.cancel(),k.dispose()}},this.result}}e.Cache=n;class D{constructor(k){this.computeFn=k,this.lastCache=void 0,this.lastArgKey=void 0}get(k){const E=JSON.stringify(k);return this.lastArgKey!==E&&(this.lastArgKey=E,this.lastCache=this.computeFn(k)),this.lastCache}}e.LRUCachedComputed=D}),define(ee[51],te([0,1,15,2]),function(j,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(u){const g=u;return g?[g.on,g.pause,g.resume,g.destroy].every(c=>typeof c=="function"):!1}e.isReadableStream=D;function C(u){const g=u;return g?D(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}e.isReadableBufferedStream=C;function k(u,g){return new E(u,g)}e.newWriteableStream=k;class E{constructor(g,c){this.reducer=g,this.options=c,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(g){if(!this.state.destroyed){if(this.state.flowing)this.emitData(g);else if(this.buffer.data.push(g),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(g){this.state.destroyed||(this.state.flowing?this.emitError(g):this.buffer.error.push(g))}end(g){this.state.destroyed||(typeof g!="undefined"&&this.write(g),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(g){this.listeners.data.slice(0).forEach(c=>c(g))}emitError(g){this.listeners.error.length===0?(0,p.onUnexpectedError)(g):this.listeners.error.slice(0).forEach(c=>c(g))}emitEnd(){this.listeners.end.slice(0).forEach(g=>g())}on(g,c){if(!this.state.destroyed)switch(g){case"data":this.listeners.data.push(c),this.resume();break;case"end":this.listeners.end.push(c),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(c),this.state.flowing&&this.flowErrors();break}}removeListener(g,c){if(this.state.destroyed)return;let o;switch(g){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const l=o.indexOf(c);l>=0&&o.splice(l,1)}}flowData(){if(this.buffer.data.length>0){const g=this.reducer(this.buffer.data);this.emitData(g),this.buffer.data.length=0;const c=[...this.pendingWritePromises];this.pendingWritePromises.length=0,c.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const g of this.buffer.error)this.emitError(g);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function w(u,g){const c=[];let o;for(;(o=u.read())!==null;)c.push(o);return g(c)}e.consumeReadable=w;function S(u,g,c){const o=[];let l;for(;(l=u.read())!==null&&o.length<c;)o.push(l);return l===null&&o.length>0?g(o):{read:()=>{if(o.length>0)return o.shift();if(typeof l!="undefined"){const s=l;return l=void 0,s}return u.read()}}}e.peekReadable=S;function b(u,g){return new Promise((c,o)=>{const l=[];M(u,{onData:s=>{g&&l.push(s)},onError:s=>{g?o(s):c(void 0)},onEnd:()=>{c(g?g(l):void 0)}})})}e.consumeStream=b;function M(u,g){let c=!1;return u.on("error",o=>{c||g.onError(o)}),u.on("end",()=>{c||g.onEnd()}),u.on("data",o=>{c||g.onData(o)}),(0,n.toDisposable)(()=>c=!0)}e.listenStream=M;function y(u,g){return new Promise((c,o)=>{const l=new n.DisposableStore,s=[],i=h=>{if(s.push(h),s.length>g)return l.dispose(),u.pause(),c({stream:u,buffer:s,ended:!1})},r=h=>o(h),a=()=>c({stream:u,buffer:s,ended:!0});l.add((0,n.toDisposable)(()=>u.removeListener("error",r))),u.on("error",r),l.add((0,n.toDisposable)(()=>u.removeListener("end",a))),u.on("end",a),l.add((0,n.toDisposable)(()=>u.removeListener("data",i))),u.on("data",i)})}e.peekStream=y;function f(u,g){const c=k(g);return c.end(u),c}e.toStream=f;function t(){const u=k(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=t;function d(u){let g=!1;return{read:()=>g?null:(g=!0,u)}}e.toReadable=d;function m(u,g,c){const o=k(c);return M(u,{onData:l=>o.write(g.data(l)),onError:l=>o.error(g.error?g.error(l):l),onEnd:()=>o.end()}),o}e.transform=m;function v(u,g,c){let o=!1;return{read:()=>{const l=g.read();return o?l:(o=!0,l!==null?c([u,l]):u)}}}e.prefixedReadable=v;function P(u,g,c){let o=!1;const l=k(c);return M(g,{onData:s=>o?l.write(s):(o=!0,l.write(c([u,s]))),onError:s=>l.error(s),onEnd:()=>{o||(o=!0,l.write(u)),l.end()}}),l}e.prefixedStream=P}),define(ee[17],te([0,1,51]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer!="undefined";let D,C;class k{constructor(I){this.buffer=I,this.byteLength=this.buffer.byteLength}static alloc(I){return n?new k(Buffer.allocUnsafe(I)):new k(new Uint8Array(I))}static wrap(I){return n&&!Buffer.isBuffer(I)&&(I=Buffer.from(I.buffer,I.byteOffset,I.byteLength)),new k(I)}static fromString(I,R){return!(R?.dontUseNodeBuffer||!1)&&n?new k(Buffer.from(I)):(D||(D=new TextEncoder),new k(D.encode(I)))}static fromByteArray(I){const R=k.alloc(I.length);for(let L=0,T=I.length;L<T;L++)R.buffer[L]=I[L];return R}static concat(I,R){if(typeof R=="undefined"){R=0;for(let $=0,Q=I.length;$<Q;$++)R+=I[$].byteLength}const L=k.alloc(R);let T=0;for(let $=0,Q=I.length;$<Q;$++){const se=I[$];L.set(se,T),T+=se.byteLength}return L}clone(){const I=k.alloc(this.byteLength);return I.set(this),I}toString(){return n?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(I,R){return new k(this.buffer.subarray(I,R))}set(I,R){if(I instanceof k)this.buffer.set(I.buffer,R);else if(I instanceof Uint8Array)this.buffer.set(I,R);else if(I instanceof ArrayBuffer)this.buffer.set(new Uint8Array(I),R);else if(ArrayBuffer.isView(I))this.buffer.set(new Uint8Array(I.buffer,I.byteOffset,I.byteLength),R);else throw new Error("Unkown argument 'array'")}readUInt32BE(I){return S(this.buffer,I)}writeUInt32BE(I,R){b(this.buffer,I,R)}readUInt32LE(I){return M(this.buffer,I)}writeUInt32LE(I,R){y(this.buffer,I,R)}readUInt8(I){return f(this.buffer,I)}writeUInt8(I,R){t(this.buffer,I,R)}}e.VSBuffer=k;function E(h,I){return h[I+0]<<0>>>0|h[I+1]<<8>>>0}e.readUInt16LE=E;function w(h,I,R){h[R+0]=I&255,I=I>>>8,h[R+1]=I&255}e.writeUInt16LE=w;function S(h,I){return h[I]*2**24+h[I+1]*2**16+h[I+2]*2**8+h[I+3]}e.readUInt32BE=S;function b(h,I,R){h[R+3]=I,I=I>>>8,h[R+2]=I,I=I>>>8,h[R+1]=I,I=I>>>8,h[R]=I}e.writeUInt32BE=b;function M(h,I){return h[I+0]<<0>>>0|h[I+1]<<8>>>0|h[I+2]<<16>>>0|h[I+3]<<24>>>0}e.readUInt32LE=M;function y(h,I,R){h[R+0]=I&255,I=I>>>8,h[R+1]=I&255,I=I>>>8,h[R+2]=I&255,I=I>>>8,h[R+3]=I&255}e.writeUInt32LE=y;function f(h,I){return h[I]}e.readUInt8=f;function t(h,I,R){h[R]=I}e.writeUInt8=t;function d(h){return p.consumeReadable(h,I=>k.concat(I))}e.readableToBuffer=d;function m(h){return p.toReadable(h)}e.bufferToReadable=m;function v(h){return p.consumeStream(h,I=>k.concat(I))}e.streamToBuffer=v;async function P(h){return h.ended?k.concat(h.buffer):k.concat([...h.buffer,await v(h.stream)])}e.bufferedStreamToBuffer=P;function u(h){return p.toStream(h,I=>k.concat(I))}e.bufferToStream=u;function g(h){return p.transform(h,{data:I=>typeof I=="string"?k.fromString(I):k.wrap(I)},I=>k.concat(I))}e.streamToBufferReadableStream=g;function c(h){return p.newWriteableStream(I=>k.concat(I),h)}e.newWriteableBufferStream=c;function o(h,I){return p.prefixedReadable(h,I,R=>k.concat(R))}e.prefixedBufferReadable=o;function l(h,I){return p.prefixedStream(h,I,R=>k.concat(R))}e.prefixedBufferStream=l;function s(h){let I=0,R=0,L=0;const T=new Uint8Array(Math.floor(h.length/4*3)),$=se=>{switch(R){case 3:T[L++]=I|se,R=0;break;case 2:T[L++]=I|se>>>2,I=se<<6,R=3;break;case 1:T[L++]=I|se>>>4,I=se<<4,R=2;break;default:I=se<<2,R=1}};for(let se=0;se<h.length;se++){const re=h.charCodeAt(se);if(re>=65&&re<=90)$(re-65);else if(re>=97&&re<=122)$(re-97+26);else if(re>=48&&re<=57)$(re-48+52);else if(re===43||re===45)$(62);else if(re===47||re===95)$(63);else{if(re===61)break;throw new SyntaxError(`Unexpected base64 character ${h[se]}`)}}const Q=L;for(;R>0;)$(0);return k.wrap(T).slice(0,Q)}e.decodeBase64=s;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:h},I=!0,R=!1){const L=R?r:i;let T="";const $=h.byteLength%3;let Q=0;for(;Q<h.byteLength-$;Q+=3){const se=h[Q+0],re=h[Q+1],V=h[Q+2];T+=L[se>>>2],T+=L[(se<<4|re>>>4)&63],T+=L[(re<<2|V>>>6)&63],T+=L[V&63]}if($===1){const se=h[Q+0];T+=L[se>>>2],T+=L[se<<4&63],I&&(T+="==")}else if($===2){const se=h[Q+0],re=h[Q+1];T+=L[se>>>2],T+=L[(se<<4|re>>>4)&63],T+=L[re<<2&63],I&&(T+="=")}return T}e.encodeBase64=a}),define(ee[25],te([0,1,112,110]),function(j,e,p,n){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function C(X){return!X||typeof X!="string"?!0:X.trim().length===0}e.isFalsyOrWhitespace=C;const k=/{(\d+)}/g;function E(X,...ae){return ae.length===0?X:X.replace(k,function(ue,ve){const Ee=parseInt(ve,10);return isNaN(Ee)||Ee<0||Ee>=ae.length?ue:ae[Ee]})}e.format=E;const w=/{([^}]+)}/g;function S(X,ae){return X.replace(w,(ue,ve)=>ae[ve]??ue)}e.format2=S;function b(X){return X.replace(/[<>&]/g,function(ae){switch(ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ae}})}e.escape=b;function M(X){return X.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=M;function y(X,ae){let ue=0;const ve=ae.charCodeAt(0);for(let Ee=X.length-1;Ee>=0;Ee--)X.charCodeAt(Ee)===ve&&ue++;return ue}e.count=y;function f(X,ae,ue="\u2026"){return X.length<=ae?X:`${X.substr(0,ae)}${ue}`}e.truncate=f;function t(X,ae=" "){const ue=d(X,ae);return m(ue,ae)}e.trim=t;function d(X,ae){if(!X||!ae)return X;const ue=ae.length;if(ue===0||X.length===0)return X;let ve=0;for(;X.indexOf(ae,ve)===ve;)ve=ve+ue;return X.substring(ve)}e.ltrim=d;function m(X,ae){if(!X||!ae)return X;const ue=ae.length,ve=X.length;if(ue===0||ve===0)return X;let Ee=ve,Le=-1;for(;Le=X.lastIndexOf(ae,Ee-1),!(Le===-1||Le+ue!==Ee);){if(Le===0)return"";Ee=Le}return X.substring(0,Ee)}e.rtrim=m;function v(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=v;function P(X){return X.replace(/\*/g,"")}e.stripWildcards=P;function u(X,ae,ue={}){if(!X)throw new Error("Cannot create regex from empty string");ae||(X=M(X)),ue.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X=X+"\\b"));let ve="";return ue.global&&(ve+="g"),ue.matchCase||(ve+="i"),ue.multiline&&(ve+="m"),ue.unicode&&(ve+="u"),new RegExp(X,ve)}e.createRegExp=u;function g(X){return X.source==="^"||X.source==="^$"||X.source==="$"||X.source==="^\\s*$"?!1:!!(X.exec("")&&X.lastIndex===0)}e.regExpLeadsToEndlessLoop=g;function c(X){return!!X.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function o(X){return(X.global?"g":"")+(X.ignoreCase?"i":"")+(X.multiline?"m":"")+(X.unicode?"u":"")}e.regExpFlags=o;function l(X){return X.split(/\r\n|\r|\n/)}e.splitLines=l;function s(X){for(let ae=0,ue=X.length;ae<ue;ae++){const ve=X.charCodeAt(ae);if(ve!==32&&ve!==9)return ae}return-1}e.firstNonWhitespaceIndex=s;function i(X,ae=0,ue=X.length){for(let ve=ae;ve<ue;ve++){const Ee=X.charCodeAt(ve);if(Ee!==32&&Ee!==9)return X.substring(ae,ve)}return X.substring(ae,ue)}e.getLeadingWhitespace=i;function r(X,ae=X.length-1){for(let ue=ae;ue>=0;ue--){const ve=X.charCodeAt(ue);if(ve!==32&&ve!==9)return ue}return-1}e.lastNonWhitespaceIndex=r;function a(X,ae){return X<ae?-1:X>ae?1:0}e.compare=a;function h(X,ae,ue=0,ve=X.length,Ee=0,Le=ae.length){for(;ue<ve&&Ee<Le;ue++,Ee++){let He=X.charCodeAt(ue),Te=ae.charCodeAt(Ee);if(He<Te)return-1;if(He>Te)return 1}const _e=ve-ue,Ke=Le-Ee;return _e<Ke?-1:_e>Ke?1:0}e.compareSubstring=h;function I(X,ae){return R(X,ae,0,X.length,0,ae.length)}e.compareIgnoreCase=I;function R(X,ae,ue=0,ve=X.length,Ee=0,Le=ae.length){for(;ue<ve&&Ee<Le;ue++,Ee++){let He=X.charCodeAt(ue),Te=ae.charCodeAt(Ee);if(He===Te)continue;if(He>=128||Te>=128)return h(X.toLowerCase(),ae.toLowerCase(),ue,ve,Ee,Le);L(He)&&(He-=32),L(Te)&&(Te-=32);const Ne=He-Te;if(Ne!==0)return Ne}const _e=ve-ue,Ke=Le-Ee;return _e<Ke?-1:_e>Ke?1:0}e.compareSubstringIgnoreCase=R;function L(X){return X>=97&&X<=122}e.isLowerAsciiLetter=L;function T(X){return X>=65&&X<=90}e.isUpperAsciiLetter=T;function $(X,ae){return X.length===ae.length&&R(X,ae)===0}e.equalsIgnoreCase=$;function Q(X,ae){const ue=ae.length;return ae.length>X.length?!1:R(X,ae,0,ue)===0}e.startsWithIgnoreCase=Q;function se(X,ae){let ue,ve=Math.min(X.length,ae.length);for(ue=0;ue<ve;ue++)if(X.charCodeAt(ue)!==ae.charCodeAt(ue))return ue;return ve}e.commonPrefixLength=se;function re(X,ae){let ue,ve=Math.min(X.length,ae.length);const Ee=X.length-1,Le=ae.length-1;for(ue=0;ue<ve;ue++)if(X.charCodeAt(Ee-ue)!==ae.charCodeAt(Le-ue))return ue;return ve}e.commonSuffixLength=re;function V(X){return 55296<=X&&X<=56319}e.isHighSurrogate=V;function Z(X){return 56320<=X&&X<=57343}e.isLowSurrogate=Z;function H(X,ae){return(X-55296<<10)+(ae-56320)+65536}e.computeCodePoint=H;function K(X,ae,ue){const ve=X.charCodeAt(ue);if(V(ve)&&ue+1<ae){const Ee=X.charCodeAt(ue+1);if(Z(Ee))return H(ve,Ee)}return ve}e.getNextCodePoint=K;function x(X,ae){const ue=X.charCodeAt(ae-1);if(Z(ue)&&ae>1){const ve=X.charCodeAt(ae-2);if(V(ve))return H(ve,ue)}return ue}class B{constructor(ae,ue=0){this._str=ae,this._len=ae.length,this._offset=ue}get offset(){return this._offset}setOffset(ae){this._offset=ae}prevCodePoint(){const ae=x(this._str,this._offset);return this._offset-=ae>=65536?2:1,ae}nextCodePoint(){const ae=K(this._str,this._len,this._offset);return this._offset+=ae>=65536?2:1,ae}eol(){return this._offset>=this._len}}e.CodePointIterator=B;class z{constructor(ae,ue=0){this._iterator=new B(ae,ue)}get offset(){return this._iterator.offset}nextGraphemeLength(){const ae=ze.getInstance(),ue=this._iterator,ve=ue.offset;let Ee=ae.getGraphemeBreakType(ue.nextCodePoint());for(;!ue.eol();){const Le=ue.offset,_e=ae.getGraphemeBreakType(ue.nextCodePoint());if(Xe(Ee,_e)){ue.setOffset(Le);break}Ee=_e}return ue.offset-ve}prevGraphemeLength(){const ae=ze.getInstance(),ue=this._iterator,ve=ue.offset;let Ee=ae.getGraphemeBreakType(ue.prevCodePoint());for(;ue.offset>0;){const Le=ue.offset,_e=ae.getGraphemeBreakType(ue.prevCodePoint());if(Xe(_e,Ee)){ue.setOffset(Le);break}Ee=_e}return ve-ue.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=z;function G(X,ae){return new z(X,ae).nextGraphemeLength()}e.nextCharLength=G;function q(X,ae){return new z(X,ae).prevGraphemeLength()}e.prevCharLength=q;function W(X,ae){ae>0&&Z(X.charCodeAt(ae))&&ae--;const ue=ae+G(X,ae);return[ue-q(X,ue),ue]}e.getCharContainingOffset=W;const N=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function F(X){return N.test(X)}e.containsRTL=F;const A=/^[\t\n\r\x20-\x7E]*$/;function U(X){return A.test(X)}e.isBasicASCII=U,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function O(X){return e.UNUSUAL_LINE_TERMINATORS.test(X)}e.containsUnusualLineTerminators=O;function _(X){return X>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}e.isFullWidthCharacter=_;function Y(X){return X>=127462&&X<=127487||X===8986||X===8987||X===9200||X===9203||X>=9728&&X<=10175||X===11088||X===11093||X>=127744&&X<=128591||X>=128640&&X<=128764||X>=128992&&X<=129008||X>=129280&&X<=129535||X>=129648&&X<=129782}e.isEmojiImprecise=Y;function ie(X,ae){if(X.length<ae)return X;const ue=/\b/g;let ve=0;for(;ue.test(X)&&!(X.length-ue.lastIndex<ae);)ve=ue.lastIndex,ue.lastIndex+=1;return X.substring(ve).replace(/^\s/,"")}e.lcut=ie;const oe=/\x1B\x5B[12]?K/g,J=/\x1b\[\d+m/g,ce=/\x1b\[0?m/g;function le(X){return X&&(X=X.replace(oe,""),X=X.replace(J,""),X=X.replace(ce,"")),X}e.removeAnsiEscapeCodes=le,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function he(X){return!!(X&&X.length>0&&X.charCodeAt(0)===65279)}e.startsWithUTF8BOM=he;function we(X){return he(X)?X.substr(1):X}e.stripUTF8BOM=we;function pe(X,ae){if(!X||!ae||X.length<ae.length)return!1;const ue=ae.length,ve=X.toLowerCase();let Ee=0,Le=-1;for(;Ee<ue;){const _e=ve.indexOf(ae[Ee],Le+1);if(_e<0)return!1;Le=_e,Ee++}return!0}e.fuzzyContains=pe;function ge(X,ae=!1){return X?(ae&&(X=X.replace(/\\./g,"")),X.toLowerCase()!==X):!1}e.containsUppercaseCharacter=ge;function fe(X){return X.charAt(0).toUpperCase()+X.slice(1)}e.uppercaseFirstLetter=fe;function Ie(X,ae=1){if(ae===0)return"";let ue=-1;do ue=X.indexOf(`
`,ue+1),ae--;while(ae>0&&ue>=0);return ue===-1?X:(X[ue-1]==="\r"&&ue--,X.substr(0,ue))}e.getNLines=Ie;function Me(X){const ae=90-65+1;return X=X%(2*ae),X<ae?String.fromCharCode(97+X):String.fromCharCode(65+X-ae)}e.singleLetterHash=Me;function Ae(X){return ze.getInstance().getGraphemeBreakType(X)}e.getGraphemeBreakType=Ae;function Xe(X,ae){return X===0?ae!==5&&ae!==7:X===2&&ae===3?!1:X===4||X===2||X===3||ae===4||ae===2||ae===3?!0:!(X===8&&(ae===8||ae===9||ae===11||ae===12)||(X===11||X===9)&&(ae===9||ae===10)||(X===12||X===10)&&ae===10||ae===5||ae===13||ae===7||X===1||X===13&&ae===14||X===6&&ae===6)}var Oe;(function(X){X[X.Other=0]="Other",X[X.Prepend=1]="Prepend",X[X.CR=2]="CR",X[X.LF=3]="LF",X[X.Control=4]="Control",X[X.Extend=5]="Extend",X[X.Regional_Indicator=6]="Regional_Indicator",X[X.SpacingMark=7]="SpacingMark",X[X.L=8]="L",X[X.V=9]="V",X[X.T=10]="T",X[X.LV=11]="LV",X[X.LVT=12]="LVT",X[X.ZWJ=13]="ZWJ",X[X.Extended_Pictographic=14]="Extended_Pictographic"})(Oe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ze{constructor(){this._data=st()}static getInstance(){return ze._INSTANCE||(ze._INSTANCE=new ze),ze._INSTANCE}getGraphemeBreakType(ae){if(ae<32)return ae===10?3:ae===13?2:4;if(ae<127)return 0;const ue=this._data,ve=ue.length/3;let Ee=1;for(;Ee<=ve;)if(ae<ue[3*Ee])Ee=2*Ee;else if(ae>ue[3*Ee+1])Ee=2*Ee+1;else return ue[3*Ee+2];return 0}}ze._INSTANCE=null;function st(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function xe(X,ae){if(X===0)return 0;const ue=Qe(X,ae);if(ue!==void 0)return ue;const ve=new B(ae,X);return ve.prevCodePoint(),ve.offset}e.getLeftDeleteOffset=xe;function Qe(X,ae){const ue=new B(ae,X);let ve=ue.prevCodePoint();for(;pt(ve)||ve===65039||ve===8419;){if(ue.offset===0)return;ve=ue.prevCodePoint()}if(!Y(ve))return;let Ee=ue.offset;return Ee>0&&ue.prevCodePoint()===8205&&(Ee=ue.offset),Ee}function pt(X){return 127995<=X&&X<=127999}var ot;(function(X){X[X.zwj=8205]="zwj",X[X.emojiVariantSelector=65039]="emojiVariantSelector",X[X.enclosingKeyCap=8419]="enclosingKeyCap"})(ot||(ot={})),e.noBreakWhitespace="\xA0";class Ve{constructor(ae){this.confusableDictionary=ae}static getInstance(ae){return Ve.cache.get(Array.from(ae))}static getLocales(){return Ve._locales.getValue()}isAmbiguous(ae){return this.confusableDictionary.has(ae)}getPrimaryConfusable(ae){return this.confusableDictionary.get(ae)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Ve,D=Ve,Ve.ambiguousCharacterData=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ve.cache=new p.LRUCachedComputed(X=>{function ae(Te){const Ne=new Map;for(let qe=0;qe<Te.length;qe+=2)Ne.set(Te[qe],Te[qe+1]);return Ne}function ue(Te,Ne){const qe=new Map(Te);for(const[tt,it]of Ne)qe.set(tt,it);return qe}function ve(Te,Ne){if(!Te)return Ne;const qe=new Map;for(const[tt,it]of Te)Ne.has(tt)&&qe.set(tt,it);return qe}const Ee=D.ambiguousCharacterData.getValue();let Le=X.filter(Te=>!Te.startsWith("_")&&Te in Ee);Le.length===0&&(Le=["_default"]);let _e;for(const Te of Le){const Ne=ae(Ee[Te]);_e=ve(_e,Ne)}const Ke=ae(Ee._common),He=ue(Ke,_e);return new Ve(He)}),Ve._locales=new n.Lazy(()=>Object.keys(Ve.ambiguousCharacterData.getValue()).filter(X=>!X.startsWith("_")));class Je{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Je.getRawData())),this._data}static isInvisibleCharacter(ae){return Je.getData().has(ae)}static get codePoints(){return Je.getData()}}e.InvisibleCharacters=Je,Je._data=void 0}),define(ee[71],te([0,1,25]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(v){return D(v,0)}e.hash=n;function D(v,P){switch(typeof v){case"object":return v===null?C(349,P):Array.isArray(v)?w(v,P):S(v,P);case"string":return E(v,P);case"boolean":return k(v,P);case"number":return C(v,P);case"undefined":return C(937,P);default:return C(617,P)}}e.doHash=D;function C(v,P){return(P<<5)-P+v|0}e.numberHash=C;function k(v,P){return C(v?433:863,P)}function E(v,P){P=C(149417,P);for(let u=0,g=v.length;u<g;u++)P=C(v.charCodeAt(u),P);return P}e.stringHash=E;function w(v,P){return P=C(104579,P),v.reduce((u,g)=>D(g,u),P)}function S(v,P){return P=C(181387,P),Object.keys(v).sort().reduce((u,g)=>(u=E(g,u),D(v[g],u)),P)}class b{constructor(){this._value=0}get value(){return this._value}hash(P){return this._value=D(P,this._value),this._value}}e.Hasher=b;var M;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(M||(M={}));function y(v,P,u=32){const g=u-P,c=~((1<<g)-1);return(v<<P|(c&v)>>>g)>>>0}function f(v,P=0,u=v.byteLength,g=0){for(let c=0;c<u;c++)v[P+c]=g}function t(v,P,u="0"){for(;v.length<P;)v=u+v;return v}function d(v,P=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(u=>u.toString(16).padStart(2,"0")).join(""):t((v>>>0).toString(16),P/4)}e.toHexString=d;class m{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(P){const u=P.length;if(u===0)return;const g=this._buff;let c=this._buffLen,o=this._leftoverHighSurrogate,l,s;for(o!==0?(l=o,s=-1,o=0):(l=P.charCodeAt(0),s=0);;){let i=l;if(p.isHighSurrogate(l))if(s+1<u){const r=P.charCodeAt(s+1);p.isLowSurrogate(r)?(s++,i=p.computeCodePoint(l,r)):i=65533}else{o=l;break}else p.isLowSurrogate(l)&&(i=65533);if(c=this._push(g,c,i),s++,s<u)l=P.charCodeAt(s);else break}this._buffLen=c,this._leftoverHighSurrogate=o}_push(P,u,g){return g<128?P[u++]=g:g<2048?(P[u++]=192|(g&1984)>>>6,P[u++]=128|(g&63)>>>0):g<65536?(P[u++]=224|(g&61440)>>>12,P[u++]=128|(g&4032)>>>6,P[u++]=128|(g&63)>>>0):(P[u++]=240|(g&1835008)>>>18,P[u++]=128|(g&258048)>>>12,P[u++]=128|(g&4032)>>>6,P[u++]=128|(g&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,P[0]=P[64+0],P[1]=P[64+1],P[2]=P[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),d(this._h0)+d(this._h1)+d(this._h2)+d(this._h3)+d(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const P=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(P/4294967296),!1),this._buffDV.setUint32(60,P%4294967296,!1),this._step()}_step(){const P=m._bigBlock32,u=this._buffDV;for(let h=0;h<64;h+=4)P.setUint32(h,u.getUint32(h,!1),!1);for(let h=64;h<320;h+=4)P.setUint32(h,y(P.getUint32(h-12,!1)^P.getUint32(h-32,!1)^P.getUint32(h-56,!1)^P.getUint32(h-64,!1),1),!1);let g=this._h0,c=this._h1,o=this._h2,l=this._h3,s=this._h4,i,r,a;for(let h=0;h<80;h++)h<20?(i=c&o|~c&l,r=1518500249):h<40?(i=c^o^l,r=1859775393):h<60?(i=c&o|c&l|o&l,r=2400959708):(i=c^o^l,r=3395469782),a=y(g,5)+i+s+r+P.getUint32(h*4,!1)&4294967295,s=l,l=o,o=y(c,30),c=g,g=a;this._h0=this._h0+g&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+o&4294967295,this._h3=this._h3+l&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=m,m._bigBlock32=new DataView(new ArrayBuffer(320))});var kt=this&&this.__classPrivateFieldSet||function(j,e,p,n,D){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?j!==e||!D:!e.has(j))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?D.call(j,p):D?D.value=p:e.set(j,p),p},Ye=this&&this.__classPrivateFieldGet||function(j,e,p,n){if(p==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?j!==e||!n:!e.has(j))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?n:p==="a"?n.call(j):n?n.value:e.get(j)};define(ee[36],te([0,1,28,25]),function(j,e,p,n){"use strict";var D,C,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function E(s,i,r){let a=s.get(i);return a===void 0&&(a=r,s.set(i,a)),a}e.getOrSet=E;function w(s){const i=[];return s.forEach((r,a)=>{i.push(`${a} => ${r}`)}),`Map(${s.size}) {${i.join(", ")}}`}e.mapToString=w;function S(s){const i=[];return s.forEach(r=>{i.push(r)}),`Set(${s.size}) {${i.join(", ")}}`}e.setToString=S;class b{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const r=i.charCodeAt(0),a=this._value.charCodeAt(this._pos);return r-a}value(){return this._value[this._pos]}}e.StringIterator=b;class M{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,n.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=M;class y{constructor(i=!0,r=!0){this._splitOnBackslash=i,this._caseSensitive=r}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let r=i.length-1;r>=0;r--,this._valueLen--){const a=this._value.charCodeAt(r);if(!(a===47||this._splitOnBackslash&&a===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,n.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=y;var f;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(f||(f={}));class t{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new y(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,n.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,n.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,n.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,n.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=t;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var m;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(m||(m={}));class v{constructor(i){this._iter=i}static forUris(i=()=>!1){return new v(new t(i))}static forPaths(i=!1){return new v(new y(void 0,!i))}static forStrings(){return new v(new b)}static forConfigKeys(){return new v(new M)}clear(){this._root=void 0}fill(i,r){if(r){const a=r.slice(0);(0,p.shuffle)(a);for(let h of a)this.set(h,i)}else{const a=i.slice(0);(0,p.shuffle)(a);for(let h of a)this.set(h[0],h[1])}}set(i,r){const a=this._iter.reset(i);let h;this._root||(this._root=new d,this._root.segment=a.value());const I=[];for(h=this._root;;){const L=a.cmp(h.segment);if(L>0)h.left||(h.left=new d,h.left.segment=a.value()),I.push([-1,h]),h=h.left;else if(L<0)h.right||(h.right=new d,h.right.segment=a.value()),I.push([1,h]),h=h.right;else if(a.hasNext())a.next(),h.mid||(h.mid=new d,h.mid.segment=a.value()),I.push([0,h]),h=h.mid;else break}const R=h.value;h.value=r,h.key=i;for(let L=I.length-1;L>=0;L--){const T=I[L][1];T.updateHeight();const $=T.balanceFactor();if($<-1||$>1){const Q=I[L][0],se=I[L+1][0];if(Q===1&&se===1)I[L][1]=T.rotateLeft();else if(Q===-1&&se===-1)I[L][1]=T.rotateRight();else if(Q===1&&se===-1)T.right=I[L+1][1]=I[L+1][1].rotateRight(),I[L][1]=T.rotateLeft();else if(Q===-1&&se===1)T.left=I[L+1][1]=I[L+1][1].rotateLeft(),I[L][1]=T.rotateRight();else throw new Error;if(L>0)switch(I[L-1][0]){case-1:I[L-1][1].left=I[L][1];break;case 1:I[L-1][1].right=I[L][1];break;case 0:I[L-1][1].mid=I[L][1];break}else this._root=I[0][1]}}return R}get(i){return this._getNode(i)?.value}_getNode(i){const r=this._iter.reset(i);let a=this._root;for(;a;){const h=r.cmp(a.segment);if(h>0)a=a.left;else if(h<0)a=a.right;else if(r.hasNext())r.next(),a=a.mid;else break}return a}has(i){const r=this._getNode(i);return!(r?.value===void 0&&r?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,r){const a=this._iter.reset(i),h=[];let I=this._root;for(;I;){const R=a.cmp(I.segment);if(R>0)h.push([-1,I]),I=I.left;else if(R<0)h.push([1,I]),I=I.right;else if(a.hasNext())a.next(),h.push([0,I]),I=I.mid;else break}if(!!I){if(r?(I.left=void 0,I.mid=void 0,I.right=void 0,I.height=1):(I.key=void 0,I.value=void 0),!I.mid&&!I.value)if(I.left&&I.right){const R=this._min(I.right),{key:L,value:T,segment:$}=R;this._delete(R.key,!1),I.key=L,I.value=T,I.segment=$}else{const R=I.left??I.right;if(h.length>0){const[L,T]=h[h.length-1];switch(L){case-1:T.left=R;break;case 0:T.mid=R;break;case 1:T.right=R;break}}else this._root=R}for(let R=h.length-1;R>=0;R--){const L=h[R][1];L.updateHeight();const T=L.balanceFactor();if(T>1?(L.right.balanceFactor()>=0||(L.right=L.right.rotateRight()),h[R][1]=L.rotateLeft()):T<-1&&(L.left.balanceFactor()<=0||(L.left=L.left.rotateLeft()),h[R][1]=L.rotateRight()),R>0)switch(h[R-1][0]){case-1:h[R-1][1].left=h[R][1];break;case 1:h[R-1][1].right=h[R][1];break;case 0:h[R-1][1].mid=h[R][1];break}else this._root=h[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const r=this._iter.reset(i);let a=this._root,h;for(;a;){const I=r.cmp(a.segment);if(I>0)a=a.left;else if(I<0)a=a.right;else if(r.hasNext())r.next(),h=a.value||h,a=a.mid;else break}return a&&a.value||h}findSuperstr(i){const r=this._iter.reset(i);let a=this._root;for(;a;){const h=r.cmp(a.segment);if(h>0)a=a.left;else if(h<0)a=a.right;else if(r.hasNext())r.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(i){for(const[r,a]of this)i(a,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=r=>{if(!r)return!0;const a=r.balanceFactor();return a<-1||a>1?!1:i(r.left)&&i(r.right)};return i(this._root)}}e.TernarySearchTree=v;class P{constructor(i,r){this.uri=i,this.value=r}}class u{constructor(i,r){this[D]="ResourceMap",i instanceof u?(this.map=new Map(i.map),this.toKey=r??u.defaultToKey):(this.map=new Map,this.toKey=i??u.defaultToKey)}set(i,r){return this.map.set(this.toKey(i),new P(i,r)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,r){typeof r!="undefined"&&(i=i.bind(r));for(let[a,h]of this.map)i(h.value,h.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=u,u.defaultToKey=s=>s.toString();var g;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(g=e.Touch||(e.Touch={}));class c{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,r=0){const a=this._map.get(i);if(!!a)return r!==0&&this.touch(a,r),a.value}set(i,r,a=0){let h=this._map.get(i);if(h)h.value=r,a!==0&&this.touch(h,a);else{switch(h={key:i,value:r,next:void 0,previous:void 0},a){case 0:this.addItemLast(h);break;case 1:this.addItemFirst(h);break;case 2:this.addItemLast(h);break;default:this.addItemLast(h);break}this._map.set(i,h),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const r=this._map.get(i);if(!!r)return this._map.delete(i),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,r){const a=this._state;let h=this._head;for(;h;){if(r?i.bind(r)(h.value,h.key,this):i(h.value,h.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const i=this,r=this._state;let a=this._head;const h={[Symbol.iterator](){return h},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const I={value:a.key,done:!1};return a=a.next,I}else return{value:void 0,done:!0}}};return h}values(){const i=this,r=this._state;let a=this._head;const h={[Symbol.iterator](){return h},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const I={value:a.value,done:!1};return a=a.next,I}else return{value:void 0,done:!0}}};return h}entries(){const i=this,r=this._state;let a=this._head;const h={[Symbol.iterator](){return h},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const I={value:[a.key,a.value],done:!1};return a=a.next,I}else return{value:void 0,done:!0}}};return h}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let r=this._head,a=this.size;for(;r&&a>i;)this._map.delete(r.key),r=r.next,a--;this._head=r,this._size=a,r&&(r.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const r=i.next,a=i.previous;if(!r||!a)throw new Error("Invalid list");r.previous=a,a.next=r}i.next=void 0,i.previous=void 0,this._state++}touch(i,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(i===this._head)return;const a=i.next,h=i.previous;i===this._tail?(h.next=void 0,this._tail=h):(a.previous=h,h.next=a),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(r===2){if(i===this._tail)return;const a=i.next,h=i.previous;i===this._head?(a.previous=void 0,this._head=a):(a.previous=h,h.next=a),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((r,a)=>{i.push([a,r])}),i}fromJSON(i){this.clear();for(const[r,a]of i)this.set(r,a)}}e.LinkedMap=c;class o extends c{constructor(i,r=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,r=2){return super.get(i,r)}peek(i){return super.get(i,0)}set(i,r){return super.set(i,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o;class l{constructor(i){k.set(this,void 0),kt(this,k,i,"f")}get size(){return Ye(this,k,"f").size}forEach(i,r){Ye(this,k,"f").forEach(i,r)}get(i){return Ye(this,k,"f").get(i)}has(i){return Ye(this,k,"f").has(i)}entries(){return Ye(this,k,"f").entries()}keys(){return Ye(this,k,"f").keys()}values(){return Ye(this,k,"f").values()}[(k=new WeakMap,Symbol.iterator)](){return Ye(this,k,"f").entries()}}e.ReadonlyMapView=l}),define(ee[72],te([0,1,36]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new p.LRUCache(1e4);function D(S){return w(S,"NFC",n)}e.normalizeNFC=D;const C=new p.LRUCache(1e4);function k(S){return w(S,"NFD",C)}e.normalizeNFD=k;const E=/[^\u0000-\u0080]/;function w(S,b,M){if(!S)return S;const y=M.get(S);if(y)return y;let f;return E.test(S)?f=S.normalize(b):f=S,M.set(S,f),f}e.removeAccents=function(){const S=/[\u0300-\u036f]/g;return function(b){return k(b).replace(S,"")}}()}),define(ee[13],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function p(a){return Array.isArray(a)}e.isArray=p;function n(a){return typeof a=="string"}e.isString=n;function D(a){return Array.isArray(a)&&a.every(h=>n(h))}e.isStringArray=D;function C(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.isObject=C;function k(a){return typeof a=="number"&&!isNaN(a)}e.isNumber=k;function E(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.isIterable=E;function w(a){return a===!0||a===!1}e.isBoolean=w;function S(a){return typeof a=="undefined"}e.isUndefined=S;function b(a){return!M(a)}e.isDefined=b;function M(a){return S(a)||a===null}e.isUndefinedOrNull=M;function y(a,h){if(!a)throw new Error(h?`Unexpected type, expected '${h}'`:"Unexpected type")}e.assertType=y;function f(a){if(M(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.assertIsDefined=f;function t(...a){const h=[];for(let I=0;I<a.length;I++){const R=a[I];if(M(R))throw new Error(`Assertion Failed: argument at index ${I} is undefined or null`);h.push(R)}return h}e.assertAllDefined=t;const d=Object.prototype.hasOwnProperty;function m(a){if(!C(a))return!1;for(let h in a)if(d.call(a,h))return!1;return!0}e.isEmptyObject=m;function v(a){return typeof a=="function"}e.isFunction=v;function P(...a){return a.length>0&&a.every(v)}e.areFunctions=P;function u(a,h){const I=Math.min(a.length,h.length);for(let R=0;R<I;R++)g(a[R],h[R])}e.validateConstraints=u;function g(a,h){if(n(h)){if(typeof a!==h)throw new Error(`argument does not match constraint: typeof ${h}`)}else if(v(h)){try{if(a instanceof h)return}catch{}if(!M(a)&&a.constructor===h||h.length===1&&h.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=g;function c(a){let h=[],I=Object.getPrototypeOf(a);for(;Object.prototype!==I;)h=h.concat(Object.getOwnPropertyNames(I)),I=Object.getPrototypeOf(I);return h}e.getAllPropertyNames=c;function o(a){const h=[];for(const I of c(a))typeof a[I]=="function"&&h.push(I);return h}e.getAllMethodNames=o;function l(a,h){const I=L=>function(){const T=Array.prototype.slice.call(arguments,0);return h(L,T)};let R={};for(const L of a)R[L]=I(L);return R}e.createProxyObject=l;function s(a){return a===null?void 0:a}e.withNullAsUndefined=s;function i(a){return typeof a=="undefined"?null:a}e.withUndefinedAsNull=i;function r(a,h="Unreachable"){throw new Error(h)}e.assertNever=r}),define(ee[29],te([0,1,9,3,25,13]),function(j,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(r){return r===47||r===92}e.isPathSeparator=k;function E(r){return r.replace(/[\\/]/g,p.posix.sep)}e.toSlashes=E;function w(r){return r.indexOf("/")===-1&&(r=E(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=w;function S(r,a=p.posix.sep){if(!r)return"";const h=r.length,I=r.charCodeAt(0);if(k(I)){if(k(r.charCodeAt(1))&&!k(r.charCodeAt(2))){let L=3;const T=L;for(;L<h&&!k(r.charCodeAt(L));L++);if(T!==L&&!k(r.charCodeAt(L+1))){for(L+=1;L<h;L++)if(k(r.charCodeAt(L)))return r.slice(0,L+1).replace(/[\\/]/g,a)}}return a}else if(v(I)&&r.charCodeAt(1)===58)return k(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let R=r.indexOf("://");if(R!==-1){for(R+=3;R<h;R++)if(k(r.charCodeAt(R)))return r.slice(0,R+1)}return""}e.getRoot=S;function b(r){if(!n.isWindows||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let h=2;const I=h;for(;h<r.length&&(a=r.charCodeAt(h),a!==92);h++);return!(I===h||(a=r.charCodeAt(h+1),isNaN(a)||a===92))}e.isUNC=b;const M=/[\\/:\*\?"<>\|]/g,y=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function t(r,a=n.isWindows){const h=a?M:y;return!(!r||r.length===0||/^\s+$/.test(r)||(h.lastIndex=0,h.test(r))||a&&f.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=t;function d(r,a,h){const I=r===a;return!h||I?I:!r||!a?!1:(0,D.equalsIgnoreCase)(r,a)}e.isEqual=d;function m(r,a,h,I=p.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(h){if(!(0,D.startsWithIgnoreCase)(r,a))return!1;if(a.length===r.length)return!0;let L=a.length;return a.charAt(a.length-1)===I&&L--,r.charAt(L)===I}return a.charAt(a.length-1)!==I&&(a+=I),r.indexOf(a)===0}e.isEqualOrParent=m;function v(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=v;function P(r,a){return n.isWindows&&r.endsWith(":")&&(r+=p.sep),(0,p.isAbsolute)(r)||(r=(0,p.join)(a,r)),r=(0,p.normalize)(r),n.isWindows?(r=(0,D.rtrim)(r,p.sep),r.endsWith(":")&&(r+=p.sep)):(r=(0,D.rtrim)(r,p.sep),r||(r=p.sep)),r}e.sanitizeFilePath=P;function u(r){const a=(0,p.normalize)(r);return n.isWindows?r.length>3?!1:g(a)&&(r.length===2||a.charCodeAt(2)===92):a===p.posix.sep}e.isRootOrDriveLetter=u;function g(r,a){return(a!==void 0?a:n.isWindows)?v(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=g;function c(r){return g(r)?r[0]:void 0}e.getDriveLetter=c;function o(r,a,h){return a.length>r.length?-1:r===a?0:(h&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.indexOfPath=o;function l(r){const a=r.split(":");let h,I,R;for(const L of a){const T=Number(L);(0,C.isNumber)(T)?I===void 0?I=T:R===void 0&&(R=T):h=h?[h,L].join(":"):L}if(!h)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:h,line:I!==void 0?I:void 0,column:R!==void 0?R:I!==void 0?1:void 0}}e.parseLineAndColumnAware=l;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(r,a,h=8){let I="";for(let L=0;L<h;L++)I+=s.charAt(Math.floor(Math.random()*s.length));let R;return a?R=`${a}-${I}`:R=I,r?(0,p.join)(r,R):R}e.randomPath=i}),define(ee[47],te([0,1,13]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const m=Array.isArray(d)?[]:{};return Object.keys(d).forEach(v=>{d[v]&&typeof d[v]=="object"?m[v]=n(d[v]):m[v]=d[v]}),m}e.deepClone=n;function D(d){if(!d||typeof d!="object")return d;const m=[d];for(;m.length>0;){const v=m.shift();Object.freeze(v);for(const P in v)if(C.call(v,P)){const u=v[P];typeof u=="object"&&!Object.isFrozen(u)&&m.push(u)}}return d}e.deepFreeze=D;const C=Object.prototype.hasOwnProperty;function k(d,m){return E(d,m,new Set)}e.cloneAndChange=k;function E(d,m,v){if((0,p.isUndefinedOrNull)(d))return d;const P=m(d);if(typeof P!="undefined")return P;if((0,p.isArray)(d)){const u=[];for(const g of d)u.push(E(g,m,v));return u}if((0,p.isObject)(d)){if(v.has(d))throw new Error("Cannot clone recursive data-structure");v.add(d);const u={};for(let g in d)C.call(d,g)&&(u[g]=E(d[g],m,v));return v.delete(d),u}return d}function w(d,m,v=!0){return(0,p.isObject)(d)?((0,p.isObject)(m)&&Object.keys(m).forEach(P=>{P in d?v&&((0,p.isObject)(d[P])&&(0,p.isObject)(m[P])?w(d[P],m[P],v):d[P]=m[P]):d[P]=m[P]}),d):m}e.mixin=w;function S(d,m){if(d===m)return!0;if(d==null||m===null||m===void 0||typeof d!=typeof m||typeof d!="object"||Array.isArray(d)!==Array.isArray(m))return!1;let v,P;if(Array.isArray(d)){if(d.length!==m.length)return!1;for(v=0;v<d.length;v++)if(!S(d[v],m[v]))return!1}else{const u=[];for(P in d)u.push(P);u.sort();const g=[];for(P in m)g.push(P);if(g.sort(),!S(u,g))return!1;for(v=0;v<u.length;v++)if(!S(d[u[v]],m[u[v]]))return!1}return!0}e.equals=S;function b(d){const m=new Set;return JSON.stringify(d,(v,P)=>{if((0,p.isObject)(P)||Array.isArray(P)){if(m.has(P))return"[Circular]";m.add(P)}return P})}e.safeStringify=b;function M(d,m,v){const P=m(d);return typeof P=="undefined"?v:P}e.getOrDefault=M;function y(d,m){const v=Object.create(null);return!d||!m||Object.keys(m).forEach(u=>{const g=d[u],c=m[u];S(g,c)||(v[u]=c)}),v}e.distinct=y;function f(d,m){const v=m.toLowerCase(),P=Object.keys(d).find(u=>u.toLowerCase()===v);return P?d[P]:d[m]}e.getCaseInsensitive=f;function t(d,m){const v=Object.create(null);for(const[P,u]of Object.entries(d))m(P,u)&&(v[P]=u);return v}e.filter=t}),define(ee[7],te([0,1,9,3]),function(j,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,C=/^\//,k=/^\/\//;function E(s,i){if(!s.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!D.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!C.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(s,i){return!s&&!i?"file":s}function S(s,i){switch(s){case"https":case"http":case"file":i?i[0]!==M&&(i=M+i):i=M;break}return i}const b="",M="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{constructor(i,r,a,h,I,R=!1){typeof i=="object"?(this.scheme=i.scheme||b,this.authority=i.authority||b,this.path=i.path||b,this.query=i.query||b,this.fragment=i.fragment||b):(this.scheme=w(i,R),this.authority=r||b,this.path=S(this.scheme,a||b),this.query=h||b,this.fragment=I||b,E(this,R))}static isUri(i){return i instanceof f?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return u(this,!1)}with(i){if(!i)return this;let{scheme:r,authority:a,path:h,query:I,fragment:R}=i;return r===void 0?r=this.scheme:r===null&&(r=b),a===void 0?a=this.authority:a===null&&(a=b),h===void 0?h=this.path:h===null&&(h=b),I===void 0?I=this.query:I===null&&(I=b),R===void 0?R=this.fragment:R===null&&(R=b),r===this.scheme&&a===this.authority&&h===this.path&&I===this.query&&R===this.fragment?this:new d(r,a,h,I,R)}static parse(i,r=!1){const a=y.exec(i);return a?new d(a[2]||b,l(a[4]||b),l(a[5]||b),l(a[7]||b),l(a[9]||b),r):new d(b,b,b,b,b)}static file(i){let r=b;if(n.isWindows&&(i=i.replace(/\\/g,M)),i[0]===M&&i[1]===M){const a=i.indexOf(M,2);a===-1?(r=i.substring(2),i=M):(r=i.substring(2,a),i=i.substring(a)||M)}return new d("file",r,i,b,b)}static from(i){const r=new d(i.scheme,i.authority,i.path,i.query,i.fragment);return E(r,!0),r}static joinPath(i,...r){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return n.isWindows&&i.scheme==="file"?a=f.file(p.win32.join(u(i,!0),...r)).path:a=p.posix.join(i.path,...r),i.with({path:a})}toString(i=!1){return g(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof f)return i;{const r=new d(i);return r._formatted=i.external,r._fsPath=i._sep===t?i.fsPath:null,r}}else return i}}e.URI=f;const t=n.isWindows?1:void 0;class d extends f{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(i=!1){return i?g(this,!0):(this._formatted||(this._formatted=g(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=t),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const m={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(s,i){let r,a=-1;for(let h=0;h<s.length;h++){const I=s.charCodeAt(h);if(I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57||I===45||I===46||I===95||I===126||i&&I===47)a!==-1&&(r+=encodeURIComponent(s.substring(a,h)),a=-1),r!==void 0&&(r+=s.charAt(h));else{r===void 0&&(r=s.substr(0,h));const R=m[I];R!==void 0?(a!==-1&&(r+=encodeURIComponent(s.substring(a,h)),a=-1),r+=R):a===-1&&(a=h)}}return a!==-1&&(r+=encodeURIComponent(s.substring(a))),r!==void 0?r:s}function P(s){let i;for(let r=0;r<s.length;r++){const a=s.charCodeAt(r);a===35||a===63?(i===void 0&&(i=s.substr(0,r)),i+=m[a]):i!==void 0&&(i+=s[r])}return i!==void 0?i:s}function u(s,i){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?i?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,n.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=u;function g(s,i){const r=i?P:v;let a="",{scheme:h,authority:I,path:R,query:L,fragment:T}=s;if(h&&(a+=h,a+=":"),(I||h==="file")&&(a+=M,a+=M),I){let $=I.indexOf("@");if($!==-1){const Q=I.substr(0,$);I=I.substr($+1),$=Q.indexOf(":"),$===-1?a+=r(Q,!1):(a+=r(Q.substr(0,$),!1),a+=":",a+=r(Q.substr($+1),!1)),a+="@"}I=I.toLowerCase(),$=I.indexOf(":"),$===-1?a+=r(I,!1):(a+=r(I.substr(0,$),!1),a+=I.substr($))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const $=R.charCodeAt(1);$>=65&&$<=90&&(R=`/${String.fromCharCode($+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const $=R.charCodeAt(0);$>=65&&$<=90&&(R=`${String.fromCharCode($+32)}:${R.substr(2)}`)}a+=r(R,!0)}return L&&(a+="?",a+=r(L,!1)),T&&(a+="#",a+=i?T:v(T,!1)),a}function c(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+c(s.substr(3)):s}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function l(s){return s.match(o)?s.replace(o,i=>c(i)):s}}),define(ee[113],te([0,1,7]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function n(S){const b=S;return b&&typeof b.type=="string"&&typeof b.severity=="string"}e.isRemoteConsoleLog=n;function D(S){const b=[];let M;try{const y=JSON.parse(S.arguments),f=y[y.length-1];f&&f.__$stack&&(y.pop(),M=f.__$stack),b.push(...y)}catch{b.push("Unable to log remote console arguments",S.arguments)}return{args:b,stack:M}}e.parse=D;function C(S){if(typeof S!="string")return C(D(S).stack);const b=S;if(b){const M=k(b),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(M||"");if(y&&y.length===4)return{uri:p.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.getFirstFrame=C;function k(S){if(!S)return S;const b=S.indexOf(`
`);return b===-1?S:S.substring(0,b)}function E(S,b){const{args:M,stack:y}=D(S),f=typeof M[0]=="string"&&M.length===1;let t=k(y);t&&(t=`(${t.trim()})`);let d=[];if(typeof M[0]=="string"?t&&f?d=[`%c[${b}] %c${M[0]} %c${t}`,w("blue"),w(""),w("grey")]:d=[`%c[${b}] %c${M[0]}`,w("blue"),w(""),...M.slice(1)]:d=[`%c[${b}]%`,w("blue"),...M],t&&!f&&d.push(t),typeof console[S.severity]!="function")throw new Error("Unknown console method");console[S.severity].apply(console,d)}e.log=E;function w(S){return`color: ${S}`}}),define(ee[114],te([0,1,17,25,7]),function(j,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function C(b){return JSON.stringify(b,w)}e.stringify=C;function k(b){let M=JSON.parse(b);return M=S(M),M}e.parse=k;var E;(function(b){b[b.Uri=1]="Uri",b[b.Regexp=2]="Regexp",b[b.ScmResource=3]="ScmResource",b[b.ScmResourceGroup=4]="ScmResourceGroup",b[b.ScmProvider=5]="ScmProvider",b[b.CommentController=6]="CommentController",b[b.CommentThread=7]="CommentThread",b[b.CommentThreadReply=8]="CommentThreadReply",b[b.CommentNode=9]="CommentNode",b[b.CommentThreadNode=10]="CommentThreadNode",b[b.TimelineActionContext=11]="TimelineActionContext",b[b.NotebookCellActionContext=12]="NotebookCellActionContext",b[b.TestItemContext=13]="TestItemContext",b[b.Date=14]="Date"})(E=e.MarshalledId||(e.MarshalledId={}));function w(b,M){return M instanceof RegExp?{$mid:2,source:M.source,flags:(0,n.regExpFlags)(M)}:M}function S(b,M=0){if(!b||M>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return D.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 14:return new Date(b.source)}if(b instanceof p.VSBuffer||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let y=0;y<b.length;++y)b[y]=S(b[y],M+1);else for(const y in b)Object.hasOwnProperty.call(b,y)&&(b[y]=S(b[y],M+1))}return b}e.revive=S}),define(ee[10],te([0,1,3,7]),function(j,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(E){E.inMemory="inmemory",E.vscode="vscode",E.internal="private",E.walkThrough="walkThrough",E.walkThroughSnippet="walkThroughSnippet",E.http="http",E.https="https",E.file="file",E.mailto="mailto",E.untitled="untitled",E.data="data",E.command="command",E.vscodeRemote="vscode-remote",E.vscodeRemoteResource="vscode-remote-resource",E.userData="vscode-userdata",E.vscodeCustomEditor="vscode-custom-editor",E.vscodeNotebook="vscode-notebook",E.vscodeNotebookCell="vscode-notebook-cell",E.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",E.vscodeNotebookCellOutput="vscode-notebook-cell-output",E.vscodeInteractive="vscode-interactive",E.vscodeInteractiveInput="vscode-interactive-input",E.vscodeSettings="vscode-settings",E.vscodeWorkspaceTrust="vscode-workspace-trust",E.vscodeTerminal="vscode-terminal",E.webviewPanel="webview-panel",E.vscodeWebview="vscode-webview",E.extension="extension",E.vscodeFileResource="vscode-file",E.tmp="tmp",E.vsls="vsls"})(D=e.Schemas||(e.Schemas={}));class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(w){this._preferredWebSchema=w}setDelegate(w){this._delegate=w}set(w,S,b){this._hosts[w]=S,this._ports[w]=b}setConnectionToken(w,S){this._connectionTokens[w]=S}rewrite(w){if(this._delegate)return this._delegate(w);const S=w.authority;let b=this._hosts[S];b&&b.indexOf(":")!==-1&&(b=`[${b}]`);const M=this._ports[S],y=this._connectionTokens[S];let f=`path=${encodeURIComponent(w.path)}`;return typeof y=="string"&&(f+=`&tkn=${encodeURIComponent(y)}`),n.URI.from({scheme:p.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${b}:${M}`,path:"/vscode-remote-resource",query:f})}}e.RemoteAuthorities=new C;class k{asBrowserUri(w,S){const b=this.toUri(w,S);return b.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(b):b.scheme===D.file&&(p.isNative||typeof p.globals.importScripts=="function"&&p.globals.origin===`${D.vscodeFileResource}://${k.FALLBACK_AUTHORITY}`)?b.with({scheme:D.vscodeFileResource,authority:b.authority||k.FALLBACK_AUTHORITY,query:null,fragment:null}):b}asFileUri(w,S){const b=this.toUri(w,S);return b.scheme===D.vscodeFileResource?b.with({scheme:D.file,authority:b.authority!==k.FALLBACK_AUTHORITY?b.authority:null,query:null,fragment:null}):b}toUri(w,S){return n.URI.isUri(w)?w:n.URI.parse(S.toUrl(w))}}k.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new k}),define(ee[16],te([0,1,29,10,9,3,25,7]),function(j,e,p,n,D,C,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(f){return(0,E.uriToFsPath)(f,!0)}e.originalFSPath=w;class S{constructor(t){this._ignorePathCasing=t}compare(t,d,m=!1){return t===d?0:(0,k.compare)(this.getComparisonKey(t,m),this.getComparisonKey(d,m))}isEqual(t,d,m=!1){return t===d?!0:!t||!d?!1:this.getComparisonKey(t,m)===this.getComparisonKey(d,m)}getComparisonKey(t,d=!1){return t.with({path:this._ignorePathCasing(t)?t.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(t){return this._ignorePathCasing(t)}isEqualOrParent(t,d,m=!1){if(t.scheme===d.scheme){if(t.scheme===n.Schemas.file)return p.isEqualOrParent(w(t),w(d),this._ignorePathCasing(t))&&t.query===d.query&&(m||t.fragment===d.fragment);if((0,e.isEqualAuthority)(t.authority,d.authority))return p.isEqualOrParent(t.path,d.path,this._ignorePathCasing(t),"/")&&t.query===d.query&&(m||t.fragment===d.fragment)}return!1}joinPath(t,...d){return E.URI.joinPath(t,...d)}basenameOrAuthority(t){return(0,e.basename)(t)||t.authority}basename(t){return D.posix.basename(t.path)}extname(t){return D.posix.extname(t.path)}dirname(t){if(t.path.length===0)return t;let d;return t.scheme===n.Schemas.file?d=E.URI.file(D.dirname(w(t))).path:(d=D.posix.dirname(t.path),t.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${t.toString})) resulted in a relative path`),d="/")),t.with({path:d})}normalizePath(t){if(!t.path.length)return t;let d;return t.scheme===n.Schemas.file?d=E.URI.file(D.normalize(w(t))).path:d=D.posix.normalize(t.path),t.with({path:d})}relativePath(t,d){if(t.scheme!==d.scheme||!(0,e.isEqualAuthority)(t.authority,d.authority))return;if(t.scheme===n.Schemas.file){const P=D.relative(w(t),w(d));return C.isWindows?p.toSlashes(P):P}let m=t.path||"/",v=d.path||"/";if(this._ignorePathCasing(t)){let P=0;for(const u=Math.min(m.length,v.length);P<u&&!(m.charCodeAt(P)!==v.charCodeAt(P)&&m.charAt(P).toLowerCase()!==v.charAt(P).toLowerCase());P++);m=v.substr(0,P)+m.substr(P)}return D.posix.relative(m,v)}resolvePath(t,d){if(t.scheme===n.Schemas.file){const m=E.URI.file(D.resolve(w(t),d));return t.with({authority:m.authority,path:m.path})}return d=p.toPosixPath(d),t.with({path:D.posix.resolve(t.path,d)})}isAbsolutePath(t){return!!t.path&&t.path[0]==="/"}isEqualAuthority(t,d){return t===d||t!==void 0&&d!==void 0&&(0,k.equalsIgnoreCase)(t,d)}hasTrailingPathSeparator(t,d=D.sep){if(t.scheme===n.Schemas.file){const m=w(t);return m.length>p.getRoot(m).length&&m[m.length-1]===d}else{const m=t.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(t.fsPath)}}removeTrailingPathSeparator(t,d=D.sep){return(0,e.hasTrailingPathSeparator)(t,d)?t.with({path:t.path.substr(0,t.path.length-1)}):t}addTrailingPathSeparator(t,d=D.sep){let m=!1;if(t.scheme===n.Schemas.file){const v=w(t);m=v!==void 0&&v.length===p.getRoot(v).length&&v[v.length-1]===d}else{d="/";const v=t.path;m=v.length===1&&v.charCodeAt(v.length-1)===47}return!m&&!(0,e.hasTrailingPathSeparator)(t,d)?t.with({path:t.path+"/"}):t}}e.ExtUri=S,e.extUri=new S(()=>!1),e.extUriBiasedIgnorePathCase=new S(f=>f.scheme===n.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new S(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function b(f,t){const d=[];for(let m=0;m<f.length;m++){const v=t(f[m]);f.some((P,u)=>u===m?!1:(0,e.isEqualOrParent)(v,t(P)))||d.push(f[m])}return d}e.distinctParents=b;var M;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function t(d){const m=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(u=>{const[g,c]=u.split(":");g&&c&&m.set(g,c)});const P=d.path.substring(0,d.path.indexOf(";"));return P&&m.set(f.META_DATA_MIME,P),m}f.parseMetaData=t})(M=e.DataUri||(e.DataUri={}));function y(f,t,d){if(t){let m=f.path;return m&&m[0]!==D.posix.sep&&(m=D.posix.sep+m),f.with({scheme:d,authority:t,path:m})}return f.with({scheme:d})}e.toLocalResource=y}),define(ee[8],te([0,1,21,15,4,2,16,3]),function(j,e,p,n,D,C,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function w(F){return!!F&&typeof F.then=="function"}e.isThenable=w;function S(F){const A=new p.CancellationTokenSource,U=F(A.token),O=new Promise((_,Y)=>{const ie=A.token.onCancellationRequested(()=>{ie.dispose(),A.dispose(),Y(new n.CancellationError)});Promise.resolve(U).then(oe=>{ie.dispose(),A.dispose(),_(oe)},oe=>{ie.dispose(),A.dispose(),Y(oe)})});return new class{cancel(){A.cancel()}then(_,Y){return O.then(_,Y)}catch(_){return this.then(void 0,_)}finally(_){return O.finally(_)}}}e.createCancelablePromise=S;function b(F,A,U){return new Promise((O,_)=>{const Y=A.onCancellationRequested(()=>{Y.dispose(),O(U)});F.then(O,_).finally(()=>Y.dispose())})}e.raceCancellation=b;function M(F,A){return new Promise((U,O)=>{const _=A.onCancellationRequested(()=>{_.dispose(),O(new n.CancellationError)});F.then(U,O).finally(()=>_.dispose())})}e.raceCancellationError=M;async function y(F){let A=-1;const U=F.map((_,Y)=>_.then(ie=>(A=Y,ie))),O=await Promise.race(U);return F.forEach((_,Y)=>{Y!==A&&_.cancel()}),O}e.raceCancellablePromises=y;function f(F,A,U){let O;const _=setTimeout(()=>{O?.(void 0),U?.()},A);return Promise.race([F.finally(()=>clearTimeout(_)),new Promise(Y=>O=Y)])}e.raceTimeout=f;function t(F){return new Promise((A,U)=>{const O=F();w(O)?O.then(A,U):A(O)})}e.asPromise=t;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(A){if(this.activePromise){if(this.queuedPromiseFactory=A,!this.queuedPromise){const U=()=>{this.queuedPromise=null;const O=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,O};this.queuedPromise=new Promise(O=>{this.activePromise.then(U,U).then(O)})}return new Promise((U,O)=>{this.queuedPromise.then(U,O)})}return this.activePromise=A(),new Promise((U,O)=>{this.activePromise.then(_=>{this.activePromise=null,U(_)},_=>{this.activePromise=null,O(_)})})}}e.Throttler=d;class m{constructor(){this.current=Promise.resolve(null)}queue(A){return this.current=this.current.then(()=>A(),()=>A())}}e.Sequencer=m;class v{constructor(){this.promiseMap=new Map}queue(A,U){const _=(this.promiseMap.get(A)??Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.promiseMap.get(A)===_&&this.promiseMap.delete(A)});return this.promiseMap.set(A,_),_}}e.SequencerByKey=v;const P=(F,A)=>{let U=!0;const O=setTimeout(()=>{U=!1,A()},F);return{isTriggered:()=>U,dispose:()=>{clearTimeout(O),U=!1}}},u=F=>{let A=!0;return queueMicrotask(()=>{A&&(A=!1,F())}),{isTriggered:()=>A,dispose:()=>{A=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class g{constructor(A){this.defaultDelay=A,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(A,U=this.defaultDelay){this.task=A,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((_,Y)=>{this.doResolve=_,this.doReject=Y}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const _=this.task;return this.task=null,_()}}));const O=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=U===e.MicrotaskDelay?u(O):P(U,O),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new n.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=g;class c{constructor(A){this.delayer=new g(A),this.throttler=new d}trigger(A,U){return this.delayer.trigger(()=>this.throttler.queue(A),U)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=c;class o{constructor(){this._isOpen=!1,this._promise=new Promise((A,U)=>{this._completePromise=A})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=o;class l extends o{constructor(A){super();this._timeout=setTimeout(()=>this.open(),A)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function s(F,A){return A?new Promise((U,O)=>{const _=setTimeout(()=>{Y.dispose(),U()},F),Y=A.onCancellationRequested(()=>{clearTimeout(_),Y.dispose(),O(new n.CancellationError)})}):S(U=>s(F,U))}e.timeout=s;function i(F,A=0){const U=setTimeout(F,A);return(0,C.toDisposable)(()=>clearTimeout(U))}e.disposableTimeout=i;function r(F){const A=[];let U=0;const O=F.length;function _(){return U<O?F[U++]():null}function Y(ie){ie!=null&&A.push(ie);const oe=_();return oe?oe.then(Y):Promise.resolve(A)}return Promise.resolve(null).then(Y)}e.sequence=r;function a(F,A=O=>!!O,U=null){let O=0;const _=F.length,Y=()=>{if(O>=_)return Promise.resolve(U);const ie=F[O++];return Promise.resolve(ie()).then(J=>A(J)?Promise.resolve(J):Y())};return Y()}e.first=a;function h(F,A=O=>!!O,U=null){if(F.length===0)return Promise.resolve(U);let O=F.length;const _=()=>{O=-1;for(const Y of F)Y.cancel?.()};return new Promise((Y,ie)=>{for(const oe of F)oe.then(J=>{--O>=0&&A(J)?(_(),Y(J)):O===0&&Y(U)}).catch(J=>{--O>=0&&(_(),ie(J))})})}e.firstParallel=h;class I{constructor(A){this._size=0,this.maxDegreeOfParalellism=A,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(A){return this._size++,new Promise((U,O)=>{this.outstandingPromises.push({factory:A,c:U,e:O}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const A=this.outstandingPromises.shift();this.runningPromises++;const U=A.factory();U.then(A.c,A.e),U.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=I;class R extends I{constructor(){super(1)}}e.Queue=R;class L{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const A=new B;return this.drainers.add(A),A.p}isDrained(){for(const[,A]of this.queues)if(A.size>0)return!1;return!0}queueFor(A,U=k.extUri){const O=U.getComparisonKey(A);let _=this.queues.get(O);return _||(_=new R,D.Event.once(_.onFinished)(()=>{_?.dispose(),this.queues.delete(O),this.onDidQueueFinish()}),this.queues.set(O,_)),_}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const A of this.drainers)A.complete();this.drainers.clear()}dispose(){for(const[,A]of this.queues)A.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=L;class T{constructor(A,U){this._token=-1,typeof A=="function"&&typeof U=="number"&&this.setIfNotSet(A,U)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(A,U){this.cancel(),this._token=setTimeout(()=>{this._token=-1,A()},U)}setIfNotSet(A,U){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,A()},U))}}e.TimeoutTimer=T;class ${constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(A,U){this.cancel(),this._token=setInterval(()=>{A()},U)}}e.IntervalTimer=$;class Q{constructor(A,U){this.timeoutToken=-1,this.runner=A,this.timeout=U,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(A=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,A)}get delay(){return this.timeout}set delay(A){this.timeout=A}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=Q;class se{constructor(A,U){U%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.runner=A,this.timeout=U,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(A=this.timeout){A%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${A}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(A/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=se;class re extends Q{constructor(A,U){super(A,U);this.units=[]}work(A){this.units.push(A),this.isScheduled()||this.schedule()}doRun(){const A=this.units;this.units=[],this.runner&&this.runner(A)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=re;class V extends C.Disposable{constructor(A,U){super();this.options=A,this.handler=U,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(A){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+A.length>this.options.maxBufferedWork)return!1}else if(this.pending+A.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...A),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new Q(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=V,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=F=>{(0,E.setTimeout0)(()=>{if(A)return;const U=Date.now()+15;F(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,U-Date.now())}}))});let A=!1;return{dispose(){A||(A=!0)}}}:e.runWhenIdle=(F,A)=>{const U=requestIdleCallback(F,typeof A=="number"?{timeout:A}:void 0);let O=!1;return{dispose(){O||(O=!0,cancelIdleCallback(U))}}}}();class Z{constructor(A){this._didRun=!1,this._executor=()=>{try{this._value=A()}catch(U){this._error=U}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=Z;async function H(F,A,U){let O;for(let _=0;_<U;_++)try{return await F()}catch(Y){O=Y,await s(A)}throw O}e.retry=H;class K{hasPending(A){return this._pending?typeof A=="number"?this._pending.taskId===A:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(A,U,O){return this._pending={taskId:A,cancel:()=>O?.(),promise:U},U.then(()=>this.donePending(A),()=>this.donePending(A)),U}donePending(A){this._pending&&A===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const A=this._next;this._next=void 0,A.run().then(A.promiseResolve,A.promiseReject)}}setNext(A){if(this._next)this._next.run=A;else{let U,O;const _=new Promise((Y,ie)=>{U=Y,O=ie});this._next={run:A,promise:_,promiseResolve:U,promiseReject:O}}return this._next.promise}}e.TaskSequentializer=K;class x{constructor(A,U=()=>Date.now()){this.interval=A,this.nowFn=U,this.lastIncrementTime=0,this.value=0}increment(){const A=this.nowFn();return A-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=A,this.value=0),this.value++,this.value}}e.IntervalCounter=x;class B{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((A,U)=>{this.completeCallback=A,this.errorCallback=U})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(A){return new Promise(U=>{this.completeCallback(A),this.resolved=!0,U()})}error(A){return new Promise(U=>{this.errorCallback(A),this.rejected=!0,U()})}cancel(){new Promise(A=>{this.errorCallback(new n.CancellationError),this.rejected=!0,A()})}}e.DeferredPromise=B;var z;(function(F){async function A(O){let _;const Y=await Promise.all(O.map(ie=>ie.then(oe=>oe,oe=>{_||(_=oe)})));if(typeof _!="undefined")throw _;return Y}F.settled=A;function U(O){return new Promise(async(_,Y)=>{try{await O(_,Y)}catch(ie){Y(ie)}})}F.withAsyncBody=U})(z=e.Promises||(e.Promises={}));var G;(function(F){F[F.Initial=0]="Initial",F[F.DoneOK=1]="DoneOK",F[F.DoneError=2]="DoneError"})(G||(G={}));class q{constructor(A){this._state=0,this._results=[],this._error=null,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const U={emitOne:O=>this.emitOne(O),emitMany:O=>this.emitMany(O),reject:O=>this.reject(O)};try{await Promise.resolve(A(U)),this.resolve()}catch(O){this.reject(O)}finally{U.emitOne=void 0,U.emitMany=void 0,U.reject=void 0}})}static fromArray(A){return new q(U=>{U.emitMany(A)})}static fromPromise(A){return new q(async U=>{U.emitMany(await A)})}static fromPromises(A){return new q(async U=>{await Promise.all(A.map(async O=>U.emitOne(await O)))})}static merge(A){return new q(async U=>{await Promise.all(A.map(async O=>{for await(const _ of O)U.emitOne(_)}))})}[Symbol.asyncIterator](){let A=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(A<this._results.length)return{done:!1,value:this._results[A++]};if(this._state===1)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(A,U){return new q(async O=>{for await(const _ of A)O.emitOne(U(_))})}map(A){return q.map(this,A)}static filter(A,U){return new q(async O=>{for await(const _ of A)U(_)&&O.emitOne(_)})}filter(A){return q.filter(this,A)}static coalesce(A){return q.filter(A,U=>!!U)}coalesce(){return q.coalesce(this)}static async toPromise(A){const U=[];for await(const O of A)U.push(O);return U}toPromise(){return q.toPromise(this)}emitOne(A){this._state===0&&(this._results.push(A),this._onStateChanged.fire())}emitMany(A){this._state===0&&(this._results=this._results.concat(A),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(A){this._state===0&&(this._state=2,this._error=A,this._onStateChanged.fire())}}e.AsyncIterableObject=q,q.EMPTY=q.fromArray([]);class W extends q{constructor(A,U){super(U);this._source=A}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=W;function N(F){const A=new p.CancellationTokenSource,U=F(A.token);return new W(A,async O=>{const _=A.token.onCancellationRequested(()=>{_.dispose(),A.dispose(),O.reject(new n.CancellationError)});try{for await(const Y of U){if(A.token.isCancellationRequested)return;O.emitOne(Y)}_.dispose(),A.dispose()}catch(Y){_.dispose(),A.dispose(),O.reject(Y)}})}e.createCancelableAsyncIterable=N}),define(ee[115],te([0,1,8,29,36,9,3,25]),function(j,e,p,n,D,C,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function w(){return Object.create(null)}e.getEmptyExpression=w,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const S="[/\\\\]",b="[^/\\\\]",M=/\//g;function y(B){switch(B){case 0:return"";case 1:return`${b}*?`;default:return`(?:${S}|${b}+${S}|${S}${b}+)*?`}}function f(B,z){if(!B)return[];const G=[];let q=!1,W=!1,N="";for(const F of B){switch(F){case z:if(!q&&!W){G.push(N),N="";continue}break;case"{":q=!0;break;case"}":q=!1;break;case"[":W=!0;break;case"]":W=!1;break}N+=F}return N&&G.push(N),G}e.splitGlobAware=f;function t(B){if(!B)return"";let z="";const G=f(B,e.GLOB_SPLIT);if(G.every(q=>q===e.GLOBSTAR))z=".*";else{let q=!1;G.forEach((W,N)=>{if(W===e.GLOBSTAR){q||(z+=y(2),q=!0);return}let F=!1,A="",U=!1,O="";for(const _ of W){if(_!=="}"&&F){A+=_;continue}if(U&&(_!=="]"||!O)){let Y;_==="-"?Y=_:(_==="^"||_==="!")&&!O?Y="^":_===e.GLOB_SPLIT?Y="":Y=(0,E.escapeRegExpCharacters)(_),O+=Y;continue}switch(_){case"{":F=!0;continue;case"[":U=!0;continue;case"}":{z+=`(?:${f(A,",").map(oe=>t(oe)).join("|")})`,F=!1,A="";break}case"]":z+="["+O+"]",U=!1,O="";break;case"?":z+=b;continue;case"*":z+=y(1);continue;default:z+=(0,E.escapeRegExpCharacters)(_)}}N<G.length-1&&(G[N+1]!==e.GLOBSTAR||N+2<G.length)&&(z+=S),q=!1})}return z}const d=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,P=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,c=new D.LRUCache(1e4),o=function(){return!1},l=function(){return null};function s(B,z){if(!B)return l;let G;typeof B!="string"?G=B.pattern:G=B,G=G.trim();const q=`${G}_${!!z.trimForExclusions}`;let W=c.get(q);if(W)return i(W,B);let N;if(d.test(G)){const F=G.substr(4);W=function(A,U){return typeof A=="string"&&A.endsWith(F)?G:null}}else(N=m.exec(r(G,z)))?W=a(N[1],G):(z.trimForExclusions?P:v).test(G)?W=h(G,z):(N=u.exec(r(G,z)))?W=I(N[1].substr(1),G,!0):(N=g.exec(r(G,z)))?W=I(N[1],G,!1):W=R(G);return c.set(q,W),i(W,B)}function i(B,z){return typeof z=="string"?B:function(G,q){return(0,n.isEqualOrParent)(G,z.base,!k.isLinux)?B(G.substr(z.base.length+1),q):null}}function r(B,z){return z.trimForExclusions&&B.endsWith("/**")?B.substr(0,B.length-2):B}function a(B,z){const G=`/${B}`,q=`\\${B}`,W=function(F,A){return typeof F!="string"?null:A?A===B?z:null:F===B||F.endsWith(G)||F.endsWith(q)?z:null},N=[B];return W.basenames=N,W.patterns=[z],W.allBasenames=N,W}function h(B,z){const G=x(B.slice(1,-1).split(",").map(A=>s(A,z)).filter(A=>A!==l),B),q=G.length;if(!q)return l;if(q===1)return G[0];const W=function(A,U){for(let O=0,_=G.length;O<_;O++)if(G[O](A,U))return B;return null},N=G.find(A=>!!A.allBasenames);N&&(W.allBasenames=N.allBasenames);const F=G.reduce((A,U)=>U.allPaths?A.concat(U.allPaths):A,[]);return F.length&&(W.allPaths=F),W}function I(B,z,G){const q=C.sep===C.posix.sep,W=q?B:B.replace(M,C.sep),N=C.sep+W,F=C.posix.sep+B,A=G?function(U,O){return typeof U=="string"&&(U===W||U.endsWith(N)||!q&&(U===B||U.endsWith(F)))?z:null}:function(U,O){return typeof U=="string"&&(U===W||!q&&U===B)?z:null};return A.allPaths=[(G?"*/":"./")+B],A}function R(B){try{const z=new RegExp(`^${t(B)}$`);return function(G){return z.lastIndex=0,typeof G=="string"&&z.test(G)?B:null}}catch{return l}}function L(B,z,G){return!B||typeof z!="string"?!1:T(B)(z,void 0,G)}e.match=L;function T(B,z={}){if(!B)return o;if(typeof B=="string"||re(B)){const G=s(B,z);if(G===l)return o;const q=function(W,N){return!!G(W,N)};return G.allBasenames&&(q.allBasenames=G.allBasenames),G.allPaths&&(q.allPaths=G.allPaths),q}return H(B,z)}e.parse=T;function $(B){if(!B)return;let z;return G=>(z||(z=(B()||Promise.resolve([])).then(q=>q?se(q):{})),z.then(q=>!!q[G]))}e.hasSiblingPromiseFn=$;function Q(B){if(!B)return;let z;return G=>{if(!z){const q=B();z=q?se(q):{}}return!!z[G]}}e.hasSiblingFn=Q;function se(B){const z={};for(const G of B)z[G]=!0;return z}function re(B){const z=B;return z?typeof z.base=="string"&&typeof z.pattern=="string":!1}e.isRelativePattern=re;function V(B){return B.allBasenames||[]}e.getBasenameTerms=V;function Z(B){return B.allPaths||[]}e.getPathTerms=Z;function H(B,z){const G=x(Object.getOwnPropertyNames(B).map(A=>K(A,B[A],z)).filter(A=>A!==l)),q=G.length;if(!q)return l;if(!G.some(A=>!!A.requiresSiblings)){if(q===1)return G[0];const A=function(_,Y){for(let ie=0,oe=G.length;ie<oe;ie++){const J=G[ie](_,Y);if(J)return J}return null},U=G.find(_=>!!_.allBasenames);U&&(A.allBasenames=U.allBasenames);const O=G.reduce((_,Y)=>Y.allPaths?_.concat(Y.allPaths):_,[]);return O.length&&(A.allPaths=O),A}const W=function(A,U,O){let _;for(let Y=0,ie=G.length;Y<ie;Y++){const oe=G[Y];oe.requiresSiblings&&O&&(U||(U=(0,C.basename)(A)),_||(_=U.substr(0,U.length-(0,C.extname)(A).length)));const J=oe(A,U,_,O);if(J)return J}return null},N=G.find(A=>!!A.allBasenames);N&&(W.allBasenames=N.allBasenames);const F=G.reduce((A,U)=>U.allPaths?A.concat(U.allPaths):A,[]);return F.length&&(W.allPaths=F),W}function K(B,z,G){if(z===!1)return l;const q=s(B,G);if(q===l)return l;if(typeof z=="boolean")return q;if(z){const W=z.when;if(typeof W=="string"){const N=(F,A,U,O)=>{if(!O||!q(F,A))return null;const _=W.replace("$(basename)",U),Y=O(_);return(0,p.isThenable)(Y)?Y.then(ie=>ie?B:null):Y?B:null};return N.requiresSiblings=!0,N}}return q}function x(B,z){const G=B.filter(A=>!!A.basenames);if(G.length<2)return B;const q=G.reduce((A,U)=>{const O=U.basenames;return O?A.concat(O):A},[]);let W;if(z){W=[];for(let A=0,U=q.length;A<U;A++)W.push(z)}else W=G.reduce((A,U)=>{const O=U.patterns;return O?A.concat(O):A},[]);const N=function(A,U){if(typeof A!="string")return null;if(!U){let _;for(_=A.length;_>0;_--){const Y=A.charCodeAt(_-1);if(Y===47||Y===92)break}U=A.substr(_)}const O=q.indexOf(U);return O!==-1?W[O]:null};N.basenames=q,N.patterns=W,N.allBasenames=q;const F=B.filter(A=>!A.basenames);return F.push(N),F}}),define(ee[33],te([0,1,29,10,9,3,16,25,7]),function(j,e,p,n,D,C,k,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function S(i,r,a){if(typeof i=="string"&&(i=w.URI.file(i)),a){const I=a.getWorkspaceFolder(i);if(I){const R=a.getWorkspace().folders.length>1;let L;if((0,k.isEqual)(I.uri,i)?L="":L=(0,k.relativePath)(I.uri,i),R){const T=I.name?I.name:(0,k.basename)(I.uri);L=L?T+" \u2022 "+L:T}return L}}if(i.scheme!==n.Schemas.file&&i.scheme!==n.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,p.hasDriveLetter)(i.fsPath))return(0,D.normalize)(M(i.fsPath));let h=(0,D.normalize)(i.fsPath);return!C.isWindows&&r?.userHome&&(h=f(h,r.userHome.fsPath)),h}e.getPathLabel=S;function b(i){if(!i)return;typeof i=="string"&&(i=w.URI.file(i));const r=(0,k.basename)(i)||(i.scheme===n.Schemas.file?i.fsPath:i.path);return C.isWindows&&(0,p.isRootOrDriveLetter)(r)?M(r):r}e.getBaseLabel=b;function M(i,r){return(0,p.hasDriveLetter)(i,r)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=M;let y=Object.create(null);function f(i,r){if(C.isWindows||!i||!r)return i;let a=y.original===r?y.normalized:void 0;return a||(a=`${(0,E.rtrim)(r,D.posix.sep)}${D.posix.sep}`,y={original:r,normalized:a}),(C.isLinux?i.startsWith(a):(0,E.startsWithIgnoreCase)(i,a))&&(i=`~/${i.substr(a.length)}`),i}e.tildify=f;function t(i,r){return i.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=t;const d="\u2026",m="\\\\",v="~";function P(i,r=D.sep){const a=new Array(i.length);let h=!1;for(let I=0;I<i.length;I++){let R=i[I];if(R===""){a[I]=`.${r}`;continue}if(!R){a[I]=R;continue}h=!0;let L="";R.indexOf(m)===0?(L=R.substr(0,R.indexOf(m)+m.length),R=R.substr(R.indexOf(m)+m.length)):R.indexOf(r)===0?(L=R.substr(0,R.indexOf(r)+r.length),R=R.substr(R.indexOf(r)+r.length)):R.indexOf(v)===0&&(L=R.substr(0,R.indexOf(v)+v.length),R=R.substr(R.indexOf(v)+v.length));const T=R.split(r);for(let $=1;h&&$<=T.length;$++)for(let Q=T.length-$;h&&Q>=0;Q--){h=!1;let se=T.slice(Q,Q+$).join(r);for(let re=0;!h&&re<i.length;re++)if(re!==I&&i[re]&&i[re].indexOf(se)>-1){const V=Q+$===T.length,Z=Q>0&&i[re].indexOf(r)>-1?r+se:se,H=i[re].endsWith(Z);h=!V||H}if(!h){let re="";(T[0].endsWith(":")||L!=="")&&(Q===1&&(Q=0,$++,se=T[0]+r+se),Q>0&&(re=T[0]+r),re=L+re),Q>0&&(re=re+d+r),re=re+se,Q+$<T.length&&(re=re+r+d),a[I]=re}}h&&(a[I]=R)}return a}e.shorten=P;var u;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function g(i,r=Object.create(null)){const a=[];let h=!1,I="";for(const R of i)if(R==="$"||h&&R==="{")I&&a.push({value:I,type:u.TEXT}),I="",h=!0;else if(R==="}"&&h){const L=r[I];if(typeof L=="string")L.length&&a.push({value:L,type:u.VARIABLE});else if(L){const T=a[a.length-1];(!T||T.type!==u.SEPARATOR)&&a.push({value:L.label,type:u.SEPARATOR})}I="",h=!1}else I+=R;return I&&!h&&a.push({value:I,type:u.TEXT}),a.filter((R,L)=>{if(R.type===u.SEPARATOR){const T=a[L-1],$=a[L+1];return[T,$].every(Q=>Q&&(Q.type===u.VARIABLE||Q.type===u.TEXT)&&Q.value.length>0)}return!0}).map(R=>R.value).join("")}e.template=g;function c(i,r){return C.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):i.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function o(i,r){return C.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,""):C.isWindows?i.replace(/&&|&/g,a=>a==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=o;function l(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=l;function s(i){const r=i.indexOf("/")!==-1?D.posix:D.win32,a=r.basename(i),h=r.dirname(i);return a.length?{name:a,parentPath:h}:{name:h,parentPath:""}}e.splitName=s}),define(ee[116],te([0,1,7]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(b){return b.toJSON()}class D{constructor(M){this._uriTransformer=M}transformIncoming(M){const y=this._uriTransformer.transformIncoming(M);return y===M?M:n(p.URI.from(y))}transformOutgoing(M){const y=this._uriTransformer.transformOutgoing(M);return y===M?M:n(p.URI.from(y))}transformOutgoingURI(M){const y=this._uriTransformer.transformOutgoing(M);return y===M?M:p.URI.from(y)}transformOutgoingScheme(M){return this._uriTransformer.transformOutgoingScheme(M)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(b){return b}transformOutgoing(b){return b}transformOutgoingURI(b){return b}transformOutgoingScheme(b){return b}};function C(b,M,y){if(!b||y>200)return null;if(typeof b=="object"){if(b instanceof p.URI)return M.transformOutgoing(b);for(let f in b)if(Object.hasOwnProperty.call(b,f)){const t=C(b[f],M,y+1);t!==null&&(b[f]=t)}}return null}function k(b,M){const y=C(b,M,0);return y===null?b:y}e.transformOutgoingURIs=k;function E(b,M,y,f){if(!b||f>200)return null;if(typeof b=="object"){if(b.$mid===1)return y?p.URI.revive(M.transformIncoming(b)):M.transformIncoming(b);for(let t in b)if(Object.hasOwnProperty.call(b,t)){const d=E(b[t],M,y,f+1);d!==null&&(b[t]=d)}}return null}function w(b,M){const y=E(b,M,!1,0);return y===null?b:y}e.transformIncomingURIs=w;function S(b,M){const y=E(b,M,!0,0);return y===null?b:y}e.transformAndReviveIncomingURIs=S}),define(ee[32],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const p=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(w){return p.test(w)}e.isUUID=n;const D=new Uint8Array(16),C=[];for(let w=0;w<256;w++)C.push(w.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(w){for(let S=0;S<w.length;S++)w[S]=Math.floor(Math.random()*256);return w};function E(){k(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let w=0,S="";return S+=C[D[w++]],S+=C[D[w++]],S+=C[D[w++]],S+=C[D[w++]],S+="-",S+=C[D[w++]],S+=C[D[w++]],S+="-",S+=C[D[w++]],S+=C[D[w++]],S+="-",S+=C[D[w++]],S+=C[D[w++]],S+="-",S+=C[D[w++]],S+=C[D[w++]],S+=C[D[w++]],S+=C[D[w++]],S+=C[D[w++]],S+=C[D[w++]],S}e.generateUuid=E}),define(ee[117],te([0,1,15,4,2,3,13,25]),function(j,e,p,n,D,C,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=e.SimpleWorkerServer=e.SimpleWorkerClient=e.logOnceWebWorkerWarning=void 0;const w="$initialize";let S=!1;function b(s){!C.isWeb||(S||(S=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(s.message))}e.logOnceWebWorkerWarning=b;var M;(function(s){s[s.Request=0]="Request",s[s.Reply=1]="Reply",s[s.SubscribeEvent=2]="SubscribeEvent",s[s.Event=3]="Event",s[s.UnsubscribeEvent=4]="UnsubscribeEvent"})(M||(M={}));class y{constructor(i,r,a,h){this.vsWorker=i,this.req=r,this.method=a,this.args=h,this.type=0}}class f{constructor(i,r,a,h){this.vsWorker=i,this.seq=r,this.res=a,this.err=h,this.type=1}}class t{constructor(i,r,a,h){this.vsWorker=i,this.req=r,this.eventName=a,this.arg=h,this.type=2}}class d{constructor(i,r,a){this.vsWorker=i,this.req=r,this.event=a,this.type=3}}class m{constructor(i,r){this.vsWorker=i,this.req=r,this.type=4}}class v{constructor(i){this._workerId=-1,this._handler=i,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(i){this._workerId=i}sendMessage(i,r){const a=String(++this._lastSentReq);return new Promise((h,I)=>{this._pendingReplies[a]={resolve:h,reject:I},this._send(new y(this._workerId,a,i,r))})}listen(i,r){let a=null;const h=new n.Emitter({onFirstListenerAdd:()=>{a=String(++this._lastSentReq),this._pendingEmitters.set(a,h),this._send(new t(this._workerId,a,i,r))},onLastListenerRemove:()=>{this._pendingEmitters.delete(a),this._send(new m(this._workerId,a)),a=null}});return h.event}handleMessage(i){!i||!i.vsWorker||this._workerId!==-1&&i.vsWorker!==this._workerId||this._handleMessage(i)}_handleMessage(i){switch(i.type){case 1:return this._handleReplyMessage(i);case 0:return this._handleRequestMessage(i);case 2:return this._handleSubscribeEventMessage(i);case 3:return this._handleEventMessage(i);case 4:return this._handleUnsubscribeEventMessage(i)}}_handleReplyMessage(i){if(!this._pendingReplies[i.seq]){console.warn("Got reply to unknown seq");return}let r=this._pendingReplies[i.seq];if(delete this._pendingReplies[i.seq],i.err){let a=i.err;i.err.$isError&&(a=new Error,a.name=i.err.name,a.message=i.err.message,a.stack=i.err.stack),r.reject(a);return}r.resolve(i.res)}_handleRequestMessage(i){let r=i.req;this._handler.handleMessage(i.method,i.args).then(h=>{this._send(new f(this._workerId,r,h,void 0))},h=>{h.detail instanceof Error&&(h.detail=(0,p.transformErrorForSerialization)(h.detail)),this._send(new f(this._workerId,r,void 0,(0,p.transformErrorForSerialization)(h)))})}_handleSubscribeEventMessage(i){const r=i.req,a=this._handler.handleEvent(i.eventName,i.arg)(h=>{this._send(new d(this._workerId,r,h))});this._pendingEvents.set(r,a)}_handleEventMessage(i){if(!this._pendingEmitters.has(i.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(i.req).fire(i.event)}_handleUnsubscribeEventMessage(i){if(!this._pendingEvents.has(i.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(i.req).dispose(),this._pendingEvents.delete(i.req)}_send(i){let r=[];if(i.type===0)for(let a=0;a<i.args.length;a++)i.args[a]instanceof ArrayBuffer&&r.push(i.args[a]);else i.type===1&&i.res instanceof ArrayBuffer&&r.push(i.res);this._handler.sendMessage(i,r)}}class P extends D.Disposable{constructor(i,r,a){super();let h=null;this._worker=this._register(i.create("vs/base/common/worker/simpleWorker",$=>{this._protocol.handleMessage($)},$=>{h&&h($)})),this._protocol=new v({sendMessage:($,Q)=>{this._worker.postMessage($,Q)},handleMessage:($,Q)=>{if(typeof a[$]!="function")return Promise.reject(new Error("Missing method "+$+" on main thread host."));try{return Promise.resolve(a[$].apply(a,Q))}catch(se){return Promise.reject(se)}},handleEvent:($,Q)=>{if(g($)){const se=a[$].call(a,Q);if(typeof se!="function")throw new Error(`Missing dynamic event ${$} on main thread host.`);return se}if(u($)){const se=a[$];if(typeof se!="function")throw new Error(`Missing event ${$} on main thread host.`);return se}throw new Error(`Malformed event name ${$}`)}}),this._protocol.setWorkerId(this._worker.getId());let I=null;typeof C.globals.require!="undefined"&&typeof C.globals.require.getConfig=="function"?I=C.globals.require.getConfig():typeof C.globals.requirejs!="undefined"&&(I=C.globals.requirejs.s.contexts._.config);const R=k.getAllMethodNames(a);this._onModuleLoaded=this._protocol.sendMessage(w,[this._worker.getId(),JSON.parse(JSON.stringify(I)),r,R]);const L=($,Q)=>this._request($,Q),T=($,Q)=>this._protocol.listen($,Q);this._lazyProxy=new Promise(($,Q)=>{h=Q,this._onModuleLoaded.then(se=>{$(c(se,L,T))},se=>{Q(se),this._onError("Worker failed to load "+r,se)})})}getProxyObject(){return this._lazyProxy}_request(i,r){return new Promise((a,h)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(i,r).then(a,h)},h)})}_onError(i,r){console.error(i),console.info(r)}}e.SimpleWorkerClient=P;function u(s){return s[0]==="o"&&s[1]==="n"&&E.isUpperAsciiLetter(s.charCodeAt(2))}function g(s){return/^onDynamic/.test(s)&&E.isUpperAsciiLetter(s.charCodeAt(9))}function c(s,i,r){const a=R=>function(){const L=Array.prototype.slice.call(arguments,0);return i(R,L)},h=R=>function(L){return r(R,L)};let I={};for(const R of s){if(g(R)){I[R]=h(R);continue}if(u(R)){I[R]=r(R,void 0);continue}I[R]=a(R)}return I}class o{constructor(i,r){this._requestHandlerFactory=r,this._requestHandler=null,this._protocol=new v({sendMessage:(a,h)=>{i(a,h)},handleMessage:(a,h)=>this._handleMessage(a,h),handleEvent:(a,h)=>this._handleEvent(a,h)})}onmessage(i){this._protocol.handleMessage(i)}_handleMessage(i,r){if(i===w)return this.initialize(r[0],r[1],r[2],r[3]);if(!this._requestHandler||typeof this._requestHandler[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._requestHandler[i].apply(this._requestHandler,r))}catch(a){return Promise.reject(a)}}_handleEvent(i,r){if(!this._requestHandler)throw new Error("Missing requestHandler");if(g(i)){const a=this._requestHandler[i].call(this._requestHandler,r);if(typeof a!="function")throw new Error(`Missing dynamic event ${i} on request handler.`);return a}if(u(i)){const a=this._requestHandler[i];if(typeof a!="function")throw new Error(`Missing event ${i} on request handler.`);return a}throw new Error(`Malformed event name ${i}`)}initialize(i,r,a,h){this._protocol.setWorkerId(i);const L=c(h,(T,$)=>this._protocol.sendMessage(T,$),(T,$)=>this._protocol.listen(T,$));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(L),Promise.resolve(k.getAllMethodNames(this._requestHandler))):(r&&(typeof r.baseUrl!="undefined"&&delete r.baseUrl,typeof r.paths!="undefined"&&typeof r.paths.vs!="undefined"&&delete r.paths.vs,typeof r.trustedTypesPolicy!==void 0&&delete r.trustedTypesPolicy,r.catchError=!0,C.globals.require.config(r)),new Promise((T,$)=>{(C.globals.require||j)([a],se=>{if(this._requestHandler=se.create(L),!this._requestHandler){$(new Error("No RequestHandler!"));return}T(k.getAllMethodNames(this._requestHandler))},$)}))}}e.SimpleWorkerServer=o;function l(s){return new o(s,null)}e.create=l}),define(ee[118],te([0,1,60,30,43]),function(j,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function C(k,E){if(await new Promise((b,M)=>{const y=n.createReadStream(k),f=p.createHash("sha1");y.pipe(f);const t=(0,D.once)((d,m)=>{y.removeAllListeners(),f.removeAllListeners(),d?M(d):b(m)});y.once("error",t),y.once("end",t),f.once("error",t),f.once("data",d=>t(void 0,d.toString("hex")))})!==E)throw new Error("Hash mismatch")}e.checksum=C}),define(ee[119],te([0,1,253]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class n{constructor(C="utf8"){this.stringDecoder=new p.StringDecoder(C),this.remaining=null}write(C){const k=[],E=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(E.length<1)return k;let w=0,S,b=w;for(;b<E.length;)if(S=E.charCodeAt(b),S===13||S===10){if(k.push(E.substring(w,b)),b++,b<E.length){const M=S;S=E.charCodeAt(b),(M===13&&S===10||M===10&&S===13)&&b++}w=b}else b++;return this.remaining=w<E.length?E.substr(w):null,k}end(){return this.remaining}}e.LineDecoder=n}),define(ee[120],te([0,1,26]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const n=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(k){const E=k.replace(/\-/g,":").toLowerCase();return!n.has(E)}function C(){const k=(0,p.networkInterfaces)();for(let E in k){const w=k[E];if(w){for(const{mac:S}of w)if(D(S))return S}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=C}),define(ee[73],te([0,1,26,15,36,32,120]),function(j,e,p,n,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(b){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(b)}value(){if(this._value===void 0){let b=0,M=0;const y=(0,p.networkInterfaces)();for(let f in y){const t=y[f];if(t)for(const{mac:d,internal:m}of t)m||(M+=1,this._isVirtualMachineMacAddress(d.toUpperCase())&&(b+=1))}this._value=M>0?b/M:0}return this._value}};let E;async function w(){return E||(E=(async()=>await S()||C.generateUuid())()),E}e.getMachineId=w;async function S(){try{const b=await new Promise((y,f)=>{j(["crypto"],y,f)}),M=(0,k.getMac)();return b.createHash("sha256").update(M,"utf8").digest("hex")}catch(b){n.onUnexpectedError(b);return}}}),define(ee[24],te([0,1,30,26,121,8,29,72,9,3,16,7]),function(j,e,p,n,D,C,k,E,w,S,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(V){V[V.UNLINK=0]="UNLINK",V[V.MOVE=1]="MOVE"})(y=e.RimRafMode||(e.RimRafMode={}));async function f(V,Z=y.UNLINK){if((0,k.isRootOrDriveLetter)(V))throw new Error("rimraf - will refuse to recursively delete root");return Z===y.UNLINK?d(V):t(V)}async function t(V){try{const Z=(0,k.randomPath)((0,n.tmpdir)());try{await p.promises.rename(V,Z)}catch{return d(V)}d(Z).catch(H=>{})}catch(Z){if(Z.code!=="ENOENT")throw Z}}async function d(V){return(0,D.promisify)(p.rm)(V,{recursive:!0,force:!0,maxRetries:3})}function m(V){if((0,k.isRootOrDriveLetter)(V))throw new Error("rimraf - will refuse to recursively delete root");p.rmSync(V,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=m;async function v(V,Z){return g(await(Z?P(V):(0,D.promisify)(p.readdir)(V)))}async function P(V){try{return await(0,D.promisify)(p.readdir)(V,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const Z=[],H=await v(V);for(const K of H){let x=!1,B=!1,z=!1;try{const G=await e.Promises.lstat((0,w.join)(V,K));x=G.isFile(),B=G.isDirectory(),z=G.isSymbolicLink()}catch(G){console.warn("[node.js fs] unexpected error from lstat after readdir: ",G)}Z.push({name:K,isFile:()=>x,isDirectory:()=>B,isSymbolicLink:()=>z})}return Z}function u(V){return g(p.readdirSync(V))}e.readdirSync=u;function g(V){return V.map(Z=>typeof Z=="string"?S.isMacintosh?(0,E.normalizeNFC)(Z):Z:(Z.name=S.isMacintosh?(0,E.normalizeNFC)(Z.name):Z.name,Z))}async function c(V){const Z=await v(V),H=[];for(const K of Z)await l.existsDirectory((0,w.join)(V,K))&&H.push(K);return H}function o(V,Z=1e3){return new Promise(H=>{let K=!1;const x=setInterval(()=>{K||(K=!0,p.access(V,B=>{K=!1,B&&(clearInterval(x),H(void 0))}))},Z)})}e.whenDeleted=o;var l;(function(V){async function Z(x){let B;try{if(B=await e.Promises.lstat(x),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(z){if(z.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(S.isWindows&&z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(G){if(G.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw G}throw z}}V.stat=Z;async function H(x){try{const{stat:B,symbolicLink:z}=await V.stat(x);return B.isFile()&&z?.dangling!==!0}catch{}return!1}V.existsFile=H;async function K(x){try{const{stat:B,symbolicLink:z}=await V.stat(x);return B.isDirectory()&&z?.dangling!==!0}catch{}return!1}V.existsDirectory=K})(l=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new C.ResourceQueue;function i(V,Z,H){return s.queueFor(M.URI.file(V),b.extUriBiasedIgnorePathCase).queue(()=>{const K=I(H);return new Promise((x,B)=>a(V,Z,K,z=>z?B(z):x()))})}let r=!0;function a(V,Z,H,K){if(!r)return p.writeFile(V,Z,{mode:H.mode,flag:H.flag},K);p.open(V,H.flag,H.mode,(x,B)=>{if(x)return K(x);p.writeFile(B,Z,z=>{if(z)return p.close(B,()=>K(z));p.fdatasync(B,G=>(G&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",G),r=!1),p.close(B,q=>K(q))))})})}function h(V,Z,H){const K=I(H);if(!r)return p.writeFileSync(V,Z,{mode:K.mode,flag:K.flag});const x=p.openSync(V,K.flag,K.mode);try{p.writeFileSync(x,Z);try{p.fdatasyncSync(x)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),r=!1}}finally{p.closeSync(x)}}e.writeFileSync=h;function I(V){return V?{mode:typeof V.mode=="number"?V.mode:438,flag:typeof V.flag=="string"?V.flag:"w"}:{mode:438,flag:"w"}}async function R(V,Z){if(V===Z)return;async function H(K){try{const x=await e.Promises.lstat(K);if(x.isDirectory()||x.isSymbolicLink())return;await e.Promises.utimes(K,x.atime,new Date)}catch{}}try{await e.Promises.rename(V,Z),await H(Z)}catch(K){if(V.toLowerCase()!==Z.toLowerCase()&&K.code==="EXDEV"||V.endsWith("."))await L(V,Z,{preserveSymlinks:!1}),await f(V,y.MOVE),await H(Z);else throw K}}async function L(V,Z,H){return $(V,Z,{root:{source:V,target:Z},options:H,handledSourcePaths:new Set})}const T=511;async function $(V,Z,H){if(H.handledSourcePaths.has(V))return;H.handledSourcePaths.add(V);const{stat:K,symbolicLink:x}=await l.stat(V);if(x){if(H.options.preserveSymlinks)try{return await re(V,Z,H)}catch(B){console.warn("[node.js fs] copy of symlink failed: ",B)}if(x.dangling)return}return K.isDirectory()?Q(V,Z,K.mode&T,H):se(V,Z,K.mode&T)}async function Q(V,Z,H,K){await e.Promises.mkdir(Z,{recursive:!0,mode:H});const x=await v(V);for(const B of x)await $((0,w.join)(V,B),(0,w.join)(Z,B),K)}async function se(V,Z,H){await e.Promises.copyFile(V,Z),await e.Promises.chmod(Z,H)}async function re(V,Z,H){let K=await e.Promises.readlink(V);(0,k.isEqualOrParent)(K,H.root.source,!S.isLinux)&&(K=(0,w.join)(H.root.target,K.substr(H.root.source.length+1))),await e.Promises.symlink(K,Z)}e.Promises=new class{get access(){return(0,D.promisify)(p.access)}get stat(){return(0,D.promisify)(p.stat)}get lstat(){return(0,D.promisify)(p.lstat)}get utimes(){return(0,D.promisify)(p.utimes)}get read(){return(V,Z,H,K,x)=>new Promise((B,z)=>{p.read(V,Z,H,K,x,(G,q,W)=>G?z(G):B({bytesRead:q,buffer:W}))})}get readFile(){return(0,D.promisify)(p.readFile)}get write(){return(V,Z,H,K,x)=>new Promise((B,z)=>{p.write(V,Z,H,K,x,(G,q,W)=>G?z(G):B({bytesWritten:q,buffer:W}))})}get appendFile(){return(0,D.promisify)(p.appendFile)}get fdatasync(){return(0,D.promisify)(p.fdatasync)}get truncate(){return(0,D.promisify)(p.truncate)}get rename(){return(0,D.promisify)(p.rename)}get copyFile(){return(0,D.promisify)(p.copyFile)}get open(){return(0,D.promisify)(p.open)}get close(){return(0,D.promisify)(p.close)}get symlink(){return(0,D.promisify)(p.symlink)}get readlink(){return(0,D.promisify)(p.readlink)}get chmod(){return(0,D.promisify)(p.chmod)}get mkdir(){return(0,D.promisify)(p.mkdir)}get unlink(){return(0,D.promisify)(p.unlink)}get rmdir(){return(0,D.promisify)(p.rmdir)}get realpath(){return(0,D.promisify)(p.realpath)}async exists(V){try{return await e.Promises.access(V),!0}catch{return!1}}get readdir(){return v}get readDirsInDir(){return c}get writeFile(){return i}get rm(){return f}get move(){return R}get copy(){return L}}}),define(ee[85],te([0,1,30,9,3,25,24]),function(j,e,p,n,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function E(y){if(D.isLinux)return y;const f=(0,n.dirname)(y);if(y===f)return y;const t=((0,n.basename)(y)||y).toLowerCase();try{const m=(0,k.readdirSync)(f).filter(v=>v.toLowerCase()===t);if(m.length===1){const v=E(f);if(v)return(0,n.join)(v,m[0])}else if(m.length>1){const v=m.indexOf(t);if(v>=0){const P=E(f);if(P)return(0,n.join)(P,m[v])}}}catch{}return null}e.realcaseSync=E;async function w(y){if(D.isLinux)return y;const f=(0,n.dirname)(y);if(y===f)return y;const t=((0,n.basename)(y)||y).toLowerCase();try{const m=(await k.Promises.readdir(f)).filter(v=>v.toLowerCase()===t);if(m.length===1){const v=await w(f);if(v)return(0,n.join)(v,m[0])}else if(m.length>1){const v=m.indexOf(t);if(v>=0){const P=await w(f);if(P)return(0,n.join)(P,m[v])}}}catch{}return null}e.realcase=w;async function S(y){try{return await k.Promises.realpath(y)}catch{const t=M(y);return await k.Promises.access(t,p.constants.R_OK),t}}e.realpath=S;function b(y){try{return p.realpathSync(y)}catch{const t=M(y);return p.accessSync(t,p.constants.R_OK),t}}e.realpathSync=b;function M(y){return(0,C.rtrim)((0,n.normalize)(y),n.sep)}}),define(ee[122],te([0,1,61]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function n(E,w,S,b=1){let M=!1;return new Promise(y=>{const f=setTimeout(()=>{if(!M)return M=!0,y(0)},S);D(E,w,b,t=>{if(!M)return M=!0,clearTimeout(f),y(t)})})}e.findFreePort=n;function D(E,w,S,b){if(w===0)return b(0);const M=new p.Socket;M.once("connect",()=>(k(M),D(E+S,w-1,S,b))),M.once("data",()=>{}),M.once("error",y=>(k(M),y.code!=="ECONNREFUSED"?D(E+S,w-1,S,b):b(E))),M.connect(E,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function C(E,w,S){let b=!1,M,y=1;const f=p.createServer({pauseOnConnect:!0});function t(d,m){b||(b=!0,f.removeAllListeners(),f.close(),M&&clearTimeout(M),m(d))}return new Promise(d=>{M=setTimeout(()=>{t(0,d)},S),f.on("listening",()=>{t(E,d)}),f.on("error",m=>{m&&(m.code==="EADDRINUSE"||m.code==="EACCES")&&y<w?(E++,y++,f.listen(E,"127.0.0.1")):t(0,d)}),f.on("close",()=>{t(0,d)}),f.listen(E,"127.0.0.1")})}e.findFreePortFaster=C;function k(E){try{E.removeAllListeners("connect"),E.removeAllListeners("error"),E.end(),E.destroy(),E.unref()}catch(w){console.error(w)}}}),define(ee[123],te([0,1,26,9,24]),function(j,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const C=/^\d+$/,k=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var w;(function(g){g[g.x64=0]="x64",g[g.x86=1]="x86",g[g.ARM=2]="ARM"})(w||(w={}));let S;switch(process.arch){case"ia32":case"x32":S=1;break;case"arm":case"arm64":S=2;break;default:S=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class M{constructor(c,o,l){this.exePath=c,this.displayName=o,this.knownToExist=l}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function y({useAlternateBitness:g=!1}={}){return g?S===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:g=!1,findPreview:c=!1}={}){const o=y({useAlternateBitness:g});if(!o)return null;const l=n.join(o,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(l))return null;let s=-1,i=null;for(const h of await D.Promises.readdir(l)){let I=-1;if(c){const L=h.indexOf("-");if(L<0)continue;const T=h.substring(0,L);if(!C.test(T)||h.substring(L+1)!=="preview")continue;I=parseInt(T,10)}else{if(!C.test(h))continue;I=parseInt(h,10)}if(I<=s)continue;const R=n.join(l,h,"pwsh.exe");!await D.SymlinkSupport.existsFile(R)||(i=R,s=I)}if(!i)return null;const r=o.includes("x86")?" (x86)":"",a=c?" Preview":"";return new M(i,`PowerShell${a}${r}`,!0)}async function t({findPreview:g}={}){if(!process.env.LOCALAPPDATA)return null;const c=n.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:o,pwshMsixName:l}=g?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const s of await D.Promises.readdir(c))if(o.test(s)){const i=n.join(c,s,"pwsh.exe");return new M(i,l)}return null}function d(){const g=n.join(p.homedir(),".dotnet","tools","pwsh.exe");return new M(g,".NET Core PowerShell Global Tool")}function m(){const g=n.join(process.env.windir,S===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new M(g,"Windows PowerShell",!0)}async function*v(){let g=await f();g&&(yield g),g=await f({useAlternateBitness:!0}),g&&(yield g),g=await t(),g&&(yield g),g=d(),g&&(yield g),g=await f({findPreview:!0}),g&&(yield g),g=await t({findPreview:!0}),g&&(yield g),g=await f({useAlternateBitness:!0,findPreview:!0}),g&&(yield g),g=m(),g&&(yield g)}async function*P(){for await(const g of v())await g.exists()&&(yield g)}e.enumeratePowerShellInstallations=P;async function u(){for await(const g of P())return g;return null}e.getFirstAvailablePowerShellInstallation=u}),define(ee[86],te([0,1,45,10]),function(j,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(k){return new Promise((E,w)=>{let S;const b=new Map;function M(f,t,d,m,v){const P=b.get(t);if(f===k||P){const u={name:y(d),cmd:d,pid:f,ppid:t,load:m,mem:v};b.set(f,u),f===k&&(S=u),P&&(P.children||(P.children=[]),P.children.push(u),P.children.length>1&&(P.children=P.children.sort((g,c)=>g.pid-c.pid)))}}function y(f){const t=/--vscode-window-kind=shared-process/,d=/--vscode-window-kind=issue-reporter/,m=/--vscode-window-kind=process-explorer/,v=/--utility-sub-type=network/,P=/--crashes-directory/,u=/\\pipe\\winpty-control/,g=/conhost\.exe/,c=/--type=([a-zA-Z-]+)/;if(P.exec(f))return"electron-crash-reporter";if(u.exec(f))return"winpty-process";if(g.exec(f))return"console-window-host (Windows internal process)";let o=c.exec(f);if(o&&o.length===2)return o[1]==="renderer"?t.exec(f)?"shared-process":d.exec(f)?"issue-reporter":m.exec(f)?"process-explorer":"window":o[1]==="utility"&&v.exec(f)?"utility-network-service":o[1];const l=/[a-zA-Z-]+\.js/g;let s="";do o=l.exec(f),o&&(s+=o+" ");while(o);return s&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron_node ${s}`:f}if(process.platform==="win32"){const f=t=>t.indexOf("\\\\?\\")===0||t.indexOf("\\??\\")===0?t.substr(4):t.indexOf('"\\\\?\\')===0||t.indexOf('"\\??\\')===0?'"'+t.substr(5):t;new Promise((t,d)=>{j(["windows-process-tree"],t,d)}).then(t=>{t.getProcessList(k,d=>{t.getProcessCpuUsage(d,m=>{const v=new Map;m.forEach(P=>{const u=f(P.commandLine||"");v.set(P.pid,{name:y(u),cmd:u,pid:P.pid,ppid:P.ppid,load:P.cpu||0,mem:P.memory||0})}),S=v.get(k),S?(v.forEach(P=>{const u=v.get(P.ppid);u&&(u.children||(u.children=[]),u.children.push(P))}),v.forEach(P=>{P.children&&(P.children=P.children.sort((u,g)=>u.pid-g.pid))}),E(S)):w(new Error(`Root process ${k} not found`))})},t.ProcessDataFlag.CommandLine|t.ProcessDataFlag.Memory)})}else{let f=function(){let t=[S];const d=[];for(;t.length;){const v=t.shift();v&&(d.push(v.pid),v.children&&(t=t.concat(v.children)))}let m=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",j).fsPath);m+=" "+d.join(" "),(0,p.exec)(m,{},(v,P,u)=>{if(v||u)w(v||new Error(u.toString()));else{const g=P.toString().split(`
`);for(let c=0;c<d.length;c++){const o=b.get(d[c]);o.load=parseFloat(g[c])}if(!S){w(new Error(`Root process ${k} not found`));return}E(S)}})};(0,p.exec)("which ps",{},(t,d,m)=>{if(t||m)if(process.platform!=="linux")w(t||new Error(m.toString()));else{const v=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/ps.sh",j).fsPath);(0,p.exec)(v,{},(P,u,g)=>{P||g?w(P||new Error(g.toString())):(C(u,M),f())})}else{const v=d.toString().trim(),P="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,p.exec)(`${v} ${P}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(u,g,c)=>{u||c&&!c.includes("screen size is bogus")?w(u||new Error(c.toString())):(C(g,M),process.platform==="linux"?f():S?E(S):w(new Error(`Root process ${k} not found`)))})}})}})}e.listProcesses=D;function C(k,E){const w=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,S=k.toString().split(`
`);for(const b of S){const M=w.exec(b.trim());M&&M.length===6&&E(parseInt(M[1]),parseInt(M[2]),M[5],parseFloat(M[3]),parseFloat(M[4]))}}}),define(ee[124],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ee[125],te([0,1,14,13,124]),function(j,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function C(){p.ipcMain.on(D.CONTEXT_MENU_CHANNEL,(E,w,S,b,M)=>{const y=k(E,b,S);y.popup({window:(0,n.withNullAsUndefined)(p.BrowserWindow.fromWebContents(E.sender)),x:M?M.x:void 0,y:M?M.y:void 0,positioningItem:M?M.positioningItem:void 0,callback:()=>{y&&E.sender.send(D.CONTEXT_MENU_CLOSE_CHANNEL,w)}})})}e.registerContextMenuListener=C;function k(E,w,S){const b=new p.Menu;return S.forEach(M=>{let y;M.type==="separator"?y=new p.MenuItem({type:M.type}):Array.isArray(M.submenu)?y=new p.MenuItem({submenu:k(E,w,M.submenu),label:M.label}):y=new p.MenuItem({label:M.label,type:M.type,accelerator:M.accelerator,checked:M.checked,enabled:M.enabled,visible:M.visible,click:(f,t,d)=>E.sender.send(w,M.id,d)}),b.append(y)}),b}});var de=this&&this.__decorate||function(j,e,p,n){var D=arguments.length,C=D<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,p):n,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(j,e,p,n);else for(var E=j.length-1;E>=0;E--)(k=j[E])&&(C=(D<3?k(C):D>3?k(e,p,C):k(e,p))||C);return D>3&&C&&Object.defineProperty(e,p,C),C};define(ee[37],te([0,1,28,8,17,21,46,15,4,2,114,25,13]),function(j,e,p,n,D,C,k,E,w,S,b,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var f;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(f=e.RequestType||(e.RequestType={}));function t(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(d=e.ResponseType||(e.ResponseType={}));function m(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var v;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(v||(v={}));class P{constructor(z){this.buffer=z,this.pos=0}read(z){const G=this.buffer.slice(this.pos,this.pos+z);return this.pos+=G.byteLength,G}}class u{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(z){this.buffers.push(z)}}var g;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object"})(g||(g={}));function c(B){const z=D.VSBuffer.alloc(4);return z.writeUInt32BE(B,0),z}function o(B){return B.read(4).readUInt32BE(0)}function l(B){const z=D.VSBuffer.alloc(1);return z.writeUInt8(B,0),z}const s={Undefined:l(g.Undefined),String:l(g.String),Buffer:l(g.Buffer),VSBuffer:l(g.VSBuffer),Array:l(g.Array),Object:l(g.Object)},i=typeof Buffer!="undefined";function r(B,z){if(typeof z=="undefined")B.write(s.Undefined);else if(typeof z=="string"){const G=D.VSBuffer.fromString(z);B.write(s.String),B.write(c(G.byteLength)),B.write(G)}else if(i&&Buffer.isBuffer(z)){const G=D.VSBuffer.wrap(z);B.write(s.Buffer),B.write(c(G.byteLength)),B.write(G)}else if(z instanceof D.VSBuffer)B.write(s.VSBuffer),B.write(c(z.byteLength)),B.write(z);else if(Array.isArray(z)){B.write(s.Array),B.write(c(z.length));for(const G of z)r(B,G)}else{const G=D.VSBuffer.fromString(JSON.stringify(z));B.write(s.Object),B.write(c(G.byteLength)),B.write(G)}}function a(B){switch(B.read(1).readUInt8(0)){case g.Undefined:return;case g.String:return B.read(o(B)).toString();case g.Buffer:return B.read(o(B)).buffer;case g.VSBuffer:return B.read(o(B));case g.Array:{const G=o(B),q=[];for(let W=0;W<G;W++)q.push(a(B));return q}case g.Object:return JSON.parse(B.read(o(B)).toString())}}class h{constructor(z,G,q=null,W=1e3){this.protocol=z,this.ctx=G,this.logger=q,this.timeoutDelay=W,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(N=>this.onRawMessage(N)),this.sendResponse({type:200})}registerChannel(z,G){this.channels.set(z,G),setTimeout(()=>this.flushPendingRequests(z),0)}sendResponse(z){switch(z.type){case 200:{const G=this.send([z.type]);this.logger&&this.logger.logOutgoing(G,0,1,m(z.type));return}case 201:case 202:case 204:case 203:{const G=this.send([z.type,z.id],z.data);this.logger&&this.logger.logOutgoing(G,z.id,1,m(z.type),z.data);return}}}send(z,G=void 0){const q=new u;return r(q,z),r(q,G),this.sendBuffer(q.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch{return 0}}onRawMessage(z){const G=new P(z),q=a(G),W=a(G),N=q[0];switch(N){case 100:return this.logger&&this.logger.logIncoming(z.byteLength,q[1],1,`${t(N)}: ${q[2]}.${q[3]}`,W),this.onPromise({type:N,id:q[1],channelName:q[2],name:q[3],arg:W});case 102:return this.logger&&this.logger.logIncoming(z.byteLength,q[1],1,`${t(N)}: ${q[2]}.${q[3]}`,W),this.onEventListen({type:N,id:q[1],channelName:q[2],name:q[3],arg:W});case 101:return this.logger&&this.logger.logIncoming(z.byteLength,q[1],1,`${t(N)}`),this.disposeActiveRequest({type:N,id:q[1]});case 103:return this.logger&&this.logger.logIncoming(z.byteLength,q[1],1,`${t(N)}`),this.disposeActiveRequest({type:N,id:q[1]})}}onPromise(z){const G=this.channels.get(z.channelName);if(!G){this.collectPendingRequest(z);return}const q=new C.CancellationTokenSource;let W;try{W=G.call(this.ctx,z.name,z.arg,q.token)}catch(A){W=Promise.reject(A)}const N=z.id;W.then(A=>{this.sendResponse({id:N,data:A,type:201}),this.activeRequests.delete(z.id)},A=>{A instanceof Error?this.sendResponse({id:N,data:{message:A.message,name:A.name,stack:A.stack?A.stack.split?A.stack.split(`
`):A.stack:void 0},type:202}):this.sendResponse({id:N,data:A,type:203}),this.activeRequests.delete(z.id)});const F=(0,S.toDisposable)(()=>q.cancel());this.activeRequests.set(z.id,F)}onEventListen(z){const G=this.channels.get(z.channelName);if(!G){this.collectPendingRequest(z);return}const q=z.id,N=G.listen(this.ctx,z.name,z.arg)(F=>this.sendResponse({id:q,data:F,type:204}));this.activeRequests.set(z.id,N)}disposeActiveRequest(z){const G=this.activeRequests.get(z.id);G&&(G.dispose(),this.activeRequests.delete(z.id))}collectPendingRequest(z){let G=this.pendingRequests.get(z.channelName);G||(G=[],this.pendingRequests.set(z.channelName,G));const q=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===100&&this.sendResponse({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);G.push({request:z,timeoutTimer:q})}flushPendingRequests(z){const G=this.pendingRequests.get(z);if(G){for(const q of G)switch(clearTimeout(q.timeoutTimer),q.request.type){case 100:this.onPromise(q.request);break;case 102:this.onEventListen(q.request);break}this.pendingRequests.delete(z)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(z=>z.dispose()),this.activeRequests.clear()}}e.ChannelServer=h;var I;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(I=e.RequestInitiator||(e.RequestInitiator={}));class R{constructor(z,G=null){this.protocol=z,this.isDisposed=!1,this.state=v.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new w.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(q=>this.onBuffer(q)),this.logger=G}getChannel(z){const G=this;return{call(q,W,N){return G.isDisposed?Promise.reject(E.canceled()):G.requestPromise(z,q,W,N)},listen(q,W){return G.isDisposed?Promise.reject(E.canceled()):G.requestEvent(z,q,W)}}}requestPromise(z,G,q,W=C.CancellationToken.None){const N=this.lastRequestId++,A={id:N,type:100,channelName:z,name:G,arg:q};if(W.isCancellationRequested)return Promise.reject(E.canceled());let U;return new Promise((_,Y)=>{if(W.isCancellationRequested)return Y(E.canceled());const ie=()=>{const le=he=>{switch(he.type){case 201:this.handlers.delete(N),_(he.data);break;case 202:{this.handlers.delete(N);const we=new Error(he.data.message);we.stack=he.data.stack,we.name=he.data.name,Y(we);break}case 203:this.handlers.delete(N),Y(he.data);break}};this.handlers.set(N,le),this.sendRequest(A)};let oe=null;this.state===v.Idle?ie():(oe=(0,n.createCancelablePromise)(le=>this.whenInitialized()),oe.then(()=>{oe=null,ie()}));const J=()=>{oe?(oe.cancel(),oe=null):this.sendRequest({id:N,type:101}),Y(E.canceled())},ce=W.onCancellationRequested(J);U=(0,S.combinedDisposable)((0,S.toDisposable)(J),ce),this.activeRequests.add(U)}).finally(()=>{this.activeRequests.delete(U)})}requestEvent(z,G,q){const W=this.lastRequestId++,F={id:W,type:102,channelName:z,name:G,arg:q};let A=null;const U=new w.Emitter({onFirstListenerAdd:()=>{A=(0,n.createCancelablePromise)(_=>this.whenInitialized()),A.then(()=>{A=null,this.activeRequests.add(U),this.sendRequest(F)})},onLastListenerRemove:()=>{A?(A.cancel(),A=null):(this.activeRequests.delete(U),this.sendRequest({id:W,type:103}))}}),O=_=>U.fire(_.data);return this.handlers.set(W,O),U.event}sendRequest(z){switch(z.type){case 100:case 102:{const G=this.send([z.type,z.id,z.channelName,z.name],z.arg);this.logger&&this.logger.logOutgoing(G,z.id,0,`${t(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case 101:case 103:{const G=this.send([z.type,z.id]);this.logger&&this.logger.logOutgoing(G,z.id,0,t(z.type));return}}}send(z,G=void 0){const q=new u;return r(q,z),r(q,G),this.sendBuffer(q.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch{return 0}}onBuffer(z){const G=new P(z),q=a(G),W=a(G),N=q[0];switch(N){case 200:return this.logger&&this.logger.logIncoming(z.byteLength,0,0,m(N)),this.onResponse({type:q[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(z.byteLength,q[1],0,m(N),W),this.onResponse({type:q[0],id:q[1],data:W})}}onResponse(z){if(z.type===200){this.state=v.Idle,this._onDidInitialize.fire();return}const G=this.handlers.get(z.id);G&&G(z)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===v.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(z=>z.dispose()),this.activeRequests.clear()}}de([k.memoize],R.prototype,"onDidInitializePromise",null),e.ChannelClient=R;class L{constructor(z){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new w.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new w.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,z(({protocol:G,onDidClientDisconnect:q})=>{w.Event.once(G.onMessage)(N=>{const F=new P(N),A=a(F),U=new h(G,A),O=new R(G);this.channels.forEach((Y,ie)=>U.registerChannel(ie,Y));const _={channelServer:U,channelClient:O,ctx:A};this._connections.add(_),this._onDidAddConnection.fire(_),q(()=>{U.dispose(),O.dispose(),this._connections.delete(_),this._onDidRemoveConnection.fire(_)})})})}get connections(){const z=[];return this._connections.forEach(G=>z.push(G)),z}getChannel(z,G){const q=this;return{call(W,N,F){let A;if((0,y.isFunction)(G)){let O=(0,p.getRandomElement)(q.connections.filter(G));A=O?Promise.resolve(O):w.Event.toPromise(w.Event.filter(q.onDidAddConnection,G))}else A=G.routeCall(q,W,N);const U=A.then(O=>O.channelClient.getChannel(z));return $(U).call(W,N,F)},listen(W,N){if((0,y.isFunction)(G))return q.getMulticastEvent(z,G,W,N);const F=G.routeEvent(q,W,N).then(A=>A.channelClient.getChannel(z));return $(F).listen(W,N)}}}getMulticastEvent(z,G,q,W){const N=this;let F=new S.DisposableStore;const A=new w.Emitter({onFirstListenerAdd:()=>{F=new S.DisposableStore;const U=new w.EventMultiplexer,O=new Map,_=ie=>{const J=ie.channelClient.getChannel(z).listen(q,W),ce=U.add(J);O.set(ie,ce)},Y=ie=>{const oe=O.get(ie);!oe||(oe.dispose(),O.delete(ie))};N.connections.filter(G).forEach(_),w.Event.filter(N.onDidAddConnection,G)(_,void 0,F),N.onDidRemoveConnection(Y,void 0,F),U.event(A.fire,A,F),F.add(U)},onLastListenerRemove:()=>{F.dispose()}});return A.event}registerChannel(z,G){this.channels.set(z,G),this._connections.forEach(q=>{q.channelServer.registerChannel(z,G)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=L;class T{constructor(z,G,q=null){const W=new u;r(W,G),z.send(W.buffer),this.channelClient=new R(z,q),this.channelServer=new h(z,G,q)}getChannel(z){return this.channelClient.getChannel(z)}registerChannel(z,G){this.channelServer.registerChannel(z,G)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function $(B){return{call(z,G,q){return B.then(W=>W.call(z,G,q))},listen(z,G){const q=new w.Relay;return B.then(W=>q.input=W.listen(z,G)),q.event}}}e.getDelayedChannel=$;function Q(B){let z=!1;return{call(G,q,W){return z?B.call(G,q,W):(0,n.timeout)(0).then(()=>z=!0).then(()=>B.call(G,q,W))},listen(G,q){if(z)return B.listen(G,q);const W=new w.Relay;return(0,n.timeout)(0).then(()=>z=!0).then(()=>W.input=B.listen(G,q)),W.event}}}e.getNextTickChannel=Q;class se{constructor(z){this.fn=z}routeCall(z){return this.route(z)}routeEvent(z){return this.route(z)}async route(z){for(const G of z.connections)if(await Promise.resolve(this.fn(G.ctx)))return Promise.resolve(G);return await w.Event.toPromise(z.onDidAddConnection),await this.route(z)}}e.StaticRouter=se;var re;(function(B){function z(N,F){const A=N,U=F&&F.disableMarshalling,O=new Map;for(const _ in A)q(_)&&O.set(_,w.Event.buffer(A[_],!0));return new class{listen(_,Y,ie){const oe=O.get(Y);if(oe)return oe;if(W(Y)){const J=A[Y];if(typeof J=="function")return J.call(A,ie)}throw new Error(`Event not found: ${Y}`)}call(_,Y,ie){const oe=A[Y];if(typeof oe=="function"){if(!U&&Array.isArray(ie))for(let J=0;J<ie.length;J++)ie[J]=(0,b.revive)(ie[J]);return oe.apply(A,ie)}throw new Error(`Method not found: ${Y}`)}}}B.fromService=z;function G(N,F){const A=F&&F.disableMarshalling;return new Proxy({},{get(U,O){if(typeof O=="string")return F?.properties?.has(O)?F.properties.get(O):W(O)?function(_){return N.listen(O,_)}:q(O)?N.listen(O):async function(..._){let Y;F&&!(0,y.isUndefinedOrNull)(F.context)?Y=[F.context,..._]:Y=_;const ie=await N.call(O,Y);return A?ie:(0,b.revive)(ie)};throw new Error(`Property not found: ${String(O)}`)}})}B.toService=G;function q(N){return N[0]==="o"&&N[1]==="n"&&M.isUpperAsciiLetter(N.charCodeAt(2))}function W(N){return/^onDynamic/.test(N)&&M.isUpperAsciiLetter(N.charCodeAt(9))}})(re=e.ProxyChannel||(e.ProxyChannel={}));const V=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Z(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){let z=B.toString();if(z!=="[object Object]")return z}return B}function H(B){return Array.isArray(B)?B.map(Z):Z(B)}function K(B,z,G,q,W,N,F){F=H(F);const A=V[W],U=A[q%A.length];let O=[`%c[${B}]%c[${String(z).padStart(7," ")}]%c[len: ${String(G).padStart(5," ")}]%c${String(q).padStart(5," ")} - ${N}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(N)?(O=O.concat(F),O.push(")")):O.push(F),console.log.apply(console,O)}e.logWithColors=K;class x{constructor(z,G){this._outgoingPrefix=z,this._incomingPrefix=G,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(z,G,q,W,N){this._totalOutgoing+=z,K(this._outgoingPrefix,this._totalOutgoing,z,G,q,W,N)}logIncoming(z,G,q,W,N){this._totalIncoming+=z,K(this._incomingPrefix,this._totalIncoming,z,G,q,W,N)}}e.IPCLogger=x}),define(ee[126],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class p{constructor(D,C){this.sender=D,this.onMessage=C}send(D){try{this.sender.send("vscode:message",D.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=p}),define(ee[127],te([0,1,17,4,37]),function(j,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class C{constructor(w){this.port=w,this.onMessage=n.Event.fromDOMEventEmitter(this.port,"message",S=>p.VSBuffer.wrap(S.data)),w.start()}send(w){this.port.postMessage(w.buffer)}disconnect(){this.port.close()}}e.Protocol=C;class k extends D.IPCClient{constructor(w,S){const b=new C(w);super(b,S);this.protocol=b}dispose(){this.protocol.disconnect()}}e.Client=k}),define(ee[87],te([0,1,17,4,2,37]),function(j,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(k=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var E;(function(i){i.enableDiagnostics=!1,i.records=[];const r=new WeakMap;let a=0;function h(R,L){if(!r.has(R)){const T=String(++a);r.set(R,T)}return r.get(R)}function I(R,L,T,$){if(!i.enableDiagnostics)return;const Q=h(R,L);if($ instanceof p.VSBuffer||$ instanceof Uint8Array||$ instanceof ArrayBuffer||ArrayBuffer.isView($)){const se=p.VSBuffer.alloc($.byteLength);se.set($),i.records.push({timestamp:Date.now(),id:Q,label:L,type:T,buff:se})}else i.records.push({timestamp:Date.now(),id:Q,label:L,type:T,data:$})}i.traceSocketEvent=I})(E=e.SocketDiagnostics||(e.SocketDiagnostics={}));var w;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(w=e.SocketCloseEventType||(e.SocketCloseEventType={}));let S=null;function b(){return S||(S=p.VSBuffer.alloc(0)),S}class M{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,a){if(r===0)return b();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const L=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=r),L}if(this._chunks[0].byteLength>r){const L=this._chunks[0].slice(0,r);return a&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),L}let h=p.VSBuffer.alloc(r),I=0,R=0;for(;r>0;){const L=this._chunks[R];if(L.byteLength>r){const T=L.slice(0,r);h.set(T,I),I+=r,a&&(this._chunks[R]=L.slice(r),this._totalLength-=r),r-=r}else h.set(L,I),I+=L.byteLength,a?(this._chunks.shift(),this._totalLength-=L.byteLength):R++,r-=L.byteLength}return h}}e.ChunkStream=M;var y;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume"})(y||(y={}));function f(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var t;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(t=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(r,a,h,I){this.type=r,this.id=a,this.ack=h,this.data=I,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends D.Disposable{constructor(r){super();this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new M,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:f(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const h=this._state.messageType,I=this._state.id,R=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",a),this._onMessage.fire(new d(h,I,R,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class v{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=p.VSBuffer.alloc(13);a.writeUInt8(r.type,0),a.writeUInt32BE(r.id,1),a.writeUInt32BE(r.ack,5),a.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:f(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(a,r.data)}_bufferAdd(r,a){const h=this._totalLength===0;return this._data.push(r,a),this._totalLength+=r.byteLength+a.byteLength,h}_bufferTake(){const r=p.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,a){this._bufferAdd(r,a)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class P extends D.Disposable{constructor(r){super();this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new v(this._socket)),this._socketReader=this._register(new m(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new d(1,0,0,r))}}e.Protocol=P;class u extends C.IPCClient{constructor(r,a,h=null){super(r,a,h);this.protocol=r}static fromSocket(r,a){return new u(new P(r),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=u;class g{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=g;class c{constructor(r){this.data=r,this.next=null}}class o{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],a=0,h=this._first;for(;h;)r[a++]=h.data,h=h.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const a=new c(r);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class l{constructor(){this.lastRuns=[];const r=Date.now();for(let a=0;a<l._HISTORY_LENGTH;a++)this.lastRuns[a]=r-1e3*a;setInterval(()=>{for(let a=l._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return l._INSTANCE||(l._INSTANCE=new l),l._INSTANCE}load(){const r=Date.now(),a=(1+l._HISTORY_LENGTH)*1e3;let h=0;for(let I=0;I<l._HISTORY_LENGTH;I++)r-this.lastRuns[I]<=a&&h++;return 1-h/l._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}l._HISTORY_LENGTH=10,l._INSTANCE=null;class s{constructor(r,a=null,h=l.getInstance()){this._onControlMessage=new g,this.onControlMessage=this._onControlMessage.event,this._onMessage=new g,this.onMessage=this._onMessage.event,this._onDidDispose=new g,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new g,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new g,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=h,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=r,this._socketWriter=new v(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new m(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(I=>this._receiveMessage(I))),this._socketDisposables.push(this._socket.onClose(I=>this._onSocketClose.fire(I))),a&&this._socketReader.acceptChunk(a)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new d(5,0,0,b());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new d(7,0,0,b());this._socketWriter.write(r)}sendResume(){const r=new d(8,0,0,b());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,a){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=new v(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new m(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(h=>this._onSocketClose.fire(h))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new d(3,0,this._incomingAckId,b());this._socketWriter.write(r);const a=this._outgoingUnackMsg.toArray();for(let h=0,I=a.length;h<I;h++)this._socketWriter.write(a[h]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new d(6,0,0,b())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const a=this._outgoingUnackMsg.toArray();for(let h=0,I=a.length;h<I;h++)this._socketWriter.write(a[h]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const h=new d(1,a,this._incomingAckId,r);this._outgoingUnackMsg.push(h),this._isReconnecting||(this._socketWriter.write(h),this._recvAckCheck())}sendControl(r){const a=new d(2,0,0,r);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),a=Date.now()-r.writtenTime,h=Date.now()-this._socketReader.lastReadTime,I=Date.now()-this._lastSocketTimeoutTime;if(a>=2e4&&h>=2e4&&I>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const R=Math.max(2e4-a,2e4-h,2e4-I,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},R)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new d(3,0,this._incomingAckId,b());this._socketWriter.write(r)}}e.PersistentProtocol=s}),define(ee[128],te([0,1,14,17,4,2,37,126]),function(j,e,p,n,D,C,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function w(b,M){const y=D.Event.fromNodeEventEmitter(p.ipcMain,M,(t,d)=>({event:t,message:d})),f=D.Event.filter(y,({event:t})=>t.sender.id===b);return D.Event.map(f,({message:t})=>t&&n.VSBuffer.wrap(t))}class S extends k.IPCServer{constructor(){super(S.getOnDidClientConnect())}static getOnDidClientConnect(){const M=D.Event.fromNodeEventEmitter(p.ipcMain,"vscode:hello",({sender:y})=>y);return D.Event.map(M,y=>{const f=y.id,t=S.Clients.get(f);t&&t.dispose();const d=new D.Emitter;S.Clients.set(f,(0,C.toDisposable)(()=>d.fire()));const m=w(f,"vscode:message"),v=D.Event.any(D.Event.signal(w(f,"vscode:disconnect")),d.event);return{protocol:new E.Protocol(y,m),onDidClientDisconnect:v}})}}e.Server=S,S.Clients=new Map}),define(ee[88],te([0,1,14,4,32,127]),function(j,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class k extends C.Client{constructor(S,b){super({addEventListener:(M,y)=>S.addListener(M,y),removeEventListener:(M,y)=>S.removeListener(M,y),postMessage:M=>S.postMessage(M),start:()=>S.start(),close:()=>S.close()},b)}}e.Client=k;async function E(w){if(w.isDestroyed()||w.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const S=(0,D.generateUuid)();w.webContents.send("vscode:createMessageChannel",S);const b=n.Event.fromNodeEventEmitter(p.ipcMain,"vscode:createMessageChannelResult",(y,f)=>({nonce:f,port:y.ports[0]})),{port:M}=await n.Event.toPromise(n.Event.once(n.Event.filter(b,y=>y.nonce===S)));return M}e.connect=E}),define(ee[89],te([0,1,8,4,2,13]),function(j,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var k;(function(M){M[M.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(k=e.StorageHint||(e.StorageHint={}));function E(M){const y=M;return y?.changed instanceof Map||y?.deleted instanceof Set}e.isStorageItemsChangeEvent=E;var w;(function(M){M[M.None=0]="None",M[M.Initialized=1]="Initialized",M[M.Closed=2]="Closed"})(w||(w={}));class S extends D.Disposable{constructor(y,f=Object.create(null)){super();this.database=y,this.options=f,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=w.None,this.cache=new Map,this.flushDelayer=new p.ThrottledDelayer(S.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(y=>this.onDidChangeItemsExternal(y)))}onDidChangeItemsExternal(y){y.changed?.forEach((f,t)=>this.accept(t,f)),y.deleted?.forEach(f=>this.accept(f,void 0))}accept(y,f){if(this.state===w.Closed)return;let t=!1;(0,C.isUndefinedOrNull)(f)?t=this.cache.delete(y):this.cache.get(y)!==f&&(this.cache.set(y,f),t=!0),t&&this._onDidChangeStorage.fire(y)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===w.None&&(this.state=w.Initialized,this.options.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(y,f){const t=this.cache.get(y);return(0,C.isUndefinedOrNull)(t)?f:t}getBoolean(y,f){const t=this.get(y);return(0,C.isUndefinedOrNull)(t)?f:t==="true"}getNumber(y,f){const t=this.get(y);return(0,C.isUndefinedOrNull)(t)?f:parseInt(t,10)}async set(y,f){if(this.state===w.Closed)return;if((0,C.isUndefinedOrNull)(f))return this.delete(y);const t=String(f);if(this.cache.get(y)!==t)return this.cache.set(y,t),this.pendingInserts.set(y,t),this.pendingDeletes.delete(y),this._onDidChangeStorage.fire(y),this.doFlush()}async delete(y){if(!(this.state===w.Closed||!this.cache.delete(y)))return this.pendingDeletes.has(y)||this.pendingDeletes.add(y),this.pendingInserts.delete(y),this._onDidChangeStorage.fire(y),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=w.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const y={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(y).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(y){if(!!this.hasPending)return this.doFlush(y)}async doFlush(y){return this.flushDelayer.trigger(()=>this.flushPending(),y)}async whenFlushed(){if(!!this.hasPending)return new Promise(y=>this.whenFlushedCallbacks.push(y))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=S,S.DEFAULT_FLUSH_DELAY=100;class b{constructor(){this.onDidChangeItemsExternal=n.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(y){y.insert&&y.insert.forEach((f,t)=>this.items.set(t,f)),y.delete&&y.delete.forEach(f=>this.items.delete(f))}async close(){}}e.InMemoryStorageDatabase=b}),define(ee[129],te([0,1,8,4,36,9,24]),function(j,e,p,n,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class E{constructor(b,M=Object.create(null)){this.path=b,this.options=M,this.name=(0,C.basename)(this.path),this.logger=new w(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return n.Event.None}async getItems(){const b=await this.whenConnected,M=new Map;return(await this.all(b,"SELECT * FROM ItemTable")).forEach(f=>M.set(f.key,f.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${M.size} rows`),M}async updateItems(b){const M=await this.whenConnected;return this.doUpdateItems(M,b)}doUpdateItems(b,M){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${M.insert?(0,D.mapToString)(M.insert):"0"}), delete(${M.delete?(0,D.setToString)(M.delete):"0"})`),this.transaction(b,()=>{const y=M.insert,f=M.delete;if(y&&y.size>0){const t=[];t.push([]);let d=0;y.forEach((m,v)=>{let P=t[d];P.length>E.MAX_HOST_PARAMETERS&&(d++,P=[],t.push(P)),P.push(v,m)}),t.forEach(m=>{this.prepare(b,`INSERT INTO ItemTable VALUES ${new Array(m.length/2).fill("(?,?)").join(",")}`,v=>v.run(m),()=>{const v=[];let P=0;return y.forEach((u,g)=>{v.push(g),P+=u.length}),`Keys: ${v.join(", ")} Length: ${P}`})})}if(f&&f.size){const t=[];t.push([]);let d=0;f.forEach(m=>{let v=t[d];v.length>E.MAX_HOST_PARAMETERS&&(d++,v=[],t.push(v)),v.push(m)}),t.forEach(m=>{this.prepare(b,`DELETE FROM ItemTable WHERE key IN (${new Array(m.length).fill("?").join(",")})`,v=>v.run(m),()=>{const v=[];return f.forEach(P=>{v.push(P)}),`Keys: ${v.join(", ")}`})})}})}async close(b){this.logger.trace(`[storage ${this.name}] close()`);const M=await this.whenConnected;return this.doClose(M,b)}doClose(b,M){return new Promise((y,f)=>{b.db.close(t=>(t&&this.handleSQLiteError(b,`[storage ${this.name}] close(): ${t}`),this.path===E.IN_MEMORY_PATH?y():!b.isErroneous&&!b.isInMemory?this.backup().then(y,d=>(this.logger.error(`[storage ${this.name}] backup(): ${d}`),y())):typeof M=="function"?k.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(d=>{const m=()=>this.doClose(d,void 0);return this.doUpdateItems(d,{insert:M()}).then(()=>m(),v=>(m(),Promise.reject(v)))})).then(y,f):f(t||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const b=this.toBackupPath(this.path);return k.Promises.copy(this.path,b,{preserveSymlinks:!1})}toBackupPath(b){return`${b}.backup`}async checkIntegrity(b){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${b})`);const M=await this.whenConnected,y=await this.get(M,b?"PRAGMA integrity_check":"PRAGMA quick_check"),f=b?y.integrity_check:y.quick_check;return M.isErroneous?`${f} (last error: ${M.lastError})`:M.isInMemory?`${f} (in-memory!)`:f}async connect(b,M=!0){this.logger.trace(`[storage ${this.name}] open(${b}, retryOnBusy: ${M})`);try{return await this.doConnect(b)}catch(y){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${y}`),y.code==="SQLITE_BUSY"&&M)return await(0,p.timeout)(E.BUSY_OPEN_TIMEOUT),this.connect(b,!1);try{await k.Promises.unlink(b);try{await k.Promises.rename(this.toBackupPath(b),b)}catch{}return await this.doConnect(b)}catch(f){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${f}`),this.doConnect(E.IN_MEMORY_PATH)}}}handleSQLiteError(b,M){b.isErroneous=!0,b.lastError=M,this.logger.error(M)}doConnect(b){return new Promise((M,y)=>{new Promise((f,t)=>{j(["@vscode/sqlite3"],f,t)}).then(f=>{const t={db:new(this.logger.isTracing?f.verbose().Database:f.Database)(b,d=>d?t.db?t.db.close(()=>y(d)):y(d):this.exec(t,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>M(t),m=>t.db.close(()=>y(m)))),isInMemory:b===E.IN_MEMORY_PATH};t.db.on("error",d=>this.handleSQLiteError(t,`[storage ${this.name}] Error (event): ${d}`)),this.logger.isTracing&&t.db.on("trace",d=>this.logger.trace(`[storage ${this.name}] Trace (event): ${d}`))},y)})}exec(b,M){return new Promise((y,f)=>{b.db.exec(M,t=>t?(this.handleSQLiteError(b,`[storage ${this.name}] exec(): ${t}`),f(t)):y())})}get(b,M){return new Promise((y,f)=>{b.db.get(M,(t,d)=>t?(this.handleSQLiteError(b,`[storage ${this.name}] get(): ${t}`),f(t)):y(d))})}all(b,M){return new Promise((y,f)=>{b.db.all(M,(t,d)=>t?(this.handleSQLiteError(b,`[storage ${this.name}] all(): ${t}`),f(t)):y(d))})}transaction(b,M){return new Promise((y,f)=>{b.db.serialize(()=>{b.db.run("BEGIN TRANSACTION"),M(),b.db.run("END TRANSACTION",t=>t?(this.handleSQLiteError(b,`[storage ${this.name}] transaction(): ${t}`),f(t)):y())})})}prepare(b,M,y,f){const t=b.db.prepare(M),d=m=>{this.handleSQLiteError(b,`[storage ${this.name}] prepare(): ${m} (${M}). Details: ${f()}`)};t.on("error",d),y(t),t.finalize(m=>{m&&d(m),t.removeListener("error",d)})}}e.SQLiteStorageDatabase=E,E.IN_MEMORY_PATH=":memory:",E.BUSY_OPEN_TIMEOUT=2e3,E.MAX_HOST_PARAMETERS=256;class w{constructor(b){b&&typeof b.logTrace=="function"&&process.env[w.VSCODE_TRACE_STORAGE]&&(this.logTrace=b.logTrace),b&&typeof b.logError=="function"&&(this.logError=b.logError)}get isTracing(){return!!this.logTrace}trace(b){this.logTrace&&this.logTrace(b)}error(b){this.logError&&this.logError(b)}}w.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(ee[130],te([12,11]),function(j,e){return j.create("vs/base/common/date",e)}),define(ee[131],te([0,1,130]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,D=n*60,C=D*24,k=C*7,E=C*30,w=C*365;function S(M,y,f){typeof M!="number"&&(M=M.getTime());const t=Math.round((new Date().getTime()-M)/1e3);if(t<-30)return(0,p.localize)(0,null,S(new Date().getTime()+t*1e3,!1));if(t<30)return(0,p.localize)(1,null);let d;return t<n?(d=t,y?d===1?f?(0,p.localize)(2,null,d):(0,p.localize)(3,null,d):f?(0,p.localize)(4,null,d):(0,p.localize)(5,null,d):d===1?f?(0,p.localize)(6,null,d):(0,p.localize)(7,null,d):f?(0,p.localize)(8,null,d):(0,p.localize)(9,null,d)):t<D?(d=Math.floor(t/n),y?d===1?f?(0,p.localize)(10,null,d):(0,p.localize)(11,null,d):f?(0,p.localize)(12,null,d):(0,p.localize)(13,null,d):d===1?f?(0,p.localize)(14,null,d):(0,p.localize)(15,null,d):f?(0,p.localize)(16,null,d):(0,p.localize)(17,null,d)):t<C?(d=Math.floor(t/D),y?d===1?f?(0,p.localize)(18,null,d):(0,p.localize)(19,null,d):f?(0,p.localize)(20,null,d):(0,p.localize)(21,null,d):d===1?f?(0,p.localize)(22,null,d):(0,p.localize)(23,null,d):f?(0,p.localize)(24,null,d):(0,p.localize)(25,null,d)):t<k?(d=Math.floor(t/C),y?d===1?(0,p.localize)(26,null,d):(0,p.localize)(27,null,d):d===1?(0,p.localize)(28,null,d):(0,p.localize)(29,null,d)):t<E?(d=Math.floor(t/k),y?d===1?f?(0,p.localize)(30,null,d):(0,p.localize)(31,null,d):f?(0,p.localize)(32,null,d):(0,p.localize)(33,null,d):d===1?f?(0,p.localize)(34,null,d):(0,p.localize)(35,null,d):f?(0,p.localize)(36,null,d):(0,p.localize)(37,null,d)):t<w?(d=Math.floor(t/E),y?d===1?f?(0,p.localize)(38,null,d):(0,p.localize)(39,null,d):f?(0,p.localize)(40,null,d):(0,p.localize)(41,null,d):d===1?f?(0,p.localize)(42,null,d):(0,p.localize)(43,null,d):f?(0,p.localize)(44,null,d):(0,p.localize)(45,null,d)):(d=Math.floor(t/w),y?d===1?f?(0,p.localize)(46,null,d):(0,p.localize)(47,null,d):f?(0,p.localize)(48,null,d):(0,p.localize)(49,null,d):d===1?f?(0,p.localize)(50,null,d):(0,p.localize)(51,null,d):f?(0,p.localize)(52,null,d):(0,p.localize)(53,null,d))}e.fromNow=S;function b(M){return M.getFullYear()+"-"+String(M.getMonth()+1).padStart(2,"0")+"-"+String(M.getDate()).padStart(2,"0")+"T"+String(M.getHours()).padStart(2,"0")+":"+String(M.getMinutes()).padStart(2,"0")+":"+String(M.getSeconds()).padStart(2,"0")+"."+(M.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=b}),define(ee[132],te([12,11]),function(j,e){return j.create("vs/base/common/errorMessage",e)}),define(ee[39],te([0,1,28,13,132]),function(j,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function C(S,b){return b&&(S.stack||S.stacktrace)?D.localize(0,null,E(S),k(S.stack)||k(S.stacktrace)):E(S)}function k(S){return Array.isArray(S)?S.join(`
`):S}function E(S){return typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?D.localize(1,null,S.message):S.message||D.localize(2,null)}function w(S=null,b=!1){if(!S)return D.localize(3,null);if(Array.isArray(S)){const M=p.coalesce(S),y=w(M[0],b);return M.length>1?D.localize(4,null,y,M.length):y}if(n.isString(S))return S;if(S.detail){const M=S.detail;if(M.error)return C(M.error,b);if(M.exception)return C(M.exception,b)}return S.stack?C(S,b):S.message?S.message:D.localize(5,null)}e.toErrorMessage=w}),define(ee[133],te([12,11]),function(j,e){return j.create("vs/base/common/keybindingLabels",e)}),define(ee[134],te([0,1,133]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class n{constructor(k,E,w=E){this.modifierLabels=[null],this.modifierLabels[2]=k,this.modifierLabels[1]=E,this.modifierLabels[3]=w}toLabel(k,E,w){if(E.length===0)return null;const S=[];for(let b=0,M=E.length;b<M;b++){const y=E[b],f=w(y);if(f===null)return null;S[b]=D(y,f,this.modifierLabels[k])}return S.join(" ")}}e.ModifierLabelProvider=n,e.UILabelProvider=new n({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:p.localize(0,null),shiftKey:p.localize(1,null),altKey:p.localize(2,null),metaKey:p.localize(3,null),separator:"+"},{ctrlKey:p.localize(4,null),shiftKey:p.localize(5,null),altKey:p.localize(6,null),metaKey:p.localize(7,null),separator:"+"}),e.AriaLabelProvider=new n({ctrlKey:p.localize(8,null),shiftKey:p.localize(9,null),altKey:p.localize(10,null),metaKey:p.localize(11,null),separator:"+"},{ctrlKey:p.localize(12,null),shiftKey:p.localize(13,null),altKey:p.localize(14,null),metaKey:p.localize(15,null),separator:"+"},{ctrlKey:p.localize(16,null),shiftKey:p.localize(17,null),altKey:p.localize(18,null),metaKey:p.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new n({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new n({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function D(C,k,E){if(k===null)return"";const w=[];return C.ctrlKey&&w.push(E.ctrlKey),C.shiftKey&&w.push(E.shiftKey),C.altKey&&w.push(E.altKey),C.metaKey&&w.push(E.metaKey),k!==""&&w.push(k),w.join(E.separator)}}),define(ee[135],te([12,11]),function(j,e){return j.create("vs/base/node/processes",e)}),define(ee[74],te([0,1,45,29,10,47,9,3,35,83,13,119,24,135]),function(j,e,p,n,D,C,k,E,w,S,b,M,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return S.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return S.TerminateResponseCode}});function t(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(o,l){if(E.isWindows)try{const s={stdio:["pipe","pipe","ignore"]};l&&(s.cwd=l);const i=p.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],s);return new Promise(r=>{i.once("error",a=>{r({success:!1,error:a})}),i.once("exit",(a,h)=>{r(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(s){return Promise.resolve({success:!1,error:s,code:s.status?t(s.status):1})}else if(E.isLinux||E.isMacintosh)try{const s=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",j).fsPath;return new Promise(i=>{p.execFile(s,[o.pid.toString()],{encoding:"utf8",shell:!0},(r,a,h)=>{i(r?{success:!1,error:r}:{success:!0})})})}catch(s){return Promise.resolve({success:!1,error:s})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function m(o){!o||(delete o.DEBUG,E.isMacintosh&&delete o.DYLD_LIBRARY_PATH,E.isLinux&&delete o.LD_PRELOAD)}e.removeDangerousEnvVariables=m;function v(o=w.env){return o.comspec||"cmd.exe"}e.getWindowsShell=v;class P{constructor(l,s,i,r){if(s!==void 0&&i!==void 0&&r!==void 0)this.cmd=l,this.args=s,this.shell=i,this.options=r;else{const a=l;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(w.env).forEach(h=>{a[h]=w.env[h]}),Object.keys(this.options.env).forEach(h=>{a[h]=this.options.env[h]}),this.options.env=a}}getSanitizedCommand(){let l=this.cmd.toLowerCase();const s=l.lastIndexOf(k.sep);return s!==-1&&(l=l.substring(s+1)),P.WellKnowCommands[l]?l:"other"}start(l){return E.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(w.cwd()))?Promise.reject(new Error(f.localize(0,null))):this.useExec().then(s=>{let i,r;const a=new Promise((h,I)=>{i=h,r=I});if(s){let h=this.cmd;this.args&&(h=h+" "+this.args.join(" ")),this.childProcess=p.exec(h,this.options,(I,R,L)=>{this.childProcess=null;const T=I;T&&T.killed?r({killed:this.terminateRequested,stdout:R.toString(),stderr:L.toString()}):this.handleExec(i,l,I,R,L)})}else{let h=null;const I=R=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(R,i,l,r);const L={terminated:this.terminateRequested};b.isNumber(R)&&(L.cmdCode=R),i(L)};if(this.shell&&E.isWindows){const R=C.deepClone(this.options);R.windowsVerbatimArguments=!0,R.detached=!1;let L=!1,T=!1;const $=[];let Q=this.ensureQuotes(this.cmd);$.push(Q.value),L=Q.quoted,this.args&&this.args.forEach(re=>{Q=this.ensureQuotes(re),$.push(Q.value),T=T&&Q.quoted});const se=["/s","/c"];L?T?se.push('"'+$.join(" ")+'"'):$.length>1?se.push('"'+$[0]+'" '+$.slice(1).join(" ")):se.push('"'+$[0]+'"'):se.push($.join(" ")),h=p.spawn(v(),se,R)}else this.cmd&&(h=p.spawn(this.cmd,this.args,this.options));h&&(this.childProcess=h,this.childProcessPromise=Promise.resolve(h),this.pidResolve&&(this.pidResolve(b.isNumber(h.pid)?h.pid:-1),this.pidResolve=void 0),h.on("error",R=>{this.childProcess=null,r({terminated:this.terminateRequested,error:R})}),h.pid&&(this.childProcess.on("close",I),this.handleSpawn(h,i,l,r,!0)))}return a})}handleClose(l,s,i,r){}ensureQuotes(l){return P.regexp.test(l)?{value:'"'+l+'"',quoted:!0}:{value:l,quoted:l.length>0&&l[0]==='"'&&l[l.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(l=>l.pid,l=>-1):new Promise(l=>{this.pidResolve=l})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(l=>(this.terminateRequested=!0,d(l,this.options.cwd).then(s=>(s.success&&(this.childProcess=null),s))),l=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(l=>{if(!this.shell||!E.isWindows)return l(!1);const s=p.spawn(v(),["/s","/c"]);s.on("error",i=>l(!0)),s.on("exit",i=>l(!1))})}}e.AbstractProcess=P,P.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},P.regexp=/^[^"].* .*[^"]/;class u extends P{constructor(l,s,i,r){super(l,s,i,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(l,s,i,r,a){[r,a].forEach((h,I)=>{const R=new M.LineDecoder;R.write(h).forEach($=>{s({line:$,source:I===0?0:1})});const T=R.end();T&&s({line:T,source:I===0?0:1})}),l({terminated:this.terminateRequested,error:i})}handleSpawn(l,s,i,r,a){const h=new M.LineDecoder,I=new M.LineDecoder;l.stdout.on("data",R=>{h.write(R).forEach(T=>i({line:T,source:0}))}),l.stderr.on("data",R=>{I.write(R).forEach(T=>i({line:T,source:1}))}),this.stdoutLineDecoder=h,this.stderrLineDecoder=I}handleClose(l,s,i,r){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&i({line:a,source:0});const h=this.stderrLineDecoder?this.stderrLineDecoder.end():null;h&&i({line:h,source:1})}}e.LineProcess=u;function g(o){let l=[],s=!1;const i=function(r){if(s){l.push(r);return}(!o.send(r,h=>{if(h&&console.error(h),s=!1,l.length>0){const I=l.slice(0);l=[],I.forEach(R=>i(R))}})||E.isWindows)&&(s=!0)};return{send:i}}e.createQueuedSender=g;var c;(function(o){async function l(s,i,r){if(k.isAbsolute(s))return s;if(i===void 0&&(i=w.cwd()),k.dirname(s)!=="."||(r===void 0&&b.isString(w.env.PATH)&&(r=w.env.PATH.split(k.delimiter)),r===void 0||r.length===0))return k.join(i,s);async function h(I){if(await y.Promises.exists(I)){let R;try{R=await y.Promises.stat(I)}catch(L){L.message.startsWith("EACCES")&&(R=await y.Promises.lstat(I))}return R?!R.isDirectory():!1}return!1}for(let I of r){let R;if(k.isAbsolute(I)?R=k.join(I,s):R=k.join(i,I,s),await h(R))return R;let L=R+".com";if(await h(L)||(L=R+".exe",await h(L)))return L}return k.join(i,s)}o.findExecutable=l})(c=e.win32||(e.win32={}))}),define(ee[136],te([0,1,26,3,123,74]),function(j,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function k(f,t){return f===1?n.isWindows?M():C.getWindowsShell(t):S(f,t)}e.getSystemShell=k;function E(f,t){return f===1?n.isWindows?y(t):C.getWindowsShell(t):S(f,t)}e.getSystemShellSync=E;let w=null;function S(f,t){if(n.isLinux&&f===2||n.isMacintosh&&f===3)return"/bin/bash";if(!w){let d;if(n.isWindows)d="/bin/bash";else{if(d=t.SHELL,!d)try{d=(0,p.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}w=d}return w}let b=null;async function M(){return b||(b=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),b}function y(f){if(b)return b;const t=n.isWindows&&parseFloat((0,p.release)())>=10,d=f.hasOwnProperty("PROCESSOR_ARCHITEW6432"),m=`${f.windir}\\${d?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return t?m:C.getWindowsShell(f)}}),define(ee[137],te([0,1,45,8,17,21,113,15,4,2,47,74,37]),function(j,e,p,n,D,C,k,E,w,S,b,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class f extends y.ChannelServer{constructor(m){super({send:v=>{try{process.send&&process.send(v.buffer.toString("base64"))}catch{}},onMessage:w.Event.fromNodeEventEmitter(process,"message",v=>D.VSBuffer.wrap(Buffer.from(v,"base64")))},m);process.once("disconnect",()=>this.dispose())}}e.Server=f;class t{constructor(m,v){this.modulePath=m,this.options=v,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new w.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const P=v&&v.timeout?v.timeout:6e4;this.disposeDelayer=new n.Delayer(P),this.child=null,this._client=null}getChannel(m){const v=this;return{call(P,u,g){return v.requestPromise(m,P,u,g)},listen(P,u){return v.requestEvent(m,P,u)}}}requestPromise(m,v,P,u=C.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(u.isCancellationRequested)return Promise.reject(E.canceled());this.disposeDelayer.cancel();const g=this.getCachedChannel(m),c=(0,n.createCancelablePromise)(s=>g.call(v,P,s)),o=u.onCancellationRequested(()=>c.cancel()),l=(0,S.toDisposable)(()=>c.cancel());return this.activeRequests.add(l),c.finally(()=>{o.dispose(),this.activeRequests.delete(l),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),c}requestEvent(m,v,P){if(!this.disposeDelayer)return w.Event.None;this.disposeDelayer.cancel();let u;const g=new w.Emitter({onFirstListenerAdd:()=>{u=this.getCachedChannel(m).listen(v,P)(g.fire,g),this.activeRequests.add(u)},onLastListenerRemove:()=>{this.activeRequests.delete(u),u.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return g.event}get client(){if(!this._client){const m=this.options&&this.options.args?this.options.args:[],v=Object.create(null);v.env={...(0,b.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(v.env={...v.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(v.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i))),(0,M.removeDangerousEnvVariables)(v.env),this.child=(0,p.fork)(this.modulePath,m,v);const P=new w.Emitter;w.Event.fromNodeEventEmitter(this.child,"message",i=>i)(i=>{if((0,k.isRemoteConsoleLog)(i)){(0,k.log)(i,`IPC Library: ${this.options.serverName}`);return}P.fire(D.VSBuffer.wrap(Buffer.from(i,"base64")))});const g=this.options.useQueue?(0,M.createQueuedSender)(this.child):this.child,c=i=>this.child&&this.child.connected&&g.send(i.buffer.toString("base64")),o=P.event,l={send:c,onMessage:o};this._client=new y.ChannelClient(l);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",i=>console.warn('IPC "'+this.options.serverName+'" errored with '+i)),this.child.on("exit",(i,r)=>{process.removeListener("exit",s),this.activeRequests.forEach(a=>(0,S.dispose)(a)),this.activeRequests.clear(),i!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+i+" and signal "+r),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:i,signal:r})})}return this._client}getCachedChannel(m){let v=this.channels.get(m);return v||(v=this.client.getChannel(m),this.channels.set(m,v)),v}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=t}),define(ee[138],te([12,11]),function(j,e){return j.create("vs/code/electron-main/app",e)}),define(ee[139],te([12,11]),function(j,e){return j.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ee[140],te([12,11]),function(j,e){return j.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ee[141],te([12,11]),function(j,e){return j.create("vs/platform/environment/node/argv",e)}),define(ee[142],te([12,11]),function(j,e){return j.create("vs/platform/environment/node/argvHelper",e)}),define(ee[143],te([12,11]),function(j,e){return j.create("vs/platform/environment/node/shellEnv",e)}),define(ee[144],te([12,11]),function(j,e){return j.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ee[145],te([12,11]),function(j,e){return j.create("vs/platform/extensions/common/extensionValidator",e)}),define(ee[146],te([12,11]),function(j,e){return j.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ee[147],te([12,11]),function(j,e){return j.create("vs/platform/files/common/fileService",e)}),define(ee[148],te([12,11]),function(j,e){return j.create("vs/platform/files/common/files",e)}),define(ee[149],te([12,11]),function(j,e){return j.create("vs/platform/files/common/io",e)}),define(ee[150],te([12,11]),function(j,e){return j.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ee[151],te([12,11]),function(j,e){return j.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ee[152],te([12,11]),function(j,e){return j.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ee[153],te([12,11]),function(j,e){return j.create("vs/platform/menubar/electron-main/menubar",e)}),define(ee[154],te([12,11]),function(j,e){return j.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ee[155],te([12,11]),function(j,e){return j.create("vs/platform/request/common/request",e)}),define(ee[156],te([12,11]),function(j,e){return j.create("vs/platform/telemetry/common/telemetryService",e)}),define(ee[157],te([12,11]),function(j,e){return j.create("vs/platform/update/common/update.config.contribution",e)}),define(ee[158],te([12,11]),function(j,e){return j.create("vs/platform/windows/electron-main/window",e)}),define(ee[159],te([12,11]),function(j,e){return j.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ee[160],te([12,11]),function(j,e){return j.create("vs/platform/workspaces/common/workspaces",e)}),define(ee[161],te([12,11]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ee[162],te([12,11]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ee[163],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEmptyWindowBackupInfo=void 0;function p(n){return typeof n?.backupFolder=="string"}e.isEmptyWindowBackupInfo=p}),define(ee[164],te([0,1,4,2]),function(j,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class D{constructor(){this._onCloseEmitter=new p.Emitter,this._onReloadEmitter=new p.Emitter,this._onTerminateEmitter=new p.Emitter,this._onAttachEmitter=new p.Emitter}call(E,w,S){switch(w){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:S[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:S[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:S[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:S[0],port:S[1],subId:S[2]}))}throw new Error("Method not implemented.")}listen(E,w,S){switch(w){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=D,D.ChannelName="extensionhostdebugservice";class C extends n.Disposable{constructor(E){super();this.channel=E}reload(E){this.channel.call("reload",[E])}get onReload(){return this.channel.listen("reload")}close(E){this.channel.call("close",[E])}get onClose(){return this.channel.listen("close")}attachSession(E,w,S){this.channel.call("attach",[E,w,S])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(E,w){this.channel.call("terminate",[E,w])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(E,w){return this.channel.call("openExtensionDevelopmentHostWindow",[E,w])}}e.ExtensionHostDebugChannelClient=C}),define(ee[165],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class p{constructor(k){this.driver=k}listen(k,E){throw new Error(`No event found: ${E}`)}call(k,E,w){switch(E){case"click":return this.driver.click(w[0],w[1],w[2]);case"doubleClick":return this.driver.doubleClick(w);case"setValue":return this.driver.setValue(w[0],w[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(w);case"getElements":return this.driver.getElements(w[0],w[1]);case"getElementXY":return this.driver.getElementXY(w[0],w[1],w[2]);case"typeInEditor":return this.driver.typeInEditor(w[0],w[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(w);case"writeInTerminal":return this.driver.writeInTerminal(w[0],w[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${E}`)}}e.WindowDriverChannel=p;class n{constructor(k){this.channel=k}click(k,E,w){return this.channel.call("click",[k,E,w])}doubleClick(k){return this.channel.call("doubleClick",k)}setValue(k,E){return this.channel.call("setValue",[k,E])}getTitle(){return this.channel.call("getTitle")}isActiveElement(k){return this.channel.call("isActiveElement",k)}getElements(k,E){return this.channel.call("getElements",[k,E])}getElementXY(k,E,w){return this.channel.call("getElementXY",[k,E,w])}typeInEditor(k,E){return this.channel.call("typeInEditor",[k,E])}getTerminalBuffer(k){return this.channel.call("getTerminalBuffer",k)}writeInTerminal(k,E){return this.channel.call("writeInTerminal",[k,E])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=n;class D{constructor(k){this.channel=k}registerWindowDriver(k){return this.channel.call("registerWindowDriver",k)}reloadWindowDriver(k){return this.channel.call("reloadWindowDriver",k)}}e.WindowDriverRegistryChannelClient=D}),define(ee[166],te([0,1,131,46,10,9,35,16,7]),function(j,e,p,n,D,C,k,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class S{constructor(d,m,v){this._args=d,this.paths=m,this.productService=v}get appRoot(){return(0,C.dirname)(D.FileAccess.asFileUri("",j).fsPath)}get userHome(){return w.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return w.URI.file((0,C.join)(this.userDataPath,"User"))}get tmpDir(){return w.URI.file(this.paths.tmpDir)}get cacheHome(){return w.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,E.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,E.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,p.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,C.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return w.URI.file((0,C.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.joinPath)(w.URI.file((0,C.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return w.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return w.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,E.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,E.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=k.env.VSCODE_PORTABLE;return d?w.URI.file((0,C.join)(d,"argv.json")):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,E.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return w.URI.file((0,C.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,C.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,C.resolve)(d):(0,C.normalize)((0,C.join)(D.FileAccess.asFileUri("",j).fsPath,"..","extensions"))}get extensionsDownloadPath(){const d=this.args["extensions-download-dir"];return d?(0,C.resolve)(d):(0,C.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,C.resolve)(d);const m=k.env.VSCODE_EXTENSIONS;if(m)return m;const v=k.env.VSCODE_PORTABLE;return v?(0,C.join)(v,"extensions"):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(m=>/^[^:/?#]+?:\/\//.test(m)?w.URI.parse(m):w.URI.file((0,C.normalize)(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?w.URI.parse(d):w.URI.file((0,C.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,E.joinPath)(w.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return w.URI.file((0,C.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([n.memoize],S.prototype,"appRoot",null),de([n.memoize],S.prototype,"userHome",null),de([n.memoize],S.prototype,"userDataPath",null),de([n.memoize],S.prototype,"appSettingsHome",null),de([n.memoize],S.prototype,"tmpDir",null),de([n.memoize],S.prototype,"cacheHome",null),de([n.memoize],S.prototype,"userRoamingDataHome",null),de([n.memoize],S.prototype,"settingsResource",null),de([n.memoize],S.prototype,"userDataSyncHome",null),de([n.memoize],S.prototype,"userDataSyncLogResource",null),de([n.memoize],S.prototype,"sync",null),de([n.memoize],S.prototype,"machineSettingsResource",null),de([n.memoize],S.prototype,"globalStorageHome",null),de([n.memoize],S.prototype,"workspaceStorageHome",null),de([n.memoize],S.prototype,"keybindingsResource",null),de([n.memoize],S.prototype,"keyboardLayoutResource",null),de([n.memoize],S.prototype,"argvResource",null),de([n.memoize],S.prototype,"snippetsHome",null),de([n.memoize],S.prototype,"isExtensionDevelopment",null),de([n.memoize],S.prototype,"untitledWorkspacesHome",null),de([n.memoize],S.prototype,"installSourcePath",null),de([n.memoize],S.prototype,"builtinExtensionsPath",null),de([n.memoize],S.prototype,"extensionsPath",null),de([n.memoize],S.prototype,"extensionDevelopmentLocationURI",null),de([n.memoize],S.prototype,"extensionDevelopmentKind",null),de([n.memoize],S.prototype,"extensionTestsLocationURI",null),de([n.memoize],S.prototype,"debugExtensionHost",null),de([n.memoize],S.prototype,"serviceMachineIdResource",null),de([n.memoize],S.prototype,"telemetryLogResource",null),de([n.memoize],S.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=S;function b(t,d){return f(t["inspect-extensions"],t["inspect-brk-extensions"],5870,d,t.debugId,t.extensionEnvironment)}e.parseExtensionHostPort=b;function M(t,d){return f(t["inspect-search"],t["inspect-brk-search"],5876,d,t.extensionEnvironment)}e.parseSearchPort=M;function y(t,d){return f(t["inspect-ptyhost"],t["inspect-brk-ptyhost"],5877,d,t.extensionEnvironment)}e.parsePtyHostPort=y;function f(t,d,m,v,P,u){const c=Number(d||t)||(v?null:m),o=c?Boolean(!!d):!1;let l;if(u)try{l=JSON.parse(u)}catch{}return{port:c,break:o,debugId:P,env:l}}}),define(ee[90],te([0,1,254,3,141]),function(j,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const C={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,D.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(14,null)},category:{type:"string",cat:"e",description:(0,D.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,D.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,D.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,D.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,D.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(27,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,D.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,D.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:["debugSearch"]},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"]},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const k={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function E(t,d,m=k){const v={},P=[],u=[];for(let l in d){const s=d[l];s.alias&&(v[l]=s.alias),s.type==="string"||s.type==="string[]"?(P.push(l),s.deprecates&&P.push(...s.deprecates)):s.type==="boolean"&&(u.push(l),s.deprecates&&u.push(...s.deprecates))}const g=p(t,{string:P,boolean:u,alias:v}),c={},o=g;c._=g._.map(l=>String(l)).filter(l=>l.length>0),delete o._;for(let l in d){const s=d[l];s.alias&&delete o[s.alias];let i=o[l];if(s.deprecates)for(const r of s.deprecates)o.hasOwnProperty(r)&&(i||(i=o[r],i&&m.onDeprecatedOption(r,s.deprecationMessage||(0,D.localize)(33,null))),delete o[r]);typeof i!="undefined"&&(s.type==="string[]"?i&&!Array.isArray(i)&&(i=[i]):s.type==="string"&&Array.isArray(i)&&(i=i.pop(),m.onMultipleValues(l,i)),c[l]=i,s.deprecationMessage&&m.onDeprecatedOption(l,s.deprecationMessage)),delete o[l]}for(let l in o)m.onUnknownOption(l);return c}e.parseArgs=E;function w(t,d){let m="";return d.args&&(Array.isArray(d.args)?m=` <${d.args.join("> <")}>`:m=` <${d.args}>`),d.alias?`-${d.alias} --${t}${m}`:`--${t}${m}`}function S(t,d){let m=0,v=[];for(const c in t){const o=t[c],l=w(c,o);m=Math.max(m,l.length),v.push([l,o.description])}let P=m+2+1;if(d-P<25)return v.reduce((c,o)=>c.concat([`  ${o[0]}`,`      ${o[1]}`]),[]);let u=d-P-1,g=[];for(const c of v){let o=c[0],l=M(c[1],u),s=b(P-o.length-2);g.push("  "+o+s+l[0]);for(let i=1;i<l.length;i++)g.push(b(P)+l[i])}return g}e.formatOptions=S;function b(t){return" ".repeat(t)}function M(t,d){let m=[];for(;t.length;){let v=t.length<d?t.length:t.lastIndexOf(" ",d),P=t.slice(0,v).trim();t=t.slice(v),m.push(P)}return m}function y(t,d,m,v,P){const u=process.stdout.isTTY&&process.stdout.columns||80,g=P?.noInputFiles!==!0?`[${(0,D.localize)(34,null)}...]`:"",c=[`${t} ${m}`];c.push(""),c.push(`${(0,D.localize)(35,null)}: ${d} [${(0,D.localize)(36,null)}]${g}`),c.push(""),P?.noPipe!==!0&&(n.isWindows?c.push((0,D.localize)(37,null,d)):c.push((0,D.localize)(38,null,d)),c.push(""));const o={};for(const l in v){const s=v[l];if(s.description&&s.cat){let i=o[s.cat];i||(o[s.cat]=i={}),i[l]=s}}for(let l in o){const s=l;let i=o[s];i&&(c.push(C[s]),c.push(...S(i,u)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=y;function f(t,d){return`${t||(0,D.localize)(39,null)}
${d||(0,D.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=f}),define(ee[167],te([0,1,61,164,90]),function(j,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class C extends n.ExtensionHostDebugBroadcastChannel{constructor(E){super();this.windowsMainService=E}call(E,w,S){return w==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(S[0],S[1]):super.call(E,w,S)}async openExtensionDevelopmentHostWindow(E,w){const S=(0,D.parseArgs)(E,D.OPTIONS);S.debugRenderer=w;const b=S.extensionDevelopmentPath;if(!b)return{success:!1};const[M]=this.windowsMainService.openExtensionDevelopmentHostWindow(b,{context:5,cli:S});if(!w)return{success:!0};const y=M.win;if(!y)return{success:!0};const f=y.webContents.debugger;let t=f.isAttached()?1/0:0;const d=(0,p.createServer)(m=>{t++==0&&f.attach();let v=!1;const P=c=>{v||m.write(JSON.stringify(c)+"\0")},u=(c,o,l,s)=>P({method:o,params:l,sessionId:s});y.on("close",()=>{f.removeListener("message",u),m.end(),v=!0}),f.addListener("message",u);let g=Buffer.alloc(0);m.on("data",c=>{g=Buffer.concat([g,c]);for(let o=g.indexOf(0);o!==-1;o=g.indexOf(0)){let l;try{const s=g.slice(0,o).toString("utf8");g=g.slice(o+1),l=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}f.sendCommand(l.method,l.params,l.sessionId).then(s=>P({id:l.id,sessionId:l.sessionId,result:s})).catch(s=>P({id:l.id,sessionId:l.sessionId,error:{code:0,message:s.message}}))}}),m.on("error",c=>{console.error("error on cdp pipe:",c)}),m.on("close",()=>{v=!0,--t==0&&f.detach()})});return await new Promise(m=>d.listen(0,m)),y.on("close",()=>d.close()),{rendererDebugPort:d.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=C}),function(){"use strict";function j(e,p,n,D){function C(E){const w=k(E),S=[w];return e.isAbsolute(w)||S.unshift(D),e.resolve(...S)}function k(E){const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");let S=process.env.VSCODE_APPDATA;if(S)return e.join(S,n);const b=E["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(S=process.env.APPDATA,!S){const M=process.env.USERPROFILE;if(typeof M!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");S=e.join(M,"AppData","Roaming")}break;case"darwin":S=e.join(p.homedir(),"Library","Application Support");break;case"linux":S=process.env.XDG_CONFIG_HOME||e.join(p.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(S,n)}return{getUserDataPath:C}}if(typeof define=="function")define(ee[168],te([0,255,26,10,16,35]),function(e,p,n,D,C,k){const E=C.dirname(D.FileAccess.asFileUri("",e)),w=e.__$__nodeRequire(C.joinPath(E,"package.json").fsPath);return j(p,n,w.name,k.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),p=require("path"),n=require("os");module.exports=j(p,n,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ee[169],te([0,1,26,166,168]),function(j,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class C extends n.AbstractNativeEnvironmentService{constructor(E,w){super(E,{homeDir:(0,p.homedir)(),tmpDir:(0,p.tmpdir)(),userDataDir:(0,D.getUserDataPath)(E)},w)}}e.NativeEnvironmentService=C}),define(ee[170],te([0,1,30,26,29]),function(j,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function C(k){const E=(0,D.randomPath)((0,n.tmpdir)());try{return(0,p.writeFileSync)(E,""),k&&console.log(`Marker file for --wait created: ${E}`),E}catch(w){k&&console.error(`Failed to create marker file for --wait: ${w}`);return}}e.createWaitMarkerFile=C}),define(ee[171],te([0,1,145]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const n=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function C(y){return y=y.trim(),y==="*"||n.test(y)}e.isValidVersionStr=C;function k(y){if(!C(y))return null;if(y=y.trim(),y==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let f=y.match(n);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=k;function E(y){if(!y)return null;let f=y.majorBase,t=y.majorMustEqual,d=y.minorBase,m=y.minorMustEqual,v=y.patchBase,P=y.patchMustEqual;y.hasCaret&&(f===0||(m=!1),P=!1);let u=0;if(y.preRelease){const g=D.exec(y.preRelease);if(g){const[,c,o,l]=g;u=Date.UTC(Number(c),Number(o)-1,Number(l))}}return{majorBase:f,majorMustEqual:t,minorBase:d,minorMustEqual:m,patchBase:v,patchMustEqual:P,isMinimum:y.hasGreaterEquals,notBefore:u}}e.normalizeVersion=E;function w(y,f,t){let d;typeof y=="string"?d=E(k(y)):d=y;let m;f instanceof Date?m=f.getTime():typeof f=="string"&&(m=new Date(f).getTime());let v;if(typeof t=="string"?v=E(k(t)):v=t,!d||!v)return!1;let P=d.majorBase,u=d.minorBase,g=d.patchBase,c=v.majorBase,o=v.minorBase,l=v.patchBase,s=v.notBefore,i=v.majorMustEqual,r=v.minorMustEqual,a=v.patchMustEqual;return v.isMinimum?P>c?!0:P<c?!1:u>o?!0:u<o||m&&m<s?!1:g>=l:(P===1&&c===0&&(!i||!r||!a)&&(c=1,o=0,l=0,i=!0,r=!1,a=!1),P<c?!1:P>c?!i:u<o?!1:u>o?!r:g<l?!1:g>l?!a:!(m&&m<s))}e.isValidVersion=w;function S(y,f,t,d){return t.isBuiltin||typeof t.main=="undefined"?!0:M(y,f,t.engines.vscode,d)}e.isValidExtensionVersion=S;function b(y,f,t){return y==="*"||M(f,t,y)}e.isEngineValid=b;function M(y,f,t,d=[]){let m=E(k(t));if(!m)return d.push(p.localize(0,null,t)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return d.push(p.localize(1,null,t)),!1}else if(!m.majorMustEqual)return d.push(p.localize(2,null,t)),!1;return w(y,f,m)?!0:(d.push(p.localize(3,null,y,t)),!1)}}),define(ee[62],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class p{constructor(D,C=[],k=!1){this.ctor=D,this.staticArguments=C,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=p}),define(ee[172],te([0,1,62]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const n=[];function D(k,E,w){E instanceof p.SyncDescriptor||(E=new p.SyncDescriptor(E,[],w)),n.push([k,E])}e.registerSingleton=D;function C(){return n}e.getSingletonServiceDescriptors=C}),define(ee[173],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class p{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=p;class n{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let k of this._nodes.values())k.outgoing.size===0&&C.push(k);return C}insertEdge(C,k){const E=this.lookupOrInsertNode(C),w=this.lookupOrInsertNode(k);E.outgoing.set(this._hashFn(k),w),w.incoming.set(this._hashFn(C),E)}removeNode(C){const k=this._hashFn(C);this._nodes.delete(k);for(let E of this._nodes.values())E.outgoing.delete(k),E.incoming.delete(k)}lookupOrInsertNode(C){const k=this._hashFn(C);let E=this._nodes.get(k);return E||(E=new p(C),this._nodes.set(k,E)),E}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[k,E]of this._nodes)C.push(`${k}, (incoming)[${[...E.incoming.keys()].join(", ")}], (outgoing)[${[...E.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,k]of this._nodes){const E=new Set([C]),w=this._findCycle(k,E);if(w)return w}}_findCycle(C,k){for(let[E,w]of C.outgoing){if(k.has(E))return[...k,E].join(" -> ");k.add(E);const S=this._findCycle(w,k);if(S)return S;k.delete(E)}}}e.Graph=n}),define(ee[5],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var p;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function E(w){return w[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=E})(p=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function n(k,E,w,S){E[p.DI_TARGET]===E?E[p.DI_DEPENDENCIES].push({id:k,index:w,optional:S}):(E[p.DI_DEPENDENCIES]=[{id:k,index:w,optional:S}],E[p.DI_TARGET]=E)}function D(k){if(p.serviceIds.has(k))return p.serviceIds.get(k);const E=function(w,S,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(E,w,b,!1)};return E.toString=()=>k,p.serviceIds.set(k,E),E}e.createDecorator=D;function C(k){return k}e.refineServiceDecorator=C}),define(ee[52],te([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,p.createDecorator)("backupMainService")}),define(ee[19],te([0,1,13,7,5]),function(j,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function C(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof n.URI)}e.isConfigurationOverrides=C;function k(m){return m&&typeof m=="object"&&(!m.overrideIdentifiers||p.isArray(m.overrideIdentifiers))&&!m.overrideIdentifier&&(!m.resource||m.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=k;var E;(function(m){m[m.USER=1]="USER",m[m.USER_LOCAL=2]="USER_LOCAL",m[m.USER_REMOTE=3]="USER_REMOTE",m[m.WORKSPACE=4]="WORKSPACE",m[m.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",m[m.DEFAULT=6]="DEFAULT",m[m.MEMORY=7]="MEMORY"})(E=e.ConfigurationTarget||(e.ConfigurationTarget={}));function w(m){switch(m){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=w;function S(m,v){const P=Object.create(null);for(let u in m)b(P,u,m[u],v);return P}e.toValuesTree=S;function b(m,v,P,u){const g=v.split("."),c=g.pop();let o=m;for(let l=0;l<g.length;l++){let s=g[l],i=o[s];switch(typeof i){case"undefined":i=o[s]=Object.create(null);break;case"object":break;default:u(`Ignoring ${v} as ${g.slice(0,l+1).join(".")} is ${JSON.stringify(i)}`);return}o=i}if(typeof o=="object"&&o!==null)try{o[c]=P}catch{u(`Ignoring ${v} as ${g.join(".")} is ${JSON.stringify(o)}`)}else u(`Ignoring ${v} as ${g.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=b;function M(m,v){const P=v.split(".");y(m,P)}e.removeFromValueTree=M;function y(m,v){const P=v.shift();if(v.length===0){delete m[P];return}if(Object.keys(m).indexOf(P)!==-1){const u=m[P];typeof u=="object"&&!Array.isArray(u)&&(y(u,v),Object.keys(u).length===0&&delete m[P])}}function f(m,v,P){function u(o,l){let s=o;for(const i of l){if(typeof s!="object"||s===null)return;s=s[i]}return s}const g=v.split("."),c=u(m,g);return typeof c=="undefined"?P:c}e.getConfigurationValue=f;function t(m,v,P){Object.keys(v).forEach(u=>{u!=="__proto__"&&(u in m?p.isObject(m[u])&&p.isObject(v[u])?t(m[u],v[u],P):P&&(m[u]=v[u]):m[u]=v[u])})}e.merge=t;function d(m,v,P){const u=m.inspect(v),g=m.inspect(P);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof g.userValue!="undefined"||typeof g.workspaceValue!="undefined"||typeof g.workspaceFolderValue!="undefined"?g.value:u.defaultValue}e.getMigratedSettingValue=d}),define(ee[174],te([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ICredentialsService=void 0,e.ICredentialsService=(0,p.createDecorator)("credentialsService")}),define(ee[75],te([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,p.createDecorator)(e.ID);function n(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=n}),define(ee[91],te([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,p.createDecorator)("encryptionMainService");class n{constructor(C){this.machineId=C}encryption(){return new Promise((C,k)=>j(["vscode-encrypt"],C,k))}async encrypt(C){try{return(await this.encryption()).encrypt(this.machineId,C)}catch{return C}}async decrypt(C){try{return(await this.encryption()).decrypt(this.machineId,C)}catch{return C}}}e.EncryptionMainService=n}),define(ee[48],te([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,p.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,p.refineServiceDecorator)(e.IEnvironmentService)}),define(ee[175],te([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,p.createDecorator)("extensionUrlTrustService")}),define(ee[176],te([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,p.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(ee[92],te([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,p.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,p.createDecorator)("externalTerminal")}),define(ee[177],te([0,1,45,10,9,3,83,24,74,146,92]),function(j,e,p,n,D,C,k,E,w,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const M=S.localize(0,null);class y{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await d.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends y{openTerminal(g,c){return this.spawnTerminal(p,g,w.getWindowsShell(),c)}spawnTerminal(g,c,o,l){const s=c.windowsExec||f.getDefaultTerminalWindows();l&&l[1]===":"&&(l=l[0].toUpperCase()+l.substr(1));const i=D.basename(s).toLowerCase();if(i==="cmder"||i==="cmder.exe")return g.spawn(s,l?[l]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return s.indexOf(" ")>=0&&r.push('""'),r.push(s),(i==="wt"||i==="wt.exe")&&r.push("-d ."),new Promise((a,h)=>{const I=m(process),R=g.spawn(o,r,{cwd:l,env:I});R.on("error",h),R.on("exit",()=>a())})}runInTerminal(g,c,o,l,s){const i="windowsExec"in s&&s.windowsExec?s.windowsExec:f.getDefaultTerminalWindows();return new Promise((r,a)=>{const h=`"${c} - ${M}"`,I=`""${o.join('" "')}" & pause"`,R=["/c","start",h,"/wait",i,"/c",I],L=Object.assign({},m(process),l);Object.keys(L).filter(Q=>L[Q]===null).forEach(Q=>delete L[Q]);const T={cwd:c,env:L,windowsVerbatimArguments:!0};p.spawn(f.CMD,R,T).on("error",Q=>{a(v(Q))}),r(void 0)})}static getDefaultTerminalWindows(){if(!f._DEFAULT_TERMINAL_WINDOWS){const g=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${g?"Sysnative":"System32"}\\cmd.exe`}return f._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=f,f.CMD="cmd.exe";class t extends y{openTerminal(g,c){return this.spawnTerminal(p,g,c)}runInTerminal(g,c,o,l,s){const i=s.osxExec||b.DEFAULT_TERMINAL_OSX;return new Promise((r,a)=>{if(i===b.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const h=i===b.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",R=[n.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${h}.scpt`,j).fsPath,"-t",g||M,"-w",c];for(let $ of o)R.push("-a"),R.push($);if(l){const $=Object.assign({},m(process),l);for(let Q in $){const se=$[Q];se===null?(R.push("-u"),R.push(Q)):(R.push("-e"),R.push(`${Q}=${se}`))}}let L="";const T=p.spawn(t.OSASCRIPT,R);T.on("error",$=>{a(v($))}),T.stderr.on("data",$=>{L+=$.toString()}),T.on("exit",$=>{if($===0)r(void 0);else if(L){const Q=L.split(`
`,1);a(new Error(Q[0]))}else a(new Error(S.localize(1,null,h,$)))})}else a(new Error(S.localize(2,null,i)))})}spawnTerminal(g,c,o){const l=c.osxExec||b.DEFAULT_TERMINAL_OSX;return new Promise((s,i)=>{const r=["-a",l];o&&r.push(o);const a=m(process),h=g.spawn("/usr/bin/open",r,{cwd:o,env:a});h.on("error",i),h.on("exit",()=>s())})}}e.MacExternalTerminalService=t,t.OSASCRIPT="/usr/bin/osascript";class d extends y{openTerminal(g,c){return this.spawnTerminal(p,g,c)}runInTerminal(g,c,o,l,s){const i=s.linuxExec?Promise.resolve(s.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((r,a)=>{let h=[];i.then(I=>{I.indexOf("gnome-terminal")>=0?h.push("-x"):h.push("-e"),h.push("bash"),h.push("-c");const R=`${P(o)}; echo; read -p "${d.WAIT_MESSAGE}" -n1;`;h.push(`''${R}''`);const L=Object.assign({},m(process),l);Object.keys(L).filter(se=>L[se]===null).forEach(se=>delete L[se]);const T={cwd:c,env:L};let $="";const Q=p.spawn(I,h,T);Q.on("error",se=>{a(v(se))}),Q.stderr.on("data",se=>{$+=se.toString()}),Q.on("exit",se=>{if(se===0)r(void 0);else if($){const re=$.split(`
`,1);a(new Error(re[0]))}else a(new Error(S.localize(4,null,I,se)))})})})}static async getDefaultTerminalLinuxReady(){if(!d._DEFAULT_TERMINAL_LINUX_READY)if(!C.isLinux)d._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const g=await E.Promises.exists("/etc/debian_version");d._DEFAULT_TERMINAL_LINUX_READY=new Promise(c=>{g?c("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?c("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?c("konsole"):process.env.COLORTERM?c(process.env.COLORTERM):process.env.TERM?c(process.env.TERM):c("xterm")})}return d._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(g,c,o){const l=c.linuxExec?Promise.resolve(c.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((s,i)=>{l.then(r=>{const a=m(process),h=g.spawn(r,[],{cwd:o,env:a});h.on("error",i),h.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=d,d.WAIT_MESSAGE=S.localize(3,null);function m(u){const g={...u.env};return(0,k.sanitizeProcessEnvironment)(g),g}function v(u){return"errno"in u&&u.errno==="ENOENT"&&"path"in u&&typeof u.path=="string"?new Error(S.localize(5,null,u.path)):u}function P(u){let g="";for(let c of u)c.indexOf(" ")>=0?g+='"'+c+'"':g+=c,g+=" ";return g}}),define(ee[18],te([0,1,36,9,25,13,7,148,5]),function(j,e,p,n,D,C,k,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,w.createDecorator)("fileService");function S(H){return H.create===!0}e.isFileOpenForWriteOptions=S;var b;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(b=e.FileType||(e.FileType={}));var M;(function(H){H[H.Readonly=1]="Readonly"})(M=e.FilePermission||(e.FilePermission={}));var y;(function(H){H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead"})(y=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=f;function t(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=t;function d(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function m(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=m;function v(H){return f(H)?!!(H.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var P;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(P=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class u extends Error{constructor(K,x){super(K);this.code=x}}e.FileSystemProviderError=u;function g(H,K){const x=new u(H.toString(),K);return o(x,K),x}e.createFileSystemProviderError=g;function c(H){return H||g((0,E.localize)(0,null),P.Unknown)}e.ensureFileSystemProviderError=c;function o(H,K){return H.name=K?`${K} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=o;function l(H){if(!H)return P.Unknown;if(H instanceof u)return H.code;const K=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!K)return P.Unknown;switch(K[1]){case P.FileExists:return P.FileExists;case P.FileIsADirectory:return P.FileIsADirectory;case P.FileNotADirectory:return P.FileNotADirectory;case P.FileNotFound:return P.FileNotFound;case P.FileExceedsMemoryLimit:return P.FileExceedsMemoryLimit;case P.FileTooLarge:return P.FileTooLarge;case P.FileWriteLocked:return P.FileWriteLocked;case P.NoPermissions:return P.NoPermissions;case P.Unavailable:return P.Unavailable}return P.Unknown}e.toFileSystemProviderErrorCode=l;function s(H){if(H instanceof R)return H.fileOperationResult;switch(l(H)){case P.FileNotFound:return 1;case P.FileIsADirectory:return 0;case P.FileNotADirectory:return 10;case P.FileWriteLocked:return 5;case P.NoPermissions:return 6;case P.FileExists:return 4;case P.FileExceedsMemoryLimit:return 9;case P.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var i;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class r{constructor(K,x,B){this.resource=K,this.operation=x,this.target=B}isOperation(K){return this.operation===K}}e.FileOperationEvent=r;var a;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class h{constructor(K,x){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=K;const B=new Map;for(const z of K){const G=B.get(z.type);switch(G?G.push([z.resource,z]):B.set(z.type,[[z.resource,z]]),z.type){case 1:this.rawAdded.push(z.resource);break;case 0:this.rawUpdated.push(z.resource);break;case 2:this.rawDeleted.push(z.resource);break}}for(const[z,G]of B)switch(z){case 1:this.added=p.TernarySearchTree.forUris(()=>x),this.added.fill(G);break;case 0:this.updated=p.TernarySearchTree.forUris(()=>x),this.updated.fill(G);break;case 2:this.deleted=p.TernarySearchTree.forUris(()=>x),this.deleted.fill(G);break}}contains(K,...x){return this.doContains(K,{includeChildren:!1},...x)}affects(K,...x){return this.doContains(K,{includeChildren:!0},...x)}doContains(K,x,...B){if(!K)return!1;const z=B.length>0;return!!((!z||B.includes(1))&&(this.added?.get(K)||x.includeChildren&&this.added?.findSuperstr(K))||(!z||B.includes(0))&&(this.updated?.get(K)||x.includeChildren&&this.updated?.findSuperstr(K))||(!z||B.includes(2))&&(this.deleted?.findSubstr(K)||x.includeChildren&&this.deleted?.findSuperstr(K)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=h;function I(H,K,x){return!H||!K||H===K||K.length>H.length?!1:(K.charAt(K.length-1)!==n.sep&&(K+=n.sep),x?(0,D.startsWithIgnoreCase)(H,K):H.indexOf(K)===0)}e.isParent=I;class R extends Error{constructor(K,x,B){super(K);this.fileOperationResult=x,this.options=B}}e.FileOperationError=R;class L extends R{constructor(K,x,B){super(K,2,B);this.stat=x}}e.NotModifiedSinceFileOperationError=L;var T;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",H[H.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(T=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var $;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})($=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function Q(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=Q;async function se(H,K){if(!K.hasProvider(k.URI.from({scheme:H.scheme})))return new Promise(x=>{const B=K.onDidChangeFileSystemProviderRegistrations(z=>{z.scheme===H.scheme&&z.added&&(B.dispose(),x())})})}e.whenProviderRegistered=se,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class re{static formatSize(K){return(0,C.isNumber)(K)||(K=0),K<re.KB?(0,E.localize)(1,null,K.toFixed(0)):K<re.MB?(0,E.localize)(2,null,(K/re.KB).toFixed(2)):K<re.GB?(0,E.localize)(3,null,(K/re.MB).toFixed(2)):K<re.TB?(0,E.localize)(4,null,(K/re.GB).toFixed(2)):(0,E.localize)(5,null,(K/re.TB).toFixed(2))}}e.ByteSize=re,re.KB=1024,re.MB=re.KB*re.KB,re.GB=re.MB*re.KB,re.TB=re.GB*re.KB;var V;(function(H){H[H.IA32=0]="IA32",H[H.OTHER=1]="OTHER"})(V=e.Arch||(e.Arch={}));function Z(H){return{maxFileSize:H===0?300*re.MB:16*re.GB,maxHeapSize:H===0?700*re.MB:2*700*re.MB}}e.getPlatformLimits=Z}),define(ee[53],te([0,1,256,142,90,18]),function(j,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function k(y,f){const t={onUnknownOption:m=>{console.warn((0,n.localize)(0,null,m))},onMultipleValues:(m,v)=>{console.warn((0,n.localize)(1,null,m,v))},onDeprecatedOption:(m,v)=>{console.warn((0,n.localize)(2,null,m,v))}},d=(0,D.parseArgs)(y,D.OPTIONS,f?t:void 0);return d.goto&&d._.forEach(m=>p(/^(\w:)?[^:]+(:\d*){0,2}$/.test(m),(0,n.localize)(3,null))),d["max-memory"]&&p(parseInt(d["max-memory"])>=C.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${C.MIN_MAX_MEMORY_SIZE_MB} MB.`),d}function E(y){const f=y.findIndex(t=>!/^-/.test(t));if(f>-1)return[...y.slice(0,f),...y.slice(f+1)]}function w(y){let[,...f]=y;process.env.VSCODE_DEV&&(f=E(f)||[]);const t=!M(process.env);return k(f,t)}e.parseMainProcessArgv=w;function S(y){const[,,...f]=y;return k(f,!0)}e.parseCLIProcessArgv=S;function b(y,...f){const t=y.indexOf("--");return t===-1?y.push(...f):y.splice(t,0,...f),y}e.addArg=b;function M(y){return y.VSCODE_CLI==="1"}e.isLaunchedFromCli=M}),define(ee[93],te([0,1,45,9,143,21,39,15,3,32,136,53,8]),function(j,e,p,n,D,C,k,E,w,S,b,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const f=1e4;let t;async function d(v,P,u){return P["force-disable-user-env"]?(v.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):w.isWindows?(v.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,M.isLaunchedFromCli)(u)&&!P["force-user-env"]?(v.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,M.isLaunchedFromCli)(u)?v.trace("resolveShellEnv(): running (--force-user-env)"):v.trace("resolveShellEnv(): running (macOS/Linux)"),t||(t=y.Promises.withAsyncBody(async(g,c)=>{const o=new C.CancellationTokenSource,l=setTimeout(()=>{o.dispose(!0),c(new Error((0,D.localize)(0,null)))},f);try{g(await m(v,o.token))}catch(s){!(0,E.isCancellationError)(s)&&!o.token.isCancellationRequested?c(new Error((0,D.localize)(1,null,(0,k.toErrorMessage)(s)))):g({})}finally{clearTimeout(l),o.dispose()}})),t)}e.getResolvedShellEnv=d;async function m(v,P){const u=process.env.ELECTRON_RUN_AS_NODE;v.trace("getUnixShellEnvironment#runAsNode",u);const g=process.env.ELECTRON_NO_ATTACH_CONSOLE;v.trace("getUnixShellEnvironment#noAttach",g);const c=(0,S.generateUuid)().replace(/-/g,"").substr(0,12),o=new RegExp(c+"(.*)"+c),l={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};v.trace("getUnixShellEnvironment#env",l);const s=await(0,b.getSystemShell)(w.OS,l);return v.trace("getUnixShellEnvironment#shell",s),new Promise((i,r)=>{if(P.isCancellationRequested)return r((0,E.canceled)());const a=(0,n.basename)(s);let h,I;const R=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(h=`& '${process.execPath}' ${R} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,I=["-Login","-Command"]):(h=`'${process.execPath}' ${R} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,a==="tcsh"?I=["-ic"]:I=["-ilc"]),v.trace("getUnixShellEnvironment#spawn",JSON.stringify(I),h);const L=(0,p.spawn)(s,[...I,h],{detached:!0,stdio:["ignore","pipe","pipe"],env:l});P.onCancellationRequested(()=>(L.kill(),r((0,E.canceled)()))),L.on("error",Q=>{v.error("getUnixShellEnvironment#errorChildProcess",(0,k.toErrorMessage)(Q)),r(Q)});const T=[];L.stdout.on("data",Q=>T.push(Q));const $=[];L.stderr.on("data",Q=>$.push(Q)),L.on("close",(Q,se)=>{const re=Buffer.concat(T).toString("utf8");v.trace("getUnixShellEnvironment#raw",re);const V=Buffer.concat($).toString("utf8");if(V.trim()&&v.trace("getUnixShellEnvironment#stderr",V),Q||se)return r(new Error((0,D.localize)(2,null,Q,se)));const Z=o.exec(re),H=Z?Z[1]:"{}";try{const K=JSON.parse(H);u?K.ELECTRON_RUN_AS_NODE=u:delete K.ELECTRON_RUN_AS_NODE,g?K.ELECTRON_NO_ATTACH_CONSOLE=g:delete K.ELECTRON_NO_ATTACH_CONSOLE,delete K.XDG_RUNTIME_DIR,v.trace("getUnixShellEnvironment#result",K),i(K)}catch(K){v.error("getUnixShellEnvironment#errorCaught",(0,k.toErrorMessage)(K)),r(K)}})})}}),define(ee[178],te([0,1,17,39,15,4,2,51,7,32,18]),function(j,e,p,n,D,C,k,E,w,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class M extends k.Disposable{constructor(f,t){super();this.channel=f,this.extraCapabilities=t,this.onDidChangeCapabilities=C.Event.None,this._onDidChange=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new C.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,S.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(f){return this.channel.call("stat",[f])}readdir(f){return this.channel.call("readdir",[f])}async readFile(f,t){const{buffer:d}=await this.channel.call("readFile",[f,t]);return d}readFileStream(f,t,d){const m=(0,E.newWriteableStream)(P=>p.VSBuffer.concat(P.map(u=>p.VSBuffer.wrap(u))).buffer),v=this.channel.listen("readFileStream",[f,t])(P=>{if(P instanceof p.VSBuffer)m.write(P.buffer);else{if(P==="end")m.end();else{let u=P;u instanceof Error||(u=(0,b.createFileSystemProviderError)((0,n.toErrorMessage)(u),b.FileSystemProviderErrorCode.Unknown)),m.error(u),m.end()}v.dispose()}});return d.onCancellationRequested(()=>{m.error((0,D.canceled)()),m.end(),v.dispose()}),m}writeFile(f,t,d){return this.channel.call("writeFile",[f,p.VSBuffer.wrap(t),d])}open(f,t){return this.channel.call("open",[f,t])}close(f){return this.channel.call("close",[f])}async read(f,t,d,m,v){const[P,u]=await this.channel.call("read",[f,t,v]);return d.set(P.buffer.slice(0,u),m),u}write(f,t,d,m,v){return this.channel.call("write",[f,t,p.VSBuffer.wrap(d),m,v])}mkdir(f){return this.channel.call("mkdir",[f])}delete(f,t){return this.channel.call("delete",[f,t])}rename(f,t,d){return this.channel.call("rename",[f,t,d])}copy(f,t,d){return this.channel.call("copy",[f,t,d])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(f=>{if(Array.isArray(f)){const t=f;this._onDidChange.fire(t.map(d=>({resource:w.URI.revive(d.resource),type:d.type})))}else{const t=f;this._onDidWatchError.fire(t)}}))}watch(f,t){const d=(0,S.generateUuid)();return this.channel.call("watch",[this.sessionId,d,f,t]),(0,k.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,d]))}}e.DiskFileSystemProviderClient=M}),define(ee[94],te([0,1,17,15,149,18]),function(j,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function k(b,M,y,f,t,d){let m;try{await E(b,M,y,f,t,d)}catch(v){m=v}finally{m&&t.errorTransformer&&(m=t.errorTransformer(m)),typeof m!="undefined"&&y.error(m),y.end()}}e.readFileIntoStream=k;async function E(b,M,y,f,t,d){w(d);const m=await b.open(M,{create:!1});try{w(d);let v=0,P=0,u=t&&typeof t.length=="number"?t.length:void 0,g=p.VSBuffer.alloc(Math.min(t.bufferSize,typeof u=="number"?u:t.bufferSize)),c=t&&typeof t.position=="number"?t.position:0,o=0;do P=await b.read(m,c,g.buffer,o,g.byteLength-o),c+=P,o+=P,v+=P,typeof u=="number"&&(u-=P),o===g.byteLength&&(await y.write(f(g)),g=p.VSBuffer.alloc(Math.min(t.bufferSize,typeof u=="number"?u:t.bufferSize)),o=0);while(P>0&&(typeof u!="number"||u>0)&&w(d)&&S(v,t));if(o>0){let l=o;typeof u=="number"&&(l=Math.min(o,u)),y.write(f(g.slice(0,l)))}}catch(v){throw(0,C.ensureFileSystemProviderError)(v)}finally{await b.close(m)}}function w(b){if(b.isCancellationRequested)throw(0,n.canceled)();return!0}function S(b,M){if(M?.limits){if(typeof M.limits.memory=="number"&&b>M.limits.memory)throw(0,C.createFileSystemProviderError)((0,D.localize)(0,null),C.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof M.limits.size=="number"&&b>M.limits.size)throw(0,C.createFileSystemProviderError)((0,D.localize)(1,null),C.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ee[63],te([0,1,2,3,7,18]),function(j,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function k(f){return f.recursive===!0}e.isRecursiveWatchRequest=k;class E extends p.Disposable{constructor(t,d,m,v){super();this.onFileChanges=t,this.onLogMessage=d,this.verboseLogging=m,this.options=v,this.watcherDisposables=this._register(new p.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const t=new p.DisposableStore;this.watcherDisposables.value=t,this.watcher=this.createWatcher(t),this.watcher.setVerboseLogging(this.verboseLogging),t.add(this.watcher.onDidChangeFile(d=>this.onFileChanges(d))),t.add(this.watcher.onDidLogMessage(d=>this.onLogMessage(d))),t.add(this.watcher.onDidError(d=>this.onError(d)))}onError(t){this.options.restartOnError?this.restartCounter<E.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${t}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${t}`):this.error(t)}restart(t){this.restartCounter++,this.init(),this.watch(t)}async watch(t){this.requests=t,await this.watcher?.watch(t)}async setVerboseLogging(t){this.verboseLogging=t,await this.watcher?.setVerboseLogging(t)}error(t){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${t}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=E,E.MAX_RESTARTS=5;class w extends E{constructor(t,d,m){super(t,d,m,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=w;class S extends E{constructor(t,d,m){super(t,d,m,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=S;function b(f){return f.map(t=>({type:t.type,resource:D.URI.file(t.path)}))}e.toFileChanges=b;function M(f){const t=new y;for(const d of f)t.processEvent(d);return t.coalesce()}e.coalesceEvents=M;class y{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(t){return n.isLinux?t.path:t.path.toLowerCase()}processEvent(t){const d=this.mapPathToChange.get(this.toKey(t));let m=!1;if(d){const v=d.type,P=t.type;d.path!==t.path&&(t.type===2||t.type===1)?m=!0:v===1&&P===2?(this.mapPathToChange.delete(this.toKey(t)),this.coalesced.delete(d)):v===2&&P===1?d.type=0:v===1&&P===0||(d.type=P)}else m=!0;m&&(this.coalesced.add(t),this.mapPathToChange.set(this.toKey(t),t))}coalesce(){const t=[],d=[];return Array.from(this.coalesced).filter(m=>m.type!==2?(t.push(m),!1):!0).sort((m,v)=>m.path.length-v.path.length).filter(m=>d.some(v=>(0,C.isParent)(m.path,v,!n.isLinux))?!1:(d.push(m.path),!0)).concat(t)}}}),define(ee[179],te([0,1,30,8,21,29,115,2,72,9,3,85,24,63]),function(j,e,p,n,D,C,k,E,w,S,b,M,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class t extends E.Disposable{constructor(v,P,u,g){super();this.request=v,this.onDidFilesChange=P,this.onLogMessage=u,this.verboseLogging=g,this.throttledFileChangesWorker=new n.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},c=>this.onDidFilesChange(c)),this.fileChangesDelayer=this._register(new n.ThrottledDelayer(t.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=this.request.excludes.map(c=>(0,k.parse)(c)),this.cts=new D.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const v=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const P=await y.Promises.stat(v);this._register(await this.doWatch(v,P.isDirectory()))}catch(v){v.code!=="ENOENT"?this.error(v):this.trace(v)}}async normalizePath(v){let P=v.path;try{P=await y.Promises.realpath(v.path),v.path===P&&(P=await(0,M.realcase)(v.path)??v.path),v.path!==P&&this.warn(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${v.path}, real: ${P})`)}catch{}return P}async doWatch(v,P){if(b.isMacintosh&&(0,C.isEqualOrParent)(v,"/Volumes/",!0))return this.error(`Refusing to watch ${v} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),E.Disposable.None;const u=new D.CancellationTokenSource(this.cts.token);let g=new E.DisposableStore;try{const c=(0,S.basename)(v),o=(0,p.watch)(v);g.add((0,E.toDisposable)(()=>{o.removeAllListeners(),o.close()})),this.trace(`Started watching: '${v}'`);const l=new Set;if(P)try{for(const i of await y.Promises.readdir(v))l.add(i)}catch(i){this.error(i)}const s=new Map;g.add((0,E.toDisposable)(()=>{for(const[,i]of s)i.dispose();s.clear()})),o.on("error",(i,r)=>{this.error(`Failed to watch ${v} for changes using fs.watch() (${i}, ${r})`),this.dispose()}),o.on("change",(i,r)=>{if(u.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${r}`);let a="";if(r&&(a=r.toString(),b.isMacintosh&&(a=(0,w.normalizeNFC)(a))),!(!a||i!=="change"&&i!=="rename"))if(P)if(i==="rename"){s.get(a)?.dispose();const h=setTimeout(async()=>{if(s.delete(a),a===c&&!await y.Promises.exists(v)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const I=await this.existsChildStrictCase((0,S.join)(v,a));if(u.token.isCancellationRequested)return;let R;I?l.has(a)?R=0:(R=1,l.add(a)):(l.delete(a),R=2),this.onFileChange({path:(0,S.join)(this.request.path,a),type:R})},t.FILE_DELETE_HANDLER_DELAY);s.set(a,(0,E.toDisposable)(()=>clearTimeout(h)))}else{let h;l.has(a)?h=0:(h=1,l.add(a)),this.onFileChange({path:(0,S.join)(this.request.path,a),type:h})}else if(i==="rename"||a!==c){const h=setTimeout(async()=>{const I=await y.Promises.exists(v);u.token.isCancellationRequested||(I?(this.onFileChange({path:this.request.path,type:0},!0),g.add(await this.doWatch(v,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},t.FILE_DELETE_HANDLER_DELAY);g.clear(),g.add((0,E.toDisposable)(()=>clearTimeout(h)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(c){await y.Promises.exists(v)&&!u.token.isCancellationRequested&&this.error(`Failed to watch ${v} for changes using fs.watch() (${c.toString()})`)}return(0,E.toDisposable)(()=>{u.dispose(!0),g.dispose()})}async onFileChange(v,P=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${v.type===1?"[ADDED]":v.type===2?"[DELETED]":"[CHANGED]"} ${v.path}`),!P&&this.excludes.some(u=>u(v.path))?this.verboseLogging&&this.trace(` >> ignored ${v.path}`):this.fileChangesBuffer.push(v);try{await this.fileChangesDelayer.trigger(async()=>{const u=this.fileChangesBuffer;this.fileChangesBuffer=[];const g=(0,f.coalesceEvents)(u);if(g.length>0){if(this.verboseLogging)for(const o of g)this.trace(`>> normalized ${o.type===1?"[ADDED]":o.type===2?"[DELETED]":"[CHANGED]"} ${o.path}`);this.throttledFileChangesWorker.work(g)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${g.length}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(v){if(b.isLinux)return y.Promises.exists(v);try{const P=(0,S.basename)(v);return(await y.Promises.readdir((0,S.dirname)(v))).some(g=>g===P)}catch(P){return this.trace(P),!1}}setVerboseLogging(v){this.verboseLogging=v}error(v){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${v}`})}warn(v){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${v}`})}trace(v){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${v}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=t,t.FILE_DELETE_HANDLER_DELAY=100,t.FILE_CHANGES_HANDLER_DELAY=50;async function d(m,v,P,u,g=512){const c=await y.Promises.open(m,"r"),o=Buffer.allocUnsafe(g),l=new D.CancellationTokenSource(u);let s,i=!1;const r={path:m,excludes:[],recursive:!1},a=new t(r,h=>{(async()=>{for(const{type:I}of h)if(I===0){if(i)return;i=!0;try{for(;!l.token.isCancellationRequested;){const{bytesRead:R}=await y.Promises.read(c,o,0,g,null);if(!R||l.token.isCancellationRequested)break;v(o.slice(0,R))}}catch(R){s=new Error(R),l.dispose(!0)}finally{i=!1}}})()});return await a.ready,P(),new Promise((h,I)=>{l.token.onCancellationRequested(async()=>{a.dispose();try{await y.Promises.close(c)}catch(R){s=new Error(R)}s?I(s):h()})})}e.watchFileContents=d}),define(ee[180],te([0,1,28,4,2,3,179]),function(j,e,p,n,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class E extends D.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new n.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new n.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=n.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(S){const b=this.normalizeRequests(S),M=b.filter(f=>{const t=this.watchers.get(f.path);return t?!(0,p.equals)(t.request.excludes,f.excludes):!0}),y=Array.from(this.watchers.values()).filter(({request:f})=>!b.find(t=>t.path===f.path&&(0,p.equals)(t.excludes,f.excludes))).map(({request:f})=>f.path);M.length&&this.trace(`Request to start watching: ${M.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"})`).join(",")}`),y.length&&this.trace(`Request to stop watching: ${y.join(",")}`);for(const f of y)this.stopWatching(f);for(const f of M)this.startWatching(f)}startWatching(S){const b=new k.NodeJSFileWatcherLibrary(S,y=>this._onDidChangeFile.fire(y),y=>this._onDidLogMessage.fire(y),this.verboseLogging),M={request:S,instance:b};this.watchers.set(S.path,M)}async stop(){for(const[S]of this.watchers)this.stopWatching(S);this.watchers.clear()}stopWatching(S){const b=this.watchers.get(S);b&&(this.watchers.delete(S),b.instance.dispose())}normalizeRequests(S){const b=new Map;for(const M of S){const y=C.isLinux?M.path:M.path.toLowerCase();b.set(y,M)}return Array.from(b.values())}async setVerboseLogging(S){this.verboseLogging=S;for(const[,b]of this.watchers)b.instance.setVerboseLogging(S)}trace(S){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(S)})}toMessage(S,b){return b?`[File Watcher (node.js)] ${S} (path: ${b.request.path})`:`[File Watcher (node.js)] ${S}`}}e.NodeJSWatcher=E}),define(ee[181],te([0,1,63,180]),function(j,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class D extends p.AbstractNonRecursiveWatcherClient{constructor(k,E,w){super(k,E,w);this.init()}createWatcher(){return new n.NodeJSWatcher}}e.NodeJSWatcherClient=D}),define(ee[182],te([0,1,10,37,137,63]),function(j,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class k extends C.AbstractUniversalWatcherClient{constructor(w,S,b){super(w,S,b);this.init()}createWatcher(w){const S=w.add(new D.Client(p.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return w.add(S.onDidProcessExit(({code:b,signal:M})=>this.onError(`terminated by itself with code ${b}, signal: ${M}`))),n.ProxyChannel.toService((0,n.getNextTickChannel)(S.getChannel("watcher")))}}e.UniversalWatcherClient=k}),define(ee[76],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class p{constructor(...D){this._entries=new Map;for(let[C,k]of D)this.set(C,k)}set(D,C){const k=this._entries.get(D);return this._entries.set(D,C),k}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=p}),define(ee[183],te([0,1,8,15,62,173,5,76]),function(j,e,p,n,D,C,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const w=!1;class S extends Error{constructor(t){super("cyclic dependency between services");this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class b{constructor(t=new E.ServiceCollection,d=!1,m){this._activeInstantiations=new Set,this._services=t,this._strict=d,this._parent=m,this._services.set(k.IInstantiationService,this)}createChild(t){return new b(t,this._strict,this)}invokeFunction(t,...d){let m=y.traceInvocation(t),v=!1;try{return t({get:u=>{if(v)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const g=this._getOrCreateServiceInstance(u,m);if(!g)throw new Error(`[invokeFunction] unknown service '${u}'`);return g}},...d)}finally{v=!0,m.stop()}}createInstance(t,...d){let m,v;return t instanceof D.SyncDescriptor?(m=y.traceCreation(t.ctor),v=this._createInstance(t.ctor,t.staticArguments.concat(d),m)):(m=y.traceCreation(t),v=this._createInstance(t,d,m)),m.stop(),v}_createInstance(t,d=[],m){let v=k._util.getServiceDependencies(t).sort((g,c)=>g.index-c.index),P=[];for(const g of v){let c=this._getOrCreateServiceInstance(g.id,m);if(!c&&this._strict&&!g.optional)throw new Error(`[createInstance] ${t.name} depends on UNKNOWN service ${g.id}.`);P.push(c)}let u=v.length>0?v[0].index:d.length;if(d.length!==u){console.warn(`[createInstance] First service dependency of ${t.name} at position ${u+1} conflicts with ${d.length} static arguments`);let g=u-d.length;g>0?d=d.concat(new Array(g)):d=d.slice(0,u)}return new t(...[...d,...P])}_setServiceInstance(t,d){if(this._services.get(t)instanceof D.SyncDescriptor)this._services.set(t,d);else if(this._parent)this._parent._setServiceInstance(t,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(t){let d=this._services.get(t);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(t):d}_getOrCreateServiceInstance(t,d){let m=this._getServiceInstanceOrDescriptor(t);return m instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(t,m,d.branch(t,!0)):(d.branch(t,!1),m)}_safeCreateAndCacheServiceInstance(t,d,m){if(this._activeInstantiations.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this._activeInstantiations.add(t);try{return this._createAndCacheServiceInstance(t,d,m)}finally{this._activeInstantiations.delete(t)}}_createAndCacheServiceInstance(t,d,m){const v=new C.Graph(g=>g.id.toString());let P=0;const u=[{id:t,desc:d,_trace:m}];for(;u.length;){const g=u.pop();if(v.lookupOrInsertNode(g),P++>1e3)throw new S(v);for(let c of k._util.getServiceDependencies(g.desc.ctor)){let o=this._getServiceInstanceOrDescriptor(c.id);if(!o&&!c.optional&&console.warn(`[createInstance] ${t} depends on ${c.id} which is NOT registered.`),o instanceof D.SyncDescriptor){const l={id:c.id,desc:o,_trace:g._trace.branch(c.id,!0)};v.insertEdge(g,l),u.push(l)}}}for(;;){const g=v.roots();if(g.length===0){if(!v.isEmpty())throw new S(v);break}for(const{data:c}of g){if(this._getServiceInstanceOrDescriptor(c.id)instanceof D.SyncDescriptor){const l=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,l)}v.removeNode(c)}}return this._getServiceInstanceOrDescriptor(t)}_createServiceInstanceWithOwner(t,d,m=[],v,P){if(this._services.get(t)instanceof D.SyncDescriptor)return this._createServiceInstance(d,m,v,P);if(this._parent)return this._parent._createServiceInstanceWithOwner(t,d,m,v,P);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(t,d=[],m,v){if(m){const P=new p.IdleValue(()=>this._createInstance(t,d,v));return new Proxy(Object.create(null),{get(u,g){if(g in u)return u[g];let c=P.value,o=c[g];return typeof o!="function"||(o=o.bind(c),u[g]=o),o},set(u,g,c){return P.value[g]=c,!0}})}else return this._createInstance(t,d,v)}}e.InstantiationService=b;var M;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(M||(M={}));class y{constructor(t,d){this.type=t,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(t){return w?new y(1,t.name||t.toString().substring(0,42).replace(/\n/g,"")):y._None}static traceCreation(t){return w?new y(0,t.name):y._None}branch(t,d){let m=new y(2,t.toString());return this._dep.push([t,d,m]),m}stop(){let t=Date.now()-this._start;y._totals+=t;let d=!1;function m(P,u){let g=[],c=new Array(P+1).join("	");for(const[o,l,s]of u._dep)if(l&&s){d=!0,g.push(`${c}CREATES -> ${o}`);let i=m(P+1,s);i&&g.push(i)}else g.push(`${c}uses -> ${o}`);return g.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${y._totals.toFixed(2)}ms)`];(t>2||d)&&console.log(v.join(`
`))}}e.Trace=y,y._None=new class extends y{constructor(){super(-1,null)}stop(){}branch(){return this}},y._totals=0}),define(ee[184],te([0,1,15,134,59]),function(j,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class C extends D.ResolvedKeybinding{constructor(E,w){super();if(w.length===0)throw(0,p.illegalArgument)("parts");this._os=E,this._parts=w}getLabel(){return n.UILabelProvider.toLabel(this._os,this._parts,E=>this._getLabel(E))}getAriaLabel(){return n.AriaLabelProvider.toLabel(this._os,this._parts,E=>this._getAriaLabel(E))}getElectronAccelerator(){return this._parts.length>1||this._parts[0].isDuplicateModifierCase()?null:n.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,E=>this._getElectronAccelerator(E))}getUserSettingsLabel(){return n.UserSettingsLabelProvider.toLabel(this._os,this._parts,E=>this._getUserSettingsLabel(E))}isWYSIWYG(){return this._parts.every(E=>this._isWYSIWYG(E))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(E=>this._getPart(E))}_getPart(E){return new D.ResolvedKeybindingPart(E.ctrlKey,E.shiftKey,E.altKey,E.metaKey,this._getLabel(E),this._getAriaLabel(E))}getDispatchParts(){return this._parts.map(E=>this._getDispatchPart(E))}getSingleModifierDispatchParts(){return this._parts.map(E=>this._getSingleModifierDispatchPart(E))}}e.BaseResolvedKeybinding=C}),define(ee[185],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeElementsAfterNulls=e.ResolvedKeybindingItem=void 0;class p{constructor(C,k,E,w,S,b,M){this._resolvedKeybindingItemBrand=void 0,this.resolvedKeybinding=C,this.keypressParts=C?n(C.getDispatchParts()):[],C&&this.keypressParts.length===0&&(this.keypressParts=n(C.getSingleModifierDispatchParts())),this.bubble=k?k.charCodeAt(0)===94:!1,this.command=this.bubble?k.substr(1):k,this.commandArgs=E,this.when=w,this.isDefault=S,this.extensionId=b,this.isBuiltinExtension=M}}e.ResolvedKeybindingItem=p;function n(D){let C=[];for(let k=0,E=D.length;k<E;k++){const w=D[k];if(!w)return C;C.push(w)}return C}e.removeElementsAfterNulls=n}),define(ee[186],te([0,1,82,59,184,185]),function(j,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class k extends D.BaseResolvedKeybinding{constructor(w,S){super(S,w.parts)}_keyCodeToUILabel(w){if(this._os===2)switch(w){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return p.KeyCodeUtils.toString(w)}_getLabel(w){return w.isDuplicateModifierCase()?"":this._keyCodeToUILabel(w.keyCode)}_getAriaLabel(w){return w.isDuplicateModifierCase()?"":p.KeyCodeUtils.toString(w.keyCode)}_getElectronAccelerator(w){return p.KeyCodeUtils.toElectronAccelerator(w.keyCode)}_getUserSettingsLabel(w){if(w.isDuplicateModifierCase())return"";const S=p.KeyCodeUtils.toUserSettingsUS(w.keyCode);return S&&S.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(w){return k.getDispatchStr(w)}static getDispatchStr(w){if(w.isModifierKey())return null;let S="";return w.ctrlKey&&(S+="ctrl+"),w.shiftKey&&(S+="shift+"),w.altKey&&(S+="alt+"),w.metaKey&&(S+="meta+"),S+=p.KeyCodeUtils.toString(w.keyCode),S}_getSingleModifierDispatchPart(w){return w.keyCode===5&&!w.shiftKey&&!w.altKey&&!w.metaKey?"ctrl":w.keyCode===4&&!w.ctrlKey&&!w.altKey&&!w.metaKey?"shift":w.keyCode===6&&!w.ctrlKey&&!w.shiftKey&&!w.metaKey?"alt":w.keyCode===57&&!w.ctrlKey&&!w.shiftKey&&!w.altKey?"meta":null}static _scanCodeToKeyCode(w){const S=p.IMMUTABLE_CODE_TO_KEY_CODE[w];if(S!==-1)return S;switch(w){case 10:return 31;case 11:return 32;case 12:return 33;case 13:return 34;case 14:return 35;case 15:return 36;case 16:return 37;case 17:return 38;case 18:return 39;case 19:return 40;case 20:return 41;case 21:return 42;case 22:return 43;case 23:return 44;case 24:return 45;case 25:return 46;case 26:return 47;case 27:return 48;case 28:return 49;case 29:return 50;case 30:return 51;case 31:return 52;case 32:return 53;case 33:return 54;case 34:return 55;case 35:return 56;case 36:return 22;case 37:return 23;case 38:return 24;case 39:return 25;case 40:return 26;case 41:return 27;case 42:return 28;case 43:return 29;case 44:return 30;case 45:return 21;case 51:return 83;case 52:return 81;case 53:return 87;case 54:return 89;case 55:return 88;case 56:return 0;case 57:return 80;case 58:return 90;case 59:return 86;case 60:return 82;case 61:return 84;case 62:return 85;case 106:return 92}return 0}static _resolveSimpleUserBinding(w){if(!w)return null;if(w instanceof n.SimpleKeybinding)return w;const S=this._scanCodeToKeyCode(w.scanCode);return S===0?null:new n.SimpleKeybinding(w.ctrlKey,w.shiftKey,w.altKey,w.metaKey,S)}static resolveUserBinding(w,S){const b=(0,C.removeElementsAfterNulls)(w.map(M=>this._resolveSimpleUserBinding(M)));return b.length>0?[new k(new n.ChordKeybinding(b),S)]:[]}}e.USLayoutResolvedKeybinding=k}),define(ee[187],te([0,1,8]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function n(D,C){if(D.length===0)return Promise.resolve(!1);const k=[];let E=!1;for(let w of D){if(w===!0)return Promise.resolve(!0);(0,p.isThenable)(w)&&k.push(w.then(S=>{S&&(E=!0)},S=>{C(S),E=!0}))}return p.Promises.settled(k).then(()=>E)}e.handleVetos=n}),define(ee[6],te([0,1,39,4,2,3,5]),function(j,e,p,n,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function E(){return new Date().toISOString()}var w;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(w=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=w.Info;function S(l,s,i){switch(s){case w.Trace:l.trace(i);break;case w.Debug:l.debug(i);break;case w.Info:l.info(i);break;case w.Warning:l.warn(i);break;case w.Error:l.error(i);break;case w.Critical:l.critical(i);break;default:throw new Error("Invalid log level")}}e.log=S;function b(l){let s="";for(let i=0;i<l.length;i++){let r=l[i];if(typeof r=="object")try{r=JSON.stringify(r)}catch{}s+=(i>0?" ":"")+r}return s}e.format=b;class M extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new n.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(s){this.level!==s&&(this.level=s,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=M;class y extends M{constructor(s){super();this.logAlways=s}checkLogLevel(s){return this.logAlways||this.getLevel()<=s}trace(s,...i){this.checkLogLevel(w.Trace)&&this.log(w.Trace,b([s,...i]))}debug(s,...i){this.checkLogLevel(w.Debug)&&this.log(w.Debug,b([s,...i]))}info(s,...i){this.checkLogLevel(w.Info)&&this.log(w.Info,b([s,...i]))}warn(s,...i){this.checkLogLevel(w.Warning)&&this.log(w.Warning,b([s,...i]))}error(s,...i){if(this.checkLogLevel(w.Error))if(s instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=s.stack,this.log(w.Error,b(r))}else this.log(w.Error,b([s,...i]))}critical(s,...i){this.checkLogLevel(w.Critical)&&this.log(w.Critical,b([s,...i]))}flush(){}}e.AbstractMessageLogger=y;class f extends M{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s),this.useColors=!C.isWindows}trace(s,...i){this.getLevel()<=w.Trace&&(this.useColors?console.log(`[90m[main ${E()}][0m`,s,...i):console.log(`[main ${E()}]`,s,...i))}debug(s,...i){this.getLevel()<=w.Debug&&(this.useColors?console.log(`[90m[main ${E()}][0m`,s,...i):console.log(`[main ${E()}]`,s,...i))}info(s,...i){this.getLevel()<=w.Info&&(this.useColors?console.log(`[90m[main ${E()}][0m`,s,...i):console.log(`[main ${E()}]`,s,...i))}warn(s,...i){this.getLevel()<=w.Warning&&(this.useColors?console.warn(`[93m[main ${E()}][0m`,s,...i):console.warn(`[main ${E()}]`,s,...i))}error(s,...i){this.getLevel()<=w.Error&&(this.useColors?console.error(`[91m[main ${E()}][0m`,s,...i):console.error(`[main ${E()}]`,s,...i))}critical(s,...i){this.getLevel()<=w.Critical&&(this.useColors?console.error(`[90m[main ${E()}][0m`,s,...i):console.error(`[main ${E()}]`,s,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=f;class t extends M{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s)}trace(s,...i){this.getLevel()<=w.Trace&&console.log("%cTRACE","color: #888",s,...i)}debug(s,...i){this.getLevel()<=w.Debug&&console.log("%cDEBUG","background: #eee; color: #888",s,...i)}info(s,...i){this.getLevel()<=w.Info&&console.log("%c INFO","color: #33f",s,...i)}warn(s,...i){this.getLevel()<=w.Warning&&console.log("%c WARN","color: #993",s,...i)}error(s,...i){this.getLevel()<=w.Error&&console.log("%c  ERR","color: #f33",s,...i)}critical(s,...i){this.getLevel()<=w.Critical&&console.log("%cCRITI","background: #f33; color: white",s,...i)}dispose(){}flush(){}}e.ConsoleLogger=t;class d extends M{constructor(s,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=s,this.setLevel(i)}trace(s,...i){this.getLevel()<=w.Trace&&this.adapter.log(w.Trace,[this.extractMessage(s),...i])}debug(s,...i){this.getLevel()<=w.Debug&&this.adapter.log(w.Debug,[this.extractMessage(s),...i])}info(s,...i){this.getLevel()<=w.Info&&this.adapter.log(w.Info,[this.extractMessage(s),...i])}warn(s,...i){this.getLevel()<=w.Warning&&this.adapter.log(w.Warning,[this.extractMessage(s),...i])}error(s,...i){this.getLevel()<=w.Error&&this.adapter.log(w.Error,[this.extractMessage(s),...i])}critical(s,...i){this.getLevel()<=w.Critical&&this.adapter.log(w.Critical,[this.extractMessage(s),...i])}extractMessage(s){return typeof s=="string"?s:(0,p.toErrorMessage)(s,this.getLevel()<=w.Trace)}dispose(){}flush(){}}e.AdapterLogger=d;class m extends M{constructor(s){super();this.logServices=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const i of this.logServices)i.setLevel(s);super.setLevel(s)}trace(s,...i){for(const r of this.logServices)r.trace(s,...i)}debug(s,...i){for(const r of this.logServices)r.debug(s,...i)}info(s,...i){for(const r of this.logServices)r.info(s,...i)}warn(s,...i){for(const r of this.logServices)r.warn(s,...i)}error(s,...i){for(const r of this.logServices)r.error(s,...i)}critical(s,...i){for(const r of this.logServices)r.critical(s,...i)}flush(){for(const s of this.logServices)s.flush()}dispose(){for(const s of this.logServices)s.dispose()}}e.MultiplexLogService=m;class v extends D.Disposable{constructor(s){super();this.logger=s,this._register(s)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(s){this.logger.setLevel(s)}getLevel(){return this.logger.getLevel()}trace(s,...i){this.logger.trace(s,...i)}debug(s,...i){this.logger.debug(s,...i)}info(s,...i){this.logger.info(s,...i)}warn(s,...i){this.logger.warn(s,...i)}error(s,...i){this.logger.error(s,...i)}critical(s,...i){this.logger.critical(s,...i)}flush(){this.logger.flush()}}e.LogService=v;class P extends D.Disposable{constructor(s,i){super();this.logLevel=s,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(r))}))}getLogger(s){return this.loggers.get(s.toString())}createLogger(s,i){let r=this.loggers.get(s.toString());return r||(r=this.doCreateLogger(s,i?.always?w.Trace:this.logLevel,i),this.loggers.set(s.toString(),r),i?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(s=>s.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=P;class u{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(s){}getLevel(){return w.Info}trace(s,...i){}debug(s,...i){}info(s,...i){}warn(s,...i){}error(s,...i){}critical(s,...i){}dispose(){}flush(){}}e.NullLogService=u;function g(l){if(l.verbose)return w.Trace;if(typeof l.logLevel=="string"){const s=c(l.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=g;function c(l){switch(l){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Critical;case"off":return w.Off}}e.parseLogLevel=c;function o(l){switch(l){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Critical:return"critical";case w.Off:return"off"}}e.LogLevelToString=o});var ne=this&&this.__param||function(j,e){return function(p,n){e(p,n,j)}};define(ee[95],te([0,1,174,172,4,2,6,3,48,5]),function(j,e,p,n,D,C,k,E,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsMainService=e.ICredentialsMainService=void 0,e.ICredentialsMainService=(0,S.createDecorator)("credentialsMainService");let b=class mt extends C.Disposable{constructor(y,f){super();this.logService=y,this.environmentMainService=f,this._onDidChangePassword=this._register(new D.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(y,f){const t=await this.withKeytar(),d=await t.getPassword(y,f);if(d)try{let{content:m,hasNextChunk:v}=JSON.parse(d);if(!m||!v)return d;let P=1;for(;v;){const u=await t.getPassword(y,`${f}-${P}`),g=JSON.parse(u);m+=g.content,v=g.hasNextChunk,P++}return m}catch{return d}return d}async setPassword(y,f,t){const d=await this.withKeytar(),m=3,v=async(P,u,g)=>{let c=0,o;for(;c<m;)try{await d.setPassword(P,u,g);return}catch(l){o=l,this.logService.warn("Error attempting to set a password: ",l),c++,await new Promise(s=>setTimeout(s,200))}throw o};if(E.isWindows&&t.length>mt.MAX_PASSWORD_LENGTH){let P=0,u=0,g=!0;for(;g;){const c=t.substring(P,P+mt.PASSWORD_CHUNK_SIZE);P+=mt.PASSWORD_CHUNK_SIZE,g=t.length-P>0;const o={content:c,hasNextChunk:g};await v(y,u?`${f}-${u}`:f,JSON.stringify(o)),u++}}else await v(y,f,t);this._onDidChangePassword.fire({service:y,account:f})}async deletePassword(y,f){const d=await(await this.withKeytar()).deletePassword(y,f);return d&&this._onDidChangePassword.fire({service:y,account:f}),d}async findPassword(y){return(await this.withKeytar()).findPassword(y)}async findCredentials(y){return(await this.withKeytar()).findCredentials(y)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((y,f)=>{j(["keytar"],y,f)})}};b.MAX_PASSWORD_LENGTH=2500,b.PASSWORD_CHUNK_SIZE=b.MAX_PASSWORD_LENGTH-100,b=de([ne(0,k.ILogService),ne(1,w.INativeEnvironmentService)],b),e.CredentialsMainService=b,(0,n.registerSingleton)(p.ICredentialsService,b,!0)}),define(ee[188],te([0,1,28,8,15,4,2,9,63,6]),function(j,e,p,n,D,C,k,E,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class b extends k.Disposable{constructor(y,f){super();this.logService=y,this.options=f,this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new C.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new n.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}watch(y,f){return f.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(y,f):this.watchNonRecursive(y,f)}watchUniversal(y,f){const t={path:this.toFilePath(y),excludes:f.excludes,recursive:f.recursive},d=(0,p.insert)(this.universalPathsToWatch,t);return this.refreshUniversalWatchers(),(0,k.toDisposable)(()=>{d(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(y=>(0,D.onUnexpectedError)(y))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(f=>this._onDidChangeFile.fire((0,w.toFileChanges)(f)),f=>this.onWatcherLogMessage(f),this.logService.getLevel()===S.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===S.LogLevel.Trace)})));const y=this.options?.watcher?.recursive?.usePolling;if(y===!0)for(const f of this.universalPathsToWatch)(0,w.isRecursiveWatchRequest)(f)&&(f.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const f of this.universalPathsToWatch)(0,w.isRecursiveWatchRequest)(f)&&y.includes(f.path)&&(f.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(y,f){const t={path:this.toFilePath(y),excludes:f.excludes,recursive:!1},d=(0,p.insert)(this.nonRecursivePathsToWatch,t);return this.refreshNonRecursiveWatchers(),(0,k.toDisposable)(()=>{d(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(y=>(0,D.onUnexpectedError)(y))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(y=>this._onDidChangeFile.fire((0,w.toFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===S.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===S.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(y){y.type==="error"&&this._onDidWatchError.fire(y.message),this.logService[y.type](y.message)}toFilePath(y){return(0,E.normalize)(y.fsPath)}}e.AbstractDiskFileSystemProvider=b}),define(ee[189],te([0,1,28,8,17,21,4,71,70,2,36,10,64,16,51,147,18,94,6]),function(j,e,p,n,D,C,k,E,w,S,b,M,y,f,t,d,m,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let u=class extends S.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new n.ResourceQueue)}registerProvider(c,o){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${c}`);const l=new S.DisposableStore;return this.provider.set(c,o),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:o}),l.add(o.onDidChangeFile(s=>this._onDidFilesChange.fire(new m.FileChangesEvent(s,!this.isPathCaseSensitive(o))))),typeof o.onDidWatchError=="function"&&l.add(o.onDidWatchError(s=>this._onDidWatchError.fire(new Error(s)))),l.add(o.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:o,scheme:c}))),(0,S.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:o}),this.provider.delete(c),(0,S.dispose)(l)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const o=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(l){o.push(l)}}),!this.provider.has(c)&&await n.Promises.settled(o)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,o){const l=this.provider.get(c.scheme);return!!(l&&l.capabilities&o)}listCapabilities(){return w.Iterable.map(this.provider,([c,o])=>({scheme:c,capabilities:o.capabilities}))}async withProvider(c){if(!(0,f.isAbsolutePath)(c))throw new m.FileOperationError((0,d.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const o=this.provider.get(c.scheme);if(!o){const l=new Error;throw l.name="ENOPRO",l.message=(0,d.localize)(1,null,c.toString()),l}return o}async withReadProvider(c){const o=await this.withProvider(c);if((0,m.hasOpenReadWriteCloseCapability)(o)||(0,m.hasReadWriteCapability)(o)||(0,m.hasFileReadStreamCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const o=await this.withProvider(c);if((0,m.hasOpenReadWriteCloseCapability)(o)||(0,m.hasReadWriteCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,o){try{return await this.doResolveFile(c,o)}catch(l){throw(0,m.toFileSystemProviderErrorCode)(l)===m.FileSystemProviderErrorCode.FileNotFound?new m.FileOperationError((0,d.localize)(2,null,this.resourceForError(c)),1):(0,m.ensureFileSystemProviderError)(l)}}async doResolveFile(c,o){const l=await this.withProvider(c),s=this.isPathCaseSensitive(l),i=o?.resolveTo,r=o?.resolveSingleChildDescendants,a=o?.resolveMetadata,h=await l.stat(c);let I;return this.toFileStat(l,c,h,void 0,!!a,(R,L)=>(I||(I=b.TernarySearchTree.forUris(()=>!s),I.set(c,!0),i&&I.fill(!0,i)),I.get(R.resource)||I.findSuperstr(R.resource.with({query:null,fragment:null}))?!0:R.isDirectory&&r?L===1:!1))}async toFileStat(c,o,l,s,i,r){const{providerExtUri:a}=this.getExtUri(c),h={resource:o,name:a.basename(o),isFile:(l.type&m.FileType.File)!=0,isDirectory:(l.type&m.FileType.Directory)!=0,isSymbolicLink:(l.type&m.FileType.SymbolicLink)!=0,mtime:l.mtime,ctime:l.ctime,size:l.size,readonly:Boolean((l.permissions??0)&m.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,m.etag)({mtime:l.mtime,size:l.size})};if(h.isDirectory&&r(h,s)){try{const I=await c.readdir(o),R=await n.Promises.settled(I.map(async([L,T])=>{try{const $=a.joinPath(o,L),Q=i?await c.stat($):{type:T};return await this.toFileStat(c,$,Q,I.length,i,r)}catch($){return this.logService.trace($),null}}));h.children=(0,p.coalesce)(R)}catch(I){this.logService.trace(I),h.children=[]}return h}return h}async resolveAll(c){return n.Promises.settled(c.map(async o=>{try{return{stat:await this.doResolveFile(o.resource,o.options),success:!0}}catch(l){return this.logService.trace(l),{stat:void 0,success:!1}}}))}async exists(c){const o=await this.withProvider(c);try{return!!await o.stat(c)}catch{return!1}}async canCreateFile(c,o){try{await this.doValidateCreateFile(c,o)}catch(l){return l}return!0}async doValidateCreateFile(c,o){if(!o?.overwrite&&await this.exists(c))throw new m.FileOperationError((0,d.localize)(3,null,this.resourceForError(c)),3,o)}async createFile(c,o=D.VSBuffer.fromString(""),l){await this.doValidateCreateFile(c,l);const s=await this.writeFile(c,o);return this._onDidRunOperation.fire(new m.FileOperationEvent(c,0,s)),s}async writeFile(c,o,l){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:i}=this.getExtUri(s);try{await this.validateWriteFile(s,c,l)||await this.mkdirp(s,i.dirname(c));let a;if((0,m.hasReadWriteCapability)(s)&&!(o instanceof D.VSBuffer))if((0,t.isReadableStream)(o)){const h=await(0,t.peekStream)(o,3);h.ended?a=D.VSBuffer.concat(h.buffer):a=h}else a=(0,t.peekReadable)(o,h=>D.VSBuffer.concat(h),3);else a=o;!(0,m.hasOpenReadWriteCloseCapability)(s)||(0,m.hasReadWriteCapability)(s)&&a instanceof D.VSBuffer?await this.doWriteUnbuffered(s,c,l,a):await this.doWriteBuffered(s,c,l,a instanceof D.VSBuffer?(0,D.bufferToReadable)(a):a)}catch(r){throw new m.FileOperationError((0,d.localize)(4,null,this.resourceForError(c),(0,m.ensureFileSystemProviderError)(r).toString()),(0,m.toFileOperationResult)(r),l)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,o,l){if(!!l?.unlock&&!(c.capabilities&8192))throw new Error((0,d.localize)(5,null,this.resourceForError(o)));let i;try{i=await c.stat(o)}catch{return}if((i.type&m.FileType.Directory)!=0)throw new m.FileOperationError((0,d.localize)(6,null,this.resourceForError(o)),0,l);if(this.throwIfFileIsReadonly(o,i),typeof l?.mtime=="number"&&typeof l.etag=="string"&&l.etag!==m.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&l.mtime<i.mtime&&l.etag!==(0,m.etag)({mtime:l.mtime,size:i.size}))throw new m.FileOperationError((0,d.localize)(7,null),3,l);return i}async readFile(c,o,l){const s=await this.withReadProvider(c);return o?.atomic?this.doReadFileAtomic(s,c,o,l):this.doReadFile(s,c,o,l)}async doReadFileAtomic(c,o,l,s){return new Promise((i,r)=>{this.writeQueue.queueFor(o,this.getExtUri(c).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(c,o,l,s);i(a)}catch(a){r(a)}})})}async doReadFile(c,o,l,s){const i=await this.doReadFileStream(c,o,{...l,preferUnbuffered:!0},s);return{...i,value:await(0,D.streamToBuffer)(i.value)}}async readFileStream(c,o,l){const s=await this.withReadProvider(c);return this.doReadFileStream(s,c,o,l)}async doReadFileStream(c,o,l,s){const i=new C.CancellationTokenSource(s),r=this.validateReadFile(o,l).then(h=>h,h=>{throw i.cancel(),h});let a;try{return typeof l?.etag=="string"&&l.etag!==m.ETAG_DISABLED&&await r,l?.atomic&&(0,m.hasFileAtomicReadCapability)(c)||!((0,m.hasOpenReadWriteCloseCapability)(c)||(0,m.hasFileReadStreamCapability)(c))||(0,m.hasReadWriteCapability)(c)&&l?.preferUnbuffered?a=this.readFileUnbuffered(c,o,l):(0,m.hasFileReadStreamCapability)(c)?a=this.readFileStreamed(c,o,i.token,l):a=this.readFileBuffered(c,o,i.token,l),{...await r,value:a}}catch(h){a&&await(0,t.consumeStream)(a);const I=(0,d.localize)(8,null,this.resourceForError(o),(0,m.ensureFileSystemProviderError)(h).toString());throw h instanceof m.NotModifiedSinceFileOperationError?new m.NotModifiedSinceFileOperationError(I,h.stat,l):new m.FileOperationError(I,(0,m.toFileOperationResult)(h),l)}}readFileStreamed(c,o,l,s=Object.create(null)){const i=c.readFileStream(o,s,l);return(0,t.transform)(i,{data:r=>r instanceof D.VSBuffer?r:D.VSBuffer.wrap(r),error:r=>new m.FileOperationError((0,d.localize)(9,null,this.resourceForError(o),(0,m.ensureFileSystemProviderError)(r).toString()),(0,m.toFileOperationResult)(r),s)},r=>D.VSBuffer.concat(r))}readFileBuffered(c,o,l,s=Object.create(null)){const i=(0,D.newWriteableBufferStream)();return(0,v.readFileIntoStream)(c,o,i,r=>r,{...s,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new m.FileOperationError((0,d.localize)(10,null,this.resourceForError(o),(0,m.ensureFileSystemProviderError)(r).toString()),(0,m.toFileOperationResult)(r),s)},l),i}readFileUnbuffered(c,o,l){const s=(0,t.newWriteableStream)(i=>D.VSBuffer.concat(i));return(async()=>{try{let i;l?.atomic&&(0,m.hasFileAtomicReadCapability)(c)?i=await c.readFile(o,{atomic:!0}):i=await c.readFile(o),typeof l?.position=="number"&&(i=i.slice(l.position)),typeof l?.length=="number"&&(i=i.slice(0,l.length)),this.validateReadFileLimits(o,i.byteLength,l),s.end(D.VSBuffer.wrap(i))}catch(i){s.error(i),s.end()}})(),s}async validateReadFile(c,o){const l=await this.resolve(c,{resolveMetadata:!0});if(l.isDirectory)throw new m.FileOperationError((0,d.localize)(11,null,this.resourceForError(c)),0,o);if(typeof o?.etag=="string"&&o.etag!==m.ETAG_DISABLED&&o.etag===l.etag)throw new m.NotModifiedSinceFileOperationError((0,d.localize)(12,null),l,o);return this.validateReadFileLimits(c,l.size,o),l}validateReadFileLimits(c,o,l){if(l?.limits){let s;if(typeof l.limits.memory=="number"&&o>l.limits.memory&&(s=9),typeof l.limits.size=="number"&&o>l.limits.size&&(s=7),typeof s=="number")throw new m.FileOperationError((0,d.localize)(13,null,this.resourceForError(c)),s)}}async canMove(c,o,l){return this.doCanMoveCopy(c,o,"move",l)}async canCopy(c,o,l){return this.doCanMoveCopy(c,o,"copy",l)}async doCanMoveCopy(c,o,l,s){if(c.toString()!==o.toString())try{const i=l==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);await this.doValidateMoveCopy(i,c,r,o,l,s)}catch(i){return i}return!0}async move(c,o,l){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=await this.doMoveCopy(s,c,i,o,"move",!!l),a=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(c,r==="move"?2:3,a)),a}async copy(c,o,l){const s=await this.withReadProvider(c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=await this.doMoveCopy(s,c,i,o,"copy",!!l),a=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(c,r==="copy"?3:2,a)),a}async doMoveCopy(c,o,l,s,i,r){if(o.toString()===s.toString())return i;const{exists:a,isSameResourceWithDifferentPathCase:h}=await this.doValidateMoveCopy(c,o,l,s,i,r);if(a&&!h&&r&&await this.del(s,{recursive:!0}),await this.mkdirp(l,this.getExtUri(l).providerExtUri.dirname(s)),i==="copy"){if(c===l&&(0,m.hasFileFolderCopyCapability)(c))await c.copy(o,s,{overwrite:r});else{const I=await this.resolve(o);I.isDirectory?await this.doCopyFolder(c,I,l,s):await this.doCopyFile(c,o,l,s)}return i}else return c===l?(await c.rename(o,s,{overwrite:r}),i):(await this.doMoveCopy(c,o,l,s,"copy",r),await this.del(o,{recursive:!0}),"copy")}async doCopyFile(c,o,l,s){if((0,m.hasOpenReadWriteCloseCapability)(c)&&(0,m.hasOpenReadWriteCloseCapability)(l))return this.doPipeBuffered(c,o,l,s);if((0,m.hasOpenReadWriteCloseCapability)(c)&&(0,m.hasReadWriteCapability)(l))return this.doPipeBufferedToUnbuffered(c,o,l,s);if((0,m.hasReadWriteCapability)(c)&&(0,m.hasOpenReadWriteCloseCapability)(l))return this.doPipeUnbufferedToBuffered(c,o,l,s);if((0,m.hasReadWriteCapability)(c)&&(0,m.hasReadWriteCapability)(l))return this.doPipeUnbuffered(c,o,l,s)}async doCopyFolder(c,o,l,s){await l.mkdir(s),Array.isArray(o.children)&&await n.Promises.settled(o.children.map(async i=>{const r=this.getExtUri(l).providerExtUri.joinPath(s,i.name);return i.isDirectory?this.doCopyFolder(c,await this.resolve(i.resource),l,r):this.doCopyFile(c,i.resource,l,r)}))}async doValidateMoveCopy(c,o,l,s,i,r){let a=!1;if(c===l){const{providerExtUri:I,isPathCaseSensitive:R}=this.getExtUri(c);if(R||(a=I.isEqual(o,s)),a&&i==="copy")throw new Error((0,d.localize)(14,null,this.resourceForError(o),this.resourceForError(s)));if(!a&&I.isEqualOrParent(s,o))throw new Error((0,d.localize)(15,null,this.resourceForError(o),this.resourceForError(s)))}const h=await this.exists(s);if(h&&!a){if(!r)throw new m.FileOperationError((0,d.localize)(16,null,this.resourceForError(o),this.resourceForError(s)),4);if(c===l){const{providerExtUri:I}=this.getExtUri(c);if(I.isEqualOrParent(o,s))throw new Error((0,d.localize)(17,null,this.resourceForError(o),this.resourceForError(s)))}}return{exists:h,isSameResourceWithDifferentPathCase:a}}getExtUri(c){const o=this.isPathCaseSensitive(c);return{providerExtUri:o?f.extUri:f.extUriIgnorePathCase,isPathCaseSensitive:o}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(o,c);const l=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(c,0,l)),l}async mkdirp(c,o){const l=[],{providerExtUri:s}=this.getExtUri(c);for(;!s.isEqual(o,s.dirname(o));)try{if(((await c.stat(o)).type&m.FileType.Directory)==0)throw new Error((0,d.localize)(18,null,this.resourceForError(o)));break}catch(i){if((0,m.toFileSystemProviderErrorCode)(i)!==m.FileSystemProviderErrorCode.FileNotFound)throw i;l.push(s.basename(o)),o=s.dirname(o)}for(let i=l.length-1;i>=0;i--){o=s.joinPath(o,l[i]);try{await c.mkdir(o)}catch(r){if((0,m.toFileSystemProviderErrorCode)(r)!==m.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(c,o){try{await this.doValidateDelete(c,o)}catch(l){return l}return!0}async doValidateDelete(c,o){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!o?.useTrash&&!(l.capabilities&4096))throw new Error((0,d.localize)(19,null,this.resourceForError(c)));let i;try{i=await l.stat(c)}catch{}if(i)this.throwIfFileIsReadonly(c,i);else throw new m.FileOperationError((0,d.localize)(20,null,this.resourceForError(c)),1);if(!!!o?.recursive){const a=await this.resolve(c);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,d.localize)(21,null,this.resourceForError(c)))}return l}async del(c,o){const l=await this.doValidateDelete(c,o),s=!!o?.useTrash,i=!!o?.recursive;await l.delete(c,{recursive:i,useTrash:s}),this._onDidRunOperation.fire(new m.FileOperationEvent(c,1))}watch(c,o={recursive:!1,excludes:[]}){const l=new S.DisposableStore;let s=!1,i=()=>{s=!0};return l.add((0,S.toDisposable)(()=>i())),(async()=>{try{const r=await this.doWatch(c,o);s?(0,S.dispose)(r):i=()=>(0,S.dispose)(r)}catch(r){this.logService.error(r)}})(),l}async doWatch(c,o){const l=await this.withProvider(c),s=(0,E.hash)([this.getExtUri(l).providerExtUri.getComparisonKey(c),o]);let i=this.activeWatchers.get(s);return i||(i={count:0,disposable:l.watch(c,o)},this.activeWatchers.set(s,i)),i.count+=1,(0,S.toDisposable)(()=>{i&&(i.count--,i.count===0&&((0,S.dispose)(i.disposable),this.activeWatchers.delete(s)))})}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,S.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,o,l,s){return this.writeQueue.queueFor(o,this.getExtUri(c).providerExtUri).queue(async()=>{const i=await c.open(o,{create:!0,unlock:l?.unlock??!1});try{(0,t.isReadableStream)(s)||(0,t.isReadableBufferedStream)(s)?await this.doWriteStreamBufferedQueued(c,i,s):await this.doWriteReadableBufferedQueued(c,i,s)}catch(r){throw(0,m.ensureFileSystemProviderError)(r)}finally{await c.close(i)}})}async doWriteStreamBufferedQueued(c,o,l){let s=0,i;if((0,t.isReadableBufferedStream)(l)){if(l.buffer.length>0){const r=D.VSBuffer.concat(l.buffer);await this.doWriteBuffer(c,o,r,r.byteLength,s,0),s+=r.byteLength}if(l.ended)return;i=l.stream}else i=l;return new Promise((r,a)=>{(0,t.listenStream)(i,{onData:async h=>{i.pause();try{await this.doWriteBuffer(c,o,h,h.byteLength,s,0)}catch(I){return a(I)}s+=h.byteLength,setTimeout(()=>i.resume())},onError:h=>a(h),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(c,o,l){let s=0,i;for(;(i=l.read())!==null;)await this.doWriteBuffer(c,o,i,i.byteLength,s,0),s+=i.byteLength}async doWriteBuffer(c,o,l,s,i,r){let a=0;for(;a<s;)a+=await c.write(o,i+a,l.buffer,r+a,s-a)}async doWriteUnbuffered(c,o,l,s){return this.writeQueue.queueFor(o,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,o,l,s))}async doWriteUnbufferedQueued(c,o,l,s){let i;s instanceof D.VSBuffer?i=s:(0,t.isReadableStream)(s)?i=await(0,D.streamToBuffer)(s):(0,t.isReadableBufferedStream)(s)?i=await(0,D.bufferedStreamToBuffer)(s):i=(0,D.readableToBuffer)(s),await c.writeFile(o,i.buffer,{create:!0,overwrite:!0,unlock:l?.unlock??!1})}async doPipeBuffered(c,o,l,s){return this.writeQueue.queueFor(s,this.getExtUri(l).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,o,l,s))}async doPipeBufferedQueued(c,o,l,s){let i,r;try{i=await c.open(o,{create:!1}),r=await l.open(s,{create:!0,unlock:!1});const a=D.VSBuffer.alloc(this.BUFFER_SIZE);let h=0,I=0,R=0;do R=await c.read(i,h,a.buffer,I,a.byteLength-I),await this.doWriteBuffer(l,r,a,R,h,I),h+=R,I+=R,I===a.byteLength&&(I=0);while(R>0)}catch(a){throw(0,m.ensureFileSystemProviderError)(a)}finally{await n.Promises.settled([typeof i=="number"?c.close(i):Promise.resolve(),typeof r=="number"?l.close(r):Promise.resolve()])}}async doPipeUnbuffered(c,o,l,s){return this.writeQueue.queueFor(s,this.getExtUri(l).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,o,l,s))}async doPipeUnbufferedQueued(c,o,l,s){return l.writeFile(s,await c.readFile(o),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,o,l,s){return this.writeQueue.queueFor(s,this.getExtUri(l).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,o,l,s))}async doPipeUnbufferedToBufferedQueued(c,o,l,s){const i=await l.open(s,{create:!0,unlock:!1});try{const r=await c.readFile(o);await this.doWriteBuffer(l,i,D.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,m.ensureFileSystemProviderError)(r)}finally{await l.close(i)}}async doPipeBufferedToUnbuffered(c,o,l,s){const i=await(0,D.streamToBuffer)(this.readFileBuffered(c,o,C.CancellationToken.None));await this.doWriteUnbuffered(l,s,void 0,i)}throwIfFileSystemIsReadonly(c,o){if(c.capabilities&2048)throw new m.FileOperationError((0,d.localize)(22,null,this.resourceForError(o)),6);return c}throwIfFileIsReadonly(c,o){if((o.permissions??0)&m.FilePermission.Readonly)throw new m.FileOperationError((0,d.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===M.Schemas.file?c.fsPath:c.toString(!0)}};u=de([ne(0,P.ILogService)],u),e.FileService=u}),define(ee[77],te([0,1,30,257,8,36,17,4,29,2,9,3,16,51,24,151,18,94,188,39,182,181]),function(j,e,p,n,D,C,k,E,w,S,b,M,y,f,t,d,m,v,P,u,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,n.gracefulify)(p)}catch(l){console.error(`Error enabling graceful-fs: ${(0,u.toErrorMessage)(l)}`)}})();class o extends P.AbstractDiskFileSystemProvider{constructor(s,i){super(s,i);this.onDidChangeCapabilities=E.Event.None,this.resourceLocks=new C.ResourceMap(r=>y.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,M.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:i,symbolicLink:r}=await t.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(i,r),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.toFileSystemProviderError(i)}}async readdir(s){try{const i=await t.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),r=[];return await Promise.all(i.map(async a=>{try{let h;a.isSymbolicLink()?h=(await this.stat((0,y.joinPath)(s,a.name))).type:h=this.toType(a),r.push([a.name,h])}catch(h){this.logService.trace(h)}})),r}catch(i){throw this.toFileSystemProviderError(i)}}toType(s,i){let r;return i?.dangling?r=m.FileType.Unknown:s.isFile()?r=m.FileType.File:s.isDirectory()?r=m.FileType.Directory:r=m.FileType.Unknown,i&&(r|=m.FileType.SymbolicLink),r}async createResourceLock(s){this.logService.trace(`[Disk FileSystemProvider]: request to acquire resource lock (${this.toFilePath(s)})`);let i;for(;i=this.resourceLocks.get(s);)this.logService.trace(`[Disk FileSystemProvider]: waiting for resource lock to be released (${this.toFilePath(s)})`),await i.wait();const r=new D.Barrier;return this.resourceLocks.set(s,r),this.logService.trace(`[Disk FileSystemProvider]: new resource lock created (${this.toFilePath(s)})`),(0,S.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: resource lock disposed (${this.toFilePath(s)})`),this.resourceLocks.delete(s),r.open()})}async readFile(s,i){let r;try{i?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(s)})`),r=await this.createResourceLock(s));const a=this.toFilePath(s);return await t.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}finally{r?.dispose()}}readFileStream(s,i,r){const a=(0,f.newWriteableStream)(h=>k.VSBuffer.concat(h.map(I=>k.VSBuffer.wrap(I))).buffer);return(0,v.readFileIntoStream)(this,s,a,h=>h.buffer,{...i,bufferSize:256*1024},r),a}async writeFile(s,i,r){let a;try{const h=this.toFilePath(s);if(!r.create||!r.overwrite){if(await t.Promises.exists(h)){if(!r.overwrite)throw(0,m.createFileSystemProviderError)((0,d.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,m.createFileSystemProviderError)((0,d.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(s,{create:!0,unlock:r.unlock}),await this.write(a,0,i,0,i.byteLength)}catch(h){throw await this.toFileSystemProviderWriteError(s,h)}finally{typeof a=="number"&&await this.close(a)}}async open(s,i){let r;(0,m.isFileOpenForWriteOptions)(i)&&(r=await this.createResourceLock(s));let a;try{const h=this.toFilePath(s);if((0,m.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:R}=await t.SymlinkSupport.stat(h);R.mode&128||await t.Promises.chmod(h,R.mode|128)}catch(R){this.logService.trace(R)}let I;if((0,m.isFileOpenForWriteOptions)(i)){if(M.isWindows)try{await t.Promises.truncate(h,0),I="r+"}catch(R){R.code!=="ENOENT"&&this.logService.trace(R)}I||(I="w")}else I="r";a=await t.Promises.open(h,I)}catch(h){throw r?.dispose(),(0,m.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(s,h):this.toFileSystemProviderError(h)}return this.mapHandleToPos.set(a,0),(0,m.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(a,s),r&&this.mapHandleToLock.set(a,r),a}async close(s){try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await t.Promises.fdatasync(s)}catch(i){this.canFlush=!1,this.logService.error(i)}return await t.Promises.close(s)}catch(i){throw this.toFileSystemProviderError(i)}finally{const i=this.mapHandleToLock.get(s);i&&(this.mapHandleToLock.delete(s),i.dispose())}}async read(s,i,r,a,h){const I=this.normalizePos(s,i);let R=null;try{const{bytesRead:L}=await t.Promises.read(s,r,a,h,I);return L}catch(L){throw this.toFileSystemProviderError(L)}finally{this.updatePos(s,I,R)}}normalizePos(s,i){return i===this.mapHandleToPos.get(s)?null:i}updatePos(s,i,r){const a=this.mapHandleToPos.get(s);typeof a=="number"&&(typeof i=="number"||(typeof r=="number"?this.mapHandleToPos.set(s,a+r):this.mapHandleToPos.delete(s)))}async write(s,i,r,a,h){return(0,D.retry)(()=>this.doWrite(s,i,r,a,h),100,3)}async doWrite(s,i,r,a,h){const I=this.normalizePos(s,i);let R=null;try{const{bytesWritten:L}=await t.Promises.write(s,r,a,h,I);return L}catch(L){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),L)}finally{this.updatePos(s,I,R)}}async mkdir(s){try{await t.Promises.mkdir(this.toFilePath(s))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(s,i){try{const r=this.toFilePath(s);i.recursive?await t.Promises.rm(r,t.RimRafMode.MOVE):await t.Promises.unlink(r)}catch(r){throw this.toFileSystemProviderError(r)}}async rename(s,i,r){const a=this.toFilePath(s),h=this.toFilePath(i);if(a!==h)try{await this.validateTargetDeleted(s,i,"move",r.overwrite),await t.Promises.move(a,h)}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,d.localize)(2,null,(0,b.basename)(a),(0,b.basename)((0,b.dirname)(h)),I.toString()))),this.toFileSystemProviderError(I)}}async copy(s,i,r){const a=this.toFilePath(s),h=this.toFilePath(i);if(a!==h)try{await this.validateTargetDeleted(s,i,"copy",r.overwrite),await t.Promises.copy(a,h,{preserveSymlinks:!0})}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,d.localize)(3,null,(0,b.basename)(a),(0,b.basename)((0,b.dirname)(h)),I.toString()))),this.toFileSystemProviderError(I)}}async validateTargetDeleted(s,i,r,a){const h=this.toFilePath(s),I=this.toFilePath(i);let R=!1;if(!!(this.capabilities&1024)||(R=(0,w.isEqual)(h,I,!0)),R&&r==="copy")throw(0,m.createFileSystemProviderError)((0,d.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(!R&&await t.Promises.exists(I)){if(!a)throw(0,m.createFileSystemProviderError)((0,d.localize)(5,null),m.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}createUniversalWatcher(s,i,r){return new g.UniversalWatcherClient(a=>s(a),a=>i(a),r)}createNonRecursiveWatcher(s,i,r){return new c.NodeJSWatcherClient(a=>s(a),a=>i(a),r)}toFileSystemProviderError(s){if(s instanceof m.FileSystemProviderError)return s;let i;switch(s.code){case"ENOENT":i=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=m.FileSystemProviderErrorCode.NoPermissions;break;default:i=m.FileSystemProviderErrorCode.Unknown}return(0,m.createFileSystemProviderError)(s,i)}async toFileSystemProviderWriteError(s,i){let r=this.toFileSystemProviderError(i);if(s&&r.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await t.SymlinkSupport.stat(this.toFilePath(s));a.mode&128||(r=(0,m.createFileSystemProviderError)(i,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.logService.trace(a)}return r}}e.DiskFileSystemProvider=o}),define(ee[190],te([0,1,4,77,2,17,51,21]),function(j,e,p,n,D,C,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class w extends D.Disposable{constructor(M,y){super();this.provider=M,this.logService=y,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(M,y,f){const t=this.getUriTransformer(M);switch(y){case"stat":return this.stat(t,f[0]);case"readdir":return this.readdir(t,f[0]);case"open":return this.open(t,f[0],f[1]);case"close":return this.close(f[0]);case"read":return this.read(f[0],f[1],f[2]);case"readFile":return this.readFile(t,f[0],f[1]);case"write":return this.write(f[0],f[1],f[2],f[3],f[4]);case"writeFile":return this.writeFile(t,f[0],f[1],f[2]);case"rename":return this.rename(t,f[0],f[1],f[2]);case"copy":return this.copy(t,f[0],f[1],f[2]);case"mkdir":return this.mkdir(t,f[0]);case"delete":return this.delete(t,f[0],f[1]);case"watch":return this.watch(t,f[0],f[1],f[2],f[3]);case"unwatch":return this.unwatch(f[0],f[1])}throw new Error(`IPC Command ${y} not found`)}listen(M,y,f){const t=this.getUriTransformer(M);switch(y){case"fileChange":return this.onFileChange(t,f[0]);case"readFileStream":return this.onReadFileStream(t,f[0],f[1])}throw new Error(`Unknown event ${y}`)}stat(M,y){const f=this.transformIncoming(M,y,!0);return this.provider.stat(f)}readdir(M,y){const f=this.transformIncoming(M,y);return this.provider.readdir(f)}async readFile(M,y,f){const t=this.transformIncoming(M,y,!0),d=await this.provider.readFile(t,f);return C.VSBuffer.wrap(d)}onReadFileStream(M,y,f){const t=this.transformIncoming(M,y,!0),d=new E.CancellationTokenSource,m=new p.Emitter({onLastListenerRemove:()=>{d.cancel()}}),v=this.provider.readFileStream(t,f,d.token);return(0,k.listenStream)(v,{onData:P=>m.fire(C.VSBuffer.wrap(P)),onError:P=>m.fire(P),onEnd:()=>{m.fire("end"),m.dispose(),d.dispose()}}),m.event}writeFile(M,y,f,t){const d=this.transformIncoming(M,y);return this.provider.writeFile(d,f.buffer,t)}open(M,y,f){const t=this.transformIncoming(M,y,!0);return this.provider.open(t,f)}close(M){return this.provider.close(M)}async read(M,y,f){const t=C.VSBuffer.alloc(f),d=0,m=await this.provider.read(M,y,t.buffer,d,f);return[t,m]}write(M,y,f,t,d){return this.provider.write(M,y,f.buffer,t,d)}mkdir(M,y){const f=this.transformIncoming(M,y);return this.provider.mkdir(f)}delete(M,y,f){const t=this.transformIncoming(M,y);return this.provider.delete(t,f)}rename(M,y,f,t){const d=this.transformIncoming(M,y),m=this.transformIncoming(M,f);return this.provider.rename(d,m,t)}copy(M,y,f,t){const d=this.transformIncoming(M,y),m=this.transformIncoming(M,f);return this.provider.copy(d,m,t)}onFileChange(M,y){const f=new p.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(y,this.createSessionFileWatcher(M,f))},onLastListenerRemove:()=>{(0,D.dispose)(this.sessionToWatcher.get(y)),this.sessionToWatcher.delete(y)}});return f.event}async watch(M,y,f,t,d){const m=this.sessionToWatcher.get(y);if(m){const v=this.transformIncoming(M,t),P=m.watch(f,v,d);this.watchRequests.set(y+f,P)}}async unwatch(M,y){const f=M+y,t=this.watchRequests.get(f);t&&((0,D.dispose)(t),this.watchRequests.delete(f))}dispose(){super.dispose();for(const[,M]of this.watchRequests)M.dispose();this.watchRequests.clear();for(const[,M]of this.sessionToWatcher)M.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=w;class S extends D.Disposable{constructor(M,y,f,t){super();this.uriTransformer=M,this.logService=f,this.environmentService=t,this.watcherRequests=new Map,this.fileWatcher=this._register(new n.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(y)}registerListeners(M){const y=this._register(new p.Emitter);this._register(y.event(f=>{M.fire(f.map(t=>({resource:this.uriTransformer.transformOutgoingURI(t.resource),type:t.type})))})),this._register(this.fileWatcher.onDidChangeFile(f=>y.fire(f))),this._register(this.fileWatcher.onDidWatchError(f=>M.fire(f)))}getRecursiveWatcherOptions(M){}getExtraExcludes(M){}watch(M,y,f){const t=this.getExtraExcludes(this.environmentService);return Array.isArray(t)&&(f.excludes=[...f.excludes,...t]),this.watcherRequests.set(M,this.fileWatcher.watch(y,f)),(0,D.toDisposable)(()=>{(0,D.dispose)(this.watcherRequests.get(M)),this.watcherRequests.delete(M)})}dispose(){super.dispose();for(const[,M]of this.watcherRequests)M.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=S}),define(ee[191],te([0,1,14,150,3,7,18,9,190,116]),function(j,e,p,n,D,C,k,E,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class b extends w.AbstractDiskFileSystemProviderChannel{constructor(f,t,d){super(f,t);this.environmentService=d}getUriTransformer(f){return S.DefaultURITransformer}transformIncoming(f,t){return C.URI.revive(t)}async delete(f,t,d){if(!d.useTrash)return super.delete(f,t,d);const m=this.transformIncoming(f,t),v=(0,E.normalize)(m.fsPath);try{await p.shell.trashItem(v)}catch{throw(0,k.createFileSystemProviderError)(D.isWindows?(0,n.localize)(0,null,(0,E.basename)(v)):(0,n.localize)(1,null,(0,E.basename)(v)),k.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(f,t){return new M(f,t,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=b;class M extends w.AbstractSessionFileWatcher{watch(f,t,d){if(d.recursive)throw(0,k.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",k.FileSystemProviderErrorCode.Unavailable);return super.watch(f,t,d)}}}),define(ee[96],te([0,1,6]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function n(C,k){switch(k){case p.LogLevel.Trace:return C.trace;case p.LogLevel.Debug:return C.debug;case p.LogLevel.Info:return C.info;case p.LogLevel.Warning:return C.warn;case p.LogLevel.Error:return C.error;case p.LogLevel.Critical:return C.critical;default:throw new Error("Invalid log level")}}class D extends p.AbstractLogger{constructor(k=p.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(k),this._register(this.onDidChangeLogLevel(E=>{this._logger&&this._logger.setLevel(E)}))}set logger(k){this._logger=k;for(const{level:E,args:w}of this.buffer)n(k,E).apply(k,w);this.buffer=[]}_log(k,...E){this._logger?n(this._logger,k).apply(this._logger,E):this.getLevel()<=k&&this.buffer.push({level:k,args:E})}trace(k,...E){this._log(p.LogLevel.Trace,k,...E)}debug(k,...E){this._log(p.LogLevel.Debug,k,...E)}info(k,...E){this._log(p.LogLevel.Info,k,...E)}warn(k,...E){this._log(p.LogLevel.Warning,k,...E)}error(k,...E){this._log(p.LogLevel.Error,k,...E)}critical(k,...E){this._log(p.LogLevel.Critical,k,...E)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=D}),define(ee[192],te([0,1,8,17,16,18,5,96,6]),function(j,e,p,n,D,C,k,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const S=5*C.ByteSize.MB;let b=class extends w.AbstractLogger{constructor(f,t,d,m,v){super();this.name=f,this.resource=t,this.donotUseFormatters=m,this.fileService=v,this.backupIndex=1,this.setLevel(d),this.queue=this._register(new p.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=w.LogLevel.Trace&&this._log(w.LogLevel.Trace,(0,w.format)(arguments))}debug(){this.getLevel()<=w.LogLevel.Debug&&this._log(w.LogLevel.Debug,(0,w.format)(arguments))}info(){this.getLevel()<=w.LogLevel.Info&&this._log(w.LogLevel.Info,(0,w.format)(arguments))}warn(){this.getLevel()<=w.LogLevel.Warning&&this._log(w.LogLevel.Warning,(0,w.format)(arguments))}error(){if(this.getLevel()<=w.LogLevel.Error){const f=arguments[0];if(f instanceof Error){const t=Array.prototype.slice.call(arguments);t[0]=f.stack,this._log(w.LogLevel.Error,(0,w.format)(t))}else this._log(w.LogLevel.Error,(0,w.format)(arguments))}}critical(){this.getLevel()<=w.LogLevel.Critical&&this._log(w.LogLevel.Critical,(0,w.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(f){if(f.fileOperationResult!==3)throw f}}_log(f,t){this.queue.queue(async()=>{await this.initializePromise;let d=await this.loadContent();d.length>S&&(await this.fileService.writeFile(this.getBackupResource(),n.VSBuffer.fromString(d)),d=""),this.donotUseFormatters?d+=t:d+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(f)}] ${t}
`,await this.fileService.writeFile(this.resource,n.VSBuffer.fromString(d))})}getCurrentTimestamp(){const f=m=>m<10?`0${m}`:m,t=m=>m<10?`00${m}`:m<100?`0${m}`:m,d=new Date;return`${d.getFullYear()}-${f(d.getMonth()+1)}-${f(d.getDate())} ${f(d.getHours())}:${f(d.getMinutes())}:${f(d.getSeconds())}.${t(d.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,D.joinPath)((0,D.dirname)(this.resource),`${(0,D.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch{return""}}stringifyLogLevel(f){switch(f){case w.LogLevel.Critical:return"critical";case w.LogLevel.Debug:return"debug";case w.LogLevel.Error:return"error";case w.LogLevel.Info:return"info";case w.LogLevel.Trace:return"trace";case w.LogLevel.Warning:return"warning"}return""}};b=de([ne(4,C.IFileService)],b),e.FileLogger=b;let M=class extends w.AbstractLoggerService{constructor(f,t,d){super(f.getLevel(),f.onDidChangeLogLevel);this.instantiationService=t,this.fileService=d}doCreateLogger(f,t,d){const m=new E.BufferLogService(t);return(0,C.whenProviderRegistered)(f,this.fileService).then(()=>m.logger=this.instantiationService.createInstance(b,d?.name||(0,D.basename)(f),f,m.getLevel(),!!d?.donotUseFormatters)),m}};M=de([ne(0,w.ILogService),ne(1,k.IInstantiationService),ne(2,C.IFileService)],M),e.FileLoggerService=M}),define(ee[193],te([0,1,4,7,6]),function(j,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class C{constructor(y){this.service=y,this.onDidChangeLogLevel=p.Event.buffer(y.onDidChangeLogLevel,!0)}listen(y,f){switch(f){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${f}`)}async call(y,f,t){switch(f){case"setLevel":return this.service.setLevel(t)}throw new Error(`Call not found: ${f}`)}}e.LogLevelChannel=C;class k{constructor(y){this.channel=y}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(y){k.setLevel(this.channel,y)}static setLevel(y,f){return y.call("setLevel",f)}}e.LogLevelChannelClient=k;class E{constructor(y){this.loggerService=y,this.loggers=new Map}listen(y,f){throw new Error(`Event not found: ${f}`)}async call(y,f,t){switch(f){case"createLogger":this.createLogger(n.URI.revive(t[0]),t[1]);return;case"log":return this.log(n.URI.revive(t[0]),t[1]);case"consoleLog":return this.consoleLog(t[0],t[1])}throw new Error(`Call not found: ${f}`)}createLogger(y,f){this.loggers.set(y.toString(),this.loggerService.createLogger(y,f))}consoleLog(y,f){let t=console.log;switch(y){case D.LogLevel.Error:t=console.error;break;case D.LogLevel.Warning:t=console.warn;break;case D.LogLevel.Info:t=console.info;break}t.call(console,...f)}log(y,f){const t=this.loggers.get(y.toString());if(!t)throw new Error("Create the logger before logging");for(const[d,m]of f)(0,D.log)(t,d,m)}}e.LoggerChannel=E;class w extends D.AbstractLoggerService{constructor(y,f,t){super(y,f);this.channel=t}createConsoleMainLogger(){return new D.AdapterLogger({log:(y,f)=>{this.channel.call("consoleLog",[y,f])}})}doCreateLogger(y,f,t){return new S(this.channel,y,f,t)}}e.LoggerChannelClient=w;class S extends D.AbstractMessageLogger{constructor(y,f,t,d){super(d?.always);this.channel=y,this.file=f,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(t),this.channel.call("createLogger",[f,d]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(y,f){const t=[[y,f]];this.isLoggerCreated?this.doLog(t):this.buffer.push(...t)}doLog(y){this.channel.call("log",[this.file,y])}}class b extends D.LogService{constructor(y,f){super(f);this.parent=y,this._register(y.onDidChangeLogLevel(t=>f.setLevel(t)))}setLevel(y){super.setLevel(y),this.parent.setLevel(y)}}e.FollowerLogService=b}),define(ee[97],te([0,1,18,6]),function(j,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function D(E,w,S,b,M){try{const y=await new Promise((t,d)=>{j(["spdlog"],t,d)});y.setFlushOn(n.LogLevel.Trace);const f=await y.createAsyncRotatingLogger(E,w,S,b);return M&&f.clearFormatters(),f}catch(y){console.error(y)}return null}function C(E,w,S){switch(w){case n.LogLevel.Trace:E.trace(S);break;case n.LogLevel.Debug:E.debug(S);break;case n.LogLevel.Info:E.info(S);break;case n.LogLevel.Warning:E.warn(S);break;case n.LogLevel.Error:E.error(S);break;case n.LogLevel.Critical:E.critical(S);break;default:throw new Error("Invalid log level")}}class k extends n.AbstractMessageLogger{constructor(w,S,b,M,y){super();this.buffer=[],this.setLevel(y),this._loggerCreationPromise=this._createSpdLogLogger(w,S,b,M),this._register(this.onDidChangeLogLevel(f=>{this._logger&&this._logger.setLevel(f)}))}async _createSpdLogLogger(w,S,b,M){const y=b?6:1,f=30/y*p.ByteSize.MB,t=await D(w,S,f,y,M);if(t){this._logger=t,this._logger.setLevel(this.getLevel());for(const{level:d,message:m}of this.buffer)C(this._logger,d,m);this.buffer=[]}}log(w,S){this._logger?C(this._logger,w,S):this.getLevel()<=w&&this.buffer.push({level:w,message:S})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=k}),define(ee[194],te([0,1,10,16,32,18,192,6,97]),function(j,e,p,n,D,C,k,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let S=class extends E.AbstractLoggerService{constructor(M,y){super(M.getLevel(),M.onDidChangeLogLevel);this.fileService=y}doCreateLogger(M,y,f){return M.scheme===p.Schemas.file?new w.SpdLogLogger(f?.name||(0,D.generateUuid)(),M.fsPath,!f?.donotRotate,!!f?.donotUseFormatters,y):new k.FileLogger(f?.name??(0,n.basename)(M),M,y,!!f?.donotUseFormatters,this.fileService)}};S=de([ne(0,E.ILogService),ne(1,C.IFileService)],S),e.LoggerService=S}),define(ee[195],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function p(k){return k.submenu!==void 0}e.isMenubarMenuItemSubmenu=p;function n(k){return k.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=n;function D(k){return k.uri!==void 0}e.isMenubarMenuItemRecentAction=D;function C(k){return!p(k)&&!n(k)&&!D(k)}e.isMenubarMenuItemAction=C}),define(ee[54],te([0,1,10,3,35,16]),function(j,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.context!="undefined"){const E=n.globals.vscode.context.configuration();if(E)k=E.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof j?.__$__nodeRequire=="function"){const E=(0,C.dirname)(p.FileAccess.asFileUri("",j));k=j.__$__nodeRequire((0,C.joinPath)(E,"product.json").fsPath);const w=j.__$__nodeRequire((0,C.joinPath)(E,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`}),Object.assign(k,{version:w.version})}else k={},Object.keys(k).length===0&&Object.assign(k,{version:"1.64.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=k}),define(ee[22],te([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,p.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ee[196],te([0,1,60,6,22]),function(j,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let C=class{constructor(E,w){this.productService=E,this.logService=w,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(E,w){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const S=/^(.*)#([^#]+)$/.exec(w);if(!S)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",w),!1;const[,b,M]=S;let y=this.trustedExtensionUrlPublicKeys.get(E);if(!y){if(y=this.productService.trustedExtensionUrlPublicKeys[E],!y||y.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",E),!1;this.trustedExtensionUrlPublicKeys.set(E,[...y])}const f=Buffer.from(decodeURIComponent(M),"base64");if(f.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",w),!1;const t=f.slice(0,6),d=f.readUIntBE(0,6),m=Date.now()-d;if(m<0||m>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",w),!1;const v=f.slice(6),P=p.createVerify("SHA256");P.write(t),P.write(Buffer.from(b)),P.end();for(let u=0;u<y.length;u++){let g=y[u];if(g!==null){if(typeof g=="string")try{g=p.createPublicKey({key:Buffer.from(g,"base64"),format:"der",type:"spki"}),y[u]=g}catch(c){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${u+1} for ${E}:`,c),y[u]=null;continue}if(P.verify(g,v))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",w),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",w),!1}};C=de([ne(0,D.IProductService),ne(1,n.ILogService)],C),e.ExtensionUrlTrustService=C}),define(ee[55],te([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,p.createDecorator)("protocolMainService")}),define(ee[197],te([0,1,14,2,36,10,3,16,7,32,48,6]),function(j,e,p,n,D,C,k,E,w,S,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let y=class extends n.Disposable{constructor(t,d){super();this.logService=d,this.validRoots=D.TernarySearchTree.forUris(()=>!k.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(w.URI.file(t.appRoot)),this.addValidFileRoot(w.URI.file(t.extensionsPath)),this.addValidFileRoot(t.globalStorageHome),this.addValidFileRoot(t.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:t}=p.session;t.protocol.registerFileProtocol(C.Schemas.vscodeFileResource,(d,m)=>this.handleResourceRequest(d,m)),t.protocol.interceptFileProtocol(C.Schemas.file,(d,m)=>this.handleFileRequest(d,m)),this._register((0,n.toDisposable)(()=>{t.protocol.unregisterProtocol(C.Schemas.vscodeFileResource),t.protocol.uninterceptProtocol(C.Schemas.file)}))}addValidFileRoot(t){return this.validRoots.get(t)?n.Disposable.None:(this.validRoots.set(t,!0),(0,n.toDisposable)(()=>this.validRoots.delete(t)))}handleFileRequest(t,d){const m=w.URI.parse(t.url);return this.logService.error(`Refused to load resource ${m.fsPath} from ${C.Schemas.file}: protocol (original URL: ${t.url})`),d({error:-3})}handleResourceRequest(t,d){const m=w.URI.parse(t.url),v=C.FileAccess.asFileUri(m);return this.validRoots.findSubstr(v)?d({path:v.fsPath}):this.validExtensions.has((0,E.extname)(v))?d({path:v.fsPath}):(this.logService.error(`${C.Schemas.vscodeFileResource}: Refused to load resource ${v.fsPath} from ${C.Schemas.vscodeFileResource}: protocol (original URL: ${t.url})`),d({error:-3}))}createIPCObjectUrl(){let t;const d=w.URI.from({scheme:"vscode",path:(0,S.generateUuid)()}),m=d.toString(),v=async()=>t;return p.ipcMain.handle(m,v),this.logService.trace(`IPC Object URL: Registered new channel ${m}.`),{resource:d,update:P=>t=P,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${m}.`),p.ipcMain.removeHandler(m)}}}};y=de([ne(0,b.INativeEnvironmentService),ne(1,M.ILogService)],y),e.ProtocolMainService=y}),define(ee[40],te([0,1,105,13]),function(j,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(k,E){p.ok(n.isString(k)),p.ok(n.isObject(E)),p.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,E)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new D}),define(ee[198],te([0,1,4,40]),function(j,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class C{constructor(){this._onDidChangeSchema=new p.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(w,S){this.schemasById[D(w)]=S,this._onDidChangeSchema.fire(w)}notifySchemaChanged(w){this._onDidChangeSchema.fire(w)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new C;n.Registry.add(e.Extensions.JSONContribution,k)}),define(ee[56],te([0,1,28,4,13,139,198,40]),function(j,e,p,n,D,C,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var w;(function(g){g.Multiline="multilineText",g.Singleline="singlelineText"})(w=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var S;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(S=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=E.Registry.as(k.Extensions.JSONContribution);class M{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(c,o=!0){this.registerConfigurations([c],o)}registerConfigurations(c,o=!0){const l=this.doRegisterConfigurations(c,o);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l})}deregisterConfigurations(c){const o=this.doDeregisterConfigurations(c);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:c,remove:o}){const l=[];l.push(...this.doDeregisterConfigurations(o)),l.push(...this.doRegisterConfigurations(c,!1)),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,p.distinct)(l)})}registerDefaultConfigurations(c){const o=[],l=[];for(const{overrides:s,source:i}of c)for(const r in s)if(o.push(r),e.OVERRIDE_PROPERTY_REGEX.test(r)){const a={...this.configurationDefaultsOverrides.get(r)?.value||{},...s[r]};this.configurationDefaultsOverrides.set(r,{source:i,value:a});const h={type:"object",default:a,description:C.localize(1,null,r),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:a,source:D.isString(i)?void 0:i};l.push(...t(r)),this.configurationProperties[r]=h,this.defaultLanguageConfigurationOverridesNode.properties[r]=h}else{this.configurationDefaultsOverrides.set(r,{value:s[r],source:i});const a=this.configurationProperties[r];a&&(this.updatePropertyDefaultValue(r,a),this.updateSchema(r,a))}this.registerOverrideIdentifiers(l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}deregisterDefaultConfigurations(c){const o=[];for(const{overrides:l,source:s}of c)for(const i in l){const r=this.configurationDefaultsOverrides.get(i),a=D.isString(s)?s:s?.id,h=D.isString(r?.source)?r?.source:r?.source?.id;if(a===h)if(o.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const I=this.configurationProperties[i];I&&(this.updatePropertyDefaultValue(i,I),this.updateSchema(i,I))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...c){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(c){for(const o of c)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(c,o){const l=[];return c.forEach(s=>{l.push(...this.validateAndRegisterProperties(s,o,s.extensionInfo,s.restrictedProperties)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),l}doDeregisterConfigurations(c){const o=[],l=s=>{if(s.properties)for(const i in s.properties)o.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,s.properties[i]);s.allOf&&s.allOf.forEach(i=>l(i))};for(const s of c){l(s);const i=this.configurationContributors.indexOf(s);i!==-1&&this.configurationContributors.splice(i,1)}return o}validateAndRegisterProperties(c,o=!0,l,s,i=3){i=D.isUndefinedOrNull(c.scope)?i:c.scope;let r=[],a=c.properties;if(a)for(let I in a){if(o&&P(I)){delete a[I];continue}const R=a[I];if(R.source=l,R.defaultDefaultValue=a[I].default,this.updatePropertyDefaultValue(I,R),e.OVERRIDE_PROPERTY_REGEX.test(I)?R.scope=void 0:(R.scope=D.isUndefinedOrNull(R.scope)?i:R.scope,R.restricted=D.isUndefinedOrNull(R.restricted)?!!s?.includes(I):R.restricted),a[I].hasOwnProperty("included")&&!a[I].included){this.excludedConfigurationProperties[I]=a[I],delete a[I];continue}else this.configurationProperties[I]=a[I];!a[I].deprecationMessage&&a[I].markdownDeprecationMessage&&(a[I].deprecationMessage=a[I].markdownDeprecationMessage),r.push(I)}let h=c.allOf;if(h)for(let I of h)r.push(...this.validateAndRegisterProperties(I,o,l,s,i));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(c){const o=l=>{let s=l.properties;if(s)for(const r in s)this.updateSchema(r,s[r]);let i=l.allOf;i&&i.forEach(o)};o(c)}updateSchema(c,o){switch(e.allSettings.properties[c]=o,o.scope){case 1:e.applicationSettings.properties[c]=o;break;case 2:e.machineSettings.properties[c]=o;break;case 6:e.machineOverridableSettings.properties[c]=o;break;case 3:e.windowSettings.properties[c]=o;break;case 4:e.resourceSettings.properties[c]=o;break;case 5:e.resourceSettings.properties[c]=o,this.resourceLanguageSettingsSchema.properties[c]=o;break}}removeFromSchema(c,o){switch(delete e.allSettings.properties[c],o.scope){case 1:delete e.applicationSettings.properties[c];break;case 2:delete e.machineSettings.properties[c];break;case 6:delete e.machineOverridableSettings.properties[c];break;case 3:delete e.windowSettings.properties[c];break;case 4:case 5:delete e.resourceSettings.properties[c],delete this.resourceLanguageSettingsSchema.properties[c];break}}updateOverridePropertyPatternKey(){for(const c of this.overrideIdentifiers.values()){const o=`[${c}]`,l={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,l),e.allSettings.properties[o]=l,e.applicationSettings.properties[o]=l,e.machineSettings.properties[o]=l,e.machineOverridableSettings.properties[o]=l,e.windowSettings.properties[o]=l,e.resourceSettings.properties[o]=l}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const c={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(c,o){const l=this.configurationDefaultsOverrides.get(c);let s=l?.value,i=l?.source;D.isUndefined(s)&&(s=o.defaultDefaultValue,i=void 0),D.isUndefined(s)&&(s=m(o.type)),o.default=s,o.defaultValueSource=i}}const y="\\[([^\\]]+)\\]",f=new RegExp(y,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${y})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function t(g){const c=[];if(e.OVERRIDE_PROPERTY_REGEX.test(g)){let o=f.exec(g);for(;o?.length;){const l=o[1].trim();l&&c.push(l),o=f.exec(g)}}return(0,p.distinct)(c)}e.overrideIdentifiersFromKey=t;function d(g){return g.reduce((c,o)=>`${c}[${o}]`,"")}e.keyFromOverrideIdentifiers=d;function m(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const v=new M;E.Registry.add(e.Extensions.Configuration,v);function P(g){return g.trim()?e.OVERRIDE_PROPERTY_REGEX.test(g)?C.localize(7,null,g):v.getConfigurationProperties()[g]!==void 0?C.localize(8,null,g):null:C.localize(6,null)}e.validateProperty=P;function u(){const g=[],c=v.getConfigurationProperties();for(const o of Object.keys(c))g.push([o,c[o].scope]);return g.push(["launch",4]),g.push(["task",4]),g}e.getScopes=u}),define(ee[199],te([0,1,28,4,44,2,36,47,13,7,19,56,40]),function(j,e,p,n,D,C,k,E,w,S,b,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class f{constructor(s={},i=[],r=[]){this._contents=s,this._keys=i,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(s){return s?(0,b.getConfigurationValue)(this.contents,s):this.contents}getOverrideValue(s,i){const r=this.getContentsForOverrideIdentifer(i);return r?s?(0,b.getConfigurationValue)(r,s):r:void 0}getKeysForOverrideIdentifier(s){const i=[];for(const r of this.overrides)r.identifiers.includes(s)&&i.push(...r.keys);return p.distinct(i)}getAllOverrideIdentifiers(){const s=[];for(const i of this.overrides)s.push(...i.identifiers);return p.distinct(s)}override(s){let i=this.overrideConfigurations.get(s);return i||(i=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,i)),i}merge(...s){const i=E.deepClone(this.contents),r=E.deepClone(this.overrides),a=[...this.keys];for(const h of s){this.mergeContents(i,h.contents);for(const I of h.overrides){const[R]=r.filter(L=>p.equals(L.identifiers,I.identifiers));R?(this.mergeContents(R.contents,I.contents),R.keys.push(...I.keys),R.keys=p.distinct(R.keys)):r.push(E.deepClone(I))}for(const I of h.keys)a.indexOf(I)===-1&&a.push(I)}return new f(i,a,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(s){const i=this.getContentsForOverrideIdentifer(s);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let r={};for(const a of p.distinct([...Object.keys(this.contents),...Object.keys(i)])){let h=this.contents[a],I=i[a];I&&(typeof h=="object"&&typeof I=="object"?(h=E.deepClone(h),this.mergeContents(h,I)):h=I),r[a]=h}return new f(r,this.keys,this.overrides)}mergeContents(s,i){for(const r of Object.keys(i)){if(r in s&&w.isObject(s[r])&&w.isObject(i[r])){this.mergeContents(s[r],i[r]);continue}s[r]=E.deepClone(i[r])}}checkAndFreeze(s){return this.isFrozen&&!Object.isFrozen(s)?E.deepFreeze(s):s}getContentsForOverrideIdentifer(s){let i=null,r=null;const a=h=>{h&&(r?this.mergeContents(r,h):r=E.deepClone(h))};for(const h of this.overrides)p.equals(h.identifiers,[s])?i=h.contents:h.identifiers.includes(s)&&a(h.contents);return a(i),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(s,i){this.addKey(s),(0,b.addToValueTree)(this.contents,s,i,r=>{throw new Error(r)})}removeValue(s){this.removeKey(s)&&(0,b.removeFromValueTree)(this.contents,s)}addKey(s){let i=this.keys.length;for(let r=0;r<i;r++)s.indexOf(this.keys[r])===0&&(i=r);this.keys.splice(i,1,s)}removeKey(s){let i=this.keys.indexOf(s);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=f;class t extends f{constructor(s={}){const i=y.Registry.as(M.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(i),a=Object.create(null),h=[];for(const I in i){const R=s[I],L=R!==void 0?R:i[I].default;(0,b.addToValueTree)(a,I,L,T=>console.error(`Conflict in default settings: ${T}`))}for(const I of Object.keys(a))M.OVERRIDE_PROPERTY_REGEX.test(I)&&h.push({identifiers:(0,M.overrideIdentifiersFromKey)(I),keys:Object.keys(a[I]),contents:(0,b.toValuesTree)(a[I],R=>console.error(`Conflict in default settings file: ${R}`))});super(a,r,h)}}e.DefaultConfigurationModel=t;class d{constructor(s){this._name=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,i){if(!w.isUndefinedOrNull(s)){const r=this.doParseContent(s);this.parseRaw(r,i)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,i){this._raw=s;const{contents:r,keys:a,overrides:h,restricted:I}=this.doParseRaw(s,i);this._configurationModel=new f(r,a,h),this._restrictedConfigurations=I||[]}doParseContent(s){let i={},r=null,a=[],h=[],I=[];function R(T){Array.isArray(a)?a.push(T):r!==null&&(a[r]=T)}let L={onObjectBegin:()=>{let T={};R(T),h.push(a),a=T,r=null},onObjectProperty:T=>{r=T},onObjectEnd:()=>{a=h.pop()},onArrayBegin:()=>{let T=[];R(T),h.push(a),a=T,r=null},onArrayEnd:()=>{a=h.pop()},onLiteralValue:R,onError:(T,$,Q)=>{I.push({error:T,offset:$,length:Q})}};if(s)try{D.visit(s,L),i=a[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return i}doParseRaw(s,i){const r=y.Registry.as(M.Extensions.Configuration).getConfigurationProperties(),a=this.filter(s,r,!0,i);s=a.raw;const h=(0,b.toValuesTree)(s,L=>console.error(`Conflict in settings file ${this._name}: ${L}`)),I=Object.keys(s),R=this.toOverrides(s,L=>console.error(`Conflict in settings file ${this._name}: ${L}`));return{contents:h,keys:I,overrides:R,restricted:a.restricted}}filter(s,i,r,a){if(!a?.scopes&&!a?.skipRestricted)return{raw:s,restricted:[]};const h={},I=[];for(let R in s)if(M.OVERRIDE_PROPERTY_REGEX.test(R)&&r){const L=this.filter(s[R],i,!1,a);h[R]=L.raw,I.push(...L.restricted)}else{const L=i[R],T=L?typeof L.scope!="undefined"?L.scope:3:void 0;L?.restricted&&I.push(R),(T===void 0||a.scopes===void 0||a.scopes.includes(T))&&(a.skipRestricted&&L?.restricted||(h[R]=s[R]))}return{raw:h,restricted:I}}toOverrides(s,i){const r=[];for(const a of Object.keys(s))if(M.OVERRIDE_PROPERTY_REGEX.test(a)){const h={};for(const I in s[a])h[I]=s[a][I];r.push({identifiers:(0,M.overrideIdentifiersFromKey)(a),keys:Object.keys(h),contents:(0,b.toValuesTree)(h,i)})}return r}}e.ConfigurationModelParser=d;class m extends C.Disposable{constructor(s,i,r,a){super();this.userSettingsResource=s,this.scopes=i,this.fileService=a,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(n.Event.filter(this.fileService.onDidFilesChange,h=>h.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new f}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=m;class v{constructor(s,i,r=new f,a=new f,h=new k.ResourceMap,I=new f,R=new k.ResourceMap,L=!0){this._defaultConfiguration=s,this._localUserConfiguration=i,this._remoteUserConfiguration=r,this._workspaceConfiguration=a,this._folderConfigurations=h,this._memoryConfiguration=I,this._memoryConfigurationByResource=R,this._freeze=L,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(s,i,r){return this.getConsolidateConfigurationModel(i,r).getValue(s)}updateValue(s,i,r={}){let a;r.resource?(a=this._memoryConfigurationByResource.get(r.resource),a||(a=new f,this._memoryConfigurationByResource.set(r.resource,a))):a=this._memoryConfiguration,i===void 0?a.removeValue(s):a.setValue(s,i),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,i,r){const a=this.getConsolidateConfigurationModel(i,r),h=this.getFolderConfigurationModelForResource(i.resource,r),I=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,R=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this._defaultConfiguration.freeze().getValue(s),L=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this.userConfiguration.freeze().getValue(s),T=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this.localUserConfiguration.freeze().getValue(s),$=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this.remoteUserConfiguration.freeze().getValue(s),Q=r?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this._workspaceConfiguration.freeze().getValue(s):void 0,se=h?i.overrideIdentifier?h.freeze().override(i.overrideIdentifier).getValue(s):h.freeze().getValue(s):void 0,re=i.overrideIdentifier?I.override(i.overrideIdentifier).getValue(s):I.getValue(s),V=a.getValue(s),Z=p.distinct(p.flatten(a.overrides.map(H=>H.identifiers))).filter(H=>a.getOverrideValue(s,H)!==void 0);return{defaultValue:R,userValue:L,userLocalValue:T,userRemoteValue:$,workspaceValue:Q,workspaceFolderValue:se,memoryValue:re,value:V,default:R!==void 0?{value:this._defaultConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,user:L!==void 0?{value:this.userConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,userLocal:T!==void 0?{value:this.localUserConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,userRemote:$!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,workspace:Q!==void 0?{value:this._workspaceConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,workspaceFolder:se!==void 0?{value:h?.freeze().getValue(s),override:i.overrideIdentifier?h?.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,memory:re!==void 0?{value:I.getValue(s),override:i.overrideIdentifier?I.getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:Z.length?Z:void 0}}keys(s){const i=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,i){this._folderConfigurations.set(s,i),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,i){const r=[];if(!i){const{added:a,updated:h,removed:I}=c(this._defaultConfiguration,s);i=[...a,...h,...I]}for(const a of i)for(const h of(0,M.overrideIdentifiersFromKey)(a)){const I=this._defaultConfiguration.getKeysForOverrideIdentifier(h),R=s.getKeysForOverrideIdentifier(h),L=[...R.filter(T=>I.indexOf(T)===-1),...I.filter(T=>R.indexOf(T)===-1),...I.filter(T=>!E.equals(this._defaultConfiguration.override(h).getValue(T),s.override(h).getValue(T)))];r.push([h,L])}return this.updateDefaultConfiguration(s),{keys:i,overrides:r}}compareAndUpdateLocalUserConfiguration(s){const{added:i,updated:r,removed:a,overrides:h}=c(this.localUserConfiguration,s),I=[...i,...r,...a];return I.length&&this.updateLocalUserConfiguration(s),{keys:I,overrides:h}}compareAndUpdateRemoteUserConfiguration(s){const{added:i,updated:r,removed:a,overrides:h}=c(this.remoteUserConfiguration,s);let I=[...i,...r,...a];return I.length&&this.updateRemoteUserConfiguration(s),{keys:I,overrides:h}}compareAndUpdateWorkspaceConfiguration(s){const{added:i,updated:r,removed:a,overrides:h}=c(this.workspaceConfiguration,s);let I=[...i,...r,...a];return I.length&&this.updateWorkspaceConfiguration(s),{keys:I,overrides:h}}compareAndUpdateFolderConfiguration(s,i){const r=this.folderConfigurations.get(s),{added:a,updated:h,removed:I,overrides:R}=c(r,i);let L=[...a,...h,...I];return(L.length||!r)&&this.updateFolderConfiguration(s,i),{keys:L,overrides:R}}compareAndDeleteFolderConfiguration(s){const i=this.folderConfigurations.get(s);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:r,updated:a,removed:h,overrides:I}=c(i,void 0);return{keys:[...r,...a,...h],overrides:I}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(s,i){let r=this.getConsolidatedConfigurationModelForResource(s,i);return s.overrideIdentifier?r.override(s.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:s},i){let r=this.getWorkspaceConsolidatedConfiguration();if(i&&s){const a=i.getFolder(s);a&&(r=this.getFolderConsolidatedConfiguration(a.uri)||r);const h=this._memoryConfigurationByResource.get(s);h&&(r=r.merge(h))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let i=this._foldersConsolidatedConfigurations.get(s);if(!i){const r=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(s);a?(i=r.merge(a),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(s,i)):i=r}return i}getFolderConfigurationModelForResource(s,i){if(i&&s){const r=i.getFolder(s);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,i)=>{const{contents:r,overrides:a,keys:h}=this._folderConfigurations.get(i);return s.push([i,{contents:r,overrides:a,keys:h}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>s.add(i)),this.userConfiguration.freeze().keys.forEach(i=>s.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(r=>s.add(r))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(r=>s.add(r))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>i.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>i.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>i.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(s).forEach(a=>i.add(a))),[...i.values()]}static parse(s){const i=this.parseConfigurationModel(s.defaults),r=this.parseConfigurationModel(s.user),a=this.parseConfigurationModel(s.workspace),h=s.folders.reduce((I,R)=>(I.set(S.URI.revive(R[0]),this.parseConfigurationModel(R[1])),I),new k.ResourceMap);return new v(i,r,new f,a,h,new f,new k.ResourceMap,!1)}static parseConfigurationModel(s){return new f(s.contents,s.keys,s.overrides).freeze()}}e.Configuration=v;function P(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const s=new Set,i=new Map;for(const a of l)a.keys.forEach(h=>s.add(h)),a.overrides.forEach(([h,I])=>{const R=(0,k.getOrSet)(i,h,new Set);I.forEach(L=>R.add(L))});const r=[];return i.forEach((a,h)=>r.push([h,[...a.values()]])),{keys:[...s.values()],overrides:r}}e.mergeChanges=P;class u{constructor(s,i,r,a){this.change=s,this.previous=i,this.currentConfiguraiton=r,this.currentWorkspace=a,this._previousConfiguration=void 0;const h=new Set;s.keys.forEach(R=>h.add(R)),s.overrides.forEach(([,R])=>R.forEach(L=>h.add(L))),this.affectedKeys=[...h.values()];const I=new f;this.affectedKeys.forEach(R=>I.setValue(R,{})),this.affectedKeysTree=I.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(s,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,s)){if(i){const r=this.previousConfiguration?this.previousConfiguration.getValue(s,i,this.previous?.workspace):void 0,a=this.currentConfiguraiton.getValue(s,i,this.currentWorkspace);return!E.equals(r,a)}return!0}return!1}doesAffectedKeysTreeContains(s,i){let r=(0,b.toValuesTree)({[i]:!0},()=>{}),a;for(;typeof r=="object"&&(a=Object.keys(r)[0]);){if(s=s[a],!s)return!1;r=r[a]}return!0}}e.ConfigurationChangeEvent=u;class g extends u{constructor(s,i,r,a){super({keys:s.allKeys(),overrides:[]},void 0,s,i);this.source=r,this.sourceConfig=a}}e.AllKeysConfigurationChangeEvent=g;function c(l,s){const{added:i,removed:r,updated:a}=o(s,l),h=[],I=l?.getAllOverrideIdentifiers()||[],R=s?.getAllOverrideIdentifiers()||[];if(s){const L=R.filter(T=>!I.includes(T));for(const T of L)h.push([T,s.getKeysForOverrideIdentifier(T)])}if(l){const L=I.filter(T=>!R.includes(T));for(const T of L)h.push([T,l.getKeysForOverrideIdentifier(T)])}if(s&&l){for(const L of I)if(R.includes(L)){const T=o({contents:l.getOverrideValue(void 0,L)||{},keys:l.getKeysForOverrideIdentifier(L)},{contents:s.getOverrideValue(void 0,L)||{},keys:s.getKeysForOverrideIdentifier(L)});h.push([L,[...T.added,...T.removed,...T.updated]])}}return{added:i,removed:r,updated:a,overrides:h}}function o(l,s){const i=l?s?l.keys.filter(h=>s.keys.indexOf(h)===-1):[...l.keys]:[],r=s?l?s.keys.filter(h=>l.keys.indexOf(h)===-1):[...s.keys]:[],a=[];if(l&&s){for(const h of s.keys)if(l.keys.indexOf(h)!==-1){const I=(0,b.getConfigurationValue)(s.contents,h),R=(0,b.getConfigurationValue)(l.contents,h);E.equals(I,R)||a.push(h)}}return{added:i,removed:r,updated:a}}}),define(ee[200],te([0,1,8,4,2,16,19,199,56,40]),function(j,e,p,n,D,C,k,E,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class b extends D.Disposable{constructor(y,f){super();this.settingsResource=y,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new E.UserSettings(this.settingsResource,void 0,C.extUriBiasedIgnorePathCase,f)),this.configuration=new E.Configuration(new E.DefaultConfigurationModel,new E.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new p.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(S.Registry.as(w.Extensions.Configuration).onDidUpdateConfiguration(({properties:t})=>this.onDidDefaultConfigurationChange(t))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const y=await this.userConfiguration.loadConfiguration();this.configuration=new E.Configuration(new E.DefaultConfigurationModel,y)}getConfigurationData(){return this.configuration.toData()}getValue(y,f){const t=typeof y=="string"?y:void 0,d=(0,k.isConfigurationOverrides)(y)?y:(0,k.isConfigurationOverrides)(f)?f:{};return this.configuration.getValue(t,d,void 0)}updateValue(y,f,t,d){return Promise.reject(new Error("not supported"))}inspect(y){return this.configuration.inspect(y,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const y=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(y)}onDidChangeUserConfiguration(y){const f=this.configuration.toData(),t=this.configuration.compareAndUpdateLocalUserConfiguration(y);this.trigger(t,f,1)}onDidDefaultConfigurationChange(y){const f=this.configuration.toData(),t=this.configuration.compareAndUpdateDefaultConfiguration(new E.DefaultConfigurationModel,y);this.trigger(t,f,6)}trigger(y,f,t){const d=new E.ConfigurationChangeEvent(y,{data:f},this.configuration);d.source=t,d.sourceConfig=this.getTargetConfiguration(t),this._onDidChangeConfiguration.fire(d)}getTargetConfiguration(y){switch(y){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=b}),define(ee[201],te([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,p.createDecorator)("remoteAuthorityResolverService");var n;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(n=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(k,E=n.Unknown,w){super(k);this._message=k,this._code=E,this._detail=w,this.isHandled=E===n.NotAvailable&&w===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(k){return k instanceof D&&k._code===n.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof D&&k._code===n.NoResolverFound}static isHandled(k){return k instanceof D&&k.isHandled}}e.RemoteAuthorityResolverError=D}),define(ee[202],te([0,1,8,17,21,15,4,2,32,87,201]),function(j,e,p,n,D,C,k,E,w,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const M=30*1e3;var y;(function(q){q[q.Management=1]="Management",q[q.ExtensionHost=2]="ExtensionHost",q[q.Tunnel=3]="Tunnel"})(y=e.ConnectionType||(e.ConnectionType={}));function f(q){switch(q){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function t(q){const W=new D.CancellationTokenSource;return setTimeout(()=>W.cancel(),q),W.token}function d(q,W){if(q.isCancellationRequested||W.isCancellationRequested)return D.CancellationToken.Cancelled;const N=new D.CancellationTokenSource;return q.onCancellationRequested(()=>N.cancel()),W.onCancellationRequested(()=>N.cancel()),N.token}class m{constructor(W){this._state="pending",this._disposables=new E.DisposableStore,this.promise=new Promise((N,F)=>{this._resolvePromise=N,this._rejectPromise=F}),W.isCancellationRequested?this._timeout():this._disposables.add(W.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(W){this._state==="pending"?this._disposables.add(W):W.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const W=new Error("Time limit reached");return W.code="ETIMEDOUT",W.syscall="connect",W}resolve(W){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(W))}reject(W){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(W))}}function v(q,W){const N=new m(W);return N.registerDisposable(q.onControlMessage(F=>{const A=JSON.parse(F.toString()),U=K(A);U?N.reject(U):N.resolve(A)})),N.promise}function P(q,W,N,F,A,U,O){const _=new m(O);return W.connect(N,F,A,U,(Y,ie)=>{_.didTimeout?(Y&&q.error(Y),ie?.dispose()):Y||!ie?_.reject(Y):_.resolve(ie)}),_.promise}function u(q,W){const N=new m(W);return q.then(F=>{N.didTimeout||N.resolve(F)},F=>{N.didTimeout||N.reject(F)}),N.promise}async function g(q,W,N,F){const A=z(q,W);q.logService.trace(`${A} 1/6. invoking socketFactory.connect().`);let U;try{U=await P(q.logService,q.socketFactory,q.host,q.port,`reconnectionToken=${q.reconnectionToken}&reconnection=${q.reconnectionProtocol?"true":"false"}`,`renderer-${f(W)}-${q.reconnectionToken}`,F)}catch(oe){throw q.logService.error(`${A} socketFactory.connect() failed or timed out. Error:`),q.logService.error(oe),oe}q.logService.trace(`${A} 2/6. socketFactory.connect() was successful.`);let O,_;q.reconnectionProtocol?(q.reconnectionProtocol.beginAcceptReconnection(U,null),O=q.reconnectionProtocol,_=!1):(O=new S.PersistentProtocol(U,null),_=!0),q.logService.trace(`${A} 3/6. sending AuthRequest control message.`);const Y=await u(q.signService.createNewMessage((0,w.generateUuid)()),F),ie={type:"auth",auth:q.connectionToken||"00000000000000000000",data:Y.data};O.sendControl(n.VSBuffer.fromString(JSON.stringify(ie)));try{const oe=await v(O,d(F,t(1e4)));if(oe.type!=="sign"||typeof oe.data!="string"){const he=new Error("Unexpected handshake message");throw he.code="VSCODE_CONNECTION_ERROR",he}if(q.logService.trace(`${A} 4/6. received SignRequest control message.`),!await u(q.signService.validate(Y,oe.signedData),F)){const he=new Error("Refused to connect to unsupported server");throw he.code="VSCODE_CONNECTION_ERROR",he}const ce=await u(q.signService.sign(oe.data),F),le={type:"connectionType",commit:q.commit,signedData:ce,desiredConnectionType:W};return N&&(le.args=N),q.logService.trace(`${A} 5/6. sending ConnectionTypeRequest control message.`),O.sendControl(n.VSBuffer.fromString(JSON.stringify(le))),{protocol:O,ownsProtocol:_}}catch(oe){throw oe&&oe.code==="ETIMEDOUT"&&(q.logService.error(`${A} the handshake timed out. Error:`),q.logService.error(oe)),oe&&oe.code==="VSCODE_CONNECTION_ERROR"&&(q.logService.error(`${A} received error control message when negotiating connection. Error:`),q.logService.error(oe)),_&&H(O),oe}}async function c(q,W,N,F){const A=Date.now(),U=z(q,W),{protocol:O,ownsProtocol:_}=await g(q,W,N,F),Y=new m(F);return Y.registerDisposable(O.onControlMessage(ie=>{const oe=JSON.parse(ie.toString()),J=K(oe);J?(q.logService.error(`${U} received error control message when negotiating connection. Error:`),q.logService.error(J),_&&H(O),Y.reject(J)):(q.reconnectionProtocol&&q.reconnectionProtocol.endAcceptReconnection(),q.logService.trace(`${U} 6/6. handshake finished, connection is up and running after ${G(A)}!`),Y.resolve({protocol:O,firstMessage:oe}))})),Y.promise}async function o(q,W){const{protocol:N}=await c(q,1,void 0,W);return{protocol:N}}async function l(q,W,N){const{protocol:F,firstMessage:A}=await c(q,2,W,N),U=A&&A.debugPort;return{protocol:F,debugPort:U}}async function s(q,W,N){const F=Date.now(),A=z(q,3),{protocol:U}=await g(q,3,W,N);return q.logService.trace(`${A} 6/6. handshake finished, connection is up and running after ${G(F)}!`),U}async function i(q,W,N){const{host:F,port:A,connectionToken:U}=await q.addressProvider.getAddress();return{commit:q.commit,host:F,port:A,connectionToken:U,reconnectionToken:W,reconnectionProtocol:N,socketFactory:q.socketFactory,signService:q.signService,logService:q.logService}}async function r(q,W,N){try{const F=(0,w.generateUuid)(),A=await i(q,F,null),{protocol:U}=await o(A,D.CancellationToken.None);return new V(q,W,N,F,U)}catch(F){throw q.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),q.logService.error(F),re.triggerPermanentFailure(0,0,b.RemoteAuthorityResolverError.isHandled(F)),F}}e.connectRemoteAgentManagement=r;async function a(q,W){try{const N=(0,w.generateUuid)(),F=await i(q,N,null),{protocol:A,debugPort:U}=await l(F,W,D.CancellationToken.None);return new Z(q,W,N,A,U)}catch(N){throw q.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),q.logService.error(N),re.triggerPermanentFailure(0,0,b.RemoteAuthorityResolverError.isHandled(N)),N}}e.connectRemoteAgentExtensionHost=a;async function h(q,W,N){const F=await i(q,(0,w.generateUuid)(),null);return await s(F,{host:W,port:N},D.CancellationToken.None)}e.connectRemoteAgentTunnel=h;function I(q){return(0,p.createCancelablePromise)(W=>new Promise((N,F)=>{const A=setTimeout(N,q*1e3);W.onCancellationRequested(()=>{clearTimeout(A),N()})}))}var R;(function(q){q[q.ConnectionLost=0]="ConnectionLost",q[q.ReconnectionWait=1]="ReconnectionWait",q[q.ReconnectionRunning=2]="ReconnectionRunning",q[q.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",q[q.ConnectionGain=4]="ConnectionGain"})(R=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class L{constructor(W,N){this.reconnectionToken=W,this.millisSinceLastIncomingData=N,this.type=0}}e.ConnectionLostEvent=L;class T{constructor(W,N,F,A){this.reconnectionToken=W,this.millisSinceLastIncomingData=N,this.durationSeconds=F,this.cancellableTimer=A,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=T;class ${constructor(W,N,F){this.reconnectionToken=W,this.millisSinceLastIncomingData=N,this.attempt=F,this.type=2}}e.ReconnectionRunningEvent=$;class Q{constructor(W,N,F){this.reconnectionToken=W,this.millisSinceLastIncomingData=N,this.attempt=F,this.type=4}}e.ConnectionGainEvent=Q;class se{constructor(W,N,F,A){this.reconnectionToken=W,this.millisSinceLastIncomingData=N,this.attempt=F,this.handled=A,this.type=3}}e.ReconnectionPermanentFailureEvent=se;class re extends E.Disposable{constructor(W,N,F,A){super();this._connectionType=W,this._onDidStateChange=this._register(new k.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=N,this.reconnectionToken=F,this.protocol=A,this._isReconnecting=!1,this._onDidStateChange.fire(new Q(this.reconnectionToken,0,0)),this._register(A.onSocketClose(U=>{const O=B(this._connectionType,this.reconnectionToken,!0);U?U.type===0?(this._options.logService.info(`${O} received socket close event (hadError: ${U.hadError}).`),U.error&&this._options.logService.error(U.error)):(this._options.logService.info(`${O} received socket close event (wasClean: ${U.wasClean}, code: ${U.code}, reason: ${U.reason}).`),U.event&&this._options.logService.error(U.event)):this._options.logService.info(`${O} received socket close event.`),this._beginReconnecting()})),this._register(A.onSocketTimeout(()=>{const U=B(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${U} received socket timeout event.`),this._beginReconnecting()})),re._instances.push(this),re._permanentFailure&&this._gotoPermanentFailure(re._permanentFailureMillisSinceLastIncomingData,re._permanentFailureAttempt,re._permanentFailureHandled)}static triggerPermanentFailure(W,N,F){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=W,this._permanentFailureAttempt=N,this._permanentFailureHandled=F,this._instances.forEach(A=>A._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(W=>W._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(W=>W._pauseSocketWriting())}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(re._permanentFailure)return;const W=B(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${W} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new L(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const N=[0,5,5,10,10,10,10,10,30];let F=-1;do{F++;const A=F<N.length?N[F]:N[N.length-1];try{if(A>0){const O=I(A);this._onDidStateChange.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),A,O)),this._options.logService.info(`${W} waiting for ${A} seconds before reconnecting...`);try{await O}catch{}}if(re._permanentFailure){this._options.logService.error(`${W} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new $(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1)),this._options.logService.info(`${W} resolving connection...`);const U=await i(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${W} connecting to ${U.host}:${U.port}...`),await this._reconnect(U,t(M)),this._options.logService.info(`${W} reconnected!`),this._onDidStateChange.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1));break}catch(U){if(U.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${W} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(U),re.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(F>360){this._options.logService.error(`${W} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(U),re.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(b.RemoteAuthorityResolverError.isTemporarilyNotAvailable(U)){this._options.logService.info(`${W} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(U);continue}if((U.code==="ETIMEDOUT"||U.code==="ENETUNREACH"||U.code==="ECONNREFUSED"||U.code==="ECONNRESET")&&U.syscall==="connect"){this._options.logService.info(`${W} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(U);continue}if((0,C.isCancellationError)(U)){this._options.logService.info(`${W} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(U);continue}if(U instanceof b.RemoteAuthorityResolverError){this._options.logService.error(`${W} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(U),re.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,b.RemoteAuthorityResolverError.isHandled(U));break}this._options.logService.error(`${W} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(U),re.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}}while(!re._permanentFailure)}_gotoPermanentFailure(W,N,F){this._onDidStateChange.fire(new se(this.reconnectionToken,W,N,F)),H(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=re,re._permanentFailure=!1,re._permanentFailureMillisSinceLastIncomingData=0,re._permanentFailureAttempt=0,re._permanentFailureHandled=!1,re._instances=[];class V extends re{constructor(W,N,F,A,U){super(1,W,A,U);this.client=this._register(new S.Client(U,{remoteAuthority:N,clientId:F},W.ipcLogger))}async _reconnect(W,N){await o(W,N)}}e.ManagementPersistentConnection=V;class Z extends re{constructor(W,N,F,A,U){super(2,W,F,A);this._startArguments=N,this.debugPort=U}async _reconnect(W,N){await l(W,this._startArguments,N)}}e.ExtensionHostPersistentConnection=Z;function H(q){try{q.acceptDisconnect();const W=q.getSocket();q.dispose(),W.dispose()}catch(W){(0,C.onUnexpectedError)(W)}}function K(q){if(q&&q.type==="error"){const W=new Error(`Connection error: ${q.reason}`);return W.code="VSCODE_CONNECTION_ERROR",W}return null}function x(q,W){for(;q.length<W;)q+=" ";return q}function B(q,W,N){return`[remote-connection][${x(f(q),13)}][${W.substr(0,5)}\u2026][${N?"reconnect":"initial"}]`}function z(q,W){return`${B(W,q.reconnectionToken,!!q.reconnectionProtocol)}[${q.host}:${q.port}]`}function G(q){return`${Date.now()-q} ms`}}),define(ee[65],te([0,1,10]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function n(S){return S.scheme===p.Schemas.vscodeRemote?S.authority:void 0}e.getRemoteAuthority=n;function D(S){if(!S)return;const b=S.indexOf("+");return b<0?S:S.substr(0,b)}e.getRemoteName=D;function C(S){return S.scheme!==p.Schemas.file&&S.scheme!==p.Schemas.vscodeRemote}e.isVirtualResource=C;function k(S){if(S.folders.length)return S.folders.every(b=>C(b.uri))?S.folders[0].uri:void 0;if(S.configuration&&C(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=k;function E(S){return k(S)?.scheme}e.getVirtualWorkspaceScheme=E;function w(S){return k(S)!==void 0}e.isVirtualWorkspace=w}),define(ee[203],te([0,1,25,5,65]),function(j,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.getWorkspaceSupportTypeMessage=C;function k(y){return y&&typeof y=="object"&&typeof y.id=="string"&&(!y.uuid||typeof y.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var E;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(E=e.ExtensionType||(e.ExtensionType={}));class w{constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,t){if(typeof f=="undefined"||f===null)return typeof t=="undefined"||t===null;if(typeof t=="undefined"||t===null)return!1;if(typeof f=="string"||typeof t=="string"){let d=typeof f=="string"?f:f.value,m=typeof t=="string"?t:t.value;return p.equalsIgnoreCase(d,m)}return f._lower===t._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.ExtensionIdentifier=w;function S(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function b(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=b;function M(y,f){if(f){const t=`onResolveRemoteAuthority:${(0,D.getRemoteName)(f)}`;return y.activationEvents?.indexOf(t)!==-1}return!1}e.isResolverExtension=M,e.IBuiltinExtensionsScannerService=(0,n.createDecorator)("IBuiltinExtensionsScannerService")}),define(ee[98],te([0,1,25,203]),function(j,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(t,d){return t.uuid&&d.uuid?t.uuid===d.uuid:t.id===d.id?!0:(0,p.compareIgnoreCase)(t.id,d.id)===0}e.areSameExtensions=D;class C{constructor(d,m){this.version=m,this.id=d.id,this.uuid=d.uuid}key(){return`${this.id}-${this.version}`}equals(d){return d instanceof C?D(this,d)&&this.version===d.version:!1}}e.ExtensionIdentifierWithVersion=C;function k(t,d){return`${t}.${d}`}e.getExtensionId=k;function E(t){return t.toLocaleLowerCase()}e.adoptToGalleryExtensionId=E;function w(t,d){return E(k(t,d))}e.getGalleryExtensionId=w;function S(t,d){const m=[],v=P=>{for(const u of m)if(u.some(g=>D(d(g),d(P))))return u;return null};for(const P of t){const u=v(P);u?u.push(P):m.push([P])}return m}e.groupByExtension=S;function b(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function M(t){return{id:t.identifier.id,name:t.name,galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),...t.telemetryData}}e.getGalleryExtensionTelemetryData=M,e.BetterMergeId=new n.ExtensionIdentifier("pprice.better-merge");function y(t){const d=new Set;if(t.malicious)for(const m of t.malicious)d.add(m.id);return d}e.getMaliciousExtensionsSet=y;function f(t,d){const m=[],v=d.manifest.extensionDependencies?.slice(0)??[];for(;v.length;){const P=v.shift();if(P&&m.every(u=>!D(u.identifier,{id:P}))){const u=t.filter(g=>D(g.identifier,{id:P}));u.length===1&&(m.push(u[0]),v.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return m}e.getExtensionDependencies=f}),define(ee[204],te([0,1,10,144,98,5]),function(j,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.getIdAndVersion=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";const k=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function E(o){const l=k.exec(o);return l&&l[1]?[(0,D.adoptToGalleryExtensionId)(l[1]),l[2]]:[(0,D.adoptToGalleryExtensionId)(o),void 0]}e.getIdAndVersion=E;var w;(function(o){o.WIN32_X64="win32-x64",o.WIN32_IA32="win32-ia32",o.WIN32_ARM64="win32-arm64",o.LINUX_X64="linux-x64",o.LINUX_ARM64="linux-arm64",o.LINUX_ARMHF="linux-armhf",o.ALPINE_X64="alpine-x64",o.ALPINE_ARM64="alpine-arm64",o.DARWIN_X64="darwin-x64",o.DARWIN_ARM64="darwin-arm64",o.WEB="web",o.UNIVERSAL="universal",o.UNKNOWN="unknown",o.UNDEFINED="undefined"})(w=e.TargetPlatform||(e.TargetPlatform={}));function S(o){switch(o){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=S;function b(o){switch(o){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=b;function M(o,l){switch(o){case 3:return l==="x64"?"win32-x64":l==="ia32"?"win32-ia32":l==="arm64"?"win32-arm64":"unknown";case 2:return l==="x64"?"linux-x64":l==="arm64"?"linux-arm64":l==="arm"?"linux-armhf":"unknown";case"alpine":return l==="x64"?"alpine-x64":l==="arm64"?"alpine-arm64":"unknown";case 1:return l==="x64"?"darwin-x64":l==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=M;function y(o,l){return l==="web"&&!o.includes("web")}e.isNotWebExtensionInWebTargetPlatform=y;function f(o,l,s){return y(l,s)?!1:o==="undefined"||o==="universal"?!0:o==="unknown"?!1:o===s?!0:t(s).includes(o)}e.isTargetPlatformCompatible=f;function t(o){switch(o){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=t;function d(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}e.isIExtensionIdentifier=d;var m;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(m=e.SortBy||(e.SortBy={}));var v;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(v=e.SortOrder||(e.SortOrder={}));var P;(function(o){o.Install="install",o.Uninstall="uninstall"})(P=e.StatisticType||(e.StatisticType={}));var u;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})(u=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService");var g;(function(o){o.Unsupported="Unsupported",o.UnsupportedPreRelease="UnsupportedPreRelease",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatiblePreRelease="IncompatiblePreRelease",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.ReleaseVersionNotFound="ReleaseVersionNotFound",o.Invalid="Invalid",o.Download="Download",o.Extract="Extract",o.Delete="Delete",o.Rename="Rename",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Internal="Internal"})(g=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class c extends Error{constructor(l,s){super(l);this.code=s,this.name=s}}e.ExtensionManagementError=c,e.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=p.FileAccess.asBrowserUri("./media/defaultIcon.png",j).toString(!0),e.ExtensionsLabel=(0,n.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,n.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,C.createDecorator)("IExtensionManagementCLIService")}),define(ee[99],te([0,1,4,3,5,6]),function(j,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var k;(function(t){t.Http="http",t.Https="https"})(k=e.TunnelProtocol||(e.TunnelProtocol={}));var E;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(E=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var w;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(w=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function S(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=S,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=b,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function M(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=M;function y(t,d){return d?d!==1&&t<1024:!n.isWindows&&t<1024}e.isPortPrivileged=y;let f=class{constructor(d){this.logService=d,this._onTunnelOpened=new p.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new p.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new p.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(d){return this._tunnelProvider=d,d?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(d){this._canElevate=d.elevation,this._privacyOptions=d.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const d=[],m=Array.from(this._tunnels.values());for(let v of m){const P=Array.from(v.values());for(let u of P){const g=await u.value;g&&d.push(g)}}return d}async dispose(){for(const d of this._tunnels.values()){for(const{value:m}of d.values())await m.then(v=>v?.dispose());d.clear()}this._tunnels.clear()}openTunnel(d,m,v,P,u=!1,g=E.Private,c){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${m}:${v} on local port ${P}.`),!d)return;m||(m="localhost");const o=this.retainOrCreateTunnel(d,m,v,P,u,g,c);return o?o.then(l=>{if(!l){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(m,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(l);return(l.tunnelRemoteHost!==m||l.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}makeTunnel(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,privacy:d.privacy,protocol:d.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const m=this._tunnels.get(d.tunnelRemoteHost);if(m){const v=m.get(d.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(d.tunnelRemoteHost,d.tunnelRemotePort,v))}}}}async tryDisposeTunnel(d,m,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${m}.`);const P=v.value.then(async u=>{u&&(await u.dispose(!0),this._onTunnelClosed.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this._tunnels.has(d)&&this._tunnels.get(d).delete(m),P}}async closeTunnel(d,m){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${m} `);const v=this._tunnels.get(d);if(v&&v.has(m)){const P=v.get(m);P.refcount=0,await this.tryDisposeTunnel(d,m,P)}}addTunnelToMap(d,m,v){this._tunnels.has(d)||this._tunnels.set(d,new Map),this._tunnels.get(d).set(m,{refcount:1,value:v})}async removeEmptyTunnelFromMap(d,m){const v=this._tunnels.get(d);v&&(await v.get(m)||v.delete(m),v.size===0&&this._tunnels.delete(d))}getTunnelFromMap(d,m){let v=[d];b(d)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):M(d)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const P=v.map(u=>this._tunnels.get(u));for(const u of P){const g=u?.get(m);if(g)return g}}canTunnel(d){return!!S(d)}createWithProvider(d,m,v,P,u,g,c){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${m}:${v} on local port ${P}.`);const l={elevationRequired:u?y(P===void 0?v:P):!1},s={remoteAddress:{host:m,port:v},localAddressPort:P,privacy:g,public:g!==E.Private,protocol:c},i=d.forwardPort(s,l);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(m,v,i),i}};f=de([ne(0,C.ILogService)],f),e.AbstractTunnelService=f}),define(ee[49],te([0,1,17,155,56,5,40]),function(j,e,p,n,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,C.createDecorator)("requestService");function E(t){return t.res.statusCode&&t.res.statusCode>=200&&t.res.statusCode<300||t.res.statusCode===1223}e.isSuccess=E;function w(t){return t.res.statusCode===204}async function S(t){if(!E(t))throw new Error("Server returned "+t.res.statusCode);return w(t)?null:(await(0,p.streamToBuffer)(t.stream)).toString()}e.asText=S;async function b(t){if(!E(t))throw new Error("Server returned "+t.res.statusCode);if(w(t))return null;const m=(await(0,p.streamToBuffer)(t.stream)).toString();try{return JSON.parse(m)}catch(v){throw v.message+=`:
`+m,v}}e.asJson=b;function M(t){f(t)}e.updateProxyConfigurationsScope=M;let y;function f(t){const d=k.Registry.as(D.Extensions.Configuration),m=y;y={id:"http",order:15,title:(0,n.localize)(0,null),type:"object",scope:t,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,n.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,n.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,n.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,n.localize)(4,null),(0,n.localize)(5,null),(0,n.localize)(6,null),(0,n.localize)(7,null)],default:"override",description:(0,n.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,n.localize)(9,null),restricted:!0}}},d.updateConfigurations({add:[y],remove:m?[m]:[]})}f(2)}),define(ee[205],te([0,1,206,13]),function(j,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function D(k,E){return k.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:k.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function C(k,E,w={}){const S=(0,p.parse)(k),b=w.proxyUrl||D(S,E);if(!b)return null;const M=(0,p.parse)(b);if(!/^https?:$/.test(M.protocol||""))return null;const y={host:M.hostname||"",port:M.port||(M.protocol==="https"?"443":"80"),auth:M.auth,rejectUnauthorized:(0,n.isBoolean)(w.strictSSL)?w.strictSSL:!0};return S.protocol==="http:"?new(await new Promise((f,t)=>{j(["http-proxy-agent"],f,t)}))(y):new(await new Promise((f,t)=>{j(["https-proxy-agent"],f,t)}))(y)}e.getProxyAgent=C}),define(ee[207],te([0,1,17,32]),function(j,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(C,k,E){let w=E&&E.get("storage.serviceMachineId",0)||null;if(w)return w;try{const b=(await k.readFile(C.serviceMachineIdResource)).value.toString();w=(0,n.isUUID)(b)?b:null}catch{w=null}if(!w){w=(0,n.generateUuid)();try{await k.writeFile(C.serviceMachineIdResource,p.VSBuffer.fromString(w))}catch{}}return E&&E.store("storage.serviceMachineId",w,0,1),w}e.getServiceMachineId=D}),define(ee[78],te([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,p.createDecorator)(e.SIGN_SERVICE_ID)}),define(ee[208],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class p{constructor(){this.validators=new Map}vsda(){return new Promise((D,C)=>j(["vsda"],D,C))}async createNewMessage(D){try{const C=await this.vsda(),k=new C.validator;if(k){const E=String(p._nextId++);return this.validators.set(E,k),{id:E,data:k.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,C){if(!D.id)return!0;const k=this.validators.get(D.id);if(!k)return!1;this.validators.delete(D.id);try{return k.validate(C)==="ok"}catch{return!1}}async sign(D){try{const C=await this.vsda(),k=new C.signer;if(k)return k.sign(D)}catch{}return D}}e.SignService=p,p._nextId=1}),define(ee[38],te([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,p.createDecorator)("stateMainService")}),define(ee[20],te([0,1,14,8,4,2,3,35,13,5,187,6,38]),function(j,e,p,n,D,C,k,E,w,S,b,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,S.createDecorator)("lifecycleMainService");var f;(function(d){d[d.Starting=1]="Starting",d[d.Ready=2]="Ready",d[d.AfterWindowOpen=3]="AfterWindowOpen"})(f=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let t=class wt extends C.Disposable{constructor(m,v){super();this.logService=m,this.stateMainService=v,this._onBeforeShutdown=this._register(new D.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new D.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new D.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new D.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new D.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(wt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(wt.QUIT_AND_RESTART_KEY)}registerListeners(){const m=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),k.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown())};p.app.addListener("before-quit",m);const v=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!k.isMacintosh)&&p.app.quit()};p.app.addListener("window-all-closed",v),p.app.once("will-quit",P=>{this.logService.trace("Lifecycle#app.on(will-quit)"),P.preventDefault(),this.fireOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),p.app.removeListener("before-quit",m),p.app.removeListener("window-all-closed",v),p.app.quit()})})}fireOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const m=[];return this._onWillShutdown.fire({join(v){m.push(v)}}),this.pendingWillShutdownPromise=(async()=>{try{await n.Promises.settled(m)}catch(v){this.logService.error(v)}try{await this.stateMainService.close()}catch(v){this.logService.error(v)}})(),this.pendingWillShutdownPromise}set phase(m){if(m<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===m)return;this.logService.trace(`lifecycle (main): phase changed (value: ${m})`),this._phase=m;const v=this.phaseWhen.get(this._phase);v&&(v.open(),this.phaseWhen.delete(this._phase))}async when(m){if(m<=this._phase)return;let v=this.phaseWhen.get(m);v||(v=new n.Barrier,this.phaseWhen.set(m,v)),await v.wait()}registerWindow(m){const v=new C.DisposableStore;this.windowCounter++,v.add(m.onWillLoad(u=>this._onWillLoadWindow.fire({window:m,workspace:u.workspace,reason:u.reason})));const P=(0,w.assertIsDefined)(m.win);P.on("close",u=>{const g=m.id;if(this.windowToCloseRequest.has(g)){this.windowToCloseRequest.delete(g);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${m.id}`),u.preventDefault(),this.unload(m,1).then(c=>{if(c){this.windowToCloseRequest.delete(g);return}this.windowToCloseRequest.add(g),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${g}`),this._onBeforeCloseWindow.fire(m),m.close()})}),P.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${m.id}`),this.windowCounter--,v.dispose(),this.windowCounter===0&&(!k.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown()})}async reload(m,v){await this.unload(m,3)||m.reload(v)}async unload(m,v){if(!m.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${m.id}`);const P=this._quitRequested?2:v;let u=await this.onBeforeUnloadWindowInRenderer(m,P);return u?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${m.id})`),this.handleWindowUnloadVeto(u)):(u=await this.onBeforeUnloadWindowInMain(m,P),u?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${m.id})`),this.handleWindowUnloadVeto(u)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${m.id})`),await this.onWillUnloadWindowInRenderer(m,P),!1))}handleWindowUnloadVeto(m){return m?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(m){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(m),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(m,v){return new Promise(P=>{const u=this.oneTimeListenerTokenGenerator++,g=`vscode:ok${u}`,c=`vscode:cancel${u}`;p.ipcMain.once(g,()=>{P(!1)}),p.ipcMain.once(c,()=>{P(!0)}),m.send("vscode:onBeforeUnload",{okChannel:g,cancelChannel:c,reason:v})})}onBeforeUnloadWindowInMain(m,v){const P=[];return this._onBeforeUnloadWindow.fire({reason:v,window:m,veto(u){P.push(u)}}),(0,b.handleVetos)(P,u=>this.logService.error(u))}onWillUnloadWindowInRenderer(m,v){return new Promise(P=>{const g=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;p.ipcMain.once(g,()=>P()),m.send("vscode:onWillUnload",{replyChannel:g,reason:v})})}quit(m){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${m}`),m&&this.stateMainService.setItem(wt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(v=>{this.pendingQuitPromiseResolve=v,this.logService.trace("Lifecycle#quit() - calling app.quit()"),p.app.quit()}),this.pendingQuitPromise)}async relaunch(m){this.logService.trace("Lifecycle#relaunch()");const v=process.argv.slice(1);if(m?.addArgs&&v.push(...m.addArgs),m?.removeArgs)for(const g of m.removeArgs){const c=v.indexOf(g);c>=0&&v.splice(c,1)}const P=()=>{try{if(k.isWindows){const g=(0,E.cwd)();g!==process.cwd()&&process.chdir(g)}}catch(g){this.logService.error(g)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),p.app.relaunch({args:v})};p.app.once("quit",P),await this.quit(!0)&&p.app.removeListener("quit",P)}async kill(m){this.logService.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(),await Promise.race([(0,n.timeout)(1e3),(async()=>{for(const v of p.BrowserWindow.getAllWindows())if(v&&!v.isDestroyed()){let P;v.webContents&&!v.webContents.isDestroyed()?P=new Promise(u=>v.once("closed",u)):P=Promise.resolve(),v.destroy(),await P}})()]),p.app.exit(m)}};t.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",t=de([ne(0,M.ILogService),ne(1,y.IStateMainService)],t),e.LifecycleMainService=t}),define(ee[209],te([0,1,4,2,5,20]),function(j,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,D.createDecorator)("keyboardLayoutMainService");let k=class extends n.Disposable{constructor(S){super();this._onDidChangeKeyboardLayout=this._register(new p.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,S.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const S=await new Promise((b,M)=>{j(["native-keymap"],b,M)});this._keyboardLayoutData=E(S),S.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=E(S),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};k=de([ne(0,C.ILifecycleMainService)],k),e.KeyboardLayoutMainService=k;function E(w){const S=w.getKeyMap(),b=w.getCurrentKeyboardLayout();return{keyboardMapping:S,keyboardLayoutInfo:b}}}),define(ee[79],te([0,1,8,4,2,64,13,89,5]),function(j,e,p,n,D,C,k,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const S="__$__targetStorageMarker";e.IStorageService=(0,w.createDecorator)("storageService");var b;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(b=e.WillSaveStateReason||(e.WillSaveStateReason={}));var M;(function(m){m[m.GLOBAL=0]="GLOBAL",m[m.WORKSPACE=1]="WORKSPACE"})(M=e.StorageScope||(e.StorageScope={}));var y;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(y=e.StorageTarget||(e.StorageTarget={}));class f extends D.Disposable{constructor(v={flushInterval:f.DEFAULT_FLUSH_INTERVAL}){super();this.options=v,this._onDidChangeValue=this._register(new n.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new n.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new n.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new p.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,p.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,C.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,C.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(v,P){P===S?(v===0?this._globalKeyTargets=void 0:v===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:v})):this._onDidChangeValue.fire({scope:v,key:P,target:this.getKeyTargets(v)[P]})}emitWillSaveState(v){this._onWillSaveState.fire({reason:v})}get(v,P,u){return this.getStorage(P)?.get(v,u)}getBoolean(v,P,u){return this.getStorage(P)?.getBoolean(v,u)}getNumber(v,P,u){return this.getStorage(P)?.getNumber(v,u)}store(v,P,u,g){if((0,k.isUndefinedOrNull)(P)){this.remove(v,u);return}this.withPausedEmitters(()=>{this.updateKeyTarget(v,u,g),this.getStorage(u)?.set(v,P)})}remove(v,P){this.withPausedEmitters(()=>{this.updateKeyTarget(v,P,void 0),this.getStorage(P)?.delete(v)})}withPausedEmitters(v){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{v()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(v,P){const u=[],g=this.getKeyTargets(v);for(const c of Object.keys(g))g[c]===P&&u.push(c);return u}updateKeyTarget(v,P,u){const g=this.getKeyTargets(P);typeof u=="number"?g[v]!==u&&(g[v]=u,this.getStorage(P)?.set(S,JSON.stringify(g))):typeof g[v]=="number"&&(delete g[v],this.getStorage(P)?.set(S,JSON.stringify(g)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(v){return v===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(v){const P=this.get(S,v);if(P)try{return JSON.parse(P)}catch{}return Object.create(null)}isNew(v){return this.getBoolean(e.IS_NEW_KEY,v)===!0}async flush(v=b.NONE){this._onWillSaveState.fire({reason:v});const P=this.getStorage(0),u=this.getStorage(1);switch(v){case b.NONE:await p.Promises.settled([P?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await p.Promises.settled([P?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve()]);break}}async logStorage(){const v=this.getStorage(0)?.items??new Map,P=this.getStorage(1)?.items??new Map;return d(v,P,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=f,f.DEFAULT_FLUSH_INTERVAL=60*1e3;class t extends f{constructor(){super();this.globalStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(v=>this.emitDidChangeValue(1,v))),this._register(this.globalStorage.onDidChangeStorage(v=>this.emitDidChangeValue(0,v)))}getStorage(v){return v===0?this.globalStorage:this.workspaceStorage}getLogDetails(v){return v===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(v){}}e.InMemoryStorageService=t;async function d(m,v,P,u){const g=a=>{try{return JSON.parse(a)}catch{return a}},c=new Map,o=new Map;m.forEach((a,h)=>{c.set(h,a),o.set(h,g(a))});const l=new Map,s=new Map;v.forEach((a,h)=>{l.set(h,a),s.set(h,g(a))}),console.group(`Storage: Global (path: ${P})`);let i=[];c.forEach((a,h)=>{i.push({key:h,value:a})}),console.table(i),console.groupEnd(),console.log(o),console.group(`Storage: Workspace (path: ${u})`);let r=[];l.forEach((a,h)=>{r.push({key:h,value:a})}),console.table(r),console.groupEnd(),console.log(s)}e.logStorage=d}),define(ee[210],te([0,1,3,35,7,32]),function(j,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function k(S){if(p.platform===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}async function E(S,b,M,y,f,t,d,m,v,P){const u=Object.create(null);u["common.machineId"]=d,u.sessionID=(0,C.generateUuid)()+Date.now(),u.commitHash=f,u.version=t,u["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,p.PlatformToString)(p.platform),u["common.nodePlatform"]=n.platform,u["common.nodeArch"]=y,u["common.product"]=P||"desktop";const g=w(m||[]);g&&(u["common.msftInternal"]=g);let c=0;const o=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),p.isLinuxSnap&&(u["common.snap"]="true");const l=k(M);l&&(u["common.platformDetail"]=l);try{const s=await S.readFile(D.URI.file(v));u["common.source"]=s.value.toString().slice(0,30)}catch{}return u}e.resolveCommonProperties=E;function w(S){const b=n.env.USERDNSDOMAIN;if(!b)return!1;const M=b.toLowerCase();return S.some(y=>M===y)}e.verifyMicrosoftInternalDomain=w}),define(ee[31],te([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,p.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,p.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var n;(function(C){C[C.NONE=0]="NONE",C[C.CRASH=1]="CRASH",C[C.ERROR=2]="ERROR",C[C.USAGE=3]="USAGE"})(n=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(C){C.OFF="off",C.CRASH="crash",C.ERROR="error",C.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ee[211],te([0,1,26,70,8,44,10,9,3,7,73,24,86,75,18,22,31]),function(j,e,p,n,D,C,k,E,w,S,b,M,y,f,t,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function v(o,l){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],i=new Map,r=new Map,a=2e4;function h(L,T,$,Q){const se=T.substring(L.length+1);return D.Promises.withAsyncBody(async re=>{let V;try{V=await M.Promises.readdir(T,{withFileTypes:!0})}catch{re();return}if(Q.count>=a){Q.count+=V.length,Q.maxReached=!0,re();return}let Z=V.length;if(Z===0){re();return}let H=V;Q.count+V.length>a&&(Q.maxReached=!0,Z=a-Q.count,H=V.slice(0,Z)),Q.count+=V.length;for(const K of H)if(K.isDirectory()){if($.includes(K.name)||await h(L,(0,E.join)(T,K.name),$,Q),--Z==0){re();return}}else{const x=K.name.lastIndexOf(".");if(x>=0){const B=K.name.substring(x+1);B&&i.set(B,(i.get(B)??0)+1)}for(const B of s)B.relativePathPattern?.test(se)!==!1&&B.filePattern.test(K.name)&&r.set(B.tag,(r.get(B.tag)??0)+1);if(--Z==0){re();return}}})}const I={count:0,maxReached:!1};await h(o,o,l,I);const R=await g(o);return{configFiles:P(r),fileTypes:P(i),fileCount:I.count,maxFilesReached:I.maxReached,launchConfigFiles:R}}e.collectWorkspaceStats=v;function P(o){return[...n.Iterable.map(o.entries(),([l,s])=>({name:l,count:s}))].sort((l,s)=>s.count-l.count)}function u(){const o={os:`${p.type()} ${p.arch()} ${p.release()}`,memory:`${(p.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(b.virtualMachineHint.value()*100)}%`},l=p.cpus();return l&&l.length>0&&(o.cpus=`${l[0].model} (${l.length} x ${l[0].speed})`),o}e.getMachineInfo=u;async function g(o){try{const l=new Map,s=(0,E.join)(o,".vscode","launch.json"),i=await M.Promises.readFile(s),r=[],a=(0,C.parse)(i.toString(),r);if(r.length)return console.log(`Unable to parse ${s}`),[];if((0,C.getNodeType)(a)==="object"&&a.configurations)for(const h of a.configurations){const I=h.type;I&&(l.has(I)?l.set(I,l.get(I)+1):l.set(I,1))}return P(l)}catch{return[]}}e.collectLaunchConfigs=g;let c=class{constructor(l,s){this.telemetryService=l,this.productService=s}formatMachineInfo(l){const s=[];return s.push(`OS Version:       ${l.os}`),s.push(`CPUs:             ${l.cpus}`),s.push(`Memory (System):  ${l.memory}`),s.push(`VM:               ${l.vmHint}`),s.join(`
`)}formatEnvironment(l){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${p.type()} ${p.arch()} ${p.release()}`);const i=p.cpus();return i&&i.length>0&&s.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),s.push(`Memory (System):  ${(p.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`),w.isWindows||s.push(`Load (avg):       ${p.loadavg().map(r=>Math.round(r)).join(", ")}`),s.push(`VM:               ${Math.round(b.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${l.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${l.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(l.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(l,s){return Promise.all([(0,y.listProcesses)(l.mainPID),this.formatWorkspaceMetadata(l)]).then(async i=>{let[r,a]=i,h=this.formatProcessList(l,r);return s.forEach(I=>{if((0,f.isRemoteDiagnosticError)(I))h+=`
${I.errorMessage}`,a+=`
${I.errorMessage}`;else if(h+=`

Remote: ${I.hostName}`,I.processes&&(h+=`
${this.formatProcessList(l,I.processes)}`),I.workspaceMetadata){a+=`
|  Remote: ${I.hostName}`;for(const R of Object.keys(I.workspaceMetadata)){const L=I.workspaceMetadata[R];let T=`${L.fileCount} files`;L.maxFilesReached&&(T=`more than ${T}`),a+=`|    Folder (${R}): ${T}`,a+=this.formatWorkspaceStats(L)}}}),{processInfo:h,workspaceInfo:a}})}async getSystemInfo(l,s){const{memory:i,vmHint:r,os:a,cpus:h}=u(),I={os:a,memory:i,cpus:h,vmHint:r,processArgs:`${l.mainArguments.join(" ")}`,gpuStatus:l.gpuFeatureStatus,screenReader:`${l.screenReader?"yes":"no"}`,remoteData:s};return w.isWindows||(I.load=`${p.loadavg().map(R=>Math.round(R)).join(", ")}`),w.isLinux&&(I.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(I)}async getDiagnostics(l,s){const i=[];return(0,y.listProcesses)(l.mainPID).then(async r=>(i.push(""),i.push(this.formatEnvironment(l)),i.push(""),i.push(this.formatProcessList(l,r)),l.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(l))),s.forEach(a=>{if((0,f.isRemoteDiagnosticError)(a))i.push(`
${a.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${a.hostName}`),i.push(this.formatMachineInfo(a.machineInfo)),a.processes&&i.push(this.formatProcessList(l,a.processes)),a.workspaceMetadata)for(const h of Object.keys(a.workspaceMetadata)){const I=a.workspaceMetadata[h];let R=`${I.fileCount} files`;I.maxFilesReached&&(R=`more than ${R}`),i.push(`Folder (${h}): ${R}`),i.push(this.formatWorkspaceStats(I))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(l){const s=[],i=60;let r=0;const a=(L,T)=>{const $=` ${L}(${T})`;r+$.length>i?(s.push(h),h="|                 ",r=h.length):r+=$.length,h+=$};let h="|      File types:";const I=10;let R=l.fileTypes.length>I?I:l.fileTypes.length;for(let L=0;L<R;L++){const T=l.fileTypes[L];a(T.name,T.count)}if(s.push(h),l.configFiles.length>=0&&(h="|      Conf files:",r=0,l.configFiles.forEach(L=>{a(L.name,L.count)}),s.push(h)),l.launchConfigFiles.length>0){let L="|      Launch Configs:";l.launchConfigFiles.forEach(T=>{L+=T.count>1?` ${T.name}(${T.count})`:` ${T.name}`}),s.push(L)}return s.join(`
`)}expandGPUFeatures(l){const s=Math.max(...Object.keys(l).map(i=>i.length));return Object.keys(l).map(i=>`${i}:  ${" ".repeat(s-i.length)}  ${l[i]}`).join(`
                  `)}formatWorkspaceMetadata(l){const s=[],i=[];return l.windows.forEach(r=>{r.folderURIs.length===0||!!r.remoteAuthority||(s.push(`|  Window (${r.title})`),r.folderURIs.forEach(a=>{const h=S.URI.revive(a);if(h.scheme===k.Schemas.file){const I=h.fsPath;i.push(v(I,["node_modules",".git"]).then(R=>{let L=`${R.fileCount} files`;R.maxFilesReached&&(L=`more than ${L}`),s.push(`|    Folder (${(0,E.basename)(I)}): ${L}`),s.push(this.formatWorkspaceStats(R))}).catch(R=>{s.push(`|      Error: Unable to collect workspace stats for folder ${I} (${R.toString()})`)}))}else s.push(`|    Folder (${h.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(r=>s.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}formatProcessList(l,s){const i=new Map;l.windows.forEach(a=>i.set(a.pid,a.title));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(l.mainPID,i,r,s,0),r.join(`
`)}formatProcessItem(l,s,i,r,a){const h=a===0;let I;h?I=r.pid===l?`${this.productService.applicationName} main`:"remote agent":(I=`${"  ".repeat(a)} ${r.name}`,r.name==="window"&&(I=`${I} (${s.get(r.pid)})`));const R=process.platform==="win32"?r.mem:p.totalmem()*(r.mem/100);i.push(`${r.load.toFixed(0).padStart(5," ")}	${(R/t.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${I}`),Array.isArray(r.children)&&r.children.forEach(L=>this.formatProcessItem(l,s,i,L,a+1))}async reportWorkspaceStats(l){for(const{uri:s}of l.folders){const i=S.URI.revive(s);if(i.scheme!==k.Schemas.file)continue;const r=i.fsPath;try{const a=await v(r,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":l.telemetryId,rendererSessionId:l.rendererSessionId}),a.fileTypes.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:l.rendererSessionId,type:h.name,count:h.count})}),a.launchConfigFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:l.rendererSessionId,type:h.name,count:h.count})}),a.configFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:l.rendererSessionId,type:h.name,count:h.count})})}catch{}}}};c=de([ne(0,m.ITelemetryService),ne(1,d.IProductService)],c),e.DiagnosticsService=c}),define(ee[212],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class p{constructor(C){this.appenders=C}listen(C,k){throw new Error(`Event not found: ${k}`)}call(C,k,{eventName:E,data:w}){return this.appenders.forEach(S=>S.log(E,w)),Promise.resolve(null)}}e.TelemetryAppenderChannel=p;class n{constructor(C){this.channel=C}log(C,k){return this.channel.call("log",{eventName:C,data:k}).then(void 0,E=>`Failed to log telemetry: ${console.warn(E)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=n}),define(ee[66],te([0,1,47,13,19,31]),function(j,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class k{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(v,P){return Promise.resolve(void 0)}publicLog2(v,P){return this.publicLog(v,P)}publicLogError(v,P){return Promise.resolve(void 0)}publicLogError2(v,P){return this.publicLogError(v,P)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=k,e.NullTelemetryService=new k;class E{async publicLog(v,P,u){}async publicLogError(v,P,u){}}e.NullEndpointTelemetryService=E,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function w(m,v){return v.onDidChangeConfiguration(P=>{P.source!==6&&m.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(P.source),configurationKeys:t(P.sourceConfig)})})}e.configurationTelemetry=w;function S(m,v){return!(v.disableTelemetry||!m.enableTelemetry||v.extensionTestsLocationURI)}e.supportsTelemetry=S;function b(m){const v=m.getValue(C.TELEMETRY_SETTING_ID),P=m.getValue("telemetry.enableCrashReporter");if(m.getValue(C.TELEMETRY_OLD_SETTING_ID)===!1||P===!1)return 0;switch(v??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=b;function M(m){const v=Object.create(null),P=Object.create(null),u=Object.create(null);f(m,u);for(let g in u){g=g.length>150?g.substr(g.length-149):g;const c=u[g];typeof c=="number"?P[g]=c:typeof c=="boolean"?P[g]=c?1:0:typeof c=="string"?(c.length>8192&&console.warn(`Telemetry property: ${g} has been trimmed to 8192, the original length is ${c.length}`),v[g]=c.substring(0,8191)):typeof c!="undefined"&&c!==null&&(v[g]=c)}return{properties:v,measurements:P}}e.validateTelemetryData=M;function y(m){if(!m)return"none";let v="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(u=>{m.indexOf(`${u}+`)===0&&(v=u)}),v}e.cleanRemoteAuthority=y;function f(m,v,P=0,u){if(!!m)for(let g of Object.getOwnPropertyNames(m)){const c=m[g],o=u?u+g:g;Array.isArray(c)?v[o]=(0,p.safeStringify)(c):c instanceof Date?v[o]=c.toISOString():(0,n.isObject)(c)?P<2?f(c,v,P+1,o+"."):v[o]=(0,p.safeStringify)(c):v[o]=c}}function t(m){if(!m)return[];const v=[];return d(v,"",m),v}function d(m,v,P){P&&typeof P=="object"&&!Array.isArray(P)?Object.keys(P).forEach(u=>d(m,v?`${v}.${u}`:u,P[u])):m.push(v)}}),define(ee[213],te([0,1,28,21,15,47,3,35,13,7,19,48,204,98,171,18,6,22,49,207,79,31,66]),function(j,e,p,n,D,C,k,E,w,S,b,M,y,f,t,d,m,v,P,u,g,c,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const l=k.isWeb?"web":(0,y.getTargetPlatform)(k.platform,E.arch);var s;(function(O){O[O.None=0]="None",O[O.IncludeVersions=1]="IncludeVersions",O[O.IncludeFiles=2]="IncludeFiles",O[O.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",O[O.IncludeSharedAccounts=8]="IncludeSharedAccounts",O[O.IncludeVersionProperties=16]="IncludeVersionProperties",O[O.ExcludeNonValidated=32]="ExcludeNonValidated",O[O.IncludeInstallationTargets=64]="IncludeInstallationTargets",O[O.IncludeAssetUri=128]="IncludeAssetUri",O[O.IncludeStatistics=256]="IncludeStatistics",O[O.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",O[O.Unpublished=4096]="Unpublished",O[O.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function i(...O){return String(O.reduce((_,Y)=>_|Y,0))}var r;(function(O){O[O.Tag=1]="Tag",O[O.ExtensionId=4]="ExtensionId",O[O.Category=5]="Category",O[O.ExtensionName=7]="ExtensionName",O[O.Target=8]="Target",O[O.Featured=9]="Featured",O[O.SearchText=10]="SearchText",O[O.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},h={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},R={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class L{constructor(_=R){this.state=_}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(_,Y=this.state.pageSize){return new L({...this.state,pageNumber:_,pageSize:Y})}withFilter(_,...Y){const ie=[...this.state.criteria,...Y.length?Y.map(oe=>({filterType:_,value:oe})):[{filterType:_}]];return new L({...this.state,criteria:ie})}withSortBy(_){return new L({...this.state,sortBy:_})}withSortOrder(_){return new L({...this.state,sortOrder:_})}withFlags(..._){return new L({...this.state,flags:_.reduce((Y,ie)=>Y|ie,0)})}withAssetTypes(..._){return new L({...this.state,assetTypes:_})}get raw(){const{criteria:_,pageNumber:Y,pageSize:ie,sortBy:oe,sortOrder:J,flags:ce,assetTypes:le}=this.state;return{filters:[{criteria:_,pageNumber:Y,pageSize:ie,sortBy:oe,sortOrder:J}],assetTypes:le,flags:ce}}get searchText(){const _=this.state.criteria.filter(Y=>Y.filterType===r.SearchText)[0];return _&&_.value?_.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(_=>String(_.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function T(O,_){const Y=(O||[]).filter(ie=>ie.statisticName===_)[0];return Y?Y.value:0}function $(O){const _="Microsoft.VisualStudio.Code.Translation.";return O.files.filter(ie=>ie.assetType.indexOf(_)===0).reduce((ie,oe)=>{const J=V(O,oe.assetType);return J&&ie.push([oe.assetType.substring(_.length),J]),ie},[])}function Q(O){if(O.properties){const _=O.properties.filter(oe=>oe.key===a.Repository),Y=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ie=_.filter(oe=>Y.test(oe.value))[0];return ie?{uri:ie.value,fallbackUri:ie.value}:null}return V(O,a.Repository)}function se(O){return{uri:`${O.fallbackAssetUri}/${a.VSIX}?redirect=true${O.targetPlatform?`&targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${a.VSIX}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}}function re(O){const _=V(O,a.Icon);if(_)return _;const Y=y.DefaultIconPath;return{uri:Y,fallbackUri:Y}}function V(O,_){return O.files.filter(ie=>ie.assetType===_)[0]?{uri:`${O.assetUri}/${_}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${_}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}:null}function Z(O,_){const Y=O.properties?O.properties.filter(oe=>oe.key===_):[],ie=Y.length>0&&Y[0].value;return ie?ie.split(",").map(oe=>(0,f.adoptToGalleryExtensionId)(oe)):[]}function H(O){const _=O.properties?O.properties.filter(Y=>Y.key===h.Engine):[];return _.length>0&&_[0].value||""}function K(O){const _=O.properties?O.properties.filter(Y=>Y.key===h.PreRelease):[];return _.length>0&&_[0].value==="true"}function x(O){const _=O.properties?O.properties.filter(ie=>ie.key===h.LocalizedLanguages):[],Y=_.length>0&&_[0].value||"";return Y?Y.split(","):[]}function B(O){return O.indexOf("preview")!==-1}function z(O){return O.targetPlatform?(0,y.toTargetPlatform)(O.targetPlatform):"undefined"}function G(O){const _=(0,p.distinct)(O.versions.map(z)),Y=!!O.tags?.includes(y.WEB_EXTENSION_TAG),ie=_.indexOf("web");return Y?ie===-1&&_.push("web"):ie!==-1&&_.splice(ie,1),_}function q(O,_){const Y=(0,y.getFallbackTargetPlarforms)(_);for(let ie=0;ie<O.length;ie++){const oe=O[ie];if(oe.version===O[ie-1]?.version){let J=ie;const ce=z(oe);if(ce===_)for(;J>0&&O[J-1].version===oe.version;)J--;else if(Y.includes(ce))for(;J>0&&O[J-1].version===oe.version&&z(O[J-1])!==_;)J--;J!==ie&&(O.splice(ie,1),O.splice(J,0,oe))}}return O}e.sortExtensionVersions=q;function W(O,_,Y){const ie=O.versions[0],oe={manifest:V(_,a.Manifest),readme:V(_,a.Details),changelog:V(_,a.Changelog),license:V(_,a.License),repository:Q(_),download:se(_),icon:re(_),coreTranslations:$(_)};return{identifier:{id:(0,f.getGalleryExtensionId)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},name:O.extensionName,version:_.version,displayName:O.displayName,publisherId:O.publisher.publisherId,publisher:O.publisher.publisherName,publisherDisplayName:O.publisher.displayName,publisherDomain:O.publisher.domain?{link:O.publisher.domain,verified:!!O.publisher.isDomainVerified}:void 0,description:O.shortDescription||"",installCount:T(O.statistics,"install"),rating:T(O.statistics,"averagerating"),ratingCount:T(O.statistics,"ratingcount"),categories:O.categories||[],tags:O.tags||[],releaseDate:Date.parse(O.releaseDate),lastUpdated:Date.parse(O.lastUpdated),allTargetPlatforms:Y,assets:oe,properties:{dependencies:Z(_,h.Dependency),extensionPack:Z(_,h.ExtensionPack),engine:H(_),localizedLanguages:x(_),targetPlatform:z(_),isPreReleaseVersion:K(_)},hasPreReleaseVersion:K(ie),hasReleaseVersion:!0,preview:B(O.flags)}}let N=class{constructor(_,Y,ie,oe,J,ce,le,he){this.requestService=Y,this.logService=ie,this.environmentService=oe,this.telemetryService=J,this.fileService=ce,this.productService=le,this.configurationService=he;const we=le.extensionsGallery;this.extensionsGalleryUrl=we&&we.serviceUrl,this.extensionsControlUrl=we&&we.controlUrl,this.commonHeadersPromise=U(le.version,le,this.environmentService,this.configurationService,this.fileService,_)}api(_=""){return`${this.extensionsGalleryUrl}${_}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(_,Y,ie){const oe=n.CancellationToken.isCancellationToken(Y)?{targetPlatform:l}:Y,J=n.CancellationToken.isCancellationToken(Y)?Y:ie,ce=[],le=[],he=[],we=[];for(const fe of _)fe.uuid?le.push(fe.uuid):ce.push(fe.id),he.push({...fe,preRelease:!!fe.preRelease}),fe.version&&we.push({...fe,version:fe.version});if(!le.length&&!ce.length)return[];let pe=new L().withPage(1,_.length);le.length&&(pe=pe.withFilter(r.ExtensionId,...le)),ce.length&&(pe=pe.withFilter(r.ExtensionName,...ce));const{extensions:ge}=await this.queryGalleryExtensions(pe,{targetPlatform:oe.targetPlatform,preRelease:he,versions:we,compatible:!!oe.compatible},J);return ge}async getCompatibleExtension(_,Y,ie){if((0,y.isNotWebExtensionInWebTargetPlatform)(_.allTargetPlatforms,ie))return null;if(await this.isExtensionCompatible(_,Y,ie))return _;const oe=new L().withFlags(s.IncludeVersions).withPage(1,1).withFilter(r.ExtensionId,_.identifier.uuid),{extensions:J}=await this.queryGalleryExtensions(oe,{targetPlatform:ie,compatible:!0,preRelease:Y},n.CancellationToken.None);return J[0]||null}async isExtensionCompatible(_,Y,ie){if(!(0,y.isTargetPlatformCompatible)(_.properties.targetPlatform,_.allTargetPlatforms,ie)||!Y&&_.properties.isPreReleaseVersion)return!1;let oe=_.properties.engine;if(!oe){const J=await this.getManifest(_,n.CancellationToken.None);if(!J)throw new Error("Manifest was not found");oe=J.engines.vscode}return(0,t.isEngineValid)(oe,this.productService.version,this.productService.date)}async isValidVersion(_,Y,ie,oe,J){if(!(0,y.isTargetPlatformCompatible)(z(_),oe,J)||!Y&&K(_))return!1;if(ie){const ce=await this.getEngine(_);if(!(0,t.isEngineValid)(ce,this.productService.version,this.productService.date))return!1}return!0}async query(_,Y){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let ie=_.text||"";const oe=(0,C.getOrDefault)(_,pe=>pe.pageSize,50);let J=new L().withPage(1,oe);ie?(ie=ie.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,ge,fe)=>(J=J.withFilter(r.Category,fe||ge),"")),ie=ie.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,ge,fe)=>(J=J.withFilter(r.Tag,fe||ge),"")),ie=ie.replace(/\bfeatured(\s+|\b|$)/g,()=>(J=J.withFilter(r.Featured),"")),ie=ie.trim(),ie&&(ie=ie.length<200?ie:ie.substring(0,200),J=J.withFilter(r.SearchText,ie)),J=J.withSortBy(0)):_.ids?J=J.withFilter(r.ExtensionId,..._.ids):_.names?J=J.withFilter(r.ExtensionName,..._.names):J=J.withSortBy(4),typeof _.sortBy=="number"&&(J=J.withSortBy(_.sortBy)),typeof _.sortOrder=="number"&&(J=J.withSortOrder(_.sortOrder));const ce=async(pe,ge)=>{const{extensions:fe,total:Ie}=await this.queryGalleryExtensions(pe,{targetPlatform:l,compatible:!1,preRelease:!!_.includePreRelease},ge);return fe.forEach((Me,Ae)=>Me.telemetryData={index:(pe.pageNumber-1)*pe.pageSize+Ae,querySource:_.source}),{extensions:fe,total:Ie}},{extensions:le,total:he}=await ce(J,Y),we=async(pe,ge)=>{if(ge.isCancellationRequested)throw new D.CancellationError;const{extensions:fe}=await ce(J.withPage(pe+1),ge);return fe};return{firstPage:le,total:he,pageSize:J.pageSize,getPage:we}}async queryGalleryExtensions(_,Y,ie){const oe=_.flags;!!(_.flags&s.IncludeLatestVersionOnly)&&!!(_.flags&s.IncludeVersions)&&(_=_.withFlags(_.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(_.flags&s.IncludeLatestVersionOnly)&&!(_.flags&s.IncludeVersions)&&(_=_.withFlags(_.flags,s.IncludeLatestVersionOnly)),Y.versions?.length&&(_=_.withFlags(_.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),_=_.withFlags(_.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:J,total:ce}=await this.queryRawGalleryExtensions(_,ie);if(!(_.flags&s.IncludeLatestVersionOnly)){const pe=[];for(const ge of J){const fe=await this.toGalleryExtensionWithCriteria(ge,Y,!0);fe&&pe.push(fe)}return{extensions:pe,total:ce}}const he=[],we=new Map;for(let pe=0;pe<J.length;pe++){const ge=J[pe],fe={id:(0,f.getGalleryExtensionId)(ge.publisher.publisherName,ge.extensionName),uuid:ge.extensionId},Ie=(0,w.isBoolean)(Y.preRelease)?Y.preRelease:!!Y.preRelease.find(Ae=>(0,f.areSameExtensions)(Ae,fe))?.preRelease;let Me=await this.toGalleryExtensionWithCriteria(ge,Y,!1);!Me||Me.properties.isPreReleaseVersion&&(!Ie||!Me.hasReleaseVersion)||!Me.properties.isPreReleaseVersion&&Me.properties.targetPlatform!==Y.targetPlatform&&Me.hasPreReleaseVersion?we.set(ge.extensionId,pe):he.push([pe,Me])}if(we.size){const pe=new Date().getTime(),ge=new L().withFlags(oe&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,we.size).withFilter(r.ExtensionId,...we.keys()),{extensions:fe}=await this.queryGalleryExtensions(ge,Y,ie);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-pe,count:we.size});for(const Ie of fe){const Me=we.get(Ie.identifier.uuid);he.push([Me,Ie])}}return{extensions:he.sort((pe,ge)=>pe[0]-ge[0]).map(([,pe])=>pe),total:ce}}async toGalleryExtensionWithCriteria(_,Y,ie){const oe={id:(0,f.getGalleryExtensionId)(_.publisher.publisherName,_.extensionName),uuid:_.extensionId},J=Y.versions?.find(we=>(0,f.areSameExtensions)(we,oe))?.version,ce=(0,w.isBoolean)(Y.preRelease)?Y.preRelease:!!Y.preRelease.find(we=>(0,f.areSameExtensions)(we,oe))?.preRelease,le=G(_),he=q(_.versions,Y.targetPlatform);if(Y.compatible&&ie&&(0,y.isNotWebExtensionInWebTargetPlatform)(le,Y.targetPlatform))return null;for(let we=0;we<he.length;we++){const pe=he[we];if(!(J&&pe.version!==J)){if(await this.isValidVersion(pe,ce,Y.compatible,le,Y.targetPlatform))return W(_,pe,le);if(J&&pe.version===J)return null}}return J||Y.compatible?null:W(_,_.versions[0],le)}async queryRawGalleryExtensions(_,Y){if(!this.isEnabled())throw new Error("No extension gallery service configured.");_=_.withFlags(_.flags,s.ExcludeNonValidated).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExcludeWithFlags,i(s.Unpublished));const ie=await this.commonHeadersPromise,oe=JSON.stringify(_.raw),J={...ie,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(oe.length)},ce=new Date().getTime();let le,he,we=0;try{if(le=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:oe,headers:J},Y),le.res.statusCode&&le.res.statusCode>=400&&le.res.statusCode<500)return{galleryExtensions:[],total:we};const pe=await(0,P.asJson)(le);if(pe){const ge=pe.results[0],fe=ge.extensions,Ie=ge.resultMetadata&&ge.resultMetadata.filter(Me=>Me.metadataType==="ResultCount")[0];return we=Ie&&Ie.metadataItems.filter(Me=>Me.name==="TotalCount")[0].count||0,{galleryExtensions:fe,total:we}}return{galleryExtensions:[],total:we}}catch(pe){throw he=pe,pe}finally{this.telemetryService.publicLog2("galleryService:query",{..._.telemetryData,requestBodySize:String(oe.length),duration:new Date().getTime()-ce,success:!!le&&(0,P.isSuccess)(le),responseBodySize:le?.res.headers["Content-Length"],statusCode:le?String(le.res.statusCode):void 0,errorCode:he?(0,D.isCancellationError)(he)?"canceled":(0,D.getErrorMessage)(he).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(we)})}}async reportStatistic(_,Y,ie,oe){if(!this.isEnabled())return;const J=k.isWeb?this.api(`/itemName/${_}.${Y}/version/${ie}/statType/${oe==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${_}/extensions/${Y}/${ie}/stats?statType=${oe}`),ce=k.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",he={...await this.commonHeadersPromise,Accept:ce};try{await this.requestService.request({type:"POST",url:J,headers:he},n.CancellationToken.None)}catch{}}async download(_,Y,ie){this.logService.trace("ExtensionGalleryService#download",_.identifier.id);const oe=(0,f.getGalleryExtensionTelemetryData)(_),J=new Date().getTime(),ce=pe=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...oe,duration:pe}),le=ie===2?"install":ie===3?"update":"",he=le?{uri:`${_.assets.download.uri}${S.URI.parse(_.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${_.assets.download.fallbackUri}${S.URI.parse(_.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:_.assets.download,we=await this.getAsset(he);await this.fileService.writeFile(Y,we.stream),ce(new Date().getTime()-J)}async getReadme(_,Y){if(_.assets.readme){const ie=await this.getAsset(_.assets.readme,{},Y);return await(0,P.asText)(ie)||""}return""}async getManifest(_,Y){if(_.assets.manifest){const ie=await this.getAsset(_.assets.manifest,{},Y),oe=await(0,P.asText)(ie);return oe?JSON.parse(oe):null}return null}async getManifestFromRawExtensionVersion(_,Y){const ie=V(_,a.Manifest);if(!ie)throw new Error("Manifest was not found");const oe={"Accept-Encoding":"gzip"},J=await this.getAsset(ie,{headers:oe});return await(0,P.asJson)(J)}async getCoreTranslation(_,Y){const ie=_.assets.coreTranslations.filter(oe=>oe[0]===Y.toUpperCase())[0];if(ie){const oe=await this.getAsset(ie[1]),J=await(0,P.asText)(oe);return J?JSON.parse(J):null}return null}async getChangelog(_,Y){if(_.assets.changelog){const ie=await this.getAsset(_.assets.changelog,{},Y);return await(0,P.asText)(ie)||""}return""}async getAllCompatibleVersions(_,Y,ie){let oe=new L().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);_.identifier.uuid?oe=oe.withFilter(r.ExtensionId,_.identifier.uuid):oe=oe.withFilter(r.ExtensionName,_.identifier.id);const{galleryExtensions:J}=await this.queryRawGalleryExtensions(oe,n.CancellationToken.None);if(!J.length)return[];const ce=G(J[0]);if((0,y.isNotWebExtensionInWebTargetPlatform)(ce,ie))return[];const le=[],he=new Set;return await Promise.all(J[0].versions.map(async we=>{try{if(he.has(we.version))return;he.add(we.version),await this.isValidVersion(we,Y,!0,ce,ie)&&le.push({version:we.version,date:we.lastUpdated,isPreReleaseVersion:K(we)})}catch{}})),le}async getAsset(_,Y={},ie=n.CancellationToken.None){const oe=await this.commonHeadersPromise,J={type:"GET"},ce={...oe,...Y.headers||{}};Y={...Y,...J,headers:ce};const le=_.uri,he=_.fallbackUri,we={...Y,url:le};try{const pe=await this.requestService.request(we,ie);if(pe.res.statusCode===200)return pe;const ge=await(0,P.asText)(pe);throw new Error(`Expected 200, got back ${pe.res.statusCode} instead.

${ge}`)}catch(pe){if((0,D.isCancellationError)(pe))throw pe;const ge=(0,D.getErrorMessage)(pe);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:le,message:ge});const fe={...Y,url:he};return this.requestService.request(fe,ie)}}async getEngine(_){let Y=H(_);if(!Y){const ie=await this.getManifestFromRawExtensionVersion(_,n.CancellationToken.None);if(!ie)throw new Error("Manifest was not found");Y=ie.engines.vscode}return Y}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const _=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(_.res.statusCode!==200)throw new Error("Could not get extensions report.");const Y=await(0,P.asJson)(_),ie=[],oe={};if(Y){for(const J of Y.malicious)ie.push({id:J});if(Y.unsupported)for(const J of Object.keys(Y.unsupported)){const ce=Y.unsupported[J];(0,w.isBoolean)(ce)||(oe[J.toLowerCase()]=ce.preReleaseExtension)}if(Y.migrateToPreRelease)for(const[J,ce]of Object.entries(Y.migrateToPreRelease))(!ce.engine||(0,t.isEngineValid)(ce.engine,this.productService.version,this.productService.date))&&(oe[J.toLowerCase()]=ce)}return{malicious:ie,unsupportedPreReleaseExtensions:oe}}};N=de([ne(1,P.IRequestService),ne(2,m.ILogService),ne(3,M.IEnvironmentService),ne(4,c.ITelemetryService),ne(5,d.IFileService),ne(6,v.IProductService),ne(7,b.IConfigurationService)],N);let F=class extends N{constructor(_,Y,ie,oe,J,ce,le,he){super(_,Y,ie,oe,J,ce,le,he)}};F=de([ne(0,g.IStorageService),ne(1,P.IRequestService),ne(2,m.ILogService),ne(3,M.IEnvironmentService),ne(4,c.ITelemetryService),ne(5,d.IFileService),ne(6,v.IProductService),ne(7,b.IConfigurationService)],F),e.ExtensionGalleryService=F;let A=class extends N{constructor(_,Y,ie,oe,J,ce,le){super(void 0,_,Y,ie,oe,J,ce,le)}};A=de([ne(0,P.IRequestService),ne(1,m.ILogService),ne(2,M.IEnvironmentService),ne(3,c.ITelemetryService),ne(4,d.IFileService),ne(5,v.IProductService),ne(6,b.IConfigurationService)],A),e.ExtensionGalleryServiceWithNoStorageService=A;async function U(O,_,Y,ie,oe,J){const ce={"X-Market-Client-Id":`VSCode ${O}`,"User-Agent":`VSCode ${O} (${_.nameShort})`},le=await(0,u.getServiceMachineId)(Y,oe,J);return(0,o.supportsTelemetry)(_,Y)&&(0,o.getTelemetryLevel)(ie)===3&&(ce["X-Market-User-Id"]=le),ce}e.resolveMarketplaceHeaders=U}),define(ee[214],te([0,1,2,47,3,25,156,19,56,54,40,31,66]),function(j,e,p,n,D,C,k,E,w,S,b,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let f=class{constructor(m,v){this._configurationService=v,this._experimentProperties={},this._disposables=new p.DisposableStore,this._cleanupPatterns=[],this._appenders=m.appenders,this._commonProperties=m.commonProperties||Promise.resolve({}),this._piiPaths=m.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!m.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let P of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,C.escapeRegExpCharacters)(P),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(P=>{const u=/^[a-f0-9]+$/i.test(P["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!u})})}setExperimentProperty(m,v){this._experimentProperties[m]=v}_updateTelemetryLevel(){this._telemetryLevel=(0,y.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const m=await this._commonProperties;let v=m.sessionID,P=m["common.machineId"],u=m["common.firstSessionDate"],g=m["common.msftInternal"];return{sessionId:v,machineId:P,firstSessionDate:u,msftInternal:g}}dispose(){this._disposables.dispose()}_log(m,v,P,u){return this.telemetryLevel<v?Promise.resolve(void 0):this._commonProperties.then(g=>{P=(0,n.mixin)(P,g),P=(0,n.mixin)(P,this._experimentProperties),P=(0,n.cloneAndChange)(P,c=>{if(typeof c=="string")return this._cleanupInfo(c,u)}),this._appenders.forEach(c=>c.log(m,P))},g=>{console.error(g)})}publicLog(m,v,P){return this._log(m,3,v,P)}publicLog2(m,v,P){return this.publicLog(m,v,P)}publicLogError(m,v){return this.sendErrorTelemetry?this._log(m,2,v,!0):Promise.resolve(void 0)}publicLogError2(m,v){return this.publicLogError(m,v)}_anonymizeFilePaths(m){let v=m;const P=[];for(let o of this._cleanupPatterns)for(;;){const l=o.exec(m);if(!l)break;P.push([l.index,o.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,g=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let c=0;for(v="";;){const o=g.exec(m);if(!o)break;!u.test(o[0])&&P.every(([l,s])=>o.index<l||o.index>=s)&&(v+=m.substring(c,o.index)+"<REDACTED: user-file-path>",c=g.lastIndex)}return c<m.length&&(v+=m.substr(c)),v}_removePropertiesWithPossibleUserInfo(m){if(!m)return m;const v=m.toLowerCase(),P=/@[a-zA-Z0-9-.]+/,u=/(key|token|sig|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/,g=/xox[pbaors]\-[a-zA-Z0-9]+\-[a-zA-Z0-9\-]+?/;return u.test(v)?"<REDACTED: secret>":P.test(v)?"<REDACTED: email>":g.test(v)?"<REDACTED: token>":m}_cleanupInfo(m,v){let P=m;v&&(P=this._anonymizeFilePaths(P));for(let u of this._cleanupPatterns)P=P.replace(u,"");return P=this._removePropertiesWithPossibleUserInfo(P),P}};f.IDLE_START_EVENT_NAME="UserIdleStart",f.IDLE_STOP_EVENT_NAME="UserIdleStop",f=de([ne(1,E.IConfigurationService)],f),e.TelemetryService=f;function t(){const d=(0,k.localize)(0,null,S.default.nameLong),m=S.default.privacyStatementUrl?(0,k.localize)(2,null,"https://aka.ms/vscode-telemetry",S.default.privacyStatementUrl):(0,k.localize)(1,null,"https://aka.ms/vscode-telemetry"),v=D.isWeb?"":(0,k.localize)(3,null),P=(0,k.localize)(4,null),u=(0,k.localize)(5,null),g=(0,k.localize)(6,null),c=(0,k.localize)(7,null),o=`
|       | ${P} | ${u} | ${g} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,l=(0,k.localize)(8,null);return`
${d} ${m} ${v}

&nbsp;

${c}
${o}

&nbsp;

${l}
`}b.Registry.as(w.Extensions.Configuration).registerConfiguration({id:M.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(9,null),properties:{[M.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,k.localize)(10,null),(0,k.localize)(11,null),(0,k.localize)(12,null),(0,k.localize)(13,null)],markdownDescription:t(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.Registry.as(w.Extensions.Configuration).registerConfiguration({id:M.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(14,null),properties:{[M.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:S.default.privacyStatementUrl?(0,k.localize)(16,null,S.default.nameLong,S.default.privacyStatementUrl):(0,k.localize)(15,null,S.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,k.localize)(17,null,`\`#${M.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ee[215],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var p;(function(n){n.DARK="dark",n.LIGHT="light",n.HIGH_CONTRAST="hc"})(p=e.ColorScheme||(e.ColorScheme={}))}),define(ee[216],te([0,1,106,4,2,5,40,215]),function(j,e,p,n,D,C,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var w;(function(m){function v(P){return P&&typeof P=="object"&&typeof P.id=="string"}m.isThemeColor=v})(w=e.ThemeColor||(e.ThemeColor={}));function S(m){return{id:m}}e.themeColorFromId=S;var b;(function(m){function v(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||w.isThemeColor(i.color))}m.isThemeIcon=v;const P=new RegExp(`^\\$\\((${p.CSSIcon.iconNameExpression}(?:${p.CSSIcon.iconModifierExpression})?)\\)$`);function u(i){const r=P.exec(i);if(!r)return;let[,a]=r;return{id:a}}m.fromString=u;function g(i){return{id:i}}m.fromId=g;function c(i,r){let a=i.id;const h=a.lastIndexOf("~");return h!==-1&&(a=a.substring(0,h)),r&&(a=`${a}~${r}`),{id:a}}m.modify=c;function o(i){const r=i.id.lastIndexOf("~");if(r!==-1)return i.id.substring(r+1)}m.getModifier=o;function l(i,r){return i.id===r.id&&i.color?.id===r.color?.id}m.isEqual=l;function s(i,r){return{id:i.id,color:r?S(r):void 0}}m.asThemeIcon=s,m.asClassNameArray=p.CSSIcon.asClassNameArray,m.asClassName=p.CSSIcon.asClassName,m.asCSSSelector=p.CSSIcon.asCSSSelector})(b=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=p.Codicon.file,e.FolderThemeIcon=p.Codicon.folder;function M(m){switch(m){case E.ColorScheme.DARK:return"vs-dark";case E.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=M,e.Extensions={ThemingContribution:"base.contributions.theming"};class y{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new n.Emitter}onColorThemeChange(v){return this.themingParticipants.push(v),this.onThemingParticipantAddedEmitter.fire(v),(0,D.toDisposable)(()=>{const P=this.themingParticipants.indexOf(v);this.themingParticipants.splice(P,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let f=new y;k.Registry.add(e.Extensions.ThemingContribution,f);function t(m){return f.onColorThemeChange(m)}e.registerThemingParticipant=t;class d extends D.Disposable{constructor(v){super();this.themeService=v,this.theme=v.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(P=>this.onThemeChange(P)))}onThemeChange(v){this.theme=v,this.updateStyles()}updateStyles(){}getColor(v,P){let u=this.theme.getColor(v);return u&&P&&(u=P(u,this.theme)),u?u.toString():null}}e.Themable=d}),define(ee[67],te([0,1,14,3,5,38]),function(j,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const k="#FFFFFF",E="#1E1E1E",w="#000000",S="theme",b="themeBackground",M="windowSplash";e.IThemeMainService=(0,D.createDecorator)("themeMainService");let y=class{constructor(t){this.stateMainService=t}getBackgroundColor(){if((n.isWindows||n.isMacintosh)&&p.nativeTheme.shouldUseInvertedColorScheme)return w;let t=this.stateMainService.getItem(b,null);if(!t){let d;(n.isWindows||n.isMacintosh)&&p.nativeTheme.shouldUseInvertedColorScheme?d="hc-black":d=this.stateMainService.getItem(S,"vs-dark").split(" ")[0],t=d==="hc-black"?w:d==="vs"?k:E}return n.isMacintosh&&t.toUpperCase()===E&&(t="#171717"),t}saveWindowSplash(t,d){this.stateMainService.setItems([{key:S,data:d.baseTheme},{key:b,data:d.colorInfo.background},{key:M,data:d}]),typeof t=="number"&&this.updateBackgroundColor(t,d)}updateBackgroundColor(t,d){for(const m of p.BrowserWindow.getAllWindows())if(m.id===t){m.setBackgroundColor(d.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(M)}};y=de([ne(0,C.IStateMainService)],y),e.ThemeMainService=y}),define(ee[41],te([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var n;(function(C){C.Uninitialized="uninitialized",C.Idle="idle",C.CheckingForUpdates="checking for updates",C.AvailableForDownload="available for download",C.Downloading="downloading",C.Downloaded="downloaded",C.Updating="updating",C.Ready="ready"})(n=e.StateType||(e.StateType={}));var D;(function(C){C[C.Setup=0]="Setup",C[C.Archive=1]="Archive",C[C.Snap=2]="Snap"})(D=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(C,k)=>({type:"idle",updateType:C,error:k}),CheckingForUpdates:C=>({type:"checking for updates",explicit:C}),AvailableForDownload:C=>({type:"available for download",update:C}),Downloading:C=>({type:"downloading",update:C}),Downloaded:C=>({type:"downloaded",update:C}),Updating:C=>({type:"updating",update:C}),Ready:C=>({type:"ready",update:C})},e.IUpdateService=(0,p.createDecorator)("updateService")}),define(ee[217],te([0,1,3,157,56,40]),function(j,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),C.Registry.as(D.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,n.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,n.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,n.localize)(2,null),(0,n.localize)(3,null),(0,n.localize)(4,null),(0,n.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,n.localize)(6,null),deprecationMessage:(0,n.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,n.localize)(8,null),description:(0,n.localize)(9,null),included:p.isWindows&&!p.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,n.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ee[218],te([0,1,4,41]),function(j,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class D{constructor(E){this.service=E}listen(E,w){switch(w){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${w}`)}call(E,w,S){switch(w){case"checkForUpdates":return this.service.checkForUpdates(S);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${w}`)}}e.UpdateChannel=D;class C{constructor(E){this.channel=E,this._onStateChange=new p.Emitter,this.onStateChange=this._onStateChange.event,this._state=n.State.Uninitialized,this.channel.listen("onStateChange")(w=>this.state=w),this.channel.call("_getInitialState").then(w=>this.state=w)}get state(){return this._state}set state(E){this._state=E,this._onStateChange.fire(E)}checkForUpdates(E){return this.channel.call("checkForUpdates",E)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=C}),define(ee[100],te([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,p.createDecorator)("urlService")}),define(ee[219],te([0,1,7]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class n{constructor(E){this.handler=E}listen(E,w){throw new Error(`Event not found: ${w}`)}call(E,w,S){switch(w){case"handleURL":return this.handler.handleURL(p.URI.revive(S[0]),S[1])}throw new Error(`Call not found: ${w}`)}}e.URLHandlerChannel=n;class D{constructor(E){this.channel=E}handleURL(E,w){return this.channel.call("handleURL",[E.toJSON(),w])}}e.URLHandlerChannelClient=D;class C{constructor(E){this.next=E}async routeCall(E,w,S,b){if(w!=="handleURL")throw new Error(`Call not found: ${w}`);if(S){const M=p.URI.revive(S);if(M&&M.query){const y=/\bwindowId=(\d+)/.exec(M.query);if(y){const f=y[1],t=new RegExp(`window:${f}`),d=E.connections.find(m=>t.test(m.ctx));if(d)return d}}}return this.next.routeCall(E,w,S,b)}routeEvent(E,w){throw new Error(`Event not found: ${w}`)}}e.URLHandlerRouter=C}),define(ee[220],te([0,1,8,2,7,22]),function(j,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class k extends n.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(S,b){const M=[...this.handlers.values()];return(0,p.first)(M.map(y=>()=>y.handleURL(S,b)),void 0,!1).then(y=>y||!1)}registerHandler(S){return this.handlers.add(S),(0,n.toDisposable)(()=>this.handlers.delete(S))}}e.AbstractURLService=k;let E=class extends k{constructor(S){super();this.productService=S}create(S){let{authority:b,path:M,query:y,fragment:f}=S||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return b&&M&&M.indexOf("/")!==0&&(M=`/${M}`),D.URI.from({scheme:this.productService.urlProtocol,authority:b,path:M,query:y,fragment:f})}};E=de([ne(0,C.IProductService)],E),e.NativeURLService=E}),define(ee[221],te([0,1,14,8,4,2,3,7]),function(j,e,p,n,D,C,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function w(b){try{return E.URI.parse(b)}catch{return null}}class S{constructor(M,y,f,t,d){if(this.urlService=y,this.uris=[],this.retryCount=0,this.flushDisposable=C.Disposable.None,this.disposables=new C.DisposableStore,this.uris=M,k.isWindows){const P=t.isBuilt?[]:[`"${t.appRoot}"`];P.push("--open-url","--"),p.app.setAsDefaultProtocolClient(d.urlProtocol,process.execPath,P)}const m=D.Event.map(D.Event.fromNodeEventEmitter(p.app,"open-url",(P,u)=>({event:P,url:u})),({event:P,url:u})=>(P.preventDefault(),u));this.disposables.add(m(P=>{const u=w(P);!u||this.urlService.open(u,{originalUrl:P})})),f.getWindows().filter(P=>P.isReady).length>0?this.flush():D.Event.once(f.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const M=[];for(const y of this.uris)await this.urlService.open(y.uri,{originalUrl:y.url})||M.push(y);M.length!==0&&(this.uris=M,this.flushDisposable=(0,n.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=S}),define(ee[222],te([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,p.createDecorator)("webviewManagerService")}),define(ee[223],te([0,1,14,2,10,7]),function(j,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class k extends n.Disposable{constructor(){super();const w=this.handleWebviewRequest.bind(this);p.protocol.registerFileProtocol(D.Schemas.vscodeWebview,w)}handleWebviewRequest(w,S){try{const b=C.URI.parse(w.url),M=k.validWebviewFilePaths.get(b.path);if(typeof M=="string"){const y=`vs/workbench/contrib/webview/browser/pre/${M}`,f=D.FileAccess.asFileUri(y,j);return S(decodeURIComponent(f.fsPath))}else return S({error:-10})}catch{}return S({error:-2})}}e.WebviewProtocolProvider=k,k.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(ee[68],te([0,1,3]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function n(S){return!!S.workspaceUri}e.isWorkspaceToOpen=n;function D(S){return!!S.folderUri}e.isFolderToOpen=D;function C(S){return!!S.fileUri}e.isFileToOpen=C;function k(S){const b=E(S),M=S.getValue("window.menuBarVisibility");return M==="default"||b==="native"&&M==="compact"||p.isMacintosh&&p.isNative?"classic":M}e.getMenuBarVisibility=k;function E(S){if(p.isWeb)return"custom";const b=S.getValue("window");if(b){if(p.isMacintosh&&b.nativeTabs===!0||p.isMacintosh&&b.nativeFullScreen===!1)return"native";const f=S.getValue("workbench.colorCustomizations");if(f?.["window.activeBorder"]||f?.["window.inactiveBorder"])return"custom";const t=b.titleBarStyle;if(t==="native"||t==="custom")return t}return p.isLinux?"native":"custom"}e.getTitleBarStyle=E;function w(S=0){return Math.pow(1.2,S)}e.zoomLevelToZoomFactor=w}),define(ee[34],te([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=e.UnloadReason=e.LoadReason=void 0;var n;(function(S){S[S.INITIAL=1]="INITIAL",S[S.LOAD=2]="LOAD",S[S.RELOAD=3]="RELOAD"})(n=e.LoadReason||(e.LoadReason={}));var D;(function(S){S[S.CLOSE=1]="CLOSE",S[S.QUIT=2]="QUIT",S[S.RELOAD=3]="RELOAD",S[S.LOAD=4]="LOAD"})(D=e.UnloadReason||(e.UnloadReason={}));var C;(function(S){S[S.CLI=0]="CLI",S[S.DOCK=1]="DOCK",S[S.MENU=2]="MENU",S[S.DIALOG=3]="DIALOG",S[S.DESKTOP=4]="DESKTOP",S[S.API=5]="API"})(C=e.OpenContext||(e.OpenContext={}));const k=function(S=1){return{width:1024,height:768,mode:S}};e.defaultWindowState=k;var E;(function(S){S[S.Maximized=0]="Maximized",S[S.Normal=1]="Normal",S[S.Minimized=2]="Minimized",S[S.Fullscreen=3]="Fullscreen"})(E=e.WindowMode||(e.WindowMode={}));var w;(function(S){S[S.UNRESPONSIVE=1]="UNRESPONSIVE",S[S.CRASHED=2]="CRASHED",S[S.LOAD=3]="LOAD"})(w=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,p.createDecorator)("windowsMainService")}),define(ee[224],te([0,1,14,21,4,71,2,32,91,6,22,34,95]),function(j,e,p,n,D,C,k,E,w,S,b,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var f;(function(d){d[d.Initial=1]="Initial",d[d.StoredCredentialsUsed=2]="StoredCredentialsUsed",d[d.LoginDialogShown=3]="LoginDialogShown"})(f||(f={}));let t=class extends k.Disposable{constructor(m,v,P,u,g){super();this.logService=m,this.windowsMainService=v,this.credentialsService=P,this.encryptionMainService=u,this.productService=g,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=f.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const m=D.Event.fromNodeEventEmitter(p.app,"login",(v,P,u,g,c)=>({event:v,webContents:P,req:u,authInfo:g,callback:c}));this._register(m(this.onLogin,this))}async onLogin({event:m,authInfo:v,req:P,callback:u}){if(!v.isProxy)return;if(!this.pendingProxyResolve&&this.state===f.LoginDialogShown&&P.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}m.preventDefault();let g;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),g=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(v);try{g=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}u(g?.username,g?.password)}async resolveProxyCredentials(m){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const v=await this.doResolveProxyCredentials(m);if(v)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),v;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(m){this.logService.trace("auth#doResolveProxyCredentials - enter",m);const v=String((0,C.hash)({scheme:m.scheme,host:m.host,port:m.port}));let P,u;try{const l=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,v);if(l){const s=JSON.parse(await this.encryptionMainService.decrypt(l));P=s.username,u=s.password}}catch(l){this.logService.error(l)}if(this.state!==f.StoredCredentialsUsed&&typeof P=="string"&&typeof u=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=f.StoredCredentialsUsed,{username:P,password:u};const g=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!g){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${g.id} to handle proxy login`);const c={authInfo:m,username:this.sessionCredentials?.username??P,password:this.sessionCredentials?.password??u,replyChannel:`vscode:proxyAuthResponse:${(0,E.generateUuid)()}`};g.sendWhenReady("vscode:openProxyAuthenticationDialog",n.CancellationToken.None,c),this.state=f.LoginDialogShown;const o=await new Promise(l=>{const s=async(i,r,a)=>{if(r===c.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${g.id}`),g.win?.webContents.off("ipc-message",s),a){const h={username:a.username,password:a.password};try{if(a.remember){const I=await this.encryptionMainService.encrypt(JSON.stringify(h));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,v,I)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,v)}catch(I){this.logService.error(I)}l({username:h.username,password:h.password})}else l(void 0)};g.win?.webContents.on("ipc-message",s)});return this.sessionCredentials=o,o}};t=de([ne(0,S.ILogService),ne(1,M.IWindowsMainService),ne(2,y.ICredentialsMainService),ne(3,w.IEncryptionMainService),ne(4,b.IProductService)],t),e.ProxyAuthHandler=t}),define(ee[225],te([0,1,14,4,2,223,34]),function(j,e,p,n,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let E=class extends D.Disposable{constructor(S){super();this.windowsMainService=S,this._onFoundInFrame=this._register(new n.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new C.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(S,b){let M;if(typeof S.windowId=="number"){const{windowId:y}=S,f=this.windowsMainService.getWindowById(y);if(!f?.win)throw new Error(`Invalid windowId: ${y}`);M=f.win.webContents}else{const{webContentsId:y}=S;if(M=p.webContents.fromId(y),!M)throw new Error(`Invalid webContentsId: ${y}`)}M.isDestroyed()||M.setIgnoreMenuShortcuts(b)}async findInFrame(S,b,M,y){const t=this.getFrameByName(S,b);if(typeof t.findInFrame=="function"){t.findInFrame(M,{findNext:y.findNext,forward:y.forward});const d=(m,v)=>{v.finalUpdate&&(this._onFoundInFrame.fire(v),t.removeListener("found-in-frame",d))};t.on("found-in-frame",d)}}async stopFindInFrame(S,b,M){const f=this.getFrameByName(S,b);typeof f.stopFindInFrame=="function"&&f.stopFindInFrame(M.keepSelection?"keepSelection":"clearSelection")}getFrameByName(S,b){const M=this.windowsMainService.getWindowById(S.windowId);if(!M?.win)throw new Error(`Invalid windowId: ${S}`);const y=M.win.webContents.mainFrame.framesInSubtree.find(f=>f.name===b);if(!y)throw new Error(`Unknown frame: ${b}`);return y}};E=de([ne(0,k.IWindowsMainService)],E),e.WebviewMainService=E}),define(ee[226],te([0,1,8,4,2]),function(j,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class C extends D.Disposable{constructor({onDidOpenWindow:E,onDidFocusWindow:w,getActiveWindowId:S}){super();this.disposables=this._register(new D.DisposableStore),n.Event.latch(n.Event.any(E,w))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,p.createCancelablePromise)(()=>S()),(async()=>{try{const M=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:M}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(E){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=E}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=C}),define(ee[227],te([0,1,36,16,7,5]),function(j,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var k;(function(y){y[y.EMPTY=1]="EMPTY",y[y.FOLDER=2]="FOLDER",y[y.WORKSPACE=3]="WORKSPACE"})(k=e.WorkbenchState||(e.WorkbenchState={}));function E(y){const f=y;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=E;function w(y){const f=y;return!!(f&&typeof f=="object"&&D.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=w;class S{constructor(f,t,d,m,v){this._id=f,this._transient=d,this._configuration=m,this._ignorePathCasing=v,this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=t}update(f){this._id=f.id,this._configuration=f.configuration,this._transient=f.transient,this._ignorePathCasing=f._ignorePathCasing,this.folders=f.folders}get folders(){return this._folders}set folders(f){this._folders=f,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(f){this._configuration=f}getFolder(f){return f&&this._foldersMap.findSubstr(f.with({scheme:f.scheme,authority:f.authority,path:f.path}))||null}updateFoldersMap(){this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing);for(const f of this.folders)this._foldersMap.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=S;class b{constructor(f,t){this.raw=t,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,n.joinPath)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=b;function M(y){return new b({uri:y,index:0,name:(0,n.basenameOrAuthority)(y)},{uri:y.toString()})}e.toWorkspaceFolder=M}),define(ee[27],te([0,1,29,44,108,33,10,9,3,16,7,160,5,65,227]),function(j,e,p,n,D,C,k,E,w,S,b,M,y,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isWorkspaceBackupInfo=e.isFolderBackupInfo=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const d=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,M.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function m(K){return(typeof K=="string"?(0,E.extname)(K):(0,S.extname)(K))===d}e.hasWorkspaceFileExtension=m,e.IWorkspacesService=(0,y.createDecorator)("workspacesService");function v(K){return K.hasOwnProperty("workspace")}e.isRecentWorkspace=v;function P(K){return K.hasOwnProperty("folderUri")}e.isRecentFolder=P;function u(K){return K.hasOwnProperty("fileUri")}e.isRecentFile=u;function g(K){return K&&K.hasOwnProperty("folderUri")}e.isFolderBackupInfo=g;function c(K){return K&&K.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=c;function o(K){const x=K;return typeof x?.id=="string"&&b.URI.isUri(x.uri)}e.isSingleFolderWorkspaceIdentifier=o;function l(K){if(K.configuration)return{id:K.id,configPath:K.configuration};if(K.folders.length===1)return{id:K.id,uri:K.folders[0].uri}}e.toWorkspaceIdentifier=l;function s(K){const x=K;return typeof x?.id=="string"&&b.URI.isUri(x.configPath)}e.isWorkspaceIdentifier=s;function i(K){const x=K;if(x?.uri)return{id:x.id,uri:b.URI.revive(x.uri)};const B=K;if(B?.configPath)return{id:B.id,configPath:b.URI.revive(B.configPath)};if(K?.id)return{id:K.id}}e.reviveIdentifier=i;function r(K,x){return S.extUriBiasedIgnorePathCase.isEqualOrParent(K,x.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function a(K){return h(K)||I(K)}e.isStoredWorkspaceFolder=a;function h(K){const x=K;return typeof x?.path=="string"&&(!x.name||typeof x.name=="string")}e.isRawFileWorkspaceFolder=h;function I(K){const x=K;return typeof x?.uri=="string"&&(!x.name||typeof x.name=="string")}e.isRawUriWorkspaceFolder=I;function R(K,x,B,z,G=!w.isWindows,q){if(K.scheme!==z.scheme)return{name:B,uri:K.toString(!0)};let W=x?void 0:q.relativePath(z,K);if(W!==void 0)W.length===0?W=".":w.isWindows&&K.scheme===k.Schemas.file&&!G&&(W=W.replace(/\//g,"\\"));else if(K.scheme===k.Schemas.file)W=K.fsPath,w.isWindows&&(W=(0,C.normalizeDriveLetter)(W),G&&(W=(0,p.toSlashes)(W)));else{if(!q.isEqualAuthority(K.authority,z.authority))return{name:B,uri:K.toString(!0)};W=K.path}return{name:B,path:W}}e.getStoredWorkspaceFolder=R;function L(K,x,B){let z=[],G=new Set;const q=B.dirname(x);for(let W of K){let N;if(h(W))W.path&&(N=B.resolvePath(q,W.path));else if(I(W))try{N=b.URI.parse(W.uri),N.path[0]!=="/"&&(N=N.with({path:"/"+N.path}))}catch(F){console.warn(F)}if(N){let F=B.getComparisonKey(N);if(!G.has(F)){G.add(F);const A=W.name||B.basenameOrAuthority(N);z.push(new t.WorkspaceFolder({uri:N,name:A,index:z.length},W))}}}return z}e.toWorkspaceFolders=L;function T(K,x,B,z,G){let q=$(x,K);const W=G.dirname(x),N=G.dirname(z),F=[],A=Q(q.folders);for(const Y of q.folders){const ie=h(Y)?G.resolvePath(W,Y.path):b.URI.parse(Y.uri);let oe;B?oe=!1:oe=!h(Y)||(0,E.isAbsolute)(Y.path),F.push(R(ie,oe,Y.name,N,A,G))}const U={insertSpaces:!1,tabSize:4,eol:w.isLinux||w.isMacintosh?`
`:`\r
`},O=D.setProperty(K,["folders"],F,U);let _=D.applyEdits(K,O);return(0,S.isEqualAuthority)(q.remoteAuthority,(0,f.getRemoteAuthority)(z))&&(_=D.applyEdits(_,D.removeProperty(_,["remoteAuthority"],U))),_}e.rewriteWorkspaceFileForNewLocation=T;function $(K,x){let B=n.parse(x);if(B&&Array.isArray(B.folders))B.folders=B.folders.filter(z=>a(z));else throw new Error(`${K} looks like an invalid workspace file.`);return B}function Q(K){return w.isWindows?K.some(x=>h(x)&&x.path.indexOf("/")>=0):!0}e.useSlashForPath=Q;function se(K){return K.workspace&&typeof K.workspace=="object"&&typeof K.workspace.id=="string"&&typeof K.workspace.configPath=="string"}function re(K){return typeof K.folderUri=="string"}function V(K){return typeof K.fileUri=="string"}function Z(K,x){const B={workspaces:[],files:[]};if(K){const z=function(q,W){for(let N=0;N<q.length;N++)try{W(q[N],N)}catch(F){x.warn(`Error restoring recent entry ${JSON.stringify(q[N])}: ${F.toString()}. Skip entry.`)}},G=K;if(Array.isArray(G.entries))z(G.entries,q=>{const W=q.label,N=q.remoteAuthority;se(q)?B.workspaces.push({label:W,remoteAuthority:N,workspace:{id:q.workspace.id,configPath:b.URI.parse(q.workspace.configPath)}}):re(q)?B.workspaces.push({label:W,remoteAuthority:N,folderUri:b.URI.parse(q.folderUri)}):V(q)&&B.files.push({label:W,remoteAuthority:N,fileUri:b.URI.parse(q.fileUri)})});else{const q=K;Array.isArray(q.workspaces3)&&z(q.workspaces3,(W,N)=>{const F=Array.isArray(q.workspaceLabels)&&q.workspaceLabels[N]||void 0;typeof W=="object"&&typeof W.id=="string"&&typeof W.configURIPath=="string"?B.workspaces.push({label:F,workspace:{id:W.id,configPath:b.URI.parse(W.configURIPath)}}):typeof W=="string"&&B.workspaces.push({label:F,folderUri:b.URI.parse(W)})}),Array.isArray(q.files2)&&z(q.files2,(W,N)=>{const F=Array.isArray(q.fileLabels)&&q.fileLabels[N]||void 0;typeof W=="string"&&B.files.push({label:F,fileUri:b.URI.parse(W)})})}}return B}e.restoreRecentlyOpened=Z;function H(K){const x={entries:[]};for(const B of K.workspaces)P(B)?x.entries.push({folderUri:B.folderUri.toString(),label:B.label,remoteAuthority:B.remoteAuthority}):x.entries.push({workspace:{id:B.workspace.id,configPath:B.workspace.configPath.toString()},label:B.label,remoteAuthority:B.remoteAuthority});for(const B of K.files)x.entries.push({fileUri:B.fileUri.toString(),label:B.label,remoteAuthority:B.remoteAuthority});return x}e.toStoreData=H}),define(ee[50],te([0,1,14,8,71,33,2,72,9,3,13,24,140,5,6,38,27]),function(j,e,p,n,D,C,k,E,w,S,b,M,y,f,t,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,f.createDecorator)("dialogMainService");let v=class yt{constructor(u,g){this.stateMainService=u,this.logService=g,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new n.Queue}pickFileFolder(u,g){return this.doPick({...u,pickFolders:!0,pickFiles:!0,title:(0,y.localize)(0,null)},g)}pickFolder(u,g){return this.doPick({...u,pickFolders:!0,title:(0,y.localize)(1,null)},g)}pickFile(u,g){return this.doPick({...u,pickFiles:!0,title:(0,y.localize)(2,null)},g)}pickWorkspace(u,g){const c=(0,y.localize)(3,null),o=(0,C.mnemonicButtonLabel)((0,y.localize)(4,null)),l=m.WORKSPACE_FILTER;return this.doPick({...u,pickFiles:!0,title:c,filters:l,buttonLabel:o},g)}async doPick(u,g){const c={title:u.title,buttonLabel:u.buttonLabel,filters:u.filters};c.defaultPath=u.defaultPath||this.stateMainService.getItem(yt.workingDirPickerStorageKey),(typeof u.pickFiles=="boolean"||typeof u.pickFolders=="boolean")&&(c.properties=void 0,u.pickFiles&&u.pickFolders&&(c.properties=["multiSelections","openDirectory","openFile","createDirectory"])),c.properties||(c.properties=["multiSelections",u.pickFolders?"openDirectory":"openFile","createDirectory"]),S.isMacintosh&&c.properties.push("treatPackageAsDirectory");const o=g||p.BrowserWindow.getFocusedWindow(),l=await this.showOpenDialog(c,(0,b.withNullAsUndefined)(o));if(l&&l.filePaths&&l.filePaths.length>0)return this.stateMainService.setItem(yt.workingDirPickerStorageKey,(0,w.dirname)(l.filePaths[0])),l.filePaths}getWindowDialogQueue(u){if(u){let g=this.windowDialogQueues.get(u.id);return g||(g=new n.Queue,this.windowDialogQueues.set(u.id,g)),g}else return this.noWindowDialogueQueue}showMessageBox(u,g){return this.getWindowDialogQueue(g).queue(async()=>g?p.dialog.showMessageBox(g,u):p.dialog.showMessageBox(u))}async showSaveDialog(u,g){const c=this.acquireFileDialogLock(u,g);if(!c)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(g).queue(async()=>{let o;return g?o=await p.dialog.showSaveDialog(g,u):o=await p.dialog.showSaveDialog(u),o.filePath=this.normalizePath(o.filePath),o})}finally{(0,k.dispose)(c)}}normalizePath(u){return u&&S.isMacintosh&&(u=(0,E.normalizeNFC)(u)),u}normalizePaths(u){return u.map(g=>this.normalizePath(g))}async showOpenDialog(u,g){u.defaultPath&&(await M.Promises.exists(u.defaultPath)||(u.defaultPath=void 0));const c=this.acquireFileDialogLock(u,g);if(!c)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(g).queue(async()=>{let o;return g?o=await p.dialog.showOpenDialog(g,u):o=await p.dialog.showOpenDialog(u),o.filePaths=this.normalizePaths(o.filePaths),o})}finally{(0,k.dispose)(c)}}acquireFileDialogLock(u,g){if(!g)return k.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",u);let c=this.windowFileDialogLocks.get(g.id);c||(c=new Set,this.windowFileDialogLocks.set(g.id,c));const o=(0,D.hash)(u);if(!c.has(o))return this.logService.trace("[DialogMainService]: new file dialog lock created",u),c.add(o),(0,k.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",u),c?.delete(o),c?.size===0&&this.windowFileDialogLocks.delete(g.id)})}};v.workingDirPickerStorageKey="pickerWorkingDir",v=de([ne(0,d.IStateMainService),ne(1,t.ILogService)],v),e.DialogMainService=v}),define(ee[228],te([0,1,4,2,27]),function(j,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class C extends n.Disposable{constructor(E,w){super();this.logService=E,this.storageMainService=w,this._onDidChangeGlobalStorage=this._register(new p.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(p.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(E,w)=>(E?E.push(w):E=[w],E),C.STORAGE_CHANGE_DEBOUNCE_TIME)(E=>{E.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(E))}))}serializeGlobalStorageEvents(E){const w=new Map,S=new Set;return E.forEach(b=>{const M=this.storageMainService.globalStorage.get(b.key);typeof M=="string"?w.set(b.key,M):S.add(b.key)}),{changed:Array.from(w.entries()),deleted:Array.from(S.values())}}listen(E,w){switch(w){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${w}`)}async call(E,w,S){const b=(0,D.reviveIdentifier)(S.workspace),M=await this.withStorageInitialized(b);switch(w){case"getItems":return Array.from(M.items.entries());case"updateItems":{const y=S;if(y.insert)for(const[f,t]of y.insert)M.set(f,t);y.delete&&y.delete.forEach(f=>M.delete(f));break}case"close":{if(b)return M.close();break}default:throw new Error(`Call not found: ${w}`)}}async withStorageInitialized(E){const w=E?this.storageMainService.workspaceStorage(E):this.storageMainService.globalStorage;try{await w.init()}catch(S){this.logService.error(`StorageIPC#init: Unable to init ${E?"workspace":"global"} storage due to ${S}`)}return w}}e.StorageDatabaseChannel=C,C.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(ee[229],te([0,1,8,4,2,9,24,89,129,6,79,31,27]),function(j,e,p,n,D,C,k,E,w,S,b,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class f extends D.Disposable{constructor(v){super();this.logService=v,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new n.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new E.Storage(new E.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new p.DeferredPromise,this.whenInit=this.whenInitPromise.p}get storage(){return this._storage}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const v=await this.doCreate();this._storage.dispose(),this._storage=v,this._register(v.onDidChangeStorage(u=>this._onDidChangeStorage.fire({key:u}))),await this.doInit(v);const P=v.getBoolean(b.IS_NEW_KEY);P===void 0?v.set(b.IS_NEW_KEY,!0):P&&v.set(b.IS_NEW_KEY,!1)}catch(v){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${v}`)}finally{this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===S.LogLevel.Trace?v=>this.logService.trace(v):void 0,logError:v=>this.logService.error(v)}}doInit(v){return v.init()}get items(){return this._storage.items}get(v,P){return this._storage.get(v,P)}set(v,P){return this._storage.set(v,P)}delete(v){return this._storage.delete(v)}async close(){this.initializePromise&&await this.initializePromise,await this._storage.close(),this._onDidCloseStorage.fire()}}class t extends f{constructor(v,P,u){super(P);this.options=v,this.environmentService=u}async doCreate(){let v;return this.options.useInMemoryStorage?v=w.SQLiteStorageDatabase.IN_MEMORY_PATH:v=(0,C.join)(this.environmentService.globalStorageHome.fsPath,t.STORAGE_NAME),new E.Storage(new w.SQLiteStorageDatabase(v,{logging:this.createLoggingOptions()}))}async doInit(v){await super.doInit(v),this.updateTelemetryState(v)}updateTelemetryState(v){v.get(M.firstSessionDateStorageKey,void 0)===void 0&&v.set(M.firstSessionDateStorageKey,new Date().toUTCString());const u=v.get(M.currentSessionDateStorageKey,void 0),g=new Date().toUTCString();v.set(M.lastSessionDateStorageKey,typeof u=="undefined"?null:u),v.set(M.currentSessionDateStorageKey,g)}}e.GlobalStorageMain=t,t.STORAGE_NAME="state.vscdb";class d extends f{constructor(v,P,u,g){super(u);this.workspace=v,this.options=P,this.environmentService=g}async doCreate(){const{storageFilePath:v,wasCreated:P}=await this.prepareWorkspaceStorageFolder();return new E.Storage(new w.SQLiteStorageDatabase(v,{logging:this.createLoggingOptions()}),{hint:P?E.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:w.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const v=(0,C.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),P=(0,C.join)(v,d.WORKSPACE_STORAGE_NAME);return await k.Promises.exists(v)?{storageFilePath:P,wasCreated:!1}:(await k.Promises.mkdir(v,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(v),{storageFilePath:P,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(v){let P;if((0,y.isSingleFolderWorkspaceIdentifier)(this.workspace)?P={folder:this.workspace.uri.toString()}:(0,y.isWorkspaceIdentifier)(this.workspace)&&(P={workspace:this.workspace.configPath.toString()}),P)try{const u=(0,C.join)(v,d.WORKSPACE_META_NAME);await k.Promises.exists(u)||await k.Promises.writeFile(u,JSON.stringify(P,void 0,2))}catch(u){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${u}`)}}}e.WorkspaceStorageMain=d,d.WORKSPACE_STORAGE_NAME="state.vscdb",d.WORKSPACE_META_NAME="workspace.json"}),define(ee[101],te([0,1,16,7,27]),function(j,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function C(w,S,b){for(const y of w){const f=y.openedWorkspace;if((0,D.isWorkspaceIdentifier)(f)){const t=b(f);if(t){if(t.folders.some(d=>p.extUriBiasedIgnorePathCase.isEqualOrParent(S,d.uri)))return y}else if(p.extUriBiasedIgnorePathCase.isEqualOrParent(S,f.configPath))return y}}const M=w.filter(y=>(0,D.isSingleFolderWorkspaceIdentifier)(y.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqualOrParent(S,y.openedWorkspace.uri));if(M.length)return M.sort((y,f)=>-(y.openedWorkspace.uri.path.length-f.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=C;function k(w,S){for(const b of w)if((0,D.isWorkspaceIdentifier)(b.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(b.openedWorkspace.configPath,S)||(0,D.isSingleFolderWorkspaceIdentifier)(b.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(b.openedWorkspace.uri,S))return b}e.findWindowOnWorkspaceOrFolder=k;function E(w,S){const b=M=>S.some(y=>p.extUriBiasedIgnorePathCase.isEqual(n.URI.file(y),n.URI.file(M)));for(const M of w)if(M.config?.extensionDevelopmentPath?.some(y=>b(y)))return M}e.findWindowOnExtensionDevelopmentPath=E}),define(ee[230],te([0,1,14,2,3,16,7,19,20,6,38,34,27]),function(j,e,p,n,D,C,k,E,w,S,b,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let f=class bt extends n.Disposable{constructor(u,g,c,o,l){super();this.windowsMainService=u,this.stateMainService=g,this.lifecycleMainService=c,this.logService=o,this.configurationService=l,this._state=t(this.stateMainService.getItem(bt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){p.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(u=>this.onBeforeCloseWindow(u)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(u=>{u.newCount-u.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(u=>this.onBeforeCloseWindow(u))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const u={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!u.lastActiveWindow){let o=this.windowsMainService.getLastActiveWindow();(!o||o.isExtensionDevelopmentHost)&&(o=this.windowsMainService.getWindows().find(l=>!l.isExtensionDevelopmentHost)),o&&(u.lastActiveWindow=this.toWindowState(o))}const g=this.windowsMainService.getWindows().find(o=>o.isExtensionDevelopmentHost&&!o.isExtensionTestHost);g&&(u.lastPluginDevelopmentHostWindow=this.toWindowState(g)),this.windowsMainService.getWindowCount()>1&&(u.openedWindows=this.windowsMainService.getWindows().filter(o=>!o.isExtensionDevelopmentHost).map(o=>this.toWindowState(o)));const c=m(u);this.stateMainService.setItem(bt.windowsStateStorageKey,c),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",c)}onBeforeCloseWindow(u){if(this.lifecycleMainService.quitRequested)return;const g=this.toWindowState(u);u.isExtensionDevelopmentHost&&!u.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=g:!u.isExtensionDevelopmentHost&&u.openedWorkspace&&this._state.openedWindows.forEach(c=>{const o=(0,y.isWorkspaceIdentifier)(u.openedWorkspace)&&c.workspace?.id===u.openedWorkspace.id,l=(0,y.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)&&c.folderUri&&C.extUriBiasedIgnorePathCase.isEqual(c.folderUri,u.openedWorkspace.uri);(o||l)&&(c.uiState=g.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=g)}toWindowState(u){return{workspace:(0,y.isWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace:void 0,folderUri:(0,y.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace.uri:void 0,backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.serializeWindowState()}}getNewWindowState(u){const g=this.doGetNewWindowState(u),c=this.configurationService.getValue("window");let o;return g.hasDefaultState?o=!!(c?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(c.newWindowDimensions)>=0):(o=!!(this.lifecycleMainService.wasRestarted||c?.restoreFullscreen),o&&D.isMacintosh&&this.windowsMainService.getWindows().some(l=>l.isFullScreen)&&(o=!1)),g.mode===3&&!o&&(g.mode=1),g}doGetNewWindowState(u){const g=this.windowsMainService.getLastActiveWindow();if(!u.extensionTestsPath){if(!!u.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const r=u.workspace;if((0,y.isWorkspaceIdentifier)(r)){const h=this.state.openedWindows.filter(I=>I.workspace&&I.workspace.id===r.id).map(I=>I.uiState);if(h.length)return h[0]}if((0,y.isSingleFolderWorkspaceIdentifier)(r)){const h=this.state.openedWindows.filter(I=>I.folderUri&&C.extUriBiasedIgnorePathCase.isEqual(I.folderUri,r.uri)).map(I=>I.uiState);if(h.length)return h[0]}else if(u.backupPath){const h=this.state.openedWindows.filter(I=>I.backupPath===u.backupPath).map(I=>I.uiState);if(h.length)return h[0]}const a=this.lastClosedState||this.state.lastActiveWindow;if(!g&&a)return a.uiState}let c;const o=p.screen.getAllDisplays();if(o.length===1)c=o[0];else{if(D.isMacintosh){const r=p.screen.getCursorScreenPoint();c=p.screen.getDisplayNearestPoint(r)}!c&&g&&(c=p.screen.getDisplayMatching(g.getBounds())),c||(c=p.screen.getPrimaryDisplay()||o[0])}let l=(0,M.defaultWindowState)();l.x=Math.round(c.bounds.x+c.bounds.width/2-l.width/2),l.y=Math.round(c.bounds.y+c.bounds.height/2-l.height/2);const s=this.configurationService.getValue("window");let i=!0;if(s?.newWindowDimensions){if(s.newWindowDimensions==="maximized")l.mode=0,i=!1;else if(s.newWindowDimensions==="fullscreen")l.mode=3,i=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&g){const r=g.serializeWindowState();r.mode===3?l.mode=3:l=r,i=l.mode!==3&&s.newWindowDimensions==="offset"}}return i&&(l=this.ensureNoOverlap(l)),l.hasDefaultState=!0,l}ensureNoOverlap(u){if(this.windowsMainService.getWindows().length===0)return u;u.x=typeof u.x=="number"?u.x:0,u.y=typeof u.y=="number"?u.y:0;const g=this.windowsMainService.getWindows().map(c=>c.getBounds());for(;g.some(c=>c.x===u.x||c.y===u.y);)u.x+=30,u.y+=30;return u}};f.windowsStateStorageKey="windowsState",f=de([ne(0,M.IWindowsMainService),ne(1,b.IStateMainService),ne(2,w.ILifecycleMainService),ne(3,S.ILogService),ne(4,E.IConfigurationService)],f),e.WindowsStateHandler=f;function t(P){const u={openedWindows:[]},g=P||{openedWindows:[]};return g.lastActiveWindow&&(u.lastActiveWindow=d(g.lastActiveWindow)),g.lastPluginDevelopmentHostWindow&&(u.lastPluginDevelopmentHostWindow=d(g.lastPluginDevelopmentHostWindow)),Array.isArray(g.openedWindows)&&(u.openedWindows=g.openedWindows.map(c=>d(c))),u}e.restoreWindowsState=t;function d(P){const u={uiState:P.uiState};return P.backupPath&&(u.backupPath=P.backupPath),P.remoteAuthority&&(u.remoteAuthority=P.remoteAuthority),P.folder&&(u.folderUri=k.URI.parse(P.folder)),P.workspaceIdentifier&&(u.workspace={id:P.workspaceIdentifier.id,configPath:k.URI.parse(P.workspaceIdentifier.configURIPath)}),u}function m(P){return{lastActiveWindow:P.lastActiveWindow&&v(P.lastActiveWindow),lastPluginDevelopmentHostWindow:P.lastPluginDevelopmentHostWindow&&v(P.lastPluginDevelopmentHostWindow),openedWindows:P.openedWindows.map(u=>v(u))}}e.getWindowsStateStoreData=m;function v(P){return{workspaceIdentifier:P.workspace&&{id:P.workspace.id,configURIPath:P.workspace.configPath.toString()},folder:P.folderUri&&P.folderUri.toString(),backupPath:P.backupPath,remoteAuthority:P.remoteAuthority,uiState:P.uiState}}}),define(ee[102],te([0,1,60,30,10,3,16]),function(j,e,p,n,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function E(S){function b(){let M=S.scheme===D.Schemas.file?(0,k.originalFSPath)(S):S.toString();return C.isLinux||(M=M.toLowerCase()),(0,p.createHash)("md5").update(M).digest("hex")}return{id:b(),configPath:S}}e.getWorkspaceIdentifier=E;function w(S,b){function M(){if(S.scheme!==D.Schemas.file)return(0,p.createHash)("md5").update(S.toString()).digest("hex");if(!b)try{b=(0,n.statSync)(S.fsPath)}catch{return}let f;return C.isLinux?f=b.ino:C.isMacintosh?f=b.birthtime.getTime():C.isWindows&&(typeof b.birthtimeMs=="number"?f=Math.floor(b.birthtimeMs):f=b.birthtime.getTime()),(0,p.createHash)("md5").update(S.fsPath).update(f?String(f):"").digest("hex")}const y=M();if(typeof y=="string")return{id:y,uri:S}}e.getSingleFolderWorkspaceIdentifier=w}),define(ee[231],te([0,1,15,4,10,6,258,117,20,84]),function(j,e,p,n,D,C,k,E,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerMainProcessExtensionHostStarter=void 0;class b{constructor(t,d){this._worker=new k.Worker(D.FileAccess.asFileUri("vs/platform/extensions/node/extensionHostStarterWorkerMain.js",j).fsPath),this._worker.on("message",t),this._worker.on("error",d),this.onError=n.Event.fromNodeEventEmitter(this._worker,"error"),this.onExit=n.Event.fromNodeEventEmitter(this._worker,"exit"),this.onMessageError=n.Event.fromNodeEventEmitter(this._worker,"messageerror")}getId(){return 1}postMessage(t,d){this._worker.postMessage(t,d)}dispose(){this._worker.terminate()}}let M=class{constructor(t){this._logService=t}async logInfo(t){this._logService.info(t)}};M=de([ne(0,C.ILogService)],M);let y=class{constructor(t,d){this._logService=t,this._shutdown=!1,this._proxy=null;const m={create:(v,P,u)=>{const g=new b(P,u);return g.onError(c=>{this._logService.error("ExtensionHostStarterWorker has encountered an error:"),this._logService.error(c)}),g.onMessageError(c=>{this._logService.error("ExtensionHostStarterWorker has encountered a message error:"),this._logService.error(c)}),g.onExit(c=>this._logService.info(`ExtensionHostStarterWorker exited with code ${c}.`)),g.postMessage(v,[]),g}};this._worker=new E.SimpleWorkerClient(m,"vs/platform/extensions/node/extensionHostStarterWorker",new M(this._logService)),this._initialize(),d.onWillShutdown(v=>{this._shutdown=!0,this._proxy&&v.join(this._proxy.waitForAllExit(6e3))})}dispose(){}async _initialize(){this._proxy=await this._worker.getProxyObject(),this._logService.info("ExtensionHostStarterWorker created")}onDynamicStdout(t){return this._proxy.onDynamicStdout(t)}onDynamicStderr(t){return this._proxy.onDynamicStderr(t)}onDynamicMessage(t){return this._proxy.onDynamicMessage(t)}onDynamicError(t){return this._proxy.onDynamicError(t)}onDynamicExit(t){return this._proxy.onDynamicExit(t)}async createExtensionHost(){const t=await this._worker.getProxyObject();if(this._shutdown)throw(0,p.canceled)();return t.createExtensionHost()}async start(t,d){const m=S.StopWatch.create(!1),v=await this._worker.getProxyObject();if(this._shutdown)throw(0,p.canceled)();const P=setTimeout(()=>{this._logService.info("ExtensionHostStarterWorker.start() did not return within 30s. This might be a problem.")},3e4),u=await v.start(t,d),g=m.elapsed();return this._logService.info(`ExtensionHostStarterWorker.start() took ${g} ms.`),clearTimeout(P),u}async enableInspectPort(t){const d=await this._worker.getProxyObject();if(this._shutdown)throw(0,p.canceled)();return d.enableInspectPort(t)}async kill(t){const d=await this._worker.getProxyObject();if(this._shutdown)throw(0,p.canceled)();return d.kill(t)}};y=de([ne(0,C.ILogService),ne(1,w.ILifecycleMainService)],y),e.WorkerMainProcessExtensionHostStarter=y}),define(ee[57],te([0,1,60,61,26,17,15,4,2,9,3,32,37,87,232]),function(j,e,p,n,D,C,k,E,w,S,b,M,y,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class d{constructor(L,T=""){this.debugLabel=T,this.socket=L,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=$=>{if(this.traceSocketEvent("error",{code:$?.code,message:$?.message}),$){if($.code==="EPIPE")return;(0,k.onUnexpectedError)($)}},this.socket.on("error",this._errorListener)}traceSocketEvent(L,T){f.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,L,T)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(L){const T=$=>{this.traceSocketEvent("read",$),L(C.VSBuffer.wrap($))};return this.socket.on("data",T),{dispose:()=>this.socket.off("data",T)}}onClose(L){const T=$=>{this.traceSocketEvent("close",{hadError:$}),L({type:0,hadError:$,error:void 0})};return this.socket.on("close",T),{dispose:()=>this.socket.off("close",T)}}onEnd(L){const T=()=>{this.traceSocketEvent("nodeEndReceived"),L()};return this.socket.on("end",T),{dispose:()=>this.socket.off("end",T)}}write(L){if(!this.socket.destroyed)try{this.traceSocketEvent("write",L),this.socket.write(L.buffer,T=>{if(T){if(T.code==="EPIPE")return;(0,k.onUnexpectedError)(T)}})}catch(T){if(T.code==="EPIPE")return;(0,k.onUnexpectedError)(T)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((L,T)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),L();return}const $=()=>{this.socket.off("close",$),this.socket.off("end",$),this.socket.off("error",$),this.socket.off("timeout",$),this.socket.off("drain",$),this.traceSocketEvent("nodeDrainEnd"),L()};this.socket.on("close",$),this.socket.on("end",$),this.socket.on("error",$),this.socket.on("timeout",$),this.socket.on("drain",$)})}}e.NodeSocket=d;var m;(function(R){R[R.MinHeaderByteSize=2]="MinHeaderByteSize"})(m||(m={}));var v;(function(R){R[R.PeekHeader=1]="PeekHeader",R[R.ReadHeader=2]="ReadHeader",R[R.ReadBody=3]="ReadBody",R[R.Fin=4]="Fin"})(v||(v={}));class P extends w.Disposable{constructor(L,T,$,Q){super();this._onData=this._register(new E.Emitter),this._onClose=this._register(new E.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=L,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:T,inflateBytesLength:$?.byteLength||0,recordInflateBytes:Q}),this._flowManager=this._register(new u(this,T,$,Q,this._onData,(se,re)=>this._write(se,re))),this._register(this._flowManager.onError(se=>{console.error(se),(0,k.onUnexpectedError)(se),this._onClose.fire({type:0,hadError:!0,error:se})})),this._incomingData=new f.ChunkStream,this._register(this.socket.onData(se=>this._acceptChunk(se))),this._register(this.socket.onClose(se=>this._onClose.fire(se)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(L,T){this.socket.traceSocketEvent(L,T)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(L){return this._onData.event(L)}onClose(L){return this._onClose.event(L)}onEnd(L){return this.socket.onEnd(L)}write(L){this._flowManager.writeMessage(L)}_write(L,T){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",L);let $=2;L.byteLength<126?$+=0:L.byteLength<2**16?$+=2:$+=8;const Q=C.VSBuffer.alloc($);if(T?Q.writeUInt8(194,0):Q.writeUInt8(130,0),L.byteLength<126)Q.writeUInt8(L.byteLength,1);else if(L.byteLength<2**16){Q.writeUInt8(126,1);let se=1;Q.writeUInt8(L.byteLength>>>8&255,++se),Q.writeUInt8(L.byteLength>>>0&255,++se)}else{Q.writeUInt8(127,1);let se=1;Q.writeUInt8(0,++se),Q.writeUInt8(0,++se),Q.writeUInt8(0,++se),Q.writeUInt8(0,++se),Q.writeUInt8(L.byteLength>>>24&255,++se),Q.writeUInt8(L.byteLength>>>16&255,++se),Q.writeUInt8(L.byteLength>>>8&255,++se),Q.writeUInt8(L.byteLength>>>0&255,++se)}this.socket.write(C.VSBuffer.concat([Q,L]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(L){if(L.byteLength!==0){for(this._incomingData.acceptChunk(L);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const T=this._incomingData.peek(this._state.readLen),$=T.readUInt8(0),Q=($&128)>>>7,se=($&64)>>>6,re=T.readUInt8(1),V=(re&128)>>>7,Z=re&127;this._state.state=2,this._state.readLen=2+(V?4:0)+(Z===126?2:0)+(Z===127?8:0),this._state.fin=Q,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(se)),this._state.firstFrameOfMessage=Boolean(Q),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const T=this._incomingData.read(this._state.readLen),$=T.readUInt8(1),Q=($&128)>>>7;let se=$&127,re=1;se===126?se=T.readUInt8(++re)*2**8+T.readUInt8(++re):se===127&&(se=T.readUInt8(++re)*0+T.readUInt8(++re)*0+T.readUInt8(++re)*0+T.readUInt8(++re)*0+T.readUInt8(++re)*2**24+T.readUInt8(++re)*2**16+T.readUInt8(++re)*2**8+T.readUInt8(++re));let V=0;Q&&(V=T.readUInt8(++re)*2**24+T.readUInt8(++re)*2**16+T.readUInt8(++re)*2**8+T.readUInt8(++re)),this._state.state=3,this._state.readLen=se,this._state.mask=V,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const T=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",T),o(T,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",T),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(T,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await E.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=P;class u extends w.Disposable{constructor(L,T,$,Q,se,re){super();this._tracer=L,this._onData=se,this._writeFn=re,this._onError=this._register(new E.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new E.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,T?(this._zlibInflateStream=this._register(new g(this._tracer,Q,$,{windowBits:15})),this._zlibDeflateStream=this._register(new c(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(V=>this._onError.fire(V))),this._register(this._zlibDeflateStream.onError(V=>this._onError.fire(V)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:C.VSBuffer.alloc(0)}writeMessage(L){this._writeQueue.push(L),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const L=this._writeQueue.shift();if(this._zlibDeflateStream){const T=await this._deflateMessage(this._zlibDeflateStream,L);this._writeFn(T,!0)}else this._writeFn(L,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(L,T){return new Promise(($,Q)=>{L.write(T),L.flush(se=>$(se))})}acceptFrame(L,T,$){this._readQueue.push({data:L,isCompressed:T,isLastFrameOfMessage:$}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const L=this._readQueue.shift();if(this._zlibInflateStream&&L.isCompressed){const T=await this._inflateFrame(this._zlibInflateStream,L.data,L.isLastFrameOfMessage);this._onData.fire(T)}else this._onData.fire(L.data)}this._isProcessingReadQueue=!1}}_inflateFrame(L,T,$){return new Promise((Q,se)=>{L.write(T),$&&L.write(C.VSBuffer.fromByteArray([0,0,255,255])),L.flush(re=>Q(re))})}}class g extends w.Disposable{constructor(L,T,$,Q){super();this._tracer=L,this._recordInflateBytes=T,this._onError=this._register(new E.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=t.createInflateRaw(Q),this._zlibInflate.on("error",se=>{this._tracer.traceSocketEvent("zlibInflateError",{message:se?.message,code:se?.code}),this._onError.fire(se)}),this._zlibInflate.on("data",se=>{this._tracer.traceSocketEvent("zlibInflateData",se),this._pendingInflateData.push(C.VSBuffer.wrap(se))}),$&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",$.buffer),this._zlibInflate.write($.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.concat(this._recordedInflateBytes):C.VSBuffer.alloc(0)}write(L){this._recordInflateBytes&&this._recordedInflateBytes.push(L.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",L),this._zlibInflate.write(L.buffer)}flush(L){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const T=C.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,L(T)})}}class c extends w.Disposable{constructor(L,T){super();this._tracer=L,this._onError=this._register(new E.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=t.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",$=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:$?.message,code:$?.code}),this._onError.fire($)}),this._zlibDeflate.on("data",$=>{this._tracer.traceSocketEvent("zlibDeflateData",$),this._pendingDeflateData.push(C.VSBuffer.wrap($))})}write(L){this._tracer.traceSocketEvent("zlibDeflateWrite",L.buffer),this._zlibDeflate.write(L.buffer)}flush(L){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let T=C.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,T=T.slice(0,T.byteLength-4),L(T)})}}function o(R,L){if(L===0)return;let T=R.byteLength>>>2;for(let Z=0;Z<T;Z++){const H=R.readUInt32BE(Z*4);R.writeUInt32BE(H^L,Z*4)}let $=T*4,Q=R.byteLength-$;const se=L>>>24&255,re=L>>>16&255,V=L>>>8&255;Q>=1&&R.writeUInt8(R.readUInt8($)^se,$),Q>=2&&R.writeUInt8(R.readUInt8($+1)^re,$+1),Q>=3&&R.writeUInt8(R.readUInt8($+2)^V,$+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function s(){const R=(0,M.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${R}-sock`;let L;return e.XDG_RUNTIME_DIR?L=(0,S.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${R}.sock`):L=(0,S.join)((0,D.tmpdir)(),`vscode-ipc-${R}.sock`),r(L),L}e.createRandomIPCHandle=s;function i(R,L,T){const $=(0,p.createHash)("md5").update(R).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${$}-${T}-${L}-sock`;let Q;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?Q=(0,S.join)(e.XDG_RUNTIME_DIR,`vscode-${$.substr(0,8)}-${T}-${L}.sock`):Q=(0,S.join)(R,`${T}-${L}.sock`),r(Q),Q}e.createStaticIPCHandle=i;function r(R){const L=l[b.platform];typeof L=="number"&&R.length>=L&&console.warn(`WARNING: IPC handle "${R}" is longer than ${L} chars, try a shorter --user-data-dir`)}class a extends y.IPCServer{constructor(L){super(a.toClientConnectionEvent(L));this.server=L}static toClientConnectionEvent(L){const T=E.Event.fromNodeEventEmitter(L,"connection");return E.Event.map(T,$=>({protocol:new f.Protocol(new d($,"ipc-server-connection")),onDidClientDisconnect:E.Event.once(E.Event.fromNodeEventEmitter($,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=a;function h(R){return new Promise((L,T)=>{const $=(0,n.createServer)();$.on("error",T),$.listen(R,()=>{$.removeListener("error",T),L(new a($))})})}e.serve=h;function I(R,L){return new Promise((T,$)=>{const Q=(0,n.createConnection)(R,()=>{Q.removeListener("error",$),T(f.Client.fromSocket(new d(Q,`ipc-client${L}`),L))});Q.once("error",$)})}e.connect=I}),define(ee[233],te([0,1,57]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class n{constructor(w){this.driver=w}listen(w,S){throw new Error("No event found")}call(w,S,b){switch(S){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(b);case"startTracing":return this.driver.startTracing(b[0],b[1]);case"stopTracing":return this.driver.stopTracing(b[0],b[1],b[2]);case"reloadWindow":return this.driver.reloadWindow(b);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(b[0],b[1]);case"click":return this.driver.click(b[0],b[1],b[2],b[3]);case"doubleClick":return this.driver.doubleClick(b[0],b[1]);case"setValue":return this.driver.setValue(b[0],b[1],b[2]);case"getTitle":return this.driver.getTitle(b[0]);case"isActiveElement":return this.driver.isActiveElement(b[0],b[1]);case"getElements":return this.driver.getElements(b[0],b[1],b[2]);case"getElementXY":return this.driver.getElementXY(b[0],b[1],b[2]);case"typeInEditor":return this.driver.typeInEditor(b[0],b[1],b[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(b[0],b[1]);case"writeInTerminal":return this.driver.writeInTerminal(b[0],b[1],b[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(b);case"getLocalizedStrings":return this.driver.getLocalizedStrings(b)}throw new Error(`Call not found: ${S}`)}}e.DriverChannel=n;class D{constructor(w){this.channel=w}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(w){return this.channel.call("capturePage",w)}startTracing(w,S){return this.channel.call("startTracing",[w,S])}stopTracing(w,S,b){return this.channel.call("stopTracing",[w,S,b])}reloadWindow(w){return this.channel.call("reloadWindow",w)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(w,S){return this.channel.call("dispatchKeybinding",[w,S])}click(w,S,b,M){return this.channel.call("click",[w,S,b,M])}doubleClick(w,S){return this.channel.call("doubleClick",[w,S])}setValue(w,S,b){return this.channel.call("setValue",[w,S,b])}getTitle(w){return this.channel.call("getTitle",[w])}isActiveElement(w,S){return this.channel.call("isActiveElement",[w,S])}getElements(w,S,b){return this.channel.call("getElements",[w,S,b])}getElementXY(w,S,b,M){return this.channel.call("getElementXY",[w,S,b,M])}typeInEditor(w,S,b){return this.channel.call("typeInEditor",[w,S,b])}getTerminalBuffer(w,S){return this.channel.call("getTerminalBuffer",[w,S])}writeInTerminal(w,S,b){return this.channel.call("writeInTerminal",[w,S,b])}getLocaleInfo(w){return this.channel.call("getLocaleInfo",w)}getLocalizedStrings(w){return this.channel.call("getLocalizedStrings",w)}}e.DriverChannelClient=D;class C{constructor(w){this.registry=w}listen(w,S){throw new Error(`Event not found: ${S}`)}call(w,S,b){switch(S){case"registerWindowDriver":return this.registry.registerWindowDriver(b);case"reloadWindowDriver":return this.registry.reloadWindowDriver(b)}throw new Error(`Call not found: ${S}`)}}e.WindowDriverRegistryChannel=C;async function k(E){const w=await(0,p.connect)(E,"driverClient"),S=w.getChannel("driver"),b=new D(S);return{client:w,driver:b}}e.connect=k}),define(ee[23],te([0,1,46,9,57,48,169,5]),function(j,e,p,n,D,C,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,E.refineServiceDecorator)(C.IEnvironmentService);class w extends k.NativeEnvironmentService{get cachedLanguagesPath(){return(0,n.join)(this.userDataPath,"clp")}get backupHome(){return(0,n.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,n.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,D.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,n.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}de([p.memoize],w.prototype,"cachedLanguagesPath",null),de([p.memoize],w.prototype,"backupHome",null),de([p.memoize],w.prototype,"backupWorkspacesPath",null),de([p.memoize],w.prototype,"mainIPCHandle",null),de([p.memoize],w.prototype,"mainLockfile",null),de([p.memoize],w.prototype,"sandbox",null),de([p.memoize],w.prototype,"driverVerbose",null),de([p.memoize],w.prototype,"disableUpdates",null),de([p.memoize],w.prototype,"disableKeytar",null),de([p.memoize],w.prototype,"codeCachePath",null),de([p.memoize],w.prototype,"useCodeCache",null),e.EnvironmentMainService=w}),define(ee[234],te([0,1,60,30,29,10,9,3,16,7,24,163,19,23,18,6,27]),function(j,e,p,n,D,C,k,E,w,S,b,M,y,f,t,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let v=class{constructor(u,g,c){this.configurationService=g,this.logService=c,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=w.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(o,l)=>(0,D.isEqual)(o,l,!E.isLinux)},this.backupHome=u.backupHome,this.workspacesJsonPath=u.backupWorkspacesPath}async initialize(){let u;try{u=JSON.parse(await b.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch{u=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(u.emptyWorkspaceInfos);let g=[];try{Array.isArray(u.rootURIWorkspaces)&&(g=u.rootURIWorkspaces.map(o=>({workspace:{id:o.id,configPath:S.URI.parse(o.configURIPath)},remoteAuthority:o.remoteAuthority})))}catch{}this.workspaces=await this.validateWorkspaces(g);let c=[];try{Array.isArray(u.folderWorkspaceInfos)?c=u.folderWorkspaceInfos.map(o=>({folderUri:S.URI.parse(o.folderUri),remoteAuthority:o.remoteAuthority})):Array.isArray(u.folderURIWorkspaces)&&(c=u.folderURIWorkspaces.map(o=>({folderUri:S.URI.parse(o),remoteAuthority:void 0})))}catch{}this.folders=await this.validateFolders(c),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==t.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===t.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||t.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(u,g){this.workspaces.some(o=>u.workspace.id===o.workspace.id)||(this.workspaces.push(u),this.saveSync());const c=this.getBackupPath(u.workspace.id);return g&&this.moveBackupFolderSync(c,g),c}moveBackupFolderSync(u,g){if(n.existsSync(u)&&this.convertToEmptyWindowBackupSync(u),n.existsSync(g))try{n.renameSync(g,u)}catch(c){this.logService.error(`Backup: Could not move backup folder to new location: ${c.toString()}`)}}unregisterWorkspaceBackupSync(u){const g=u.id,c=this.workspaces.findIndex(o=>o.workspace.id===g);c!==-1&&(this.workspaces.splice(c,1),this.saveSync())}registerFolderBackupSync(u){return this.folders.some(g=>this.backupUriComparer.isEqual(u.folderUri,g.folderUri))||(this.folders.push(u),this.saveSync()),this.getBackupPath(this.getFolderHash(u))}unregisterFolderBackupSync(u){const g=this.folders.findIndex(c=>this.backupUriComparer.isEqual(u,c.folderUri));g!==-1&&(this.folders.splice(g,1),this.saveSync())}registerEmptyWindowBackupSync(u,g){const c=u||this.getRandomEmptyWindowId();return this.emptyWindows.some(o=>!!o.backupFolder&&this.backupPathComparer.isEqual(o.backupFolder,c))||(this.emptyWindows.push({backupFolder:c,remoteAuthority:g}),this.saveSync()),this.getBackupPath(c)}unregisterEmptyWindowBackupSync(u){const g=this.emptyWindows.findIndex(c=>!!c.backupFolder&&this.backupPathComparer.isEqual(c.backupFolder,u));g!==-1&&(this.emptyWindows.splice(g,1),this.saveSync())}getBackupPath(u){return(0,k.join)(this.backupHome,u)}async validateWorkspaces(u){if(!Array.isArray(u))return[];const g=new Set,c=[];for(let o of u){const l=o.workspace;if(!(0,m.isWorkspaceIdentifier)(l))return[];if(!g.has(l.id)){g.add(l.id);const s=this.getBackupPath(l.id);await this.doHasBackups(s)?l.configPath.scheme!==C.Schemas.file||await b.Promises.exists(l.configPath.fsPath)?c.push(o):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return c}async validateFolders(u){if(!Array.isArray(u))return[];const g=[],c=new Set;for(let o of u){const l=o.folderUri,s=this.backupUriComparer.getComparisonKey(l);if(!c.has(s)){c.add(s);const i=this.getBackupPath(this.getFolderHash(o));await this.doHasBackups(i)?l.scheme!==C.Schemas.file||await b.Promises.exists(l.fsPath)?g.push(o):await this.convertToEmptyWindowBackup(i):await this.deleteStaleBackup(i)}}return g}async validateEmptyWorkspaces(u){if(!Array.isArray(u))return[];const g=[],c=new Set;for(let o of u){const l=o.backupFolder;if(typeof l!="string")return[];if(!c.has(l)){c.add(l);const s=this.getBackupPath(l);await this.doHasBackups(s)?g.push(o):await this.deleteStaleBackup(s)}}return g}async deleteStaleBackup(u){try{await b.Promises.exists(u)&&await b.Promises.rm(u,b.RimRafMode.MOVE)}catch(g){this.logService.error(`Backup: Could not delete stale backup: ${g.toString()}`)}}async convertToEmptyWindowBackup(u){let g=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(o=>!!o.backupFolder&&this.backupPathComparer.isEqual(o.backupFolder,g));)g=this.getRandomEmptyWindowId();const c=this.getBackupPath(g);try{await b.Promises.rename(u,c)}catch(o){return this.logService.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.emptyWindows.push({backupFolder:g}),!0}convertToEmptyWindowBackupSync(u){let g=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(o=>!!o.backupFolder&&this.backupPathComparer.isEqual(o.backupFolder,g));)g=this.getRandomEmptyWindowId();const c=this.getBackupPath(g);try{n.renameSync(u,c)}catch(o){return this.logService.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.emptyWindows.push({backupFolder:g}),!0}async getDirtyWorkspaces(){const u=[];for(const g of this.workspaces)await this.hasBackups(g)&&u.push(g);for(const g of this.folders)await this.hasBackups(g)&&u.push(g);return u}hasBackups(u){let g;return(0,M.isEmptyWindowBackupInfo)(u)?g=u.backupFolder:(0,m.isFolderBackupInfo)(u)?g=this.getBackupPath(this.getFolderHash(u)):g=this.getBackupPath(u.workspace.id),this.doHasBackups(g)}async doHasBackups(u){try{const g=await b.Promises.readdir(u);for(const c of g)try{if((await b.Promises.readdir((0,k.join)(u,c))).length>0)return!0}catch{}}catch{}return!1}saveSync(){try{(0,b.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}async save(){try{await b.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(u=>({id:u.workspace.id,configURIPath:u.workspace.configPath.toString(),remoteAuthority:u.remoteAuthority})),folderWorkspaceInfos:this.folders.map(u=>({folderUri:u.folderUri.toString(),remoteAuthority:u.remoteAuthority})),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(u){const g=u.folderUri;let c;return g.scheme===C.Schemas.file?c=E.isLinux?g.fsPath:g.fsPath.toLowerCase():c=g.toString().toLowerCase(),(0,p.createHash)("md5").update(c).digest("hex")}};v=de([ne(0,f.IEnvironmentMainService),ne(1,y.IConfigurationService),ne(2,d.ILogService)],v),e.BackupMainService=v}),define(ee[235],te([0,1,8,4,109,59,2,3,37,57,165,233,23,186,20,34,18,7,9,17,6]),function(j,e,p,n,D,C,k,E,w,S,b,M,y,f,t,d,m,v,P,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function c(s){return s<21}let o=class{constructor(i,r,a,h,I,R,L){this.windowServer=i,this.options=r,this.windowsMainService=a,this.lifecycleMainService=h,this.fileService=I,this.environmentMainService=R,this.logService=L,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new n.Emitter}async registerWindowDriver(i){return this.logService.info(`[driver] registerWindowDriver(${i})`),this.registeredWindowIds.add(i),this.reloadingWindowIds.delete(i),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(i){this.logService.info(`[driver] reloadWindowDriver(${i})`),this.reloadingWindowIds.add(i)}async getWindowIds(){return this.windowsMainService.getWindows().map(r=>r.id).filter(r=>this.registeredWindowIds.has(r)&&!this.reloadingWindowIds.has(r))}async capturePage(i){const r=this.windowsMainService.getWindowById(i)??this.windowsMainService.getLastActiveWindow();if(!r?.win)throw new Error("Invalid window");return(await r.win.webContents.capturePage()).toPNG().toString("base64")}async startTracing(i,r){}async stopTracing(i,r,a){if(!a)return;const h=await this.capturePage(i),I=Buffer.from(h,"base64");await this.fileService.writeFile(v.URI.file((0,P.join)(this.environmentMainService.logsPath,`${r}.png`)),u.VSBuffer.wrap(I))}async reloadWindow(i){this.logService.info(`[driver] reloadWindow(${i})`),await this.whenUnfrozen(i);const r=this.windowsMainService.getWindowById(i);if(!r)throw new Error("Invalid window");this.reloadingWindowIds.add(i),this.lifecycleMainService.reload(r)}exitApplication(){return this.logService.info("[driver] exitApplication()"),this.lifecycleMainService.quit()}async dispatchKeybinding(i,r){await this.whenUnfrozen(i);const a=D.KeybindingParser.parseUserBinding(r);for(let h of a)await this._dispatchKeybinding(i,h)}async _dispatchKeybinding(i,r){if(r instanceof C.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const a=this.windowsMainService.getWindowById(i);if(!a?.win)throw new Error("Invalid window");const h=a.win.webContents,I=new C.SimpleKeybinding(!1,!1,!1,!1,r.keyCode),L=new f.USLayoutResolvedKeybinding(I.toChord(),E.OS).getElectronAccelerator(),T=[];r.ctrlKey&&T.push("ctrl"),r.metaKey&&T.push("meta"),r.shiftKey&&T.push("shift"),r.altKey&&T.push("alt"),h.sendInputEvent({type:"keyDown",keyCode:L,modifiers:T}),c(r.keyCode)||h.sendInputEvent({type:"char",keyCode:L,modifiers:T}),h.sendInputEvent({type:"keyUp",keyCode:L,modifiers:T}),await(0,p.timeout)(100)}async click(i,r,a,h){await(await this.getWindowDriver(i)).click(r,a,h)}async doubleClick(i,r){await(await this.getWindowDriver(i)).doubleClick(r)}async setValue(i,r,a){await(await this.getWindowDriver(i)).setValue(r,a)}async getTitle(i){return await(await this.getWindowDriver(i)).getTitle()}async isActiveElement(i,r){return await(await this.getWindowDriver(i)).isActiveElement(r)}async getElements(i,r,a){return await(await this.getWindowDriver(i)).getElements(r,a)}async getElementXY(i,r,a,h){return await(await this.getWindowDriver(i)).getElementXY(r,a,h)}async typeInEditor(i,r,a){await(await this.getWindowDriver(i)).typeInEditor(r,a)}async getTerminalBuffer(i,r){return await(await this.getWindowDriver(i)).getTerminalBuffer(r)}async writeInTerminal(i,r,a){await(await this.getWindowDriver(i)).writeInTerminal(r,a)}async getLocaleInfo(i){return await(await this.getWindowDriver(i)).getLocaleInfo()}async getLocalizedStrings(i){return await(await this.getWindowDriver(i)).getLocalizedStrings()}async getWindowDriver(i){await this.whenUnfrozen(i);const r=`window:${i}`,a=new w.StaticRouter(I=>I===r),h=this.windowServer.getChannel("windowDriver",a);return new b.WindowDriverChannelClient(h)}async whenUnfrozen(i){for(;this.reloadingWindowIds.has(i);)await n.Event.toPromise(this.onDidReloadingChange.event)}};o=de([ne(2,d.IWindowsMainService),ne(3,t.ILifecycleMainService),ne(4,m.IFileService),ne(5,y.IEnvironmentMainService),ne(6,g.ILogService)],o),e.Driver=o;async function l(s,i,r,a){const h=r.driverVerbose,I=a.createInstance(o,s,{verbose:h}),R=new M.WindowDriverRegistryChannel(I);s.registerChannel("windowDriverRegistry",R);const L=await(0,S.serve)(i),T=new M.DriverChannel(I);return L.registerChannel("driver",T),(0,k.combinedDisposable)(L,s)}e.serve=l}),define(ee[236],te([0,1,61,57]),function(j,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,C,k,E,w){const S=M=>w(M,void 0),b=p.createConnection({host:D,port:C},()=>{b.removeListener("error",S);const M=Buffer.alloc(16);for(let d=0;d<16;d++)M[d]=Math.round(Math.random()*256);const y=M.toString("base64"),f=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${C}/?${k}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${y}`];b.write(f.join(`\r
`)+`\r
\r
`);const t=d=>{d.toString().indexOf(`\r
\r
`)>=0&&(b.off("data",t),w(void 0,new n.NodeSocket(b,E)))};b.on("data",t)});b.setNoDelay(!0),b.once("error",S)}}}),define(ee[237],te([0,1,61,122,236,8,2,19,6,22,202,99,78]),function(j,e,p,n,D,C,k,E,w,S,b,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function f(P,u,g,c,o){let l;for(let s=3;s&&(l&&l.dispose(),l=await new t(P,u,g,c,o).waitForReady(),!(o&&n.BROWSER_RESTRICTED_PORTS[o]||!n.BROWSER_RESTRICTED_PORTS[l.tunnelLocalPort]));s--);return l}class t extends k.Disposable{constructor(u,g,c,o,l){super();this.defaultTunnelHost=g,this.suggestedLocalPort=l,this.privacy=M.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=u,this._server=p.createServer(),this._barrier=new C.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=o,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(g=>{g()})}async waitForReady(){let u=await(0,n.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),g=null;return this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),g=this._server.address(),g||(u=0,this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),g=this._server.address()),this.tunnelLocalPort=g.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${g.port}`,this}async _onConnection(u){u.pause();const g=(0,M.isLocalhost)(this.tunnelRemoteHost)||(0,M.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,b.connectRemoteAgentTunnel)(this._options,g,this.tunnelRemotePort),o=c.getSocket().socket,l=c.readEntireBuffer();c.dispose(),l.byteLength>0&&u.write(l.buffer),u.on("end",()=>{u.localAddress&&this._socketsDispose.delete(u.localAddress),o.end()}),u.on("close",()=>o.end()),u.on("error",()=>{u.localAddress&&this._socketsDispose.delete(u.localAddress),o.destroy()}),o.on("end",()=>u.end()),o.on("close",()=>u.end()),o.on("error",()=>{u.destroy()}),u.pipe(o),o.pipe(u),u.localAddress&&this._socketsDispose.set(u.localAddress,()=>{u.end(),o.end()})}}let d=class extends M.AbstractTunnelService{constructor(u,g,c,o,l){super(g);this.socketFactory=u,this.signService=c,this.productService=o,this.configurationService=l}get defaultTunnelHost(){const u=this.configurationService.getValue("remote.localPortHost");return!u||u==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(u,g,c,o,l,s,i){const r=this.getTunnelFromMap(g,c);if(r)return++r.refcount,r.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,g,c,o,l,s,i);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${g}:${c} on local port ${o}.`);const a={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:u,signService:this.signService,logService:this.logService,ipcLogger:null},h=f(a,this.defaultTunnelHost,g,c,o);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(g,c,h),h}}};d=de([ne(1,w.ILogService),ne(2,y.ISignService),ne(3,S.IProductService),ne(4,E.IConfigurationService)],d),e.BaseTunnelService=d;let m=class extends d{constructor(u,g,c,o){super(D.nodeSocketFactory,u,g,c,o)}};m=de([ne(0,w.ILogService),ne(1,y.ISignService),ne(2,S.IProductService),ne(3,E.IConfigurationService)],m),e.TunnelService=m;let v=class extends k.Disposable{constructor(u,g,c,o){super();this.logService=u,this.productService=g,this.signService=c,this.configurationService=o,this._tunnelServices=new Map}async openTunnel(u,g,c,o,l,s,i,r){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${o} on local port ${l}.`),!this._tunnelServices.has(u)){const a=new m(this.logService,this.signService,this.productService,this.configurationService);this._register(a),this._tunnelServices.set(u,a),a.onTunnelClosed(async()=>{(await a.tunnels).length===0&&(a.dispose(),this._tunnelServices.delete(u))})}return this._tunnelServices.get(u).openTunnel(g,c,o,l,s,i,r)}};v=de([ne(0,w.ILogService),ne(1,S.IProductService),ne(2,y.ISignService),ne(3,E.IConfigurationService)],v),e.SharedTunnelsService=v}),define(ee[238],te([0,1,206,8,17,15,2,13,19,48,93,6,205,232]),function(j,e,p,n,D,C,k,E,w,S,b,M,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let t=class extends k.Disposable{constructor(m,v,P){super();this.environmentService=v,this.logService=P,this.configure(m.getValue()),this._register(m.onDidChangeConfiguration(()=>this.configure(m.getValue()),this))}configure(m){this.proxyUrl=m.http&&m.http.proxy,this.strictSSL=!!(m.http&&m.http.proxyStrictSSL),this.authorization=m.http&&m.http.proxyAuthorization}async request(m,v){this.logService.trace("RequestService#request",m.url);const{proxyUrl:P,strictSSL:u}=this;let g;try{g=await(0,b.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(l){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request resolving shell environment failed",l))}const c={...process.env,...g},o=m.agent?m.agent:await(0,y.getProxyAgent)(m.url||"",c,{proxyUrl:P,strictSSL:u});return m.agent=o,m.strictSSL=u,this.authorization&&(m.headers={...m.headers||{},"Proxy-Authorization":this.authorization}),this._request(m,v)}async getNodeRequest(m){return((0,p.parse)(m.url).protocol==="https:"?await new Promise((u,g)=>{j(["https"],u,g)}):await new Promise((u,g)=>{j(["http"],u,g)})).request}_request(m,v){return n.Promises.withAsyncBody(async(P,u)=>{let g;const c=(0,p.parse)(m.url),o=m.getRawRequest?m.getRawRequest(m):await this.getNodeRequest(m),l={hostname:c.hostname,port:c.port?parseInt(c.port):c.protocol==="https:"?443:80,protocol:c.protocol,path:c.path,method:m.type||"GET",headers:m.headers,agent:m.agent,rejectUnauthorized:(0,E.isBoolean)(m.strictSSL)?m.strictSSL:!0};m.user&&m.password&&(l.auth=m.user+":"+m.password),g=o(l,s=>{const i=(0,E.isNumber)(m.followRedirects)?m.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&i>0&&s.headers.location)this._request({...m,url:s.headers.location,followRedirects:i-1},v).then(P,u);else{let r=s;s.headers["content-encoding"]==="gzip"&&(r=s.pipe((0,f.createGunzip)())),P({res:s,stream:(0,D.streamToBufferReadableStream)(r)})}}),g.on("error",u),m.timeout&&g.setTimeout(m.timeout),m.data&&typeof m.data=="string"&&g.write(m.data),g.end(),v.onCancellationRequested(()=>{g.abort(),u((0,C.canceled)())})})}async resolveProxy(m){}};t=de([ne(0,w.IConfigurationService),ne(1,S.INativeEnvironmentService),ne(2,M.ILogService)],t),e.RequestService=t}),define(ee[239],te([0,1,14,238]),function(j,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function D(k){return p.net.request}class C extends n.RequestService{request(E,w){return super.request({...E||{},getRawRequest:D},w)}}e.RequestMainService=C}),define(ee[240],te([0,1,14,8,4,2,10,13,88,23,20,6,54,55,67,39]),function(j,e,p,n,D,C,k,E,w,S,b,M,y,f,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let m=class extends C.Disposable{constructor(P,u,g,c,o,l,s){super();this.machineId=P,this.userEnv=u,this.environmentMainService=g,this.lifecycleMainService=c,this.logService=o,this.themeMainService=l,this.protocolMainService=s,this.firstWindowConnectionBarrier=new n.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new D.Emitter),this.onDidError=D.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){p.ipcMain.on("vscode:createSharedProcessMessageChannel",(P,u)=>this.onWindowConnection(P,u)),p.ipcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(P,u)=>this.onWorkerConnection(P,u)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(P,u){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const g=await this.connect();if(P.sender.isDestroyed())return g.close();P.sender.postMessage("vscode:createSharedProcessMessageChannelResult",u,[g])}onWorkerConnection(P,u){this.logService.trace("SharedProcess: onWorkerConnection",u);const g=new C.DisposableStore,c=l=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${l}')`,u),g.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",u))},o=p.BrowserWindow.fromId(u.reply.windowId);if(!o||o.isDestroyed()||o.webContents.isDestroyed()||!u.reply.channel){c("unavailable");return}g.add(D.Event.filter(this.lifecycleMainService.onWillLoadWindow,l=>l.window.win===o)(()=>c("load"))),g.add(D.Event.fromNodeEventEmitter(o,"closed")(()=>c("closed"))),o.webContents.postMessage(u.reply.channel,u.reply.nonce,P.ports)}onWillShutdown(){const P=this.window;!P||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(P.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{P.close()}catch{}this.window=void 0},0))}send(P,...u){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${P}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(P,...u)}catch(g){this.logService.warn(`Error sending IPC message to channel '${P}' of shared process: ${(0,d.toErrorMessage)(g)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(P=>p.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),P()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(P=>p.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),P()}))})()),this._whenIpcReady}createWindow(){const P=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new p.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:k.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${P.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1}}),P.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:y.default}),this.window.loadURL(k.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",j).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=P=>{this.logService.trace("SharedProcess#close prevented"),P.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(P,u)=>this._onDidError.fire({type:2,details:u})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(P,u,g)=>this._onDidError.fire({type:3,details:{reason:g,exitCode:u}})))}async connect(){await this.whenIpcReady;const P=(0,E.assertIsDefined)(this.window);return(0,w.connect)(P)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const P=this.window;return P?!P.isDestroyed()&&!P.webContents.isDestroyed():!1}};m=de([ne(2,S.IEnvironmentMainService),ne(3,b.ILifecycleMainService),ne(4,M.ILogService),ne(5,t.IThemeMainService),ne(6,f.IProtocolMainService)],m),e.SharedProcess=m}),define(ee[241],te([0,1,8,17,9,13,7,23,18,6]),function(j,e,p,n,D,C,k,E,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class b{constructor(f,t,d){this.storagePath=f,this.logService=t,this.fileService=d,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new p.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(f){f.fileOperationResult!==1&&this.logService.error(f)}}getItem(f,t){const d=this.storage[f];return(0,C.isUndefinedOrNull)(d)?t:d}setItem(f,t){this.setItems([{key:f,data:t}])}setItems(f){let t=!1;for(const{key:d,data:m}of f)this.storage[d]!==m&&((0,C.isUndefinedOrNull)(m)?(0,C.isUndefined)(this.storage[d])||(this.storage[d]=void 0,t=!0):(this.storage[d]=m,t=!0));t&&this.save()}removeItem(f){(0,C.isUndefined)(this.storage[f])||(this.storage[f]=void 0,this.save())}async save(f){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),f)}async doSave(){if(!this.initializing)return;await this.initializing;const f=JSON.stringify(this.storage,null,4);if(f!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,n.VSBuffer.fromString(f)),this.lastSavedStorageContents=f}catch(t){this.logService.error(t)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=b;let M=class It{constructor(f,t,d){this.fileStorage=new b(k.URI.file((0,D.join)(f.userDataPath,It.STATE_FILE)),t,d)}async init(){return this.fileStorage.init()}getItem(f,t){return this.fileStorage.getItem(f,t)}setItem(f,t){this.fileStorage.setItem(f,t)}setItems(f){this.fileStorage.setItems(f)}removeItem(f){this.fileStorage.removeItem(f)}close(){return this.fileStorage.close()}};M.STATE_FILE="storage.json",M=de([ne(0,E.IEnvironmentMainService),ne(1,S.ILogService),ne(2,w.IFileService)],M),e.StateMainService=M}),define(ee[80],te([0,1,43,2,48,23,5,20,6,79,229]),function(j,e,p,n,D,C,k,E,w,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GlobalStorageMainService=e.IGlobalStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,k.createDecorator)("storageMainService");let M=class extends n.Disposable{constructor(t,d,m){super();this.logService=t,this.environmentService=d,this.lifecycleMainService=m,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async t=>{t.workspace&&this.workspaceStorage(t.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(t=>{t.join(this.globalStorage.close());for(const[,d]of this.mapWorkspaceToStorage)t.join(d.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const t=new b.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,p.once)(t.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),t}createWorkspaceStorage(t){return new b.WorkspaceStorageMain(t,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(t){let d=this.mapWorkspaceToStorage.get(t.id);return d||(this.logService.trace(`StorageMainService: creating workspace storage (${t.id})`),d=this.createWorkspaceStorage(t),this.mapWorkspaceToStorage.set(t.id,d),(0,p.once)(d.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${t.id})`),this.mapWorkspaceToStorage.delete(t.id)})),d}};M=de([ne(0,w.ILogService),ne(1,D.IEnvironmentService),ne(2,E.ILifecycleMainService)],M),e.StorageMainService=M,e.IGlobalStorageMainService=(0,k.createDecorator)("globalStorageMainService");let y=class extends S.AbstractStorageService{constructor(t,d){super();this.environmentMainService=t,this.storageMainService=d,this.whenReady=this.storageMainService.globalStorage.whenInit}doInitialize(){return this.storageMainService.globalStorage.whenInit}getStorage(t){switch(t){case 0:return this.storageMainService.globalStorage.storage;case 1:return}}getLogDetails(t){return t===0?this.environmentMainService.globalStorageHome.fsPath:void 0}shouldFlushWhenIdle(){return!1}migrate(){throw new Error("Migrating storage is unsupported from main process")}};y=de([ne(0,C.IEnvironmentMainService),ne(1,e.IStorageMainService)],y),e.GlobalStorageMainService=y}),define(ee[81],te([0,1,8,21,4,19,23,20,6,22,49,41]),function(j,e,p,n,D,C,k,E,w,S,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function y(t,d,m){return`${m.updateUrl}/api/update/${t}/${d}/${m.commit}`}e.createUpdateURL=y;let f=class{constructor(d,m,v,P,u,g){this.lifecycleMainService=d,this.configurationService=m,this.environmentMainService=v,this.requestService=P,this.logService=u,this.productService=g,this._state=M.State.Uninitialized,this._onStateChange=new D.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(d){this.logService.info("update#setState",d.type),this._state=d,this._onStateChange.fire(d)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const d=this.getUpdateMode(),m=this.getProductQuality(d);if(!m){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(m),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(M.State.Idle(this.getUpdateType())),d==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}d==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,v=>this.logService.error(v))}getUpdateMode(){return(0,C.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(d){return d==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(d=60*60*1e3){return(0,p.timeout)(d).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(d){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(d)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(d){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(d=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${d}`),!d&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(this.url){if(this.getUpdateMode()==="none")return!1}else return;return(await this.requestService.request({url:this.url},n.CancellationToken.None)).res.statusCode===204}getUpdateType(){return 1}doQuitAndInstall(){}};f=de([ne(0,E.ILifecycleMainService),ne(1,C.IConfigurationService),ne(2,k.IEnvironmentMainService),ne(3,b.IRequestService),ne(4,w.ILogService),ne(5,S.IProductService)],f),e.AbstractUpdateService=f}),define(ee[242],te([0,1,14,46,4,2,19,23,20,6,22,49,31,41,81]),function(j,e,p,n,D,C,k,E,w,S,b,M,y,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let d=class extends t.AbstractUpdateService{constructor(v,P,u,g,c,o,l){super(v,P,g,c,o,l);this.telemetryService=u,this.disposables=new C.DisposableStore}get onRawError(){return D.Event.fromNodeEventEmitter(p.autoUpdater,"error",(v,P)=>P)}get onRawUpdateNotAvailable(){return D.Event.fromNodeEventEmitter(p.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return D.Event.fromNodeEventEmitter(p.autoUpdater,"update-available",(v,P,u)=>({url:P,version:u,productVersion:u}))}get onRawUpdateDownloaded(){return D.Event.fromNodeEventEmitter(p.autoUpdater,"update-downloaded",(v,P,u,g)=>({releaseNotes:P,version:u,productVersion:u,date:g}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(v){this.logService.error("UpdateService error:",v);const u=(this.state.type==="checking for updates"?this.state.explicit:!0)?v:void 0;this.setState(f.State.Idle(1,u))}buildUpdateFeedUrl(v){let P;this.productService.darwinUniversalAssetId?P=this.productService.darwinUniversalAssetId:P=process.arch==="x64"?"darwin":"darwin-arm64";const u=(0,t.createUpdateURL)(P,v,this.productService);try{p.autoUpdater.setFeedURL({url:u})}catch(g){this.logService.error("Failed to set update feed URL",g);return}return u}doCheckForUpdates(v){this.setState(f.State.CheckingForUpdates(v)),p.autoUpdater.checkForUpdates()}onUpdateAvailable(v){this.state.type==="checking for updates"&&this.setState(f.State.Downloading(v))}onUpdateDownloaded(v){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:v.version}),this.setState(f.State.Ready(v)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(f.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),p.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};de([n.memoize],d.prototype,"onRawError",null),de([n.memoize],d.prototype,"onRawUpdateNotAvailable",null),de([n.memoize],d.prototype,"onRawUpdateAvailable",null),de([n.memoize],d.prototype,"onRawUpdateDownloaded",null),d=de([ne(0,w.ILifecycleMainService),ne(1,k.IConfigurationService),ne(2,y.ITelemetryService),ne(3,E.IEnvironmentMainService),ne(4,M.IRequestService),ne(5,S.ILogService),ne(6,b.IProductService)],d),e.DarwinUpdateService=d}),define(ee[243],te([0,1,45,30,8,4,9,23,20,6,31,41]),function(j,e,p,n,D,C,k,E,w,S,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let y=class{constructor(d,m,v){if(this.lifecycleMainService=d,this.logService=v,this._state=M.State.Uninitialized,this._onStateChange=new C.Emitter,this.onStateChange=this._onStateChange.event,m.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(M.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,P=>this.logService.error(P))}get state(){return this._state}setState(d){this.logService.info("update#setState",d.type),this._state=d,this._onStateChange.fire(d)}scheduleCheckForUpdates(d=60*60*1e3){return(0,D.timeout)(d).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(d){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(d)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(d){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(d=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${d}`),!d&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};y=de([ne(0,w.ILifecycleMainService),ne(1,E.IEnvironmentMainService),ne(2,S.ILogService)],y);let f=class extends y{constructor(d,m,v,P,u,g){super(v,P,u);this.snap=d,this.snapRevision=m,this.telemetryService=g;const c=(0,n.watch)(k.dirname(this.snap)),o=C.Event.fromNodeEventEmitter(c,"change",(r,a)=>a),l=C.Event.filter(o,r=>r==="current"),i=C.Event.debounce(l,(r,a)=>a,2e3)(()=>this.checkForUpdates(!1));v.onWillShutdown(()=>{i.dispose(),c.close()})}doCheckForUpdates(){this.setState(M.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(d=>{d?this.setState(M.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(M.State.Idle(2)))},d=>{this.logService.error(d),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(M.State.Idle(2,d.message||d))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,p.spawn)("sleep 3 && "+k.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const d=await new Promise((v,P)=>(0,n.realpath)(`${k.dirname(this.snap)}/current`,(u,g)=>u?P(u):v(g))),m=k.basename(d);return this.snapRevision!==m}isLatestVersion(){return this.isUpdateAvailable().then(void 0,d=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};f=de([ne(2,w.ILifecycleMainService),ne(3,E.IEnvironmentMainService),ne(4,S.ILogService),ne(5,b.ITelemetryService)],f),e.SnapUpdateService=f}),define(ee[42],te([0,1,14,30,4,44,33,2,10,9,3,16,13,24,162,52,50,23,5,6,22,101,27,102]),function(j,e,p,n,D,C,k,E,w,S,b,M,y,f,t,d,m,v,P,u,g,c,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,P.createDecorator)("workspacesManagementMainService");let s=class extends E.Disposable{constructor(r,a,h,I,R){super();this.environmentMainService=r,this.logService=a,this.backupMainService=h,this.dialogMainService=I,this.productService=R,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new D.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new D.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(r){return this.doResolveLocalWorkspace(r,a=>(0,n.readFileSync)(a,"utf8"))}resolveLocalWorkspace(r){return this.doResolveLocalWorkspace(r,a=>f.Promises.readFile(a,"utf8"))}doResolveLocalWorkspace(r,a){if(!!this.isWorkspacePath(r)&&r.scheme===w.Schemas.file)try{const h=a(r.fsPath);return h instanceof Promise?h.then(I=>this.doResolveWorkspace(r,I),I=>{}):this.doResolveWorkspace(r,h)}catch{return}}isWorkspacePath(r){return(0,o.isUntitledWorkspace)(r,this.environmentMainService)||(0,o.hasWorkspaceFileExtension)(r)}doResolveWorkspace(r,a){try{const h=this.doParseStoredWorkspace(r,a),I=(0,l.getWorkspaceIdentifier)(r);return{id:I.id,configPath:I.configPath,folders:(0,o.toWorkspaceFolders)(h.folders,I.configPath,M.extUriBiasedIgnorePathCase),remoteAuthority:h.remoteAuthority,transient:h.transient}}catch(h){this.logService.warn(h.toString())}}doParseStoredWorkspace(r,a){const h=(0,C.parse)(a);if(h&&Array.isArray(h.folders))h.folders=h.folders.filter(I=>(0,o.isStoredWorkspaceFolder)(I));else throw new Error(`${r.toString(!0)} looks like an invalid workspace file.`);return h}async createUntitledWorkspace(r,a){const{workspace:h,storedWorkspace:I}=this.newUntitledWorkspace(r,a),R=h.configPath.fsPath;return await f.Promises.mkdir((0,S.dirname)(R),{recursive:!0}),await f.Promises.writeFile(R,JSON.stringify(I,null,"	")),h}createUntitledWorkspaceSync(r,a){const{workspace:h,storedWorkspace:I}=this.newUntitledWorkspace(r,a),R=h.configPath.fsPath;return(0,n.mkdirSync)((0,S.dirname)(R),{recursive:!0}),(0,f.writeFileSync)(R,JSON.stringify(I,null,"	")),h}newUntitledWorkspace(r=[],a){const h=(Date.now()+Math.round(Math.random()*1e3)).toString(),I=(0,M.joinPath)(this.untitledWorkspacesHome,h),R=(0,M.joinPath)(I,o.UNTITLED_WORKSPACE_NAME),L=[];for(const T of r)L.push((0,o.getStoredWorkspaceFolder)(T.uri,!0,T.name,I,!b.isWindows,M.extUriBiasedIgnorePathCase));return{workspace:(0,l.getWorkspaceIdentifier)(R),storedWorkspace:{folders:L,remoteAuthority:a}}}async getWorkspaceIdentifier(r){return(0,l.getWorkspaceIdentifier)(r)}isUntitledWorkspace(r){return(0,o.isUntitledWorkspace)(r.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(r){!this.isUntitledWorkspace(r)||(this.doDeleteUntitledWorkspaceSync(r),this._onDidDeleteUntitledWorkspace.fire(r))}async deleteUntitledWorkspace(r){this.deleteUntitledWorkspaceSync(r)}doDeleteUntitledWorkspaceSync(r){const a=(0,M.originalFSPath)(r.configPath);try{(0,f.rimrafSync)((0,S.dirname)(a));const h=(0,S.join)(this.environmentMainService.workspaceStorageHome.fsPath,r.id);(0,n.existsSync)(h)&&(0,f.writeFileSync)((0,S.join)(h,"obsolete"),"")}catch(h){this.logService.warn(`Unable to delete untitled workspace ${a} (${h}).`)}}getUntitledWorkspacesSync(){const r=[];try{const a=(0,f.readdirSync)(this.untitledWorkspacesHome.fsPath).map(h=>(0,M.joinPath)(this.untitledWorkspacesHome,h,o.UNTITLED_WORKSPACE_NAME));for(const h of a){const I=(0,l.getWorkspaceIdentifier)(h),R=this.resolveLocalWorkspaceSync(h);R?r.push({workspace:I,remoteAuthority:R.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(I)}}catch(a){a.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${a}).`)}return r}async enterWorkspace(r,a,h){if(!r||!r.win||!r.isReady||!await this.isValidTargetWorkspacePath(r,a,h))return;const R=this.doEnterWorkspace(r,(0,l.getWorkspaceIdentifier)(h));if(!!R)return this._onDidEnterWorkspace.fire({window:r,workspace:R.workspace}),R}async isValidTargetWorkspacePath(r,a,h){if(!h)return!0;if((0,o.isWorkspaceIdentifier)(r.openedWorkspace)&&M.extUriBiasedIgnorePathCase.isEqual(r.openedWorkspace.configPath,h))return!1;if((0,c.findWindowOnWorkspaceOrFolder)(a,h)){const I={title:this.productService.nameLong,type:"info",buttons:[(0,k.mnemonicButtonLabel)((0,t.localize)(0,null))],message:(0,t.localize)(1,null,(0,M.basename)(h)),detail:(0,t.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(I,(0,y.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(r,a){if(!r.config)return;r.focus();let h;return r.config.extensionDevelopmentPath||(h=this.backupMainService.registerWorkspaceBackupSync({workspace:a,remoteAuthority:r.remoteAuthority},r.config.backupPath)),(0,o.isWorkspaceIdentifier)(r.openedWorkspace)&&this.isUntitledWorkspace(r.openedWorkspace)&&this.deleteUntitledWorkspaceSync(r.openedWorkspace),r.config.workspace=a,r.config.backupPath=h,{workspace:a,backupPath:h}}};s=de([ne(0,v.IEnvironmentMainService),ne(1,u.ILogService),ne(2,d.IBackupMainService),ne(3,m.IDialogMainService),ne(4,g.IProductService)],s),e.WorkspacesManagementMainService=s}),define(ee[103],te([0,1,14,21,5,34,27,42]),function(j,e,p,n,D,C,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,D.createDecorator)(e.ID);let w=class{constructor(b,M){this.windowsMainService=b,this.workspacesManagementMainService=M}async getRemoteDiagnostics(b){const M=this.windowsMainService.getWindows();return(await Promise.all(M.map(f=>new Promise(t=>{const d=f.remoteAuthority;if(d){const m=`vscode:getDiagnosticInfoResponse${f.id}`,v={includeProcesses:b.includeProcesses,folders:b.includeWorkspaceMetadata?this.getFolderURIs(f):void 0};f.sendWhenReady("vscode:getDiagnosticInfo",n.CancellationToken.None,{replyChannel:m,args:v}),p.ipcMain.once(m,(P,u)=>{u||t({hostName:d,errorMessage:`Unable to resolve connection to '${d}'.`}),t(u)}),setTimeout(()=>{t({hostName:d,errorMessage:`Connection to '${d}' could not be established`})},5e3)}else t(void 0)})))).filter(f=>!!f)}getFolderURIs(b){const M=[],y=b.openedWorkspace;if((0,k.isSingleFolderWorkspaceIdentifier)(y))M.push(y.uri);else if((0,k.isWorkspaceIdentifier)(y)){const f=this.workspacesManagementMainService.resolveLocalWorkspaceSync(y.configPath);f&&f.folders.forEach(d=>{M.push(d.uri)})}return M}};w=de([ne(0,C.IWindowsMainService),ne(1,E.IWorkspacesManagementMainService)],w),e.DiagnosticsMainService=w}),define(ee[104],te([0,1,14,28,3,13,7,24,19,53,5,6,100,34,27,42]),function(j,e,p,n,D,C,k,E,w,S,b,M,y,f,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,b.createDecorator)(e.ID);let m=class{constructor(P,u,g,c,o){this.logService=P,this.windowsMainService=u,this.urlService=g,this.workspacesManagementMainService=c,this.configurationService=o}async start(P,u){this.logService.trace("Received data from other instance: ",P,u),D.isMacintosh&&p.app.focus({steal:!0});const g=this.parseOpenUrl(P);if(g.length){let c=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(c=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),c.then(()=>{for(const{uri:o,url:l}of g)this.urlService.open(o,{originalUrl:l})})}else return this.startOpenWindow(P,u)}parseOpenUrl(P){return P["open-url"]&&P._urls&&P._urls.length>0?(0,n.coalesce)(P._urls.map(u=>{try{return{uri:k.URI.parse(u),url:u}}catch{return null}})):[]}async startOpenWindow(P,u){const g=(0,S.isLaunchedFromCli)(u)?0:4;let c=[];const o=P.wait&&P.waitMarkerFilePath?k.URI.file(P.waitMarkerFilePath):void 0,l=P.remote||void 0,s={context:g,cli:P,userEnv:u,waitMarkerFileURI:o,remoteAuthority:l};if(P.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(P.extensionDevelopmentPath,s);else if(!P._.length&&!P["folder-uri"]&&!P["file-uri"]){let i=!1;if(P["new-window"]||P["unity-launch"])i=!0;else if(P["reuse-window"])i=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":i=!0;break;case"off":i=!1;break;default:i=!D.isMacintosh}if(i)c=this.windowsMainService.open({...s,forceNewWindow:!0,forceEmpty:!0});else{const r=this.windowsMainService.getLastActiveWindow();r?(this.windowsMainService.openExistingWindow(r,s),c=[r]):c=this.windowsMainService.open({...s,forceEmpty:!0})}}else c=this.windowsMainService.open({...s,forceNewWindow:P["new-window"],preferNewWindow:!P["reuse-window"]&&!P.wait,forceReuseWindow:P["reuse-window"],diffMode:P.diff,addMode:P.add,noRecentEntry:!!P["skip-add-to-recently-opened"],gotoLineMode:P.goto});if(o&&c.length===1&&c[0])return Promise.race([c[0].whenClosedOrLoaded,(0,E.whenDeleted)(o.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const P=[];return p.BrowserWindow.getAllWindows().forEach(u=>{const g=this.windowsMainService.getWindowById(u.id);g?P.push(this.codeWindowToInfo(g)):P.push(this.browserWindowToInfo(u))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:P,screenReader:!!p.app.accessibilitySupportEnabled,gpuFeatureStatus:p.app.getGPUFeatureStatus()}}getFolderURIs(P){const u=[],g=P.openedWorkspace;if((0,t.isSingleFolderWorkspaceIdentifier)(g))u.push(g.uri);else if((0,t.isWorkspaceIdentifier)(g)){const c=this.workspacesManagementMainService.resolveLocalWorkspaceSync(g.configPath);c&&c.folders.forEach(l=>{u.push(l.uri)})}return u}codeWindowToInfo(P){const u=this.getFolderURIs(P),g=(0,C.assertIsDefined)(P.win);return this.browserWindowToInfo(g,u,P.remoteAuthority)}browserWindowToInfo(P,u=[],g){return{pid:P.webContents.getOSProcessId(),title:P.getTitle(),folderURIs:u,remoteAuthority:g}}};m=de([ne(0,M.ILogService),ne(1,f.IWindowsMainService),ne(2,y.IURLService),ne(3,d.IWorkspacesManagementMainService),ne(4,w.IConfigurationService)],m),e.LaunchMainService=m}),define(ee[58],te([0,1,45,14,26,121,46,4,33,2,10,9,3,7,85,73,24,154,50,23,5,20,6,22,31,67,34,27,42]),function(j,e,p,n,D,C,k,E,w,S,b,M,y,f,t,d,m,v,P,u,g,c,o,l,s,i,r,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,g.createDecorator)("nativeHostMainService");let I=class extends S.Disposable{constructor(L,T,$,Q,se,re,V,Z,H,K){super();this.sharedProcess=L,this.windowsMainService=T,this.dialogMainService=$,this.lifecycleMainService=Q,this.environmentMainService=se,this.telemetryService=re,this.logService=V,this.productService=Z,this.themeMainService=H,this.workspacesManagementMainService=K,this.onDidOpenWindow=E.Event.map(this.windowsMainService.onDidOpenWindow,x=>x.id),this.onDidMaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(n.app,"browser-window-maximize",(x,B)=>B.id),x=>!!this.windowsMainService.getWindowById(x)),this.onDidUnmaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(n.app,"browser-window-unmaximize",(x,B)=>B.id),x=>!!this.windowsMainService.getWindowById(x)),this.onDidBlurWindow=E.Event.filter(E.Event.fromNodeEventEmitter(n.app,"browser-window-blur",(x,B)=>B.id),x=>!!this.windowsMainService.getWindowById(x)),this.onDidFocusWindow=E.Event.any(E.Event.map(E.Event.filter(E.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),x=>!!x),x=>x.id),E.Event.filter(E.Event.fromNodeEventEmitter(n.app,"browser-window-focus",(x,B)=>B.id),x=>!!this.windowsMainService.getWindowById(x))),this.onDidResumeOS=E.Event.fromNodeEventEmitter(n.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new E.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new E.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=E.Event.debounce(E.Event.any(E.Event.filter(E.Event.fromNodeEventEmitter(n.screen,"display-metrics-changed",(x,B,z)=>z),x=>!(Array.isArray(x)&&x.length===1&&x[0]==="workArea")),E.Event.fromNodeEventEmitter(n.screen,"display-added"),E.Event.fromNodeEventEmitter(n.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){n.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.osColorScheme)})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(T=>({id:T.id,workspace:T.openedWorkspace,title:T.win?.getTitle()??"",filename:T.getRepresentedFilename(),dirty:T.isDocumentEdited()}))}async getWindowCount(L){return this.windowsMainService.getWindowCount()}async getActiveWindowId(L){const T=n.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(T)return T.id}openWindow(L,T,$){return Array.isArray(T)?this.doOpenWindow(L,T,$):this.doOpenEmptyWindow(L,T)}async doOpenWindow(L,T,$=Object.create(null)){T.length>0&&this.windowsMainService.open({context:5,contextWindowId:L,urisToOpen:T,cli:this.environmentMainService.args,forceNewWindow:$.forceNewWindow,forceReuseWindow:$.forceReuseWindow,preferNewWindow:$.preferNewWindow,diffMode:$.diffMode,addMode:$.addMode,gotoLineMode:$.gotoLineMode,noRecentEntry:$.noRecentEntry,waitMarkerFileURI:$.waitMarkerFileURI,remoteAuthority:$.remoteAuthority||void 0})}async doOpenEmptyWindow(L,T){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:L},T)}async toggleFullScreen(L){const T=this.windowById(L);T&&T.toggleFullScreen()}async handleTitleDoubleClick(L){const T=this.windowById(L);T&&T.handleTitleDoubleClick()}async isMaximized(L){const T=this.windowById(L);return T?.win?T.win.isMaximized():!1}async maximizeWindow(L){const T=this.windowById(L);T?.win&&T.win.maximize()}async unmaximizeWindow(L){const T=this.windowById(L);T?.win&&T.win.unmaximize()}async minimizeWindow(L){const T=this.windowById(L);T?.win&&T.win.minimize()}async focusWindow(L,T){T&&typeof T.windowId=="number"&&(L=T.windowId);const $=this.windowById(L);$&&$.focus({force:T?.force??!1})}async setMinimumSize(L,T,$){const Q=this.windowById(L);if(Q?.win){const[se,re]=Q.win.getSize(),[V,Z]=Q.win.getMinimumSize(),[H,K]=[T??V,$??Z],[x,B]=[Math.max(se,H),Math.max(re,K)];(V!==H||Z!==K)&&Q.win.setMinimumSize(H,K),(se!==x||re!==B)&&Q.win.setSize(x,B)}}async saveWindowSplash(L,T){this.themeMainService.saveWindowSplash(L,T)}async installShellCommand(L){const{source:T,target:$}=await this.getShellCommandLink();try{const{symbolicLink:Q}=await m.SymlinkSupport.stat(T);if(Q&&!Q.dangling){const se=await(0,t.realpath)(T);if($===se)return}await m.Promises.unlink(T)}catch(Q){if(Q.code!=="ENOENT")throw Q}try{await m.Promises.symlink($,T)}catch(Q){if(Q.code!=="EACCES"&&Q.code!=="ENOENT")throw Q;const{response:se}=await this.showMessageBox(L,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(0,null,this.productService.nameShort),buttons:[(0,w.mnemonicButtonLabel)((0,v.localize)(1,null)),(0,w.mnemonicButtonLabel)((0,v.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(se===0)try{const re=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${$}' '${T}'\\" with administrator privileges"`;await(0,C.promisify)(p.exec)(re)}catch{throw new Error((0,v.localize)(3,null,T))}}}async uninstallShellCommand(L){const{source:T}=await this.getShellCommandLink();try{await m.Promises.unlink(T)}catch($){switch($.code){case"EACCES":{const{response:Q}=await this.showMessageBox(L,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(4,null,this.productService.nameShort),buttons:[(0,w.mnemonicButtonLabel)((0,v.localize)(5,null)),(0,w.mnemonicButtonLabel)((0,v.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(Q===0)try{const se=`osascript -e "do shell script \\"rm '${T}'\\" with administrator privileges"`;await(0,C.promisify)(p.exec)(se)}catch{throw new Error((0,v.localize)(7,null,T))}break}case"ENOENT":break;default:throw $}}}async getShellCommandLink(){const L=(0,M.resolve)(this.environmentMainService.appRoot,"bin","code"),T=`/usr/local/bin/${this.productService.applicationName}`;if(!await m.Promises.exists(L))throw new Error((0,v.localize)(8,null,L));return{source:T,target:L}}async showMessageBox(L,T){return this.dialogMainService.showMessageBox(T,this.toBrowserWindow(L))}async showSaveDialog(L,T){return this.dialogMainService.showSaveDialog(T,this.toBrowserWindow(L))}async showOpenDialog(L,T){return this.dialogMainService.showOpenDialog(T,this.toBrowserWindow(L))}toBrowserWindow(L){const T=this.windowById(L);if(T?.win)return T.win}async pickFileFolderAndOpen(L,T){const $=await this.dialogMainService.pickFileFolder(T);$&&(this.sendPickerTelemetry($,T.telemetryEventName||"openFileFolder",T.telemetryExtraData),this.doOpenPicked(await Promise.all($.map(async Q=>await m.SymlinkSupport.existsDirectory(Q)?{folderUri:f.URI.file(Q)}:{fileUri:f.URI.file(Q)})),T,L))}async pickFolderAndOpen(L,T){const $=await this.dialogMainService.pickFolder(T);$&&(this.sendPickerTelemetry($,T.telemetryEventName||"openFolder",T.telemetryExtraData),this.doOpenPicked($.map(Q=>({folderUri:f.URI.file(Q)})),T,L))}async pickFileAndOpen(L,T){const $=await this.dialogMainService.pickFile(T);$&&(this.sendPickerTelemetry($,T.telemetryEventName||"openFile",T.telemetryExtraData),this.doOpenPicked($.map(Q=>({fileUri:f.URI.file(Q)})),T,L))}async pickWorkspaceAndOpen(L,T){const $=await this.dialogMainService.pickWorkspace(T);$&&(this.sendPickerTelemetry($,T.telemetryEventName||"openWorkspace",T.telemetryExtraData),this.doOpenPicked($.map(Q=>({workspaceUri:f.URI.file(Q)})),T,L))}doOpenPicked(L,T,$){this.windowsMainService.open({context:3,contextWindowId:$,cli:this.environmentMainService.args,urisToOpen:L,forceNewWindow:T.forceNewWindow})}sendPickerTelemetry(L,T,$){const Q=L?L.length:0;this.telemetryService.publicLog(T,{...$,outcome:Q?"success":"canceled",numberOfPaths:Q})}async showItemInFolder(L,T){n.shell.showItemInFolder(T)}async setRepresentedFilename(L,T){const $=this.windowById(L);$&&$.setRepresentedFilename(T)}async setDocumentEdited(L,T){const $=this.windowById(L);$&&$.setDocumentEdited(T)}async openExternal(L,T){return y.isLinuxSnap?this.safeSnapOpenExternal(T):n.shell.openExternal(T),!0}safeSnapOpenExternal(L){const T=process.env.GDK_PIXBUF_MODULE_FILE,$=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,n.shell.openExternal(L),process.env.GDK_PIXBUF_MODULE_FILE=T,process.env.GDK_PIXBUF_MODULEDIR=$}moveItemToTrash(L,T){return n.shell.trashItem(T)}async isAdmin(){let L;return y.isWindows?L=(await new Promise((T,$)=>{j(["native-is-elevated"],T,$)}))():L=process.getuid()===0,L}async writeElevated(L,T,$,Q){const se=await new Promise((re,V)=>{j(["@vscode/sudo-prompt"],re,V)});return new Promise((re,V)=>{const Z=[`"${this.cliPath}"`];Q?.unlock&&Z.push("--file-chmod"),Z.push("--file-write",`"${T.fsPath}"`,`"${$.fsPath}"`);const H={name:this.productService.nameLong.replace("-",""),icns:y.isMacintosh&&this.environmentMainService.isBuilt?(0,M.join)((0,M.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};se.exec(Z.join(" "),H,(K,x,B)=>{x&&this.logService.trace(`[sudo-prompt] received stdout: ${x}`),B&&this.logService.trace(`[sudo-prompt] received stderr: ${B}`),K?V(K):re(void 0)})})}get cliPath(){return y.isWindows?this.environmentMainService.isBuilt?(0,M.join)((0,M.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,M.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):y.isLinux?this.environmentMainService.isBuilt?(0,M.join)((0,M.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,M.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,M.join)(this.environmentMainService.appRoot,"bin","code"):(0,M.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,D.totalmem)(),freemem:(0,D.freemem)(),loadavg:(0,D.loadavg)()}}async getOSProperties(){return{arch:(0,D.arch)(),platform:(0,D.platform)(),release:(0,D.release)(),type:(0,D.type)(),cpus:(0,D.cpus)()}}async getOSVirtualMachineHint(){return d.virtualMachineHint.value()}get osColorScheme(){return{highContrast:n.nativeTheme.shouldUseInvertedColorScheme||n.nativeTheme.shouldUseHighContrastColors,dark:n.nativeTheme.shouldUseDarkColors}}async getOSColorScheme(){return this.osColorScheme}async killProcess(L,T,$){process.kill(T,$)}async readClipboardText(L,T){return n.clipboard.readText(T)}async writeClipboardText(L,T,$){return n.clipboard.writeText(T,$)}async readClipboardFindText(L){return n.clipboard.readFindText()}async writeClipboardFindText(L,T){return n.clipboard.writeFindText(T)}async writeClipboardBuffer(L,T,$,Q){return n.clipboard.writeBuffer(T,Buffer.from($),Q)}async readClipboardBuffer(L,T){return n.clipboard.readBuffer(T)}async hasClipboard(L,T,$){return n.clipboard.has(T,$)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){n.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){n.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){n.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){n.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){n.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(L,T){const $=this.windowById(L);$&&$.updateTouchBar(T)}async notifyReady(L){const T=this.windowById(L);T&&T.setReady()}async relaunch(L,T){return this.lifecycleMainService.relaunch(T)}async reload(L,T){const $=this.windowById(L);if($){if((0,a.isWorkspaceIdentifier)($.openedWorkspace)){const Q=$.openedWorkspace.configPath;if(Q.scheme===b.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(Q))?.transient)return this.openWindow($.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload($,T?.disableExtensions!==void 0?{_:[],"disable-extensions":T.disableExtensions}:void 0)}}async closeWindow(L){this.closeWindowById(L,L)}async closeWindowById(L,T){const $=this.windowById(T);if($?.win)return $.win.close()}async quit(L){const T=this.windowsMainService.getLastActiveWindow();T?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&T.win?T.win.close():this.lifecycleMainService.quit()}async exit(L,T){await this.lifecycleMainService.kill(T)}async resolveProxy(L,T){const Q=this.windowById(L)?.win?.webContents?.session;if(Q)return Q.resolveProxy(T)}async openDevTools(L,T){const $=this.windowById(L);$?.win&&$.win.webContents.openDevTools(T)}async toggleDevTools(L){const T=this.windowById(L);T?.win&&T.win.webContents.toggleDevTools()}async sendInputEvent(L,T){const $=this.windowById(L);$?.win&&(T.type==="mouseDown"||T.type==="mouseUp")&&$.win.webContents.sendInputEvent(T)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(L,T,$,Q){if(!y.isWindows)return;const se=await new Promise((re,V)=>{j(["@vscode/windows-registry"],re,V)});try{return se.GetStringRegKey(T,$,Q)}catch{return}}windowById(L){if(typeof L=="number")return this.windowsMainService.getWindowById(L)}};de([k.memoize],I.prototype,"cliPath",null),I=de([ne(1,r.IWindowsMainService),ne(2,P.IDialogMainService),ne(3,c.ILifecycleMainService),ne(4,u.IEnvironmentMainService),ne(5,s.ITelemetryService),ne(6,o.ILogService),ne(7,l.IProductService),ne(8,i.IThemeMainService),ne(9,h.IWorkspacesManagementMainService)],I),e.NativeHostMainService=I}),define(ee[244],te([0,1,14,26,33,2,10,3,86,152,75,103,50,23,5,104,6,58,54,22,55,68]),function(j,e,p,n,D,C,k,E,w,S,b,M,y,f,t,d,m,v,P,u,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,t.createDecorator)("issueMainService");let o=class Pt{constructor(s,i,r,a,h,I,R,L,T,$){this.userEnv=s,this.environmentMainService=i,this.launchMainService=r,this.logService=a,this.diagnosticsService=h,this.diagnosticsMainService=I,this.dialogMainService=R,this.nativeHostMainService=L,this.protocolMainService=T,this.productService=$,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){p.ipcMain.on("vscode:issueSystemInfoRequest",async s=>{const[i,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),a=await this.diagnosticsService.getSystemInfo(i,r);this.safeSend(s,"vscode:issueSystemInfoResponse",a)}),p.ipcMain.on("vscode:listProcesses",async s=>{const i=[];try{const r=await this.launchMainService.getMainProcessId();i.push({name:(0,S.localize)(0,null),rootProcess:await(0,w.listProcesses)(r)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(h=>{(0,b.isRemoteDiagnosticError)(h)?i.push({name:h.hostName,rootProcess:h}):h.processes&&i.push({name:h.hostName,rootProcess:h.processes})})}catch(r){this.logService.error(`Listing processes failed: ${r}`)}this.safeSend(s,"vscode:listProcessesResponse",i)}),p.ipcMain.on("vscode:issueReporterClipboard",async s=>{const i={title:this.productService.nameLong,message:(0,S.localize)(1,null),type:"warning",buttons:[(0,D.mnemonicButtonLabel)((0,S.localize)(2,null)),(0,D.mnemonicButtonLabel)((0,S.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const r=await this.dialogMainService.showMessageBox(i,this.issueReporterWindow);this.safeSend(s,"vscode:issueReporterClipboardResponse",r.response===0)}}),p.ipcMain.on("vscode:issuePerformanceInfoRequest",async s=>{const i=await this.getPerformanceInfo();this.safeSend(s,"vscode:issuePerformanceInfoResponse",i)}),p.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const s={title:this.productService.nameLong,message:(0,S.localize)(4,null),type:"warning",buttons:[(0,D.mnemonicButtonLabel)((0,S.localize)(5,null)),(0,D.mnemonicButtonLabel)((0,S.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(s,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),p.ipcMain.on("vscode:workbenchCommand",(s,i)=>{const{id:r,from:a,args:h}=i;let I;switch(a){case"issueReporter":I=this.issueReporterParentWindow;break;case"processExplorer":I=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${a}`)}I&&I.webContents.send("vscode:runAction",{id:r,from:a,args:h})}),p.ipcMain.on("vscode:openExternal",(s,i)=>{this.nativeHostMainService.openExternal(void 0,i)}),p.ipcMain.on("vscode:closeIssueReporter",s=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),p.ipcMain.on("vscode:closeProcessExplorer",s=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),p.ipcMain.on("vscode:windowsInfoRequest",async s=>{const i=await this.launchMainService.getMainProcessInfo();this.safeSend(s,"vscode:windowsInfoResponse",i.windows)})}safeSend(s,i,...r){s.sender.isDestroyed()||s.sender.send(i,...r)}async openReporter(s){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=p.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const i=new C.DisposableStore,r=i.add(this.protocolMainService.createIPCObjectUrl()),a=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(a,r,{backgroundColor:s.styles.backgroundColor,title:(0,S.localize)(7,null),zoomLevel:s.zoomLevel,alwaysOnTop:!1},"issue-reporter"),r.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:s,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,n.type)(),arch:(0,n.arch)(),release:(0,n.release)()},product:P.default}),this.issueReporterWindow.loadURL(k.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",j).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,i.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,i.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(s){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=p.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const i=new C.DisposableStore,r=i.add(this.protocolMainService.createIPCObjectUrl()),a=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(a,r,{backgroundColor:s.styles.backgroundColor,title:(0,S.localize)(8,null),zoomLevel:s.zoomLevel,alwaysOnTop:!0},"process-explorer"),r.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:s,product:P.default}),this.processExplorerWindow.loadURL(k.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",j).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,i.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,i.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(s){s.isMinimized()&&s.restore(),s.focus()}createBrowserWindow(s,i,r,a){const h=new p.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:s.width,height:s.height,minWidth:300,minHeight:200,x:s.x,y:s.y,title:r.title,backgroundColor:r.backgroundColor||Pt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:k.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${i.resource.toString()}`,`--vscode-window-kind=${a}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,c.zoomLevelToZoomFactor)(r.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:r.alwaysOnTop,experimentalDarkMode:!0});return h.setMenuBarVisibility(!1),h}async getSystemStatus(){const[s,i]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(s,i)}getWindowPosition(s,i,r){let a;const h=p.screen.getAllDisplays();if(h.length===1)a=h[0];else{if(E.isMacintosh){const L=p.screen.getCursorScreenPoint();a=p.screen.getDisplayNearestPoint(L)}!a&&s&&(a=p.screen.getDisplayMatching(s.getBounds())),a||(a=p.screen.getPrimaryDisplay()||h[0])}const I={width:i,height:r},R=a.bounds;return I.x=R.x+R.width/2-I.width/2,I.y=R.y+R.height/2-I.height/2,R.width>0&&R.height>0&&(I.x<R.x&&(I.x=R.x),I.y<R.y&&(I.y=R.y),I.x>R.x+R.width&&(I.x=R.x),I.y>R.y+R.height&&(I.y=R.y),I.width>R.width&&(I.width=R.width),I.height>R.height&&(I.height=R.height)),I}async getPerformanceInfo(){try{const[s,i]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(s,i)}catch(s){throw this.logService.warn("issueService#getPerformanceInfo ",s.message),s}}};o.DEFAULT_BACKGROUND_COLOR="#1E1E1E",o=de([ne(1,f.IEnvironmentMainService),ne(2,d.ILaunchMainService),ne(3,m.ILogService),ne(4,b.IDiagnosticsService),ne(5,M.IDiagnosticsMainService),ne(6,y.IDialogMainService),ne(7,v.INativeHostMainService),ne(8,g.IProtocolMainService),ne(9,u.IProductService)],o),e.IssueMainService=o}),define(ee[245],te([0,1,21,19,23,20,6,58,22,49,31,41,81]),function(j,e,p,n,D,C,k,E,w,S,b,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let f=class extends y.AbstractUpdateService{constructor(d,m,v,P,u,g,c,o){super(d,m,P,u,g,o);this.telemetryService=v,this.nativeHostMainService=c}buildUpdateFeedUrl(d){return(0,y.createUpdateURL)(`linux-${process.arch}`,d,this.productService)}doCheckForUpdates(d){!this.url||(this.setState(M.State.CheckingForUpdates(d)),this.requestService.request({url:this.url},p.CancellationToken.None).then(S.asJson).then(m=>{!m||!m.url||!m.version||!m.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!d}),this.setState(M.State.Idle(1))):this.setState(M.State.AvailableForDownload(m))}).then(void 0,m=>{this.logService.error(m),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!d});const v=d?m.message||m:void 0;this.setState(M.State.Idle(1,v))}))}async doDownloadUpdate(d){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):d.update.url&&this.nativeHostMainService.openExternal(void 0,d.update.url),this.setState(M.State.Idle(1))}};f=de([ne(0,C.ILifecycleMainService),ne(1,n.IConfigurationService),ne(2,b.ITelemetryService),ne(3,D.IEnvironmentMainService),ne(4,S.IRequestService),ne(5,k.ILogService),ne(6,E.INativeHostMainService),ne(7,w.IProductService)],f),e.LinuxUpdateService=f}),define(ee[246],te([0,1,45,30,26,8,21,46,9,7,118,24,19,23,18,20,6,58,22,49,31,41,81]),function(j,e,p,n,D,C,k,E,w,S,b,M,y,f,t,d,m,v,P,u,g,c,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function l(a,h=1e3){for(;!a();)await(0,C.timeout)(h)}let s;function i(){return typeof s=="undefined"&&(s=n.existsSync(w.join(w.dirname(process.execPath),"unins000.exe"))?0:1),s}let r=class extends o.AbstractUpdateService{constructor(h,I,R,L,T,$,Q,se,re){super(h,I,L,T,$,re);this.telemetryService=R,this.fileService=Q,this.nativeHostMainService=se}get cachePath(){const h=w.join((0,D.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return M.Promises.mkdir(h,{recursive:!0}).then(()=>h)}initialize(){super.initialize(),i()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(h){let I="win32";return process.arch!=="ia32"&&(I+=`-${process.arch}`),i()===1?I+="-archive":this.productService.target==="user"&&(I+="-user"),(0,o.createUpdateURL)(I,h,this.productService)}doCheckForUpdates(h){!this.url||(this.setState(c.State.CheckingForUpdates(h)),this.requestService.request({url:this.url},k.CancellationToken.None).then(u.asJson).then(I=>{const R=i();return!I||!I.url||!I.version||!I.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!h}),this.setState(c.State.Idle(R)),Promise.resolve(null)):R===1?(this.setState(c.State.AvailableForDownload(I)),Promise.resolve(null)):(this.setState(c.State.Downloading(I)),this.cleanup(I.version).then(()=>this.getUpdatePackagePath(I.version).then(L=>M.Promises.exists(L).then(T=>{if(T)return Promise.resolve(L);const $=I.url,Q=I.hash,se=`${L}.tmp`;return this.requestService.request({url:$},k.CancellationToken.None).then(re=>this.fileService.writeFile(S.URI.file(se),re.stream)).then(Q?()=>(0,b.checksum)(se,I.hash):()=>{}).then(()=>M.Promises.rename(se,L)).then(()=>L)})).then(L=>{const T=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:L},T&&I.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(I)):this.setState(c.State.Ready(I))})))}).then(void 0,I=>{this.logService.error(I),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!h});const R=h?I.message||I:void 0;this.setState(c.State.Idle(i(),R))}))}async doDownloadUpdate(h){h.update.url&&this.nativeHostMainService.openExternal(void 0,h.update.url),this.setState(c.State.Idle(i()))}async getUpdatePackagePath(h){const I=await this.cachePath;return w.join(I,`CodeSetup-${this.productService.quality}-${h}.exe`)}async cleanup(h=null){const I=h?$=>!new RegExp(`${this.productService.quality}-${h}\\.exe$`).test($):()=>!0,R=await this.cachePath,T=(await M.Promises.readdir(R)).filter(I).map(async $=>{try{await M.Promises.unlink(w.join(R,$))}catch{}});await Promise.all(T)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const h=this.state.update;this.setState(c.State.Updating(h));const I=await this.cachePath;this.availableUpdate.updateFilePath=w.join(I,`CodeSetup-${this.productService.quality}-${h.version}.flag`),await M.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,p.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(c.State.Idle(i()))});const L=`${this.productService.win32MutexName}-ready`,T=await new Promise(($,Q)=>{j(["windows-mutex"],$,Q)});l(()=>T.isActive(L)).then(()=>this.setState(c.State.Ready(h)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?n.unlinkSync(this.availableUpdate.updateFilePath):(0,p.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return i()}};de([E.memoize],r.prototype,"cachePath",null),r=de([ne(0,d.ILifecycleMainService),ne(1,y.IConfigurationService),ne(2,g.ITelemetryService),ne(3,f.IEnvironmentMainService),ne(4,u.IRequestService),ne(5,m.ILogService),ne(6,t.IFileService),ne(7,v.INativeHostMainService),ne(8,P.IProductService)],r),e.Win32UpdateService=r}),define(ee[247],te([0,1,14,8,21,39,4,33,2,10,9,64,3,7,158,52,19,50,23,53,213,18,20,6,22,55,80,31,216,67,68,34,27,42]),function(j,e,p,n,D,C,k,E,w,S,b,M,y,f,t,d,m,v,P,u,g,c,o,l,s,i,r,a,h,I,R,L,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var Q;(function(re){re[re.NONE=0]="NONE",re[re.NAVIGATING=1]="NAVIGATING",re[re.READY=2]="READY"})(Q||(Q={}));let se=class extends w.Disposable{constructor(V,Z,H,K,x,B,z,G,q,W,N,F,A,U,O){super();this.logService=Z,this.environmentMainService=H,this.fileService=K,this.globalStorageMainService=x,this.configurationService=B,this.themeMainService=z,this.workspacesManagementMainService=G,this.backupMainService=q,this.telemetryService=W,this.dialogMainService=N,this.lifecycleMainService=F,this.productService=A,this.protocolMainService=U,this.windowsMainService=O,this._onWillLoad=this._register(new k.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new k.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new k.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new k.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[_,Y]=this.restoreWindowState(V.state);this.windowState=_,this.logService.trace("window#ctor: using window state",_);const ie=this.windowState.mode===0||this.windowState.mode===3,oe=this.configurationService.getValue("window"),J={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:R.WindowMinimumSize.WIDTH,minHeight:R.WindowMinimumSize.HEIGHT,show:!ie,title:this.productService.nameLong,webPreferences:{preload:S.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,R.zoomLevelToZoomFactor)(oe?.zoomLevel),enableBlinkFeatures:"HighlightAPI",...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};y.isLinux?J.icon=(0,b.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):y.isWindows&&!this.environmentMainService.isBuilt&&(J.icon=(0,b.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),y.isMacintosh&&!this.useNativeFullScreen()&&(J.fullscreenable=!1),y.isMacintosh&&(J.acceptFirstMouse=!0,oe?.clickThroughInactive===!1&&(J.acceptFirstMouse=!1));const ce=y.isMacintosh&&oe?.nativeTabs===!0;ce&&(J.tabbingIdentifier=this.productService.nameShort);const le=(0,R.getTitleBarStyle)(this.configurationService)==="custom";if(le&&(J.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,y.isMacintosh||(J.frame=!1)),(0,M.mark)("code/willCreateCodeBrowserWindow"),this._win=new p.BrowserWindow(J),(0,M.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),y.isMacintosh&&le&&this._win.setSheetOffset(22),y.isMacintosh&&Y&&(!ce||p.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(he=>typeof he=="number")){const he=this.windowState;this._win.setBounds({width:he.width,height:he.height,x:he.x,y:he.y})}ie&&((0,M.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,M.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(V){y.isMacintosh?this._win.setRepresentedFilename(V):this.representedFilename=V}getRepresentedFilename(){return y.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(V){y.isMacintosh&&this._win.setDocumentEdited(V),this.documentEdited=V}isDocumentEdited(){return y.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(V){y.isMacintosh&&V?.force&&p.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(V=>{if(this.isReady)return V(this);this.whenReadyCallbacks.push(V)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(V=>{function Z(){H.dispose(),K.dispose(),V()}const H=this.onDidClose(()=>Z()),K=this.onWillLoad(()=>Z())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(Z,H)=>this.onWindowError(2,H)),this._win.webContents.on("did-fail-load",(Z,H,K)=>this.onWindowError(3,{reason:K,exitCode:H})),this._win.webContents.on("will-prevent-unload",Z=>{Z.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",Z=>{this.currentConfig&&(this.currentConfig.maximized=!0),p.app.emit("browser-window-maximize",Z,this._win)}),this._win.on("unmaximize",Z=>{this.currentConfig&&(this.currentConfig.maximized=!1),p.app.emit("browser-window-unmaximize",Z,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",D.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",D.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(Z=>this.onDidDeleteUntitledWorkspace(Z)));const V=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:V},async(Z,H)=>{const K=await this.getMarketplaceHeaders();H({cancel:!1,requestHeaders:Object.assign(Z.requestHeaders,K)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,g.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.globalStorageMainService)),this.marketplaceHeadersPromise}async onWindowError(V,Z){switch(V){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${Z?.reason||"<unknown>"}, code: ${Z?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${Z?.reason||"<unknown>"}, code: ${Z?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:V,reason:Z?.reason,code:Z?.exitCode}),V){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.driverHandle){this.destroyWindow(!1);return}if(V===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const H=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,E.mnemonicButtonLabel)((0,t.localize)(0,null)),(0,E.mnemonicButtonLabel)((0,t.localize)(1,null)),(0,E.mnemonicButtonLabel)((0,t.localize)(2,null))],message:(0,t.localize)(3,null),detail:(0,t.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(H.response!==1){const K=H.response===0;this.destroyWindow(K)}}else if(V===2){let H;Z?H=(0,t.localize)(6,null,Z.reason,Z.exitCode??"<unknown>"):H=(0,t.localize)(5,null);const x=(await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,E.mnemonicButtonLabel)((0,t.localize)(7,null)),(0,E.mnemonicButtonLabel)((0,t.localize)(8,null))],message:H,detail:(0,t.localize)(9,null),noLink:!0,defaultId:0},this._win)).response===0;this.destroyWindow(x)}break}}destroyWindow(V){if(this._onDidDestroy.fire(),this._win?.destroy(),V&&this.config){let Z,H;(0,T.isSingleFolderWorkspaceIdentifier)(this.openedWorkspace)?Z={folderUri:this.openedWorkspace.uri}:(0,T.isWorkspaceIdentifier)(this.openedWorkspace)?Z={workspaceUri:this.openedWorkspace.configPath}:H=!0;const[K]=this.windowsMainService.open({context:5,userEnv:this.config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:Z?[Z]:void 0,forceEmpty:H,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});K.focus()}}onDidDeleteUntitledWorkspace(V){this.openedWorkspace?.id===V.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const V=this.getMenuBarVisibility();V!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=V,this.setMenuBarVisibility(V));let Z=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;Z?.endsWith("/")&&(Z=Z.substr(0,Z.length-1));const H=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((Z||"").indexOf("@")===-1&&(Z!==this.currentHttpProxy||H!==this.currentNoProxy)){this.currentHttpProxy=Z,this.currentNoProxy=H;const K=Z||"",x=H?`${H},<local>`:"<local>";this.logService.trace(`Setting proxy to '${K}', bypassing '${x}'`),this._win.webContents.session.setProxy({proxyRules:K,proxyBypassRules:x,pacScript:""})}}addTabbedWindow(V){y.isMacintosh&&V.win&&this._win.addTabbedWindow(V.win)}load(V,Z=Object.create(null)){this.isDocumentEdited()&&(!Z.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),Z.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(V,Z),this.readyState===0?this.currentConfig=V:this.pendingLoadConfig=V,this.readyState=1,this._win.loadURL(S.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",j).toString(!0));const H=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new n.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:V.workspace,reason:Z.isReload?3:H?2:1})}updateConfiguration(V,Z){const H=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(H){const K=(0,u.isLaunchedFromCli)(H)&&!(0,u.isLaunchedFromCli)(V.userEnv),x=this.isExtensionDevelopmentHost;(K||x)&&(V.userEnv={...H,...V.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(V.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),Z.disableExtensions!==void 0&&(V["disable-extensions"]=Z.disableExtensions),V.fullscreen=this.isFullScreen,V.maximized=this._win.isMaximized(),V.partsSplash=this.themeMainService.getWindowSplash(),(0,M.mark)("code/willOpenNewWindow"),V.perfMarks=(0,M.getMarks)(),this.configObjectUrl.update(V)}async reload(V){const Z=Object.assign({},this.currentConfig);Z.workspace=await this.validateWorkspaceBeforeReload(Z),delete Z.filesToOpenOrCreate,delete Z.filesToDiff,delete Z.filesToWait,this.isExtensionDevelopmentHost&&V&&(Z.verbose=V.verbose,Z.debugId=V.debugId,Z.extensionEnvironment=V.extensionEnvironment,Z["inspect-extensions"]=V["inspect-extensions"],Z["inspect-brk-extensions"]=V["inspect-brk-extensions"],Z["extensions-dir"]=V["extensions-dir"]),Z.isInitialStartup=!1,this.load(Z,{isReload:!0,disableExtensions:V?.["disable-extensions"]})}async validateWorkspaceBeforeReload(V){if((0,T.isWorkspaceIdentifier)(V.workspace)){const Z=V.workspace.configPath;if(Z.scheme===S.Schemas.file&&!await this.fileService.exists(Z))return}else if((0,T.isSingleFolderWorkspaceIdentifier)(V.workspace)){const Z=V.workspace.uri;if(Z.scheme===S.Schemas.file&&!await this.fileService.exists(Z))return}return V.workspace}serializeWindowState(){if(!this._win)return(0,L.defaultWindowState)();if(this.isFullScreen){let H;try{H=p.screen.getDisplayMatching(this.getBounds())}catch{}const K=(0,L.defaultWindowState)();return{mode:3,display:H?H.id:void 0,width:this.windowState.width||K.width,height:this.windowState.height||K.height,x:this.windowState.x||0,y:this.windowState.y||0}}const V=Object.create(null);let Z;if(!y.isMacintosh&&this._win.isMaximized()?Z=0:Z=1,Z===0?V.mode=0:V.mode=1,Z===1||Z===0){let H;Z===1?H=this.getBounds():H=this._win.getNormalBounds(),V.x=H.x,V.y=H.y,V.width=H.width,V.height=H.height}return V}restoreWindowState(V){(0,M.mark)("code/willRestoreCodeWindowState");let Z=!1;if(V)try{const H=p.screen.getAllDisplays();Z=H.length>1,V=this.validateWindowState(V,H)}catch(H){this.logService.warn(`Unexpected error validating window state: ${H}
${H.stack}`)}return(0,M.mark)("code/didRestoreCodeWindowState"),[V||(0,L.defaultWindowState)(),Z]}validateWindowState(V,Z){if(this.logService.trace(`window#validateWindowState: validating window state on ${Z.length} display(s)`,V),typeof V.x!="number"||typeof V.y!="number"||typeof V.width!="number"||typeof V.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(V.width<=0||V.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(Z.length===1){const x=this.getWorkingArea(Z[0]);if(x){let B=function(){!V||typeof V.x!="number"||typeof V.y!="number"||!x||(V.x<x.x&&(V.x=x.x),V.y<x.y&&(V.y=x.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",x),B(),V.width>x.width&&(V.width=x.width),V.height>x.height&&(V.height=x.height),V.x>x.x+x.width-128&&(V.x=x.x+x.width-V.width),V.y>x.y+x.height-128&&(V.y=x.y+x.height-V.height),B()}return V}if(V.display&&V.mode===3){const x=Z.find(B=>B.id===V.display);if(x&&typeof x.bounds?.x=="number"&&typeof x.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const B=(0,L.defaultWindowState)(3);return B.x=x.bounds.x,B.y=x.bounds.y,B}}let H,K;try{H=p.screen.getDisplayMatching({x:V.x,y:V.y,width:V.width,height:V.height}),K=this.getWorkingArea(H)}catch{}if(H&&K&&V.x+V.width>K.x&&V.y+V.height>K.y&&V.x<K.x+K.width&&V.y<K.y+K.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",K),V}getWorkingArea(V){if(V.workArea.width>0&&V.workArea.height>0)return V.workArea;if(V.bounds.width>0&&V.bounds.height>0)return V.bounds}getBounds(){const[V,Z]=this._win.getPosition(),[H,K]=this._win.getSize();return{x:V,y:Z,width:H,height:K}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(V){this.useNativeFullScreen()?this.setNativeFullScreen(V):this.setSimpleFullScreen(V),this.sendWhenReady(V?"vscode:enterFullScreen":"vscode:leaveFullScreen",D.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(V){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(V)}setSimpleFullScreen(V){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(V),this._win.webContents.focus()}useNativeFullScreen(){const V=this.configurationService.getValue("window");return!V||typeof V.nativeFullScreen!="boolean"||V.nativeTabs?!0:V.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let V=(0,R.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(V)<0&&(V="classic"),V}setMenuBarVisibility(V,Z=!0){y.isMacintosh||(V==="toggle"&&Z&&this.send("vscode:showInfoMessage",(0,t.localize)(10,null)),V==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(V)}):this.doSetMenuBarVisibility(V))}doSetMenuBarVisibility(V){const Z=this.isFullScreen;switch(V){case"classic":this._win.setMenuBarVisibility(!Z),this._win.autoHideMenuBar=Z;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(y.isMacintosh)switch(p.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(V,Z,...H){this.isReady?this.send(V,...H):this.ready().then(()=>{Z.isCancellationRequested||this.send(V,...H)})}send(V,...Z){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${V}' for window that is destroyed`);return}try{this._win.webContents.send(V,...Z)}catch(H){this.logService.warn(`Error sending IPC message to channel '${V}' of window ${this._id}: ${(0,C.toErrorMessage)(H)}`)}}}updateTouchBar(V){!y.isMacintosh||this.touchBarGroups.forEach((Z,H)=>{const K=V[H];Z.segments=this.createTouchBarGroupSegments(K)})}createTouchBar(){if(!!y.isMacintosh){for(let V=0;V<10;V++){const Z=this.createTouchBarGroup();this.touchBarGroups.push(Z)}this._win.setTouchBar(new p.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(V=[]){const Z=this.createTouchBarGroupSegments(V),H=new p.TouchBar.TouchBarSegmentedControl({segments:Z,mode:"buttons",segmentStyle:"automatic",change:K=>{this.sendWhenReady("vscode:runAction",D.CancellationToken.None,{id:H.segments[K].id,from:"touchbar"})}});return H}createTouchBarGroupSegments(V=[]){return V.map(H=>{let K;H.icon&&!h.ThemeIcon.isThemeIcon(H.icon)&&H.icon?.dark?.scheme===S.Schemas.file&&(K=p.nativeImage.createFromPath(f.URI.revive(H.icon.dark).fsPath),K.isEmpty()&&(K=void 0));let x;return typeof H.title=="string"?x=H.title:x=H.title.value,{id:H.id,label:K?void 0:x,icon:K}})}dispose(){super.dispose(),this._win=null}};se=de([ne(1,l.ILogService),ne(2,P.IEnvironmentMainService),ne(3,c.IFileService),ne(4,r.IGlobalStorageMainService),ne(5,m.IConfigurationService),ne(6,I.IThemeMainService),ne(7,$.IWorkspacesManagementMainService),ne(8,d.IBackupMainService),ne(9,a.ITelemetryService),ne(10,v.IDialogMainService),ne(11,o.ILifecycleMainService),ne(12,s.IProductService),ne(13,i.IProtocolMainService),ne(14,L.IWindowsMainService)],se),e.CodeWindow=se}),define(ee[69],te([0,1,14,28,8,4,33,2,10,3,16,7,24,161,5,20,6,38,80,27,42]),function(j,e,p,n,D,C,k,E,w,S,b,M,y,f,t,d,m,v,P,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,t.createDecorator)("workspacesHistoryMainService");let c=class $e extends E.Disposable{constructor(l,s,i,r,a){super();this.stateMainService=l,this.logService=s,this.workspacesManagementMainService=i,this.lifecycleMainService=r,this.globalStorageMainService=a,this._onDidChangeRecentlyOpened=this._register(new C.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new D.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(l=>this.addRecentlyOpened([{workspace:l.workspace,remoteAuthority:l.window.remoteAuthority}])))}async addRecentlyOpened(l){const s=[],i=[];for(let r of l)if((0,u.isRecentWorkspace)(r))!this.workspacesManagementMainService.isUntitledWorkspace(r.workspace)&&this.indexOfWorkspace(s,r.workspace)===-1&&s.push(r);else if((0,u.isRecentFolder)(r))this.indexOfFolder(s,r.folderUri)===-1&&s.push(r);else{const a=this.indexOfFile(i,r.fileUri)>=0,h=r.fileUri.scheme===w.Schemas.file&&$e.COMMON_FILES_FILTER.indexOf((0,b.basename)(r.fileUri))>=0;!a&&!h&&(i.push(r),S.isWindows&&r.fileUri.scheme===w.Schemas.file&&p.app.addRecentDocument(r.fileUri.fsPath))}await this.addEntriesFromStorage(s,i),s.length>$e.MAX_TOTAL_RECENT_ENTRIES&&(s.length=$e.MAX_TOTAL_RECENT_ENTRIES),i.length>$e.MAX_TOTAL_RECENT_ENTRIES&&(i.length=$e.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:s,files:i}),this._onDidChangeRecentlyOpened.fire(),S.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(l){const s=h=>{const I=this.location(h);for(const R of l)if(b.extUriBiasedIgnorePathCase.isEqual(R,I))return!1;return!0},i=await this.getRecentlyOpened(),r=i.workspaces.filter(s),a=i.files.filter(s);(r.length!==i.workspaces.length||a.length!==i.files.length)&&(await this.saveRecentlyOpened({files:a,workspaces:r}),this._onDidChangeRecentlyOpened.fire(),S.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),p.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(l){const s=[],i=[];if(l){const a=l.config?.workspace;(0,u.isWorkspaceIdentifier)(a)&&!this.workspacesManagementMainService.isUntitledWorkspace(a)?s.push({workspace:a,remoteAuthority:l.remoteAuthority}):(0,u.isSingleFolderWorkspaceIdentifier)(a)&&s.push({folderUri:a.uri,remoteAuthority:l.remoteAuthority})}const r=l?.config?.filesToOpenOrCreate;if(r)for(let a of r){const h=a.fileUri;h&&this.indexOfFile(i,h)===-1&&i.push({fileUri:h})}return await this.addEntriesFromStorage(s,i),{workspaces:s,files:i}}async addEntriesFromStorage(l,s){let i=await this.getRecentlyOpenedFromStorage();for(let r of i.workspaces){let a=(0,u.isRecentFolder)(r)?this.indexOfFolder(l,r.folderUri):this.indexOfWorkspace(l,r.workspace);a>=0?l[a].label=l[a].label||r.label:l.push(r)}for(let r of i.files){let a=this.indexOfFile(s,r.fileUri);a>=0?s[a].label=s[a].label||r.label:s.push(r)}}async getRecentlyOpenedFromStorage(){await this.globalStorageMainService.whenReady;let l;const s=this.globalStorageMainService.get($e.RECENTLY_OPENED_STORAGE_KEY,0);if(typeof s=="string")try{l=JSON.parse(s)}catch(i){this.logService.error("Unexpected error parsing opened paths list",i)}else l=this.stateMainService.getItem($e.legacyRecentlyOpenedStorageKey),l&&(this.stateMainService.removeItem($e.legacyRecentlyOpenedStorageKey),this.globalStorageMainService.store($e.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify(l),0,1));return(0,u.restoreRecentlyOpened)(l,this.logService)}async saveRecentlyOpened(l){await this.globalStorageMainService.whenReady,this.globalStorageMainService.store($e.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,u.toStoreData)(l)),0,1)}location(l){return(0,u.isRecentFolder)(l)?l.folderUri:(0,u.isRecentFile)(l)?l.fileUri:l.workspace.configPath}indexOfWorkspace(l,s){return l.findIndex(i=>(0,u.isRecentWorkspace)(i)&&i.workspace.id===s.id)}indexOfFolder(l,s){return l.findIndex(i=>(0,u.isRecentFolder)(i)&&b.extUriBiasedIgnorePathCase.isEqual(i.folderUri,s))}indexOfFile(l,s){return l.findIndex(i=>b.extUriBiasedIgnorePathCase.isEqual(i.fileUri,s))}async handleWindowsJumpList(){!S.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!S.isWindows)return;const l=[];if(l.push({type:"tasks",items:[{type:"task",title:(0,f.localize)(0,null),description:(0,f.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){let s=[];for(let a of p.app.getJumpListSettings().removedItems){const h=a.args;if(h){const I=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(h);I&&s.push(M.URI.parse(I[2]))}}await this.removeRecentlyOpened(s);let i=!1;const r=(0,n.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,$e.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(a=>{const h=(0,u.isRecentWorkspace)(a)?a.workspace:a.folderUri,{title:I,description:R}=this.getWindowsJumpListLabel(h,a.label);let L;return M.URI.isUri(h)?L=`--folder-uri "${h.toString()}"`:(i=!0,L=`--file-uri "${h.configPath.toString()}"`),{type:"task",title:I.substr(0,255),description:R.substr(0,255),program:process.execPath,args:L,iconPath:"explorer.exe",iconIndex:0}}));r.length>0&&l.push({type:"custom",name:i?(0,f.localize)(2,null):(0,f.localize)(3,null),items:r})}l.push({type:"recent"});try{p.app.setJumpList(l)}catch(s){this.logService.warn("updateWindowsJumpList#setJumpList",s)}}getWindowsJumpListLabel(l,s){if(s)return{title:(0,k.splitName)(s).name,description:s};if(M.URI.isUri(l))return{title:(0,b.basename)(l),description:this.renderJumpListPathDescription(l)};if(this.workspacesManagementMainService.isUntitledWorkspace(l))return{title:(0,f.localize)(4,null),description:""};let i=(0,b.basename)(l.configPath);return i.endsWith(u.WORKSPACE_EXTENSION)&&(i=i.substr(0,i.length-u.WORKSPACE_EXTENSION.length-1)),{title:(0,f.localize)(5,null,i),description:this.renderJumpListPathDescription(l.configPath)}}renderJumpListPathDescription(l){return l.scheme==="file"?(0,k.normalizeDriveLetter)(l.fsPath):l.toString()}async updateMacOSRecentDocuments(){if(!S.isMacintosh)return;p.app.clearRecentDocuments();const l=await this.getRecentlyOpened(),s=[];let i=0;for(let a=0;a<l.workspaces.length&&i<$e.MAX_MACOS_DOCK_RECENT_WORKSPACES;a++){const h=this.location(l.workspaces[a]);if(h.scheme===w.Schemas.file){const I=(0,b.originalFSPath)(h);await y.Promises.exists(I)&&(s.push(I),i++)}}const r=[];for(let a=0;a<l.files.length&&i<$e.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;a++){const h=this.location(l.files[a]);if(h.scheme===w.Schemas.file){const I=(0,b.originalFSPath)(h);if($e.COMMON_FILES_FILTER.includes((0,b.basename)(h))||s.includes(I))continue;await y.Promises.exists(I)&&(r.push(I),i++)}}r.reverse().forEach(a=>p.app.addRecentDocument(a)),s.reverse().forEach(a=>p.app.addRecentDocument(a))}};c.MAX_TOTAL_RECENT_ENTRIES=500,c.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",c.legacyRecentlyOpenedStorageKey="openedPathsList",c.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,c.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,c.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,c.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],c=de([ne(0,v.IStateMainService),ne(1,m.ILogService),ne(2,g.IWorkspacesManagementMainService),ne(3,d.ILifecycleMainService),ne(4,P.IGlobalStorageMainService)],c),e.WorkspacesHistoryMainService=c}),define(ee[248],te([0,1,14,8,21,33,3,7,153,19,23,20,6,195,58,22,38,31,41,68,34,69]),function(j,e,p,n,D,C,k,E,w,S,b,M,y,f,t,d,m,v,P,u,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const o="menu";let l=class Et{constructor(r,a,h,I,R,L,T,$,Q,se,re){this.updateService=r,this.configurationService=a,this.windowsMainService=h,this.environmentMainService=I,this.telemetryService=R,this.workspacesHistoryMainService=L,this.stateMainService=T,this.lifecycleMainService=$,this.logService=Q,this.nativeHostMainService=se,this.productService=re,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new n.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new n.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(k.isMacintosh||(0,u.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const r=this.stateMainService.getItem(Et.lastKnownMenubarStorageKey);r&&(r.menus&&(this.menubarMenus=r.menus),r.keybindings&&(this.keybindings=r.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(L,T,$)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:T?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(L,T,$)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:T?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(L,T,$)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick($),telemetryExtraData:{from:o}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(L,T,$)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick($),telemetryExtraData:{from:o}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const r=this.productService.twitterUrl;r&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(r,"openTwitterUrl"));const a=this.productService.requestFeatureUrl;a&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(a,"openUserVoiceUrl"));const h=this.productService.reportIssueUrl;h&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(h,"openReportIssues"));const I=this.productService.licenseUrl;I&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(k.language){const L=I.indexOf("?")>0?"&":"?";this.openUrl(`${I}${L}lang=${k.language}`,"openLicenseUrl")}else this.openUrl(I,"openLicenseUrl")});const R=this.productService.privacyStatementUrl;R&&I&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(R,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(r=>this.onDidChangeWindowsCount(r)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let r=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof r!="boolean"?!0:r}get currentEnableNativeTabs(){if(!k.isMacintosh)return!1;let r=this.configurationService.getValue("window.nativeTabs");return typeof r!="boolean"?!1:r}updateMenu(r,a){this.menubarMenus=r.menus,this.keybindings=r.keybindings,this.stateMainService.setItem(Et.lastKnownMenubarStorageKey,r),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(r){!k.isMacintosh||(r.oldCount===0&&r.newCount>0||r.oldCount>0&&r.newCount===0)&&(this.closedLastWindow=r.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!k.isMacintosh||(this.noActiveWindow=!p.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const r=p.Menu.getApplicationMenu();if(r&&this.oldMenus.push(r),Object.keys(this.menubarMenus).length===0){p.Menu.setApplicationMenu(k.isMacintosh?new p.Menu:null);return}const a=new p.Menu;let h;if(k.isMacintosh){const R=new p.Menu;h=new p.MenuItem({label:this.productService.nameShort,submenu:R}),this.setMacApplicationMenu(R),a.append(h)}if(k.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const R=new p.Menu;R.append(new p.MenuItem({label:this.mnemonicLabel(w.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),p.app.dock.setMenu(R)}if(this.shouldDrawMenu("File")){const R=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(w.localize(1,null)),submenu:R});this.setMenuById(R,"File"),a.append(L)}if(this.shouldDrawMenu("Edit")){const R=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(w.localize(2,null)),submenu:R});this.setMenuById(R,"Edit"),a.append(L)}if(this.shouldDrawMenu("Selection")){const R=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(w.localize(3,null)),submenu:R});this.setMenuById(R,"Selection"),a.append(L)}if(this.shouldDrawMenu("View")){const R=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(w.localize(4,null)),submenu:R});this.setMenuById(R,"View"),a.append(L)}if(this.shouldDrawMenu("Go")){const R=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(w.localize(5,null)),submenu:R});this.setMenuById(R,"Go"),a.append(L)}if(this.shouldDrawMenu("Run")){const R=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(w.localize(6,null)),submenu:R});this.setMenuById(R,"Run"),a.append(L)}if(this.shouldDrawMenu("Terminal")){const R=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(w.localize(7,null)),submenu:R});this.setMenuById(R,"Terminal"),a.append(L)}let I;if(this.shouldDrawMenu("Window")){const R=new p.Menu;I=new p.MenuItem({label:this.mnemonicLabel(w.localize(8,null)),submenu:R,role:"window"}),this.setMacWindowMenu(R)}if(I&&a.append(I),this.shouldDrawMenu("Help")){const R=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(w.localize(9,null)),submenu:R,role:"help"});this.setMenuById(R,"Help"),a.append(L)}a.items&&a.items.length>0?p.Menu.setApplicationMenu(a):p.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(r){const a=this.createMenuItem(w.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),h=this.getUpdateMenuItems();let I;if(this.shouldDrawMenu("Preferences")){const V=new p.Menu;this.setMenuById(V,"Preferences"),I=new p.MenuItem({label:this.mnemonicLabel(w.localize(11,null)),submenu:V})}const R=new p.Menu,L=new p.MenuItem({label:w.localize(12,null),role:"services",submenu:R}),T=new p.MenuItem({label:w.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),$=new p.MenuItem({label:w.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),Q=new p.MenuItem({label:w.localize(15,null),role:"unhide"}),se=new p.MenuItem(this.likeAction("workbench.action.quit",{label:w.localize(16,null,this.productService.nameLong),click:()=>{const V=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!p.BrowserWindow.getFocusedWindow()||V?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),re=[a];re.push(...h),I&&re.push(s(),I),re.push(s(),L,s(),T,$,Q,s(),se),re.forEach(V=>r.append(V))}shouldDrawMenu(r){if(!k.isMacintosh&&(0,u.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(r){case"File":case"Help":if(k.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[r];case"Window":if(k.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[r]}}setMenu(r,a){a.forEach(h=>{if((0,f.isMenubarMenuItemSeparator)(h))r.append(s());else if((0,f.isMenubarMenuItemSubmenu)(h)){const I=new p.Menu,R=new p.MenuItem({label:this.mnemonicLabel(h.label),submenu:I});this.setMenu(I,h.submenu.items),r.append(R)}else(0,f.isMenubarMenuItemRecentAction)(h)?r.append(this.createOpenRecentMenuItem(h)):(0,f.isMenubarMenuItemAction)(h)&&(h.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(r),k.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[h.id]?r.append(new p.MenuItem(this.likeAction(h.id,{label:this.mnemonicLabel(h.label),click:this.fallbackMenuHandlers[h.id]}))):r.append(this.createMenuItem(h.label,h.id,!1,h.checked)):r.append(this.createMenuItem(h.label,h.id,h.enabled!==!1,!!h.checked)):r.append(this.createMenuItem(h.label,h.id,h.enabled!==!1,!!h.checked)))})}setMenuById(r,a){this.menubarMenus&&this.menubarMenus[a]&&this.setMenu(r,this.menubarMenus[a].items)}insertCheckForUpdatesItems(r){const a=this.getUpdateMenuItems();a.length&&(a.forEach(h=>r.append(h)),r.append(s()))}createOpenRecentMenuItem(r){const a=E.URI.revive(r.uri),h=r.id,I=h==="openRecentFile"?{fileUri:a}:h==="openRecentWorkspace"?{workspaceUri:a}:{folderUri:a};return new p.MenuItem(this.likeAction(h,{label:r.label,click:(R,L,T)=>{const $=this.isOptionClick(T);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[I],forceNewWindow:$,gotoLineMode:!1,remoteAuthority:r.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([a])}},!1))}isOptionClick(r){return!!(r&&(!k.isMacintosh&&(r.ctrlKey||r.shiftKey)||k.isMacintosh&&(r.metaKey||r.altKey)))}createRoleMenuItem(r,a,h){const I={label:this.mnemonicLabel(r),role:h,enabled:!0};return new p.MenuItem(this.withKeybinding(a,I))}setMacWindowMenu(r){const a=new p.MenuItem({label:w.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),h=new p.MenuItem({label:w.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),I=new p.MenuItem({label:w.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),R=this.createMenuItem(w.localize(20,null),"workbench.action.switchWindow"),L=[];this.currentEnableNativeTabs&&(L.push(s()),L.push(this.createMenuItem(w.localize(21,null),"workbench.action.newWindowTab")),L.push(this.createRoleMenuItem(w.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),L.push(this.createRoleMenuItem(w.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),L.push(this.createRoleMenuItem(w.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),L.push(this.createRoleMenuItem(w.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[a,h,s(),R,...L,s(),I].forEach(T=>r.append(T))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new p.MenuItem({label:this.mnemonicLabel(w.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new p.MenuItem({label:w.localize(27,null),enabled:!1})];case"available for download":return[new p.MenuItem({label:this.mnemonicLabel(w.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new p.MenuItem({label:w.localize(29,null),enabled:!1})];case"downloaded":return[new p.MenuItem({label:this.mnemonicLabel(w.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new p.MenuItem({label:w.localize(31,null),enabled:!1})];case"ready":return[new p.MenuItem({label:this.mnemonicLabel(w.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(r,a,h,I){const R=this.mnemonicLabel(r),L=typeof a=="function"?a:(re,V,Z)=>{const H=re?re.userSettingsLabel:null;let K=a;Array.isArray(a)&&(K=this.isOptionClick(Z)?a[1]:a[0]),H&&Z.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:H}):this.runActionInRenderer({type:"commandId",commandId:K})},T=typeof h=="boolean"?h:this.windowsMainService.getWindowCount()>0,$=typeof I=="boolean"?I:!1,Q={label:R,click:L,enabled:T};$&&(Q.type="checkbox",Q.checked=$);let se;return typeof a=="string"?se=a:Array.isArray(a)&&(se=a[0]),k.isMacintosh&&(se==="editor.action.clipboardCutAction"?Q.role="cut":se==="editor.action.clipboardCopyAction"?Q.role="copy":se==="editor.action.clipboardPasteAction"&&(Q.role="paste"),se==="undo"?Q.click=this.makeContextAwareClickHandler(L,{inDevTools:re=>re.undo(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("undo:")}):se==="redo"?Q.click=this.makeContextAwareClickHandler(L,{inDevTools:re=>re.redo(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("redo:")}):se==="editor.action.selectAll"&&(Q.click=this.makeContextAwareClickHandler(L,{inDevTools:re=>re.selectAll(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("selectAll:")}))),new p.MenuItem(this.withKeybinding(se,Q))}makeContextAwareClickHandler(r,a){return(h,I,R)=>{const L=p.BrowserWindow.getFocusedWindow();if(!L)return a.inNoWindow();if(L.webContents.isDevToolsFocused()&&L.webContents.devToolsWebContents)return a.inDevTools(L.webContents.devToolsWebContents);r(h,I||L,R)}}runActionInRenderer(r){let a=p.BrowserWindow.getFocusedWindow();if(!a){const I=this.windowsMainService.getLastActiveWindow();I?.isMinimized()&&(a=I.win)}const h=a?this.windowsMainService.getWindowById(a.id):void 0;if(h){if(this.logService.trace("menubar#runActionInRenderer",r),k.isMacintosh&&!this.environmentMainService.isBuilt&&!h.isReady&&(r.type==="commandId"&&r.commandId==="workbench.action.toggleDevTools"||r.type!=="commandId"&&r.userSettingsLabel==="alt+cmd+i"))return;if(r.type==="commandId"){const I={id:r.commandId,from:"menu"};h.sendWhenReady("vscode:runAction",D.CancellationToken.None,I)}else{const I={userSettingsLabel:r.userSettingsLabel};h.sendWhenReady("vscode:runKeybinding",D.CancellationToken.None,I)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",r)}withKeybinding(r,a){const h=typeof r=="string"?this.keybindings[r]:void 0;if(h?.label){if(h.isNative!==!1)a.accelerator=h.label,a.userSettingsLabel=h.userSettingsLabel;else if(typeof a.label=="string"){const I=a.label.indexOf("[");I>=0?a.label=`${a.label.substr(0,I)} [${h.label}]`:a.label=`${a.label} [${h.label}]`}}else a.accelerator=void 0;return a}likeAction(r,a,h=!a.accelerator){h&&(a=this.withKeybinding(r,a));const I=a.click;return a.click=(R,L,T)=>{this.reportMenuActionTelemetry(r),I&&I(R,L,T)},a}openUrl(r,a){this.nativeHostMainService.openExternal(void 0,r),this.reportMenuActionTelemetry(a)}reportMenuActionTelemetry(r){this.telemetryService.publicLog2("workbenchActionExecuted",{id:r,from:o})}mnemonicLabel(r){return(0,C.mnemonicMenuLabel)(r,!this.currentEnableMenuBarMnemonics)}};l.lastKnownMenubarStorageKey="lastKnownMenubarData",l=de([ne(0,P.IUpdateService),ne(1,S.IConfigurationService),ne(2,g.IWindowsMainService),ne(3,b.IEnvironmentMainService),ne(4,v.ITelemetryService),ne(5,c.IWorkspacesHistoryMainService),ne(6,m.IStateMainService),ne(7,M.ILifecycleMainService),ne(8,y.ILogService),ne(9,t.INativeHostMainService),ne(10,d.IProductService)],l),e.Menubar=l;function s(){return new p.MenuItem({type:"separator"})}}),define(ee[249],te([0,1,5,20,6,248]),function(j,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,p.createDecorator)("menubarMainService");let k=class{constructor(w,S,b){this.instantiationService=w,this.lifecycleMainService=S,this.logService=b,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(C.Menubar)}async updateMenubar(w,S){this.logService.trace("menubarService#updateMenubar",w),(await this.menubar).updateMenu(S,w)}};k=de([ne(0,p.IInstantiationService),ne(1,n.ILifecycleMainService),ne(2,D.ILogService)],k),e.MenubarMainService=k}),define(ee[250],te([0,1,14,30,26,28,21,4,29,43,33,2,10,9,64,3,35,16,13,7,159,52,19,50,23,18,5,20,6,54,22,55,65,38,68,247,101,230,27,102,69,42]),function(j,e,p,n,D,C,k,E,w,S,b,M,y,f,t,d,m,v,P,u,g,c,o,l,s,i,r,a,h,I,R,L,T,$,Q,se,re,V,Z,H,K,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function B(q){return(0,Z.isWorkspaceIdentifier)(q?.workspace)}function z(q){return(0,Z.isSingleFolderWorkspaceIdentifier)(q?.workspace)}let G=class rt extends M.Disposable{constructor(W,N,F,A,U,O,_,Y,ie,oe,J,ce,le,he,we){super();this.machineId=W,this.initialUserEnv=N,this.logService=F,this.stateMainService=A,this.environmentMainService=U,this.lifecycleMainService=O,this.backupMainService=_,this.configurationService=Y,this.workspacesHistoryMainService=ie,this.workspacesManagementMainService=oe,this.instantiationService=J,this.dialogMainService=ce,this.fileService=le,this.productService=he,this.protocolMainService=we,this._onDidOpenWindow=this._register(new E.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new E.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new E.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new E.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new V.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(W=>this._onDidSignalReadyWindow.fire(W.window))),this._register(this.onDidSignalReadyWindow(W=>{if(W.config?.extensionDevelopmentPath||W.config?.extensionTestsPath){const N=new M.DisposableStore;if(N.add(E.Event.any(W.onDidClose,W.onDidDestroy)(()=>N.dispose())),W.config.extensionDevelopmentPath)for(const F of W.config.extensionDevelopmentPath)N.add(this.protocolMainService.addValidFileRoot(u.URI.file(F)));W.config.extensionTestsPath&&N.add(this.protocolMainService.addValidFileRoot(u.URI.file(W.config.extensionTestsPath)))}}))}openEmptyWindow(W,N){let F=this.environmentMainService.args;const A=N?.remoteAuthority||void 0,U=!0,O=N?.forceReuseWindow,_=!O;return this.open({...W,cli:F,forceEmpty:U,forceNewWindow:_,forceReuseWindow:O,remoteAuthority:A})}openExistingWindow(W,N){W.focus(),this.handleWaitMarkerFile(N,[W])}open(W){this.logService.trace("windowsManager#open"),W.addMode&&(W.initialStartup||!this.getLastActiveWindow())&&(W.addMode=!1);const N=[],F=[],A=[],U=[],O=[];let _,Y=0;const ie=this.getPathsToOpen(W);this.logService.trace("windowsManager#open pathsToOpen",ie);for(const le of ie)z(le)?W.addMode?N.push(le):F.push(le):B(le)?A.push(le):le.fileUri?(_||(_={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:le.remoteAuthority}),_.filesToOpenOrCreate.push(le)):le.backupPath?O.push({backupFolder:(0,f.basename)(le.backupPath),remoteAuthority:le.remoteAuthority}):Y++;W.diffMode&&_&&_.filesToOpenOrCreate.length>=2&&(_.filesToDiff=_.filesToOpenOrCreate.slice(0,2),_.filesToOpenOrCreate=[]),_&&W.waitMarkerFileURI&&(_.filesToWait={paths:[..._.filesToDiff,..._.filesToOpenOrCreate],waitMarkerFileUri:W.waitMarkerFileURI}),W.initialStartup?(U.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),A.push(...U),O.push(...this.backupMainService.getEmptyWindowBackupPaths())):O.length=0;const{windows:oe,filesOpenedInWindow:J}=this.doOpen(W,A,F,O,Y,_,N);if(this.logService.trace(`windowsManager#open used window count ${oe.length} (workspacesToOpen: ${A.length}, foldersToOpen: ${F.length}, emptyToRestore: ${O.length}, emptyToOpen: ${Y})`),oe.length>1)if(J)J.focus();else{const le=this.windowsStateHandler.state.lastActiveWindow&&!W.forceEmpty&&!W.cli._.length&&!W.cli["file-uri"]&&!W.cli["folder-uri"]&&!(W.urisToOpen&&W.urisToOpen.length);let he=!0,we=!0;if(le){const pe=oe.filter(ge=>this.windowsStateHandler.state.lastActiveWindow&&ge.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);pe.length&&(pe[0].focus(),he=!1,we=!1)}if(he)for(let pe=oe.length-1;pe>=0;pe--){const ge=oe[pe];if(!(ge.openedWorkspace&&U.some(fe=>ge.openedWorkspace&&fe.workspace.id===ge.openedWorkspace.id)||ge.backupPath&&O.some(fe=>ge.backupPath&&fe.backupFolder===(0,f.basename)(ge.backupPath)))){ge.focus(),we=!1;break}}we&&oe[oe.length-1].focus()}const ce=_&&_.filesToDiff.length>0;if(!oe.some(le=>le.isExtensionDevelopmentHost)&&!ce&&!W.noRecentEntry){const le=[];for(const he of ie)B(he)&&!he.transient?le.push({label:he.label,workspace:he.workspace,remoteAuthority:he.remoteAuthority}):z(he)?le.push({label:he.label,folderUri:he.workspace.uri,remoteAuthority:he.remoteAuthority}):he.fileUri&&le.push({label:he.label,fileUri:he.fileUri,remoteAuthority:he.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(le)}return this.handleWaitMarkerFile(W,oe),oe}handleWaitMarkerFile(W,N){const F=W.waitMarkerFileURI;W.context===0&&F&&N.length===1&&N[0]&&(async()=>{await N[0].whenClosedOrLoaded;try{await this.fileService.del(F)}catch{}})()}doOpen(W,N,F,A,U,O,_){const Y=[];let ie;function oe(ge,fe){Y.push(ge),fe&&(ie=ge,O=void 0)}let{openFolderInNewWindow:J,openFilesInNewWindow:ce}=this.shouldOpenNewWindow(W);if(!W.initialStartup&&_.length>0){const ge=_[0].remoteAuthority,fe=this.getLastActiveWindowForAuthority(ge);fe&&oe(this.doAddFoldersToExistingWindow(fe,_.map(Ie=>Ie.workspace.uri)))}const le=F.length+N.length+A.length;if(O&&le===0){const ge=O.filesToOpenOrCreate[0]||O.filesToDiff[0],fe=this.getWindows().filter(Me=>O&&(0,v.isEqualAuthority)(Me.remoteAuthority,O.remoteAuthority));let Ie;ge?.fileUri&&!ce&&((W.context===4||W.context===0||W.context===1)&&(Ie=(0,re.findWindowOnFile)(fe,ge.fileUri,Me=>Me.configPath.scheme===y.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Me.configPath):void 0)),Ie||(Ie=this.doGetLastActiveWindow(fe))),Ie?(0,Z.isWorkspaceIdentifier)(Ie.openedWorkspace)?N.push({workspace:Ie.openedWorkspace,remoteAuthority:Ie.remoteAuthority}):(0,Z.isSingleFolderWorkspaceIdentifier)(Ie.openedWorkspace)?F.push({workspace:Ie.openedWorkspace,remoteAuthority:Ie.remoteAuthority}):oe(this.doOpenFilesInExistingWindow(W,Ie,O),!0):oe(this.openInBrowserWindow({userEnv:W.userEnv,cli:W.cli,initialStartup:W.initialStartup,filesToOpen:O,forceNewWindow:!0,remoteAuthority:O.remoteAuthority,forceNewTabbedWindow:W.forceNewTabbedWindow}),!0)}const he=(0,C.distinct)(N,ge=>ge.workspace.id);if(he.length>0){const ge=(0,C.coalesce)(he.map(fe=>(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),fe.workspace.configPath)));if(ge.length>0){const fe=ge[0],Ie=(0,v.isEqualAuthority)(O?.remoteAuthority,fe.remoteAuthority)?O:void 0;oe(this.doOpenFilesInExistingWindow(W,fe,Ie),!!Ie),J=!0}he.forEach(fe=>{if(ge.some(Ae=>Ae.openedWorkspace&&Ae.openedWorkspace.id===fe.workspace.id))return;const Ie=fe.remoteAuthority,Me=(0,v.isEqualAuthority)(O?.remoteAuthority,Ie)?O:void 0;oe(this.doOpenFolderOrWorkspace(W,fe,J,Me),!!Me),J=!0})}const we=(0,C.distinct)(F,ge=>v.extUriBiasedIgnorePathCase.getComparisonKey(ge.workspace.uri));if(we.length>0){const ge=(0,C.coalesce)(we.map(fe=>(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),fe.workspace.uri)));if(ge.length>0){const fe=ge[0],Ie=(0,v.isEqualAuthority)(O?.remoteAuthority,fe.remoteAuthority)?O:void 0;oe(this.doOpenFilesInExistingWindow(W,fe,Ie),!!Ie),J=!0}we.forEach(fe=>{if(ge.some(Ae=>(0,Z.isSingleFolderWorkspaceIdentifier)(Ae.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(Ae.openedWorkspace.uri,fe.workspace.uri)))return;const Ie=fe.remoteAuthority,Me=(0,v.isEqualAuthority)(O?.remoteAuthority,Ie)?O:void 0;oe(this.doOpenFolderOrWorkspace(W,fe,J,Me),!!Me),J=!0})}const pe=(0,C.distinct)(A,ge=>ge.backupFolder);if(pe.length>0&&pe.forEach(ge=>{const fe=ge.remoteAuthority,Ie=(0,v.isEqualAuthority)(O?.remoteAuthority,fe)?O:void 0;oe(this.doOpenEmpty(W,!0,fe,Ie,ge),!!Ie),J=!0}),Y.length===0||O){O&&!U&&U++;const ge=O?O.remoteAuthority:W.remoteAuthority;for(let fe=0;fe<U;fe++)oe(this.doOpenEmpty(W,J,ge,O),!!O),J=!0}return{windows:(0,C.distinct)(Y),filesOpenedInWindow:ie}}doOpenFilesInExistingWindow(W,N,F){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:F}),N.focus();const A={filesToOpenOrCreate:F?.filesToOpenOrCreate,filesToDiff:F?.filesToDiff,filesToWait:F?.filesToWait,termProgram:W?.userEnv?.TERM_PROGRAM};return N.sendWhenReady("vscode:openFiles",k.CancellationToken.None,A),N}doAddFoldersToExistingWindow(W,N){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:N}),W.focus();const F={foldersToAdd:N};return W.sendWhenReady("vscode:addFolders",k.CancellationToken.None,F),W}doOpenEmpty(W,N,F,A,U){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!U,remoteAuthority:F,filesToOpen:A,forceNewWindow:N});let O;return!N&&typeof W.contextWindowId=="number"&&(O=this.getWindowById(W.contextWindowId)),this.openInBrowserWindow({userEnv:W.userEnv,cli:W.cli,initialStartup:W.initialStartup,remoteAuthority:F,forceNewWindow:N,forceNewTabbedWindow:W.forceNewTabbedWindow,filesToOpen:A,windowToUse:O,emptyWindowBackupInfo:U})}doOpenFolderOrWorkspace(W,N,F,A,U){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:N,filesToOpen:A}),!F&&!U&&typeof W.contextWindowId=="number"&&(U=this.getWindowById(W.contextWindowId)),this.openInBrowserWindow({workspace:N.workspace,userEnv:W.userEnv,cli:W.cli,initialStartup:W.initialStartup,remoteAuthority:N.remoteAuthority,forceNewWindow:F,forceNewTabbedWindow:W.forceNewTabbedWindow,filesToOpen:A,windowToUse:U})}getPathsToOpen(W){let N,F=!1,A=!1;if(W.urisToOpen&&W.urisToOpen.length>0?(N=this.doExtractPathsFromAPI(W),F=!0):W.forceEmpty?N=[Object.create(null)]:W.cli._.length||W.cli["folder-uri"]||W.cli["file-uri"]?(N=this.doExtractPathsFromCLI(W.cli),N.length===0&&N.push(Object.create(null)),F=!0):(N=this.doGetPathsFromLastSession(),N.length===0&&N.push(Object.create(null)),A=!0),!W.addMode&&F){const U=N.filter(O=>z(O));if(U.length>1){const O=U[0].remoteAuthority;if(U.every(_=>(0,v.isEqualAuthority)(_.remoteAuthority,O))){const _=this.workspacesManagementMainService.createUntitledWorkspaceSync(U.map(Y=>({uri:Y.workspace.uri})));N.push({workspace:_,remoteAuthority:O}),N=N.filter(Y=>!z(Y))}}}return W.initialStartup&&!A&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&N.unshift(...this.doGetPathsFromLastSession().filter(U=>B(U)||z(U)||U.backupPath)),N}doExtractPathsFromAPI(W){const N=[],F={gotoLineMode:W.gotoLineMode,remoteAuthority:W.remoteAuthority};for(const A of(0,C.coalesce)(W.urisToOpen||[])){const U=this.resolveOpenable(A,F);if(U)U.label=A.label,N.push(U);else{const O=this.resourceFromOpenable(A),_={title:this.productService.nameLong,type:"info",buttons:[(0,b.mnemonicButtonLabel)((0,g.localize)(0,null))],defaultId:0,message:O.scheme===y.Schemas.file?(0,g.localize)(1,null):(0,g.localize)(2,null),detail:O.scheme===y.Schemas.file?(0,g.localize)(3,null,(0,b.getPathLabel)(O.fsPath,this.environmentMainService)):(0,g.localize)(4,null,O.toString()),noLink:!0};this.dialogMainService.showMessageBox(_,(0,P.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow()))}}return N}doExtractPathsFromCLI(W){const N=[],F={ignoreFileNotFound:!0,gotoLineMode:W.goto,remoteAuthority:W.remote||void 0,forceOpenWorkspaceAsFile:!1},A=W["folder-uri"];if(A)for(const _ of A){const Y=this.cliArgToUri(_);if(Y){const ie=this.resolveOpenable({folderUri:Y},F);ie&&N.push(ie)}}const U=W["file-uri"];if(U)for(const _ of U){const Y=this.cliArgToUri(_);if(Y){const ie=this.resolveOpenable((0,Z.hasWorkspaceFileExtension)(_)?{workspaceUri:Y}:{fileUri:Y},F);ie&&N.push(ie)}}const O=W._;for(const _ of O){const Y=F.remoteAuthority?this.doResolvePathRemote(_,F):this.doResolveFilePath(_,F);Y&&N.push(Y)}return N}cliArgToUri(W){try{const N=u.URI.parse(W);if(!N.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${W}`);return}return N}catch(N){this.logService.error(`Invalid URI input string: ${W}, ${N.message}`)}}doGetPathsFromLastSession(){const W=this.getRestoreWindowsSetting();switch(W){case"none":return[];case"one":case"all":case"preserve":case"folders":{const N=[];W!=="one"&&N.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&N.push(this.windowsStateHandler.state.lastActiveWindow);const F=[];for(const A of N)if(A.workspace){const U=this.resolveOpenable({workspaceUri:A.workspace.configPath},{remoteAuthority:A.remoteAuthority,rejectTransientWorkspaces:!0});B(U)&&F.push(U)}else if(A.folderUri){const U=this.resolveOpenable({folderUri:A.folderUri},{remoteAuthority:A.remoteAuthority});z(U)&&F.push(U)}else W!=="folders"&&A.backupPath&&F.push({backupPath:A.backupPath,remoteAuthority:A.remoteAuthority});return F}}}getRestoreWindowsSetting(){let W;return this.lifecycleMainService.wasRestarted?W="all":(W=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(W)||(W="all")),W}resolveOpenable(W,N=Object.create(null)){let F=this.resourceFromOpenable(W);return F.scheme===y.Schemas.file?((0,Q.isFileToOpen)(W)&&(N={...N,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(F.fsPath,N)):this.doResolveRemoteOpenable(W,N)}doResolveRemoteOpenable(W,N){let F=this.resourceFromOpenable(W);const A=(0,T.getRemoteAuthority)(F)||N.remoteAuthority;if(F=(0,v.removeTrailingPathSeparator)((0,v.normalizePath)(F)),(0,Q.isFileToOpen)(W)){if(N.gotoLineMode){const{path:U,line:O,column:_}=(0,w.parseLineAndColumnAware)(F.path);return{fileUri:F.with({path:U}),selection:O?{startLineNumber:O,startColumn:_||1}:void 0,remoteAuthority:A}}return{fileUri:F,remoteAuthority:A}}else if((0,Q.isWorkspaceToOpen)(W))return{workspace:(0,H.getWorkspaceIdentifier)(F),remoteAuthority:A};return{workspace:(0,H.getSingleFolderWorkspaceIdentifier)(F),remoteAuthority:A}}resourceFromOpenable(W){return(0,Q.isWorkspaceToOpen)(W)?W.workspaceUri:(0,Q.isFolderToOpen)(W)?W.folderUri:W.fileUri}doResolveFilePath(W,N){let F,A;N.gotoLineMode&&({path:W,line:F,column:A}=(0,w.parseLineAndColumnAware)(W)),W=(0,w.sanitizeFilePath)((0,f.normalize)(W),(0,m.cwd)());try{const U=(0,n.statSync)(W);if(U.isFile()){if(!N.forceOpenWorkspaceAsFile){const O=this.workspacesManagementMainService.resolveLocalWorkspaceSync(u.URI.file(W));if(O)return O.transient&&N.rejectTransientWorkspaces?void 0:{workspace:{id:O.id,configPath:O.configPath},type:i.FileType.File,exists:!0,remoteAuthority:O.remoteAuthority,transient:O.transient}}return{fileUri:u.URI.file(W),type:i.FileType.File,exists:!0,selection:F?{startLineNumber:F,startColumn:A||1}:void 0}}else{if(U.isDirectory())return{workspace:(0,H.getSingleFolderWorkspaceIdentifier)(u.URI.file(W),U),type:i.FileType.Directory,exists:!0};if(!d.isWindows&&W==="/dev/null")return{fileUri:u.URI.file(W),type:i.FileType.File,exists:!0}}}catch{const O=u.URI.file(W);if(this.workspacesHistoryMainService.removeRecentlyOpened([O]),N.ignoreFileNotFound)return{fileUri:O,type:i.FileType.File,exists:!1}}}doResolvePathRemote(W,N){const F=W.charCodeAt(0),A=N.remoteAuthority;let U,O;N.gotoLineMode&&({path:W,line:U,column:O}=(0,w.parseLineAndColumnAware)(W)),F!==47&&((0,w.isWindowsDriveLetter)(F)&&W.charCodeAt(W.charCodeAt(1))===58&&(W=(0,w.toSlashes)(W)),W=`/${W}`);const _=u.URI.from({scheme:y.Schemas.vscodeRemote,authority:A,path:W});if(W.charCodeAt(W.length-1)!==47){if((0,Z.hasWorkspaceFileExtension)(W))return N.forceOpenWorkspaceAsFile?{fileUri:_,selection:U?{startLineNumber:U,startColumn:O||1}:void 0,remoteAuthority:N.remoteAuthority}:{workspace:(0,H.getWorkspaceIdentifier)(_),remoteAuthority:A};if(N.gotoLineMode||f.posix.basename(W).indexOf(".")!==-1)return{fileUri:_,selection:U?{startLineNumber:U,startColumn:O||1}:void 0,remoteAuthority:A}}return{workspace:(0,H.getSingleFolderWorkspaceIdentifier)(_),remoteAuthority:A}}shouldOpenNewWindow(W){const N=this.configurationService.getValue("window"),F=N?.openFoldersInNewWindow||"default",A=N?.openFilesInNewWindow||"off";let U=(W.preferNewWindow||W.forceNewWindow)&&!W.forceReuseWindow;!W.forceNewWindow&&!W.forceReuseWindow&&(F==="on"||F==="off")&&(U=F==="on");let O=!1;return W.forceNewWindow||W.forceReuseWindow?O=!!W.forceNewWindow&&!W.forceReuseWindow:(d.isMacintosh?W.context===1&&(O=!0):W.context!==3&&W.context!==2&&!(W.userEnv&&W.userEnv.TERM_PROGRAM==="vscode")&&(O=!0),!W.cli.extensionDevelopmentPath&&(A==="on"||A==="off")&&(O=A==="on")),{openFolderInNewWindow:!!U,openFilesInNewWindow:O}}openExtensionDevelopmentHostWindow(W,N){const F=(0,re.findWindowOnExtensionDevelopmentPath)(this.getWindows(),W);if(F)return this.lifecycleMainService.reload(F,N.cli),F.focus(),[F];let A=N.cli["folder-uri"]||[],U=N.cli["file-uri"]||[],O=N.cli._;if(!O.length&&!A.length&&!U.length&&!N.cli.extensionTestsPath){const oe=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,J=oe&&(oe.workspace||oe.folderUri);J&&(u.URI.isUri(J)?J.scheme===y.Schemas.file?O=[J.fsPath]:A=[J.toString()]:J.configPath.scheme===y.Schemas.file?O=[(0,v.originalFSPath)(J.configPath)]:U=[J.configPath.toString()])}let _=N.remoteAuthority;for(const oe of W)if(oe.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const J=u.URI.parse(oe),ce=(0,T.getRemoteAuthority)(J);ce&&(_?(0,v.isEqualAuthority)(ce,_)||this.logService.error("more than one extension development path authority"):_=ce)}O=O.filter(oe=>{const J=u.URI.file(oe);return(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),J)?!1:(0,v.isEqualAuthority)((0,T.getRemoteAuthority)(J),_)}),A=A.filter(oe=>{const J=this.cliArgToUri(oe);return J&&!!(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),J)?!1:J?(0,v.isEqualAuthority)((0,T.getRemoteAuthority)(J),_):!1}),U=U.filter(oe=>{const J=this.cliArgToUri(oe);return J&&!!(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),J)?!1:J?(0,v.isEqualAuthority)((0,T.getRemoteAuthority)(J),_):!1}),N.cli._=O,N.cli["folder-uri"]=A,N.cli["file-uri"]=U;const Y=!O.length&&!A.length&&!U.length,ie={context:N.context,cli:N.cli,forceNewWindow:!0,forceEmpty:Y,userEnv:N.userEnv,noRecentEntry:!0,waitMarkerFileURI:N.waitMarkerFileURI,remoteAuthority:_};return this.open(ie)}openInBrowserWindow(W){const N=this.configurationService.getValue("window"),F={...this.environmentMainService.args,...W.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:W.emptyWindowBackupInfo?(0,f.join)(this.environmentMainService.backupHome,W.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:W.remoteAuthority,workspace:W.workspace,userEnv:{...this.initialUserEnv,...W.userEnv},filesToOpenOrCreate:W.filesToOpen?.filesToOpenOrCreate,filesToDiff:W.filesToOpen?.filesToDiff,filesToWait:W.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:I.default,isInitialStartup:W.initialStartup,perfMarks:(0,t.getMarks)(),os:{release:(0,D.release)(),hostname:(0,D.hostname)()},zoomLevel:typeof N?.zoomLevel=="number"?N.zoomLevel:void 0,autoDetectHighContrast:N?.autoDetectHighContrast??!0,accessibilitySupport:p.app.accessibilitySupportEnabled,colorScheme:{dark:p.nativeTheme.shouldUseDarkColors,highContrast:p.nativeTheme.shouldUseInvertedColorScheme||p.nativeTheme.shouldUseHighContrastColors}};let A;if(!W.forceNewWindow&&!W.forceNewTabbedWindow&&(A=W.windowToUse||this.getLastActiveWindow(),A&&A.focus()),A){const U=A.config;!F.extensionDevelopmentPath&&U&&!!U.extensionDevelopmentPath&&(F.extensionDevelopmentPath=U.extensionDevelopmentPath,F.verbose=U.verbose,F["inspect-brk-extensions"]=U["inspect-brk-extensions"],F.debugId=U.debugId,F.extensionEnvironment=U.extensionEnvironment,F["inspect-extensions"]=U["inspect-extensions"],F["extensions-dir"]=U["extensions-dir"])}else{const U=this.windowsStateHandler.getNewWindowState(F);(0,t.mark)("code/willCreateCodeWindow");const O=A=this.instantiationService.createInstance(se.CodeWindow,{state:U,extensionDevelopmentPath:F.extensionDevelopmentPath,isExtensionTestHost:!!F.extensionTestsPath});if((0,t.mark)("code/didCreateCodeWindow"),W.forceNewTabbedWindow){const Y=this.getLastActiveWindow();Y&&Y.addTabbedWindow(O)}rt.WINDOWS.push(O),this._onDidOpenWindow.fire(O),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,S.once)(O.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(O)),(0,S.once)(O.onDidClose)(()=>this.onWindowClosed(O)),(0,S.once)(O.onDidDestroy)(()=>this._onDidDestroyWindow.fire(O));const _=(0,P.assertIsDefined)(O.win?.webContents);_.removeAllListeners("devtools-reload-page"),_.on("devtools-reload-page",()=>this.lifecycleMainService.reload(O)),this.lifecycleMainService.registerWindow(O)}return F.windowId=A.id,A.isReady?this.lifecycleMainService.unload(A,4).then(U=>{U||this.doOpenInBrowserWindow(A,F,W)}):this.doOpenInBrowserWindow(A,F,W),A}doOpenInBrowserWindow(W,N,F){if(!N.extensionDevelopmentPath)if((0,Z.isWorkspaceIdentifier)(N.workspace))N.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:N.workspace,remoteAuthority:N.remoteAuthority});else if((0,Z.isSingleFolderWorkspaceIdentifier)(N.workspace))N.backupPath=this.backupMainService.registerFolderBackupSync({folderUri:N.workspace.uri,remoteAuthority:N.remoteAuthority});else{const A=F.emptyWindowBackupInfo&&F.emptyWindowBackupInfo.backupFolder;N.backupPath=this.backupMainService.registerEmptyWindowBackupSync(A,N.remoteAuthority)}W.load(N)}onWindowClosed(W){const N=rt.WINDOWS.indexOf(W);rt.WINDOWS.splice(N,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const W=p.BrowserWindow.getFocusedWindow();if(W)return this.getWindowById(W.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(W){return this.doGetLastActiveWindow(this.getWindows().filter(N=>(0,v.isEqualAuthority)(N.remoteAuthority,W)))}doGetLastActiveWindow(W){const N=Math.max.apply(Math,W.map(F=>F.lastFocusTime));return W.find(F=>F.lastFocusTime===N)}sendToFocused(W,...N){const F=this.getFocusedWindow()||this.getLastActiveWindow();F&&F.sendWhenReady(W,k.CancellationToken.None,...N)}sendToAll(W,N,F){for(const A of this.getWindows())F&&F.indexOf(A.id)>=0||A.sendWhenReady(W,k.CancellationToken.None,N)}getWindows(){return rt.WINDOWS}getWindowCount(){return rt.WINDOWS.length}getWindowById(W){const N=this.getWindows().filter(F=>F.id===W);return(0,C.firstOrDefault)(N)}getWindowByWebContents(W){const N=p.BrowserWindow.fromWebContents(W);if(!!N)return this.getWindowById(N.id)}};G.WINDOWS=[],G=de([ne(2,h.ILogService),ne(3,$.IStateMainService),ne(4,s.IEnvironmentMainService),ne(5,a.ILifecycleMainService),ne(6,c.IBackupMainService),ne(7,o.IConfigurationService),ne(8,K.IWorkspacesHistoryMainService),ne(9,x.IWorkspacesManagementMainService),ne(10,r.IInstantiationService),ne(11,l.IDialogMainService),ne(12,i.IFileService),ne(13,R.IProductService),ne(14,L.IProtocolMainService)],G),e.WindowsMainService=G}),define(ee[251],te([0,1,52,34,69,42]),function(j,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let k=class{constructor(w,S,b,M){this.workspacesManagementMainService=w,this.windowsMainService=S,this.workspacesHistoryMainService=b,this.backupMainService=M,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(w,S){const b=this.windowsMainService.getWindowById(w);if(b)return this.workspacesManagementMainService.enterWorkspace(b,this.windowsMainService.getWindows(),S)}createUntitledWorkspace(w,S,b){return this.workspacesManagementMainService.createUntitledWorkspace(S,b)}deleteUntitledWorkspace(w,S){return this.workspacesManagementMainService.deleteUntitledWorkspace(S)}getWorkspaceIdentifier(w,S){return this.workspacesManagementMainService.getWorkspaceIdentifier(S)}getRecentlyOpened(w){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(w))}addRecentlyOpened(w,S){return this.workspacesHistoryMainService.addRecentlyOpened(S)}removeRecentlyOpened(w,S){return this.workspacesHistoryMainService.removeRecentlyOpened(S)}clearRecentlyOpened(w){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};k=de([ne(0,C.IWorkspacesManagementMainService),ne(1,n.IWindowsMainService),ne(2,D.IWorkspacesHistoryMainService),ne(3,p.IBackupMainService)],k),e.WorkspacesMainService=k}),define(ee[252],te([0,1,14,30,26,17,39,15,29,43,44,33,2,10,9,3,13,7,32,73,125,37,128,88,224,138,52,234,19,95,167,75,103,50,235,91,23,53,93,175,196,176,231,92,177,178,18,191,77,62,5,76,244,209,104,20,6,193,249,58,22,65,240,78,38,228,80,210,31,212,214,66,41,218,242,245,243,246,100,219,220,221,222,225,34,250,226,27,69,251,42]),function(j,e,p,n,D,C,k,E,w,S,b,M,y,f,t,d,m,v,P,u,g,c,o,l,s,i,r,a,h,I,R,L,T,$,Q,se,re,V,Z,H,K,x,B,z,G,q,W,N,F,A,U,O,_,Y,ie,oe,J,ce,le,he,we,pe,ge,fe,Ie,Me,Ae,Xe,Oe,ze,st,xe,Qe,pt,ot,Ve,Je,X,ae,ue,ve,Ee,Le,_e,Ke,He,Te,Ne,qe,tt,it){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let vt=class extends y.Disposable{constructor(me,ye,be,Se,Ce,Re,De,Pe,ke,We){super();this.mainProcessNodeIpcServer=me,this.userEnv=ye,this.mainInstantiationService=be,this.logService=Se,this.environmentMainService=Ce,this.lifecycleMainService=Re,this.configurationService=De,this.stateMainService=Pe,this.fileService=ke,this.productService=We,this.configureSession(),this.registerListeners()}configureSession(){const me=Pe=>Pe?.startsWith(`${f.Schemas.vscodeWebview}://`),ye=new Set(["clipboard-read","clipboard-sanitized-write"]);p.session.defaultSession.setPermissionRequestHandler((Pe,ke,We,Be)=>me(Be.requestingUrl)?We(ye.has(ke)):We(!1)),p.session.defaultSession.setPermissionCheckHandler((Pe,ke,We,Be)=>me(Be.requestingUrl)?ye.has(ke):!1);const be=new Set([f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemoteResource,"devtools"]),Se=Pe=>{for(let ke=Pe;ke;ke=ke.parent)if(ke.url.startsWith(`${f.Schemas.vscodeWebview}://`))return!0;return!1},Ce=Pe=>Pe.resourceType==="xhr"||Se(Pe.frame),Re=Pe=>{const ke=Pe.frame;if(!ke||!this.windowsMainService)return!1;const We=p.BrowserWindow.getAllWindows();for(const Be of We)if(ke.processId===Be.webContents.mainFrame.processId)return!0;return!1};p.session.defaultSession.webRequest.onBeforeRequest((Pe,ke)=>{const We=v.URI.parse(Pe.url);return We.scheme===f.Schemas.vscodeFileResource&&!Re(Pe)?(this.logService.error("Blocked vscode-file request",Pe.url),ke({cancel:!0})):We.path.endsWith(".svg")&&!be.has(We.scheme)?ke({cancel:!Ce(Pe)}):ke({cancel:!1})}),p.session.defaultSession.webRequest.onHeadersReceived((Pe,ke)=>{const We=Pe.responseHeaders,Be=We["content-type"]||We["Content-Type"];if(Be&&Array.isArray(Be)){const Ge=v.URI.parse(Pe.url);if(Ge.path.endsWith(".svg")&&be.has(Ge.scheme))return We["Content-Type"]=["image/svg+xml"],ke({cancel:!1,responseHeaders:We});if(!Ge.path.includes(f.Schemas.vscodeRemoteResource)&&Be.some(et=>et.toLowerCase().includes("image/svg")))return ke({cancel:!Ce(Pe)})}return ke({cancel:!1})});const De=p.session.defaultSession;typeof De.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&De.setCodeCachePath((0,t.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,E.setUnexpectedErrorHandler)(be=>this.onUnexpectedError(be)),process.on("uncaughtException",be=>(0,E.onUnexpectedError)(be)),process.on("unhandledRejection",be=>(0,E.onUnexpectedError)(be)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,g.registerContextMenuListener)(),p.app.on("accessibility-support-changed",(be,Se)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",Se)}),p.app.on("activate",(be,Se)=>{this.logService.trace("app#activate"),Se||this.windowsMainService?.openEmptyWindow({context:1})}),p.app.on("web-contents-created",(be,Se)=>{Se.on("will-navigate",Ce=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Ce.preventDefault()}),Se.setWindowOpenHandler(({url:Ce})=>(this.nativeHostMainService?.openExternal(void 0,Ce),{action:"deny"}))});let me=[],ye;p.app.on("open-file",(be,Se)=>{this.logService.trace("app#open-file: ",Se),be.preventDefault(),me.push(this.getWindowOpenableFromPathSync(Se)),ye!==void 0&&(clearTimeout(ye),ye=void 0),ye=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:me,gotoLineMode:!1,preferNewWindow:!0}),me=[],ye=void 0},100)}),p.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),p.ipcMain.handle("vscode:fetchShellEnv",be=>{const Se=this.windowsMainService?.getWindowByWebContents(be.sender);let Ce,Re;return Se?.config?(Ce=Se.config,Re={...process.env,...Se.config.userEnv}):(Ce=this.environmentMainService.args,Re=process.env),this.resolveShellEnvironment(Ce,Re,!1)}),p.ipcMain.handle("vscode:writeNlsFile",(be,Se,Ce)=>{const Re=this.validateNlsPath([Se]);if(!Re||typeof Ce!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Re,C.VSBuffer.fromString(Ce))}),p.ipcMain.handle("vscode:readNlsFile",async(be,...Se)=>{const Ce=this.validateNlsPath(Se);if(!Ce)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Ce)).value.toString()}),p.ipcMain.on("vscode:toggleDevTools",be=>be.sender.toggleDevTools()),p.ipcMain.on("vscode:openDevTools",be=>be.sender.openDevTools()),p.ipcMain.on("vscode:reloadWindow",be=>be.sender.reload())}validateNlsPath(me){let ye;for(const be of me)typeof be=="string"&&(typeof ye!="string"?ye=be:ye=(0,t.join)(ye,be));if(!(typeof ye!="string"||!(0,t.isAbsolute)(ye)||!(0,w.isEqualOrParent)(ye,this.environmentMainService.cachedLanguagesPath,!d.isLinux)))return v.URI.file(ye)}onUnexpectedError(me){if(me){const ye={message:`[uncaught exception in main]: ${me.message}`,stack:me.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(ye))}this.logService.error(`[uncaught exception in main]: ${me}`),me.stack&&this.logService.error(me.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const me=this.productService.win32AppUserModelId;d.isWindows&&me&&p.app.setAppUserModelId(me);try{d.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!p.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&p.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(ke){this.logService.error(ke)}const ye=new o.Server;this.logService.trace("Resolving machine identifier...");const be=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${be}`);const{sharedProcess:Se,sharedProcessReady:Ce,sharedProcessClient:Re}=this.setupSharedProcess(be),De=await this.initServices(be,Se,Ce);if(this.environmentMainService.driverHandle){const ke=await(0,Q.serve)(ye,this.environmentMainService.driverHandle,this.environmentMainService,De);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(ke)}this._register(De.createInstance(s.ProxyAuthHandler)),De.invokeFunction(ke=>this.initChannels(ke,ye,Re));const Pe=De.invokeFunction(ke=>this.openFirstWindow(ke,ye));De.invokeFunction(ke=>this.afterWindowOpen(ke,Se)),this.environmentMainService.args.trace&&De.invokeFunction(ke=>this.stopTracingEventually(ke,Pe))}async resolveMachineId(){let me=this.stateMainService.getItem(Oe.machineIdKey);return(!me||d.isMacintosh&&me==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(me=await(0,u.getMachineId)(),this.stateMainService.setItem(Oe.machineIdKey,me)),me}setupSharedProcess(me){const ye=this._register(this.mainInstantiationService.createInstance(ge.SharedProcess,me,this.userEnv)),be=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Ce=await ye.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new l.Client(Ce,"main")})(),Se=(async()=>(await ye.whenReady(),be))();return{sharedProcess:ye,sharedProcessReady:Se,sharedProcessClient:be}}async initServices(me,ye,be){const Se=new O.ServiceCollection;switch(process.platform){case"win32":Se.set(Qe.IUpdateService,new A.SyncDescriptor(X.Win32UpdateService));break;case"linux":d.isLinuxSnap?Se.set(Qe.IUpdateService,new A.SyncDescriptor(Je.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Se.set(Qe.IUpdateService,new A.SyncDescriptor(Ve.LinuxUpdateService));break;case"darwin":Se.set(Qe.IUpdateService,new A.SyncDescriptor(ot.DarwinUpdateService));break}Se.set(Ke.IWindowsMainService,new A.SyncDescriptor(He.WindowsMainService,[me,this.userEnv])),Se.set($.IDialogMainService,new A.SyncDescriptor($.DialogMainService)),Se.set(ie.ILaunchMainService,new A.SyncDescriptor(ie.LaunchMainService)),Se.set(T.IDiagnosticsMainService,new A.SyncDescriptor(T.DiagnosticsMainService)),Se.set(L.IDiagnosticsService,c.ProxyChannel.toService((0,c.getDelayedChannel)(be.then(Re=>Re.getChannel("diagnostics"))))),Se.set(_.IIssueMainService,new A.SyncDescriptor(_.IssueMainService,[this.userEnv])),Se.set(se.IEncryptionMainService,new A.SyncDescriptor(se.EncryptionMainService,[me])),Se.set(Y.IKeyboardLayoutMainService,new A.SyncDescriptor(Y.KeyboardLayoutMainService)),Se.set(he.INativeHostMainService,new A.SyncDescriptor(he.NativeHostMainService,[ye])),Se.set(I.ICredentialsMainService,new A.SyncDescriptor(I.CredentialsMainService)),Se.set(Le.IWebviewManagerService,new A.SyncDescriptor(_e.WebviewMainService)),Se.set(Ne.IWorkspacesService,new A.SyncDescriptor(tt.WorkspacesMainService)),Se.set(it.IWorkspacesManagementMainService,new A.SyncDescriptor(it.WorkspacesManagementMainService)),Se.set(qe.IWorkspacesHistoryMainService,new A.SyncDescriptor(qe.WorkspacesHistoryMainService)),Se.set(le.IMenubarMainService,new A.SyncDescriptor(le.MenubarMainService)),Se.set(H.IExtensionUrlTrustService,new A.SyncDescriptor(K.ExtensionUrlTrustService)),Se.set(x.IExtensionHostStarter,new A.SyncDescriptor(B.WorkerMainProcessExtensionHostStarter)),Se.set(Ae.IStorageMainService,new A.SyncDescriptor(Ae.StorageMainService)),Se.set(Ae.IGlobalStorageMainService,new A.SyncDescriptor(Ae.GlobalStorageMainService)),d.isWindows?Se.set(z.IExternalTerminalMainService,new A.SyncDescriptor(G.WindowsExternalTerminalService)):d.isMacintosh?Se.set(z.IExternalTerminalMainService,new A.SyncDescriptor(G.MacExternalTerminalService)):d.isLinux&&Se.set(z.IExternalTerminalMainService,new A.SyncDescriptor(G.LinuxExternalTerminalService));const Ce=new a.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(Se.set(r.IBackupMainService,Ce),Se.set(ae.IURLService,new A.SyncDescriptor(ve.NativeURLService)),(0,xe.supportsTelemetry)(this.productService,this.environmentMainService)){const Re=(0,c.getDelayedChannel)(be.then(Be=>Be.getChannel("telemetryAppender"))),De=new ze.TelemetryAppenderClient(Re),Pe=(0,Xe.resolveCommonProperties)(this.fileService,(0,D.release)(),(0,D.hostname)(),process.arch,this.productService.commit,this.productService.version,me,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),ke=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],We={appenders:[De],commonProperties:Pe,piiPaths:ke,sendErrorTelemetry:!0};Se.set(Oe.ITelemetryService,new A.SyncDescriptor(st.TelemetryService,[We]))}else Se.set(Oe.ITelemetryService,xe.NullTelemetryService);return await Ce.initialize(),this.mainInstantiationService.createChild(Se)}initChannels(me,ye,be){const Se=c.ProxyChannel.fromService(me.get(ie.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",Se);const Ce=c.ProxyChannel.fromService(me.get(T.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",Ce);const Re=this.fileService.getProvider(f.Schemas.file);(0,m.assertType)(Re instanceof F.DiskFileSystemProvider);const De=new N.DiskFileSystemProviderChannel(Re,this.logService,this.environmentMainService);ye.registerChannel(q.LOCAL_FILE_SYSTEM_CHANNEL_NAME,De),be.then(je=>je.registerChannel(q.LOCAL_FILE_SYSTEM_CHANNEL_NAME,De));const Pe=new pt.UpdateChannel(me.get(Qe.IUpdateService));ye.registerChannel("update",Pe);const ke=c.ProxyChannel.fromService(me.get(_.IIssueMainService));ye.registerChannel("issue",ke);const We=c.ProxyChannel.fromService(me.get(se.IEncryptionMainService));ye.registerChannel("encryption",We);const Be=c.ProxyChannel.fromService(me.get(I.ICredentialsMainService));ye.registerChannel("credentials",Be);const Ge=c.ProxyChannel.fromService(me.get(fe.ISignService));ye.registerChannel("sign",Ge);const et=c.ProxyChannel.fromService(me.get(Y.IKeyboardLayoutMainService));ye.registerChannel("keyboardLayout",et),this.nativeHostMainService=me.get(he.INativeHostMainService);const dt=c.ProxyChannel.fromService(this.nativeHostMainService);ye.registerChannel("nativeHost",dt),be.then(je=>je.registerChannel("nativeHost",dt));const Ue=c.ProxyChannel.fromService(me.get(Ne.IWorkspacesService));ye.registerChannel("workspaces",Ue);const ft=c.ProxyChannel.fromService(me.get(le.IMenubarMainService));ye.registerChannel("menubar",ft);const at=c.ProxyChannel.fromService(me.get(ae.IURLService));ye.registerChannel("url",at);const ct=c.ProxyChannel.fromService(me.get(H.IExtensionUrlTrustService));ye.registerChannel("extensionUrlTrust",ct);const gt=c.ProxyChannel.fromService(me.get(Le.IWebviewManagerService));ye.registerChannel("webview",gt);const lt=this._register(new Me.StorageDatabaseChannel(this.logService,me.get(Ae.IStorageMainService)));ye.registerChannel("storage",lt),be.then(je=>je.registerChannel("storage",lt));const ut=c.ProxyChannel.fromService(me.get(z.IExternalTerminalMainService));ye.registerChannel("externalTerminal",ut);const nt=new ce.LogLevelChannel(me.get(J.ILogService));ye.registerChannel("logLevel",nt),be.then(je=>je.registerChannel("logLevel",nt));const ht=new ce.LoggerChannel(me.get(J.ILoggerService));ye.registerChannel("logger",ht),be.then(je=>je.registerChannel("logger",ht));const Fe=new R.ElectronExtensionHostDebugBroadcastChannel(me.get(Ke.IWindowsMainService));ye.registerChannel("extensionhostdebugservice",Fe);const Ze=c.ProxyChannel.fromService(me.get(x.IExtensionHostStarter));ye.registerChannel(x.ipcExtensionHostStarterChannelName,Ze)}openFirstWindow(me,ye){const be=this.windowsMainService=me.get(Ke.IWindowsMainService),Se=me.get(ae.IURLService),Ce=me.get(he.INativeHostMainService);this.lifecycleMainService.phase=2;const Re=[],De=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Fe=>{try{return{uri:v.URI.parse(Fe),url:Fe}}catch{return}}).filter(Fe=>{if(!Fe||this.shouldBlockURI(Fe.uri))return!1;const Ze=this.getWindowOpenableFromProtocolLink(Fe.uri);return Ze?(Re.push(Ze),!1):!0}),Pe=this,ke=this.environmentMainService,We=this.productService;Se.registerHandler({async handleURL(Fe,Ze){if(Fe.scheme===We.urlProtocol&&Fe.path==="workspace"&&(Fe=Fe.with({authority:"file",path:v.URI.parse(Fe.query).path,query:""})),Pe.shouldBlockURI(Fe))return!0;const je=Pe.getWindowOpenableFromProtocolLink(Fe);if(je){const[St]=be.open({context:5,cli:{...ke.args},urisToOpen:[je],gotoLineMode:!0});return St.focus(),!0}if(d.isMacintosh&&be.getWindowCount()===0){const[St]=be.open({context:5,cli:{...ke.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,pe.getRemoteAuthority)(Fe)});return await St.ready(),Se.open(Fe,Ze)}return!1}});const Be=this._register(new Te.ActiveWindowManager({onDidOpenWindow:Ce.onDidOpenWindow,onDidFocusWindow:Ce.onDidFocusWindow,getActiveWindowId:()=>Ce.getActiveWindowId(-1)})),Ge=new c.StaticRouter(Fe=>Be.getActiveClientId().then(Ze=>Fe===Ze)),et=new ue.URLHandlerRouter(Ge),dt=ye.getChannel("urlHandler",et);Se.registerHandler(new ue.URLHandlerChannelClient(dt)),this._register(new Ee.ElectronURLListener(De,Se,be,this.environmentMainService,this.productService));const Ue=this.environmentMainService.args,ft=global.macOpenFiles,at=(0,V.isLaunchedFromCli)(process.env)?0:4,ct=Ue._.length,gt=!!Ue["folder-uri"],lt=!!Ue["file-uri"],ut=Ue["skip-add-to-recently-opened"]===!0,nt=Ue.wait&&Ue.waitMarkerFilePath?v.URI.file(Ue.waitMarkerFilePath):void 0,ht=Ue.remote||void 0;return Re.length>0?be.open({context:at,cli:Ue,urisToOpen:Re,gotoLineMode:!0,initialStartup:!0}):Ue["new-window"]&&!ct&&!gt&&!lt?be.open({context:at,cli:Ue,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:ut,waitMarkerFileURI:nt,initialStartup:!0,remoteAuthority:ht}):ft.length&&!ct&&!gt&&!lt?be.open({context:1,cli:Ue,urisToOpen:ft.map(Fe=>this.getWindowOpenableFromPathSync(Fe)),noRecentEntry:ut,waitMarkerFileURI:nt,initialStartup:!0}):be.open({context:at,cli:Ue,forceNewWindow:Ue["new-window"]||!ct&&Ue["unity-launch"],diffMode:Ue.diff,noRecentEntry:ut,waitMarkerFileURI:nt,gotoLineMode:Ue.goto,initialStartup:!0,remoteAuthority:ht})}shouldBlockURI(me){return!!(me.authority===f.Schemas.file&&d.isWindows&&p.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,M.mnemonicButtonLabel)((0,i.localize)(0,null)),(0,M.mnemonicButtonLabel)((0,i.localize)(1,null))],defaultId:0,cancelId:1,message:(0,i.localize)(2,null,(0,M.getPathLabel)(me.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,i.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(me){if(!!me.path){if(me.authority===f.Schemas.file){const ye=v.URI.file(me.fsPath);return(0,Ne.hasWorkspaceFileExtension)(ye)?{workspaceUri:ye}:{fileUri:ye}}else if(me.authority===f.Schemas.vscodeRemote){const ye=me.path.indexOf(t.posix.sep,1);if(ye!==-1){const be=me.path.substring(1,ye),Se=me.path.substring(ye),Ce=v.URI.from({scheme:f.Schemas.vscodeRemote,authority:be,path:Se,query:me.query,fragment:me.fragment});return(0,Ne.hasWorkspaceFileExtension)(Se)?{workspaceUri:Ce}:/:[\d]+$/.test(Se)?{fileUri:Ce}:{folderUri:Ce}}}}}getWindowOpenableFromPathSync(me){try{if((0,n.statSync)(me).isDirectory())return{folderUri:v.URI.file(me)};if((0,Ne.hasWorkspaceFileExtension)(me))return{workspaceUri:v.URI.file(me)}}catch{}return{fileUri:v.URI.file(me)}}async afterWindowOpen(me,ye){this.lifecycleMainService.phase=3;let be=!1;(0,S.once)(this.lifecycleMainService.onWillShutdown)(()=>be=!0);const Se=me.get(Oe.ITelemetryService);this._register(ye.onDidError(({type:De,details:Pe})=>{let ke;switch(De){case 1:ke="SharedProcess: detected unresponsive window";break;case 2:ke=`SharedProcess: crashed (detail: ${Pe?.reason??"<unknown>"}, code: ${Pe?.exitCode??"<unknown>"})`;break;case 3:ke=`SharedProcess: failed to load (detail: ${Pe?.reason??"<unknown>"}, code: ${Pe?.exitCode??"<unknown>"})`;break}(0,E.onUnexpectedError)(new Error(ke)),Se.publicLog2("sharedprocesserror",{type:De,reason:Pe?.reason,code:Pe?.exitCode,visible:ye.isVisible(),shuttingdown:be})}));const Ce=this.productService.win32MutexName;if(d.isWindows&&Ce)try{const De=j.__$__nodeRequire("windows-mutex").Mutex,Pe=new De(Ce);(0,S.once)(this.lifecycleMainService.onWillShutdown)(()=>Pe.release())}catch(De){this.logService.error(De)}p.protocol.registerHttpProtocol(f.Schemas.vscodeRemoteResource,(De,Pe)=>{Pe({url:De.url.replace(/^vscode-remote-resource:/,"http:"),method:De.method})});const Re=me.get(Qe.IUpdateService);(Re instanceof X.Win32UpdateService||Re instanceof Ve.LinuxUpdateService||Re instanceof ot.DarwinUpdateService)&&Re.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0);try{const Pe=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,b.stripComments)(Pe))["enable-crash-reporter"]===void 0){const Be=(0,xe.getTelemetryLevel)(this.configurationService)>=1,Ge=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Be},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,P.generateUuid)()}"`,"}"],et=Pe.substring(0,Pe.length-2).concat(`,
`,Ge.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,C.VSBuffer.fromString(et))}}catch(De){this.logService.error(De)}}async resolveShellEnvironment(me,ye,be){try{return await(0,Z.getResolvedShellEnv)(this.logService,me,ye)}catch(Se){const Ce=(0,k.toErrorMessage)(Se);be?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Ce):this.logService.error(Ce)}return{}}stopTracingEventually(me,ye){this.logService.info("Tracing: waiting for windows to get ready...");const be=me.get($.IDialogMainService);let Se=!1;const Ce=async De=>{if(Se)return;Se=!0;const Pe=await p.contentTracing.stopRecording(`${(0,w.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);De?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Pe}`):be.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,i.localize)(4,null),detail:(0,i.localize)(5,null,Pe),buttons:[(0,M.mnemonicButtonLabel)((0,i.localize)(6,null))],defaultId:0,noLink:!0},(0,m.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow()))},Re=setTimeout(()=>Ce(!0),3e4);Promise.all(ye.map(De=>De.ready())).then(()=>{clearTimeout(Re),Ce(!1)})}};vt=de([ne(2,U.IInstantiationService),ne(3,J.ILogService),ne(4,re.IEnvironmentMainService),ne(5,oe.ILifecycleMainService),ne(6,h.IConfigurationService),ne(7,Ie.IStateMainService),ne(8,W.IFileService),ne(9,we.IProductService)],vt),e.CodeApplication=vt}),define(ee[259],te([0,1,14,30,28,8,39,15,29,43,33,10,9,64,3,35,25,24,37,57,252,11,19,200,211,23,53,170,18,189,77,62,183,76,20,96,6,194,97,54,22,55,197,99,237,49,239,78,208,38,241,66,67,217]),function(j,e,p,n,D,C,k,E,w,S,b,M,y,f,t,d,m,v,P,u,g,c,o,l,s,i,r,a,h,I,R,L,T,$,Q,se,re,V,Z,H,K,x,B,z,G,q,W,N,F,A,U,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Y{main(){try{this.startup()}catch(J){console.error(J.message),p.app.exit(1)}}async startup(){(0,E.setUnexpectedErrorHandler)(fe=>console.error(fe));const[J,ce,le,he,we,pe,ge]=this.createServices();try{try{await this.initServices(le,he,we)}catch(fe){throw this.handleStartupDataDirError(le,ge.nameLong,fe),fe}await J.invokeFunction(async fe=>{const Ie=fe.get(re.ILogService),Me=fe.get(Q.ILifecycleMainService),Ae=fe.get(h.IFileService),Xe=await this.claimInstance(Ie,le,Me,J,ge,!0);return v.Promises.writeFile(le.mainLockfile,String(process.pid)).catch(Oe=>{Ie.warn(`Error writing main lockfile: ${Oe.stack}`)}),pe.logger=new Z.SpdLogLogger("main",(0,y.join)(le.logsPath,"main.log"),!0,!1,pe.getLevel()),(0,S.once)(Me.onWillShutdown)(Oe=>{Ae.dispose(),he.dispose(),Oe.join(v.Promises.unlink(le.mainLockfile).catch(()=>{}))}),J.createInstance(g.CodeApplication,Xe,ce).startup()})}catch(fe){J.invokeFunction(this.quit,fe)}}createServices(){const J=new $.ServiceCollection,ce={_serviceBrand:void 0,...H.default};J.set(K.IProductService,ce);const le=new i.EnvironmentMainService(this.resolveArgs(),ce),he=this.patchEnvironment(le);J.set(i.IEnvironmentMainService,le);const we=new se.BufferLogService,pe=new re.MultiplexLogService([new re.ConsoleMainLogger((0,re.getLogLevel)(le)),we]);process.once("exit",()=>pe.dispose()),J.set(re.ILogService,pe);const ge=new I.FileService(pe);J.set(h.IFileService,ge);const fe=new R.DiskFileSystemProvider(pe);ge.registerProvider(M.Schemas.file,fe),J.set(re.ILoggerService,new V.LoggerService(pe,ge));const Ie=new l.ConfigurationService(le.settingsResource,ge);J.set(o.IConfigurationService,Ie),J.set(Q.ILifecycleMainService,new L.SyncDescriptor(Q.LifecycleMainService));const Me=new U.StateMainService(le,pe,ge);return J.set(A.IStateMainService,Me),J.set(q.IRequestService,new L.SyncDescriptor(W.RequestMainService)),J.set(_.IThemeMainService,new L.SyncDescriptor(_.ThemeMainService)),J.set(N.ISignService,new L.SyncDescriptor(F.SignService)),J.set(z.ITunnelService,new L.SyncDescriptor(G.TunnelService)),J.set(x.IProtocolMainService,new L.SyncDescriptor(B.ProtocolMainService)),[new T.InstantiationService(J,!0),he,le,Ie,Me,we,ce]}patchEnvironment(J){const ce={VSCODE_IPC_HOOK:J.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(le=>{const he=process.env[le];typeof he=="string"&&(ce[le]=he)}),Object.assign(process.env,ce),ce}initServices(J,ce,le){return C.Promises.settled([Promise.all([J.extensionsPath,J.codeCachePath,J.logsPath,J.globalStorageHome.fsPath,J.workspaceStorageHome.fsPath,J.backupHome].map(he=>he?v.Promises.mkdir(he,{recursive:!0}):void 0)),ce.initialize(),le.init()])}async claimInstance(J,ce,le,he,we,pe){let ge;try{(0,f.mark)("code/willStartMainServer"),ge=await(0,u.serve)(ce.mainIPCHandle),(0,f.mark)("code/didStartMainServer"),(0,S.once)(le.onWillShutdown)(()=>ge.dispose())}catch(fe){if(fe.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ce,we.nameLong,fe),fe;let Ie;try{Ie=await(0,u.connect)(ce.mainIPCHandle,"main")}catch(Oe){if(!pe||t.isWindows||Oe.code!=="ECONNREFUSED")throw Oe.code==="EPERM"&&this.showStartupWarningDialog((0,c.localize)(0,null,we.nameShort),(0,c.localize)(1,null),we.nameLong),Oe;try{(0,n.unlinkSync)(ce.mainIPCHandle)}catch(ze){throw J.warn("Could not delete obsolete instance handle",ze),ze}return this.claimInstance(J,ce,le,he,we,!1)}if(ce.extensionTestsLocationURI&&!ce.debugExtensionHost.break){const Oe="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw J.error(Oe),Ie.dispose(),new Error(Oe)}let Me;!ce.args.wait&&!ce.args.status&&(Me=setTimeout(()=>{this.showStartupWarningDialog((0,c.localize)(2,null,we.nameShort),(0,c.localize)(3,null),we.nameLong)},1e4));const Ae=P.ProxyChannel.toService(Ie.getChannel("launch"),{disableMarshalling:!0}),Xe=P.ProxyChannel.toService(Ie.getChannel("diagnostics"),{disableMarshalling:!0});if(ce.args.status)return he.invokeFunction(async()=>{const Oe=new s.DiagnosticsService(O.NullTelemetryService,we),ze=await Ae.getMainProcessInfo(),st=await Xe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),xe=await Oe.getDiagnostics(ze,st);throw console.log(xe),new E.ExpectedError});throw t.isWindows&&await this.windowsAllowSetForegroundWindow(Ae,J),J.trace("Sending env to running instance..."),await Ae.start(ce.args,process.env),Ie.dispose(),Me&&clearTimeout(Me),new E.ExpectedError("Sent env to running instance. Terminating...")}if(ce.args.status)throw J.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new E.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),ge}handleStartupDataDirError(J,ce,le){if(le.code==="EACCES"||le.code==="EPERM"){const he=(0,D.coalesce)([J.userDataPath,J.extensionsPath,u.XDG_RUNTIME_DIR]).map(we=>(0,b.getPathLabel)(we,J));this.showStartupWarningDialog((0,c.localize)(4,null),(0,c.localize)(5,null,(0,k.toErrorMessage)(le),he.join(`
`)),ce)}}showStartupWarningDialog(J,ce,le){p.dialog.showMessageBoxSync({title:le,type:"warning",buttons:[(0,b.mnemonicButtonLabel)((0,c.localize)(6,null))],message:J,detail:ce,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(J,ce){if(t.isWindows){const le=await J.getMainProcessId();ce.trace("Sending some foreground love to the running instance:",le);try{(await new Promise((he,we)=>{j(["windows-foreground-love"],he,we)})).allowSetForegroundWindow(le)}catch(he){ce.error(he)}}}quit(J,ce){const le=J.get(re.ILogService),he=J.get(Q.ILifecycleMainService);let we=0;ce&&(ce.isExpected?ce.message&&le.trace(ce.message):(we=1,ce.stack?le.error(ce.stack):le.error(`Startup error: ${ce.toString()}`))),he.kill(we)}resolveArgs(){const J=this.validatePaths((0,r.parseMainProcessArgv)(process.argv));if(J.wait&&!J.waitMarkerFilePath){const ce=(0,a.createWaitMarkerFile)(J.verbose);ce&&((0,r.addArg)(process.argv,"--waitMarkerFilePath",ce),J.waitMarkerFilePath=ce)}return J}validatePaths(J){if(J["open-url"]&&(J._urls=J._,J._=[]),!J.remote){const ce=this.doValidatePaths(J._,J.goto);J._=ce}return J}doValidatePaths(J,ce){const le=(0,d.cwd)(),he=J.map(ge=>{let fe=String(ge),Ie;ce&&(Ie=(0,w.parseLineAndColumnAware)(fe),fe=Ie.path),fe&&(fe=this.preparePath(le,fe));const Me=(0,w.sanitizeFilePath)(fe,le),Ae=(0,y.basename)(Me);return Ae&&!(0,w.isValidBasename)(Ae)?null:ce&&Ie?(Ie.path=Me,this.toPath(Ie)):Me}),we=t.isWindows||t.isMacintosh,pe=(0,D.distinct)(he,ge=>ge&&we?ge.toLowerCase():ge||"");return(0,D.coalesce)(pe)}preparePath(J,ce){return t.isWindows&&(ce=(0,m.rtrim)(ce,'"')),ce=(0,m.trim)((0,m.trim)(ce," "),"	"),t.isWindows&&(ce=(0,y.resolve)(J,ce),ce=(0,m.rtrim)(ce,".")),ce}toPath(J){const ce=[J.path];return typeof J.line=="number"&&ce.push(String(J.line)),typeof J.column=="number"&&ce.push(String(J.column)),ce.join(":")}}new Y().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/3b2245ad832e745817eb63707bf21ed4002005d6/core/vs/code/electron-main/main.js.map
